DECLARE SUB SETCOL (COL1!, COL2!)
'MAIN PROGRAM FOR THE STRESS FIELD IN AN OVERTHRUST BLOCK
'
'A layer in plane strain, linear viscous/elastic
'
'The SUB include:
'
'   ONELAYER to plot the details of the layer
'$DYNAMIC
DECLARE SUB ONELAYER (FREE$, ZSTR$, T(), G(), A#(), XT#(), NL, k#(), m#(), NW, LG, WN, TT, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$) '$DYNAMIC
DECLARE SUB ALLAYERS (FREE$, ZSTR$, T(), G(), A#(), XT#(), NL, k#(), m#(), NW, LG, WN, LAYER, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$) '$DYNAMIC
MAXWAVE = 321: MAXLAYER = 11
99 DIM T(25), G(25), A#(4 * MAXLAYER, 4 * MAXLAYER + 1), XT#(MAXLAYER * 4, MAXWAVE), k#(2 * MAXWAVE), m#(2 * MAXWAVE), COLNUM%(20)
DIM X#(200), Y#(200)
'
'Default values
'
    LG = 80000: W = LG / 2: VERT = 1: HORIZ = 0
    FT = 1: FY = 2.4: PI = 4 * ATN(1)
    GI = 10: N = 1: ZSTR$ = "S": CLS
    COLOR (4)
    LOCATE 1, 20
FOR I = 1 TO 36
    PRINT CHR$(219);
NEXT I
    LOCATE 2, 20
FOR I = 1 TO 36
    PRINT CHR$(219);
NEXT I
    LOCATE 3, 20
FOR I = 1 TO 36
    PRINT CHR$(219);
NEXT I
    LOCATE 4, 20
FOR I = 1 TO 36
    PRINT CHR$(219);
NEXT I

    LOCATE 2, 35
    COLOR (15)
    LOCATE 2, 31
    PRINT "OVER";
    COLOR (2): PRINT "THRUST";
    COLOR (15): PRINT " BLOCK"
    COLOR (2)
    LOCATE 4, 1
    PRINT "         Stress field within a horizontal, elastic (or viscous) layer"
    PRINT "                subjected to lateral stress and gravity loading"
    PRINT
    COLOR (6)
    PRINT "                    A QuickBasic program by Ze'ev Reches"
    PRINT "                         Version 1.1 November, 1999"
    PRINT
    COLOR (15)
    FACT = 1
    PRINT "This is an interactive program that prompts for input and suggests defaults."
    PRINT "Defaults appear in [SQUARE BRACKETS] that are activated by hitting RETURN. "
    PRINT "Input units: Dimensions (meters); Stresses (MPa); Density (kg / m3)"
    PRINT "Sign convention: Tensile stresses are positive"
18  PRINT
    PRINT "Gravity stresses within elastic layers induce lithostatic (vertical) load."
    PRINT "'Poisson effect' induces smaller horizontal stresses."
    PRINT "Two options for stress maps (see text on BLOCK under Help of SoftStructure):"
    PRINT "  1. Byerlee Law Factor: BLF = ("; CHR$(229); "1 - "; CHR$(229); "3) / ("; CHR$(229); "1 + "; CHR$(229); "3) "
    PRINT "     According to Byerlee friction law,"; CHR$(231); " = 0.85 "; CHR$(229); "n; thus:"
    PRINT "     when BLF = 0.65  frictional shear occurs along ideally oriented fractures, "
    PRINT "     when 0.65 "; CHR$(243); " BLF "; CHR$(243); " 1, shear occurs also along poorly oriented fractures,"
    PRINT "     when BLF > 1, "; CHR$(229); "3 is tensile and tensile fractures are expected."
    PRINT "  2. {local maximum shear stress = 0.5 ("; CHR$(229); "1 - "; CHR$(229); "3)} (in MPa)."
    INPUT " [CONTINUE] "; Y$


500     CLS : SCREEN 0
      COLOR (4)
      PRINT "SCREEN DISPLAY"
      PRINT "  Output is presented in two-dimensional sections of the analyzed layer."
      PRINT "  Intensities are divided into 10 levels shown in red-green scale for:"
      PRINT "     {local maximum shear stress} = ("; CHR$(229); "1 - "; CHR$(229); "3) / 2,   OR"
      PRINT "     Byerlee Law Factor BLF= ("; CHR$(229); "1 - "; CHR$(229); "3) / ("; CHR$(229); "1 + "; CHR$(229); "3) (See text on BLOCK)"
    PRINT "     According to Byerlee friction law,"; CHR$(231); " = 0.85 "; CHR$(229); "n; thus:"
    PRINT "     when BLF = 0.65  frictional shear occurs along ideally oriented fractures, "
    PRINT "     when 0.65 "; CHR$(243); " BLF "; CHR$(243); " 1, shear occurs also along poorly oriented fractures,"
    PRINT "     when BLF > 1, "; CHR$(229); "3 is tensile and tensile fractures are expected."

      PRINT "  Small circles show that ("; CHR$(229); "1 + "; CHR$(229); "3)  is TENSILE."
      PRINT "  Trends of maximum local compression are shown with two options:"
      PRINT "     1. Short lines with length propoertional to maximum compression magnitude."
      PRINT "     2. Stress trajectories. (NOTE: Stress trajectories are plotted only for"
      PRINT "        COMPRESSIVE horizontal stress)."
      PRINT "  Positions within cross-sections are given by 23 by 13 squares marked as X, Z. "
      PRINT "     (1,1) is top-left, X counts left to right and Z counts downward."
      PRINT "HARD-COPIES: See instructions under SoftStructure."
COLOR (2)
        PRINT
        INPUT "Hit 99- to stop [Plot stress field in the layer] "; LAYER
COLOR (15)
        PRINT
        PRINT
        IF LAYER = 99 THEN STOP
        IF LAYER = 0 THEN LAYER = 1
        IF LAYER < 20 THEN CALL ONELAYER(FREE$, ZSTR$, T(), G(), A#(), XT#(), NL, k#(), m#(), NW, LG, WN, LAYER, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$)
        IF YS$ <> "" THEN ZRO$ = "w"
        IF YS$ <> "" THEN ZRO$ = ""
   
    IF YSTR$ <> "" THEN ZSTR$ = "E"
    GOTO 500
507 IF YSTR$ <> "" THEN ZSTR$ = "S"
    GOTO 500

SUB ONELAYER (FREE$, ZSTR$, T(), G(), A#(), XT#(), NL, k#(), m#(), NW, LG, WN, LAYER, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$) '
LENG = 1000: THICK = 250: SR = -10: POI = .25: RHO = -2500 * 10 / 1000000
12  REDIM WZ(42, 6), UZ(42, 6), COLNUM%(40)
    REDIM S11(25, 25), S22(25, 25), THET(25, 25)
    REDIM XP(25, 25), ZP(25, 25), XPR2(25, 25), ZPR2(25, 25), XPR3(25, 25), ZPR3(25, 25)
CLS : SCREEN 12
    'LENG = LG: THICK = T(LAYER):
    FT = 1: FY = 2.4: PI = 4 * ATN(1)
    PRINT
    PRINT "  CALCULATION AND PLOT OF STRESS FIELD "
    PRINT
   
'    THICK = 250:    LENG = 1000:    SR = -10:    POI = .25
LINE (400, 25)-(595, 80), 1, BF
LINE (400, 25)-(595, 80), , B
LINE (500, 80)-(620, 80)
LINE (400, 10)-(400, 30)
LOCATE 1, 50: PRINT "Y"
LOCATE 6, 78: PRINT "X"

LOCATE 2, 65: PRINT "L"
LOCATE 4, 1:
PRINT "Enter layer data:"
PRINT "   Block length-L  (meters) ["; LENG; "] ";
INPUT LENG1
IF LENG1 <> 0 THEN LENG = LENG1

LOCATE 4, 75: PRINT "H"
LOCATE 7, 1
PRINT "   Block height-H (meters) ["; THICK; "] ";
INPUT THICK1
IF THICK1 <> 0 THEN THICK = THICK1

COLOR (4)
FOR I = 1 TO 11
k = 20 + I * 5
LINE (595, k)-(620, k), 4
NEXT I
LOCATE 4, 77: PRINT "S"
COLOR (15)

LOCATE 9, 1
PRINT "   Stress on right side of block-S ; 99-for no stress (MPa) ["; SR; "] ";
INPUT SR1
IF SR1 = 99 THEN SR = 0
IF SR1 = 99 THEN GOTO 82
IF SR1 <> 0 THEN SR = SR1

LOCATE 11, 1
82 PRINT "   Enter Poisson's ratio;1-for Poisson's ratio=0 ["; POI; "] ";
INPUT POI1
IF POI1 <> 0 AND POI1 <> 1 THEN POI = POI1
IF POI1 = 1 THEN POI = 0
LOCATE 4, 65: PRINT "D"

LOCATE 13, 1
RHO = -RHO * 100000
PRINT "   Enter density-D (kg/m3) for stress calcualtions;1-no density ["; RHO; "]";
INPUT RHO1

IF RHO1 = 0 THEN RHO1 = RHO
IF RHO1 = 1 THEN RHO1 = 0
RHO = -RHO1 * 10 / 1000000
RO = RHO
PRINT
COHESION = 1
PRINT "   Enter COHESION (MPa) for the slipping discontinuities ["; COHESION; "]";
INPUT COH
IF COH <> 0 THEN COHESION = COH

    LG = LENG * 2
    STOPDISP = 0: SCDISP = 35: RO = RHO: GM = 1
    IF FF = 0 THEN FF = 1
    XPLOT = SCDISP * FF
  
  
   XFINAL = .75: XSTART = .5:
   XFINAL = 1!: XSTART = 0


   IF ZSTR$ = "S" THEN MAXBLACK = .01
   IF ZSTR$ = "E" THEN MAXBLACK = 0!
   XSCALE = ((XFINAL - XSTART) * LG / 2) / 400
   YSCALE = THICK / XSCALE
   PRINT
   INPUT "Hit 1- To display stress field in TRUE scale [FULL SCREEN]"; SPLOT
   PRINT
   PRINT "Plot trajectories of maximum compressive axis. This option is valid only for "
   INPUT "  compressive right-side loading (negative). Any key-no plot [TRAJECTORIES] "; TRAJ$
   PRINT
   INPUT "Enter confinement pressure to simulate overburden (negative!) (MPa) [0] "; PCONF
   PRINT
   PRINT "Enter pore-pressure, Pp, at the basal zone of the block.  This will be used for"
   PRINT "    slip resistance calculations. Default is hydrostatic pore-pressure."
   INPUT "Enter Pp as fraction of normal stress (0 =< Pp =< 1.); 2-for Pp=0 [0.4] "; LAM
   IF LAM = 0 THEN LAM = .4
   IF LAM = 2 THEN LAM = 0

   PRINT

   F$ = "A"
   IF F$ <> "" THEN IFINE = 10
   PRINT "Current plot from "; XSTART * LG / 2000; " to "; XFINAL * LG / 2000; " km, change plot width [NO] ";
   INPUT DS$
   IF DS$ = "" THEN GOTO 17
   PRINT "Enter width of plot by START, END as fraction of HALF the longest wavelength."
   INPUT "         Note:       0.0 =<  START < END =< 1.0 "; XSTART, XFINAL

   XSCALE = ((XFINAL - XSTART) * LG / 2) / 400
   YSCALE = THICK / XSCALE

17  LY = (LAYER - 1) * 4
   
   
    ZTOP = -THICK / 2 - THICK / 18

FOR KZ = 2 TO 10
    Z = ZTOP + (KZ - 1) * THICK / 9
FOR KX = 1 TO 13 + IFINE
        X = XSTART * LG / 2 + (KX - 1) * LG * (XFINAL - XSTART) / (24 + 2 * IFINE)
        SXT = 0: SZT = 0: SXZT = 0

Z0 = Z + THICK / 2
Z1 = THICK - Z0

        SZT = (SR / LENG ^ 2) * (THICK ^ 2 - 2 * Z1 * THICK + Z1 ^ 2) + (Z0 * RHO)
        SXT = (SR * X ^ 2 / LENG ^ 2) + (POI / (1 - POI)) * Z0 * RHO * (X * (1 - X / LENG) / LENG)
        SXZT = (2 * SR / LENG ^ 2) * X * (-THICK + Z1)

'PRINT KX, KZ
'PRINT SXT, SZT, SXZT
'INPUT OK


        S1 = .5 * (SZT + SXT) + SQR(SXZT ^ 2 + .25 * (SXT - SZT) ^ 2)
        S2 = .5 * (SZT + SXT) - SQR(SXZT ^ 2 + .25 * (SXT - SZT) ^ 2)
              IF SXT = SZT THEN TET = 10000
              IF SXT = SZT AND SXT < 0 THEN TET = -10000
              IF SXT = SZT THEN THETA = ATN(TET) / 2
              IF SXT = SZT THEN GOTO 608
              TET = ABS(2 * SXZT / (SXT - SZT))
              THETA = ATN(TET) / 2
        IF SXT > SZT AND SXZT > 0 THEN GOTO 608
        IF SXT > SZT AND SXZT < 0 THEN GOTO 602
        IF SXT < SZT AND SXZT > 0 THEN GOTO 603
        IF SXT < SZT AND SXZT < 0 THEN GOTO 604
602 THETA = -THETA
        GOTO 608
603 THETA = -THETA + PI / 2
        GOTO 608
604 THETA = THETA - PI / 2
608

'    PRINT USING " ###.#### "; SXT, SZT, SXZT, S1, S2, THICK, Z1
    
    S11(KX, KZ) = S1 + PCONF
    S22(KX, KZ) = S2 + PCONF
    THET(KX, KZ) = THETA
'PRINT S11(KX, KZ), S22(KX, KZ), -(1.5 / (S11(KX, KZ) + S22(KX, KZ))) - (S11(KX, KZ) - S22(KX, KZ)) / (S11(KX, KZ) + S22(KX, KZ))
'INPUT OK

NEXT KX
NEXT KZ


        ZTOP = -THICK / 2 - THICK / 18
        KBASE = 0: BASAL = 0
FOR KX = 1 TO 13 + IFINE
        X = XSTART * LG / 2 + (KX - 1) * LG * (XFINAL - XSTART) / (24 + 2 * IFINE)
Z0 = THICK
Z1 = THICK - Z0
        SZT = (SR / LENG ^ 2) * (THICK ^ 2 - 2 * Z1 * THICK + Z1 ^ 2) + (Z0 * RHO)
        SXT = (SR * X ^ 2 / LENG ^ 2) + (POI / (1 - POI)) * Z0 * RHO * (X * (1 - X / LENG) / LENG)
        SXZT = (2 * SR / LENG ^ 2) * X * (-THICK + Z1)
BASAL = BASAL + (SXZT / (SZT * (1 - LAM)))
KBASE = KBASE + 1
NEXT KX







'Calculations of stress trajectories and magnitude of shear stress/vertical stress

605 ZABOVE = 0
   IF LAYER = 1 THEN GOTO 14
FOR I = 1 TO LAYER - 1
   ZABOVE = ZABOVE + T(I)
NEXT I

14 CONT$ = "": MAX = 0: MIN = 10000: MAXCOMP = -10000
       ZTOP = -THICK / 18
FOR KZ = 2 TO 10
    Z = ZTOP + (KZ - 1) * THICK / 9
FOR KX = 1 TO 13 + IFINE

        IF ZRO$ = "w" THEN RO = RHO
          X = XSTART * LG / 2 + (KX - 1) * LG * (XFINAL - XSTART) / (24 + 2 * IFINE)
          IF ABS(S22(KX, KZ)) > MAXCOMP THEN MAXCOMP = ABS(S22(KX, KZ))

          IF ZRO$ = "w" THEN SNN = .5 * (S11(KX, KZ) + S22(KX, KZ))
          IF ZRO$ = "" THEN SNN = 1
          SINTENSE = ABS(.5 * (S11(KX, KZ) - S22(KX, KZ)) / SNN)
          IF ZRO$ = "w" THEN SINTENSE = SINTENSE - 1.5 * COHESION / ABS(S11(KX, KZ) + S22(KX, KZ))
                IF SINTENSE > MAX THEN XMAX = KX
                IF SINTENSE < MIN THEN XMIN = KX
                IF SINTENSE > MAX THEN ZMAX = KZ
                IF SINTENSE < MIN THEN ZMIN = KZ
                IF SINTENSE > MAX THEN MAX = SINTENSE
                IF SINTENSE < MIN THEN MIN = SINTENSE
        IF ZRO$ = "w" AND MIN < 0 THEN MIN = 0
    NCYCLE = NCYCLE + 1
NEXT KX
NEXT KZ

        ZTOP = -THICK / 2 - THICK / 18
FOR KZ = 2 TO 10
         Z = ZTOP + (KZ - 1) * THICK / 9
FOR KX = 1 TO 13 + IFINE
          X = (KX - 1) * LG * (XFINAL - XSTART) / (24 + 2 * IFINE)
          XP(KX, KZ) = X * 800 / (LG * (XFINAL - XSTART))
       IF SPLOT <> 1 THEN ZP(KX, KZ) = (Z + THICK / 2 + THICK / 18) * 126 / THICK
       IF SPLOT = 1 THEN ZP(KX, KZ) = (Z + THICK / 2 + THICK / 18) * YSCALE / THICK
          XPR2(KX, KZ) = XP(KX, KZ) + 25 * SIN(THET(KX, KZ)) * ABS(S22(KX, KZ)) / MAXCOMP
          ZPR2(KX, KZ) = ZP(KX, KZ) - 25 * COS(THET(KX, KZ)) * ABS(S22(KX, KZ)) / MAXCOMP
          XPR3(KX, KZ) = XP(KX, KZ) - 25 * SIN(THET(KX, KZ)) * ABS(S22(KX, KZ)) / MAXCOMP
          ZPR3(KX, KZ) = ZP(KX, KZ) + 25 * COS(THET(KX, KZ)) * ABS(S22(KX, KZ)) / MAXCOMP
NEXT KX
NEXT KZ


29
PRINT
PRINT "Calculated minimum and maximum stresses are: ";
PRINT USING " ####.#####"; MIN, MAX
INPUT "  Choose different minimum and maximum values [NO] "; CH$
IF CH$ = "" THEN GOTO 39
INPUT "Enter NEW minimum, maximum stresses are: "; MIN, MAX
CLS

39 'start plotting
'
CONT$ = ""
1001       CLS
            SCREEN 12
FOR I = 0 TO 10
            IF FLAGCOL <> 1 THEN COLNUM%(I) = 256 * I * 4 + (10 - I) * 6
NEXT I
FOR J = 1 TO 10
            IF FLAGCOL <> 1 THEN PALETTE J, COLNUM%(J)
NEXT J
      IF FLAGCOL <> 1 THEN PALETTE 1, 0

      DX = 400 / (23 + 2 * IFINE)
      IF SPLOT <> 1 THEN DZ = 126 * FY / 17
      IF SPLOT = 1 THEN DZ = (THICK / XSCALE) / 17
      
    ZTOP = -THICK / 18
FOR KZ = 2 TO 10
    Z = ZTOP + (KZ - 1) * THICK / 9
FOR KX = 1 TO 23

        X = (KX - 1) * LG * (XFINAL - XSTART) / 44
       
          IF ZRO$ = "w" THEN SNN = .5 * (S11(KX, KZ) + S22(KX, KZ))
          IF ZRO$ = "" THEN SNN = 1
          SINTENSE = ABS(.5 * (S11(KX, KZ) - S22(KX, KZ)) / SNN)
          IF ZRO$ = "w" THEN SINTENSE = SINTENSE - 1.5 * COHESION / ABS(S11(KX, KZ) + S22(KX, KZ))


        IF ZRO$ = "" AND (SINTENSE) < MAXBLACK THEN GOTO 334
       
        COL1 = 1.2 + 9 * ((SINTENSE) - MIN) / (MAX - MIN)
        IF COL1 < 1.2 THEN COL1 = 0

        IF ZRO$ <> "" AND SNN > 0 THEN COL1 = 10
        IF FLAGCOL = 1 THEN CALL SETCOL(COL1, COL2)
        IF FLAGCOL <> 1 THEN COL2 = COL1
        IF FLAGCOL <> 1 AND COL1 > 10 THEN COL2 = 10

        IF SPLOT <> 1 AND KX <> 1 AND KX <> (13 + IFINE) THEN LINE (XP(KX, KZ) + 20 - DX, (ZP(KX, KZ) + 50) * FY - DZ)-(XP(KX, KZ) + 20 + DX, (ZP(KX, KZ) + 50) * FY + DZ), COL2, BF
        IF SPLOT <> 1 AND KX = 1 THEN LINE (XP(KX, KZ) + 20, (ZP(KX, KZ) + 50) * FY - DZ)-(XP(KX, KZ) + 20 + DX, (ZP(KX, KZ) + 50) * FY + DZ), COL2, BF
        IF SPLOT <> 1 AND KX = (13 + IFINE) THEN LINE (XP(KX, KZ) + 20 - DX, (ZP(KX, KZ) + 50) * FY - DZ)-(XP(KX, KZ) + 20, (ZP(KX, KZ) + 50) * FY + DZ), COL2, BF
       
        IF SPLOT = 1 AND KX <> 1 AND KX <> (13 + IFINE) THEN LINE (XP(KX, KZ) + 20 - DX, (ZP(KX, KZ) + (440 - YSCALE - .85 * DZ) - DZ))-(XP(KX, KZ) + 20 + DX, (ZP(KX, KZ) + (440 - YSCALE - .85 * DZ)) + DZ), COL2, BF
        IF SPLOT = 1 AND KX = 1 THEN LINE (XP(KX, KZ) + 20, (ZP(KX, KZ) + (440 - YSCALE - .85 * DZ) - DZ))-(XP(KX, KZ) + 20 + DX, (ZP(KX, KZ) + (440 - YSCALE - .85 * DZ)) + DZ), COL2, BF
        IF SPLOT = 1 AND KX = (13 + IFINE) THEN LINE (XP(KX, KZ) + 20 - DX, (ZP(KX, KZ) + (440 - YSCALE - .85 * DZ) - DZ))-(XP(KX, KZ) + 20, (ZP(KX, KZ) + (440 - YSCALE - .85 * DZ)) + DZ), COL2, BF
       
        IF ZRO$ <> "" AND SPLOT <> 1 AND SNN > 0 THEN CIRCLE (XP(KX, KZ) + 20, (ZP(KX, KZ) + 50) * FY), 2, 0
        IF ZRO$ <> "" AND SPLOT = 1 AND SNN > 0 THEN CIRCLE (XP(KX, KZ) + 20, (ZP(KX, KZ) + (440 - YSCALE - .85 * DZ))), 2, 0
        IF ZRO$ <> "" AND SPLOT <> 1 AND SNN > 0 THEN CIRCLE (XP(KX, KZ) + 20, (ZP(KX, KZ) + 50) * FY), 1, 0
        IF ZRO$ <> "" AND SPLOT = 1 AND SNN > 0 THEN CIRCLE (XP(KX, KZ) + 20, (ZP(KX, KZ) + (440 - YSCALE - .85 * DZ))), 1, 0


334     IF SPLOT = 1 THEN LINE (XP(KX, KZ) + 20, (ZP(KX, KZ) + 440 - YSCALE - .85 * DZ))-(XPR2(KX, KZ) + 20, (ZPR2(KX, KZ) + 440 - YSCALE - .85 * DZ))
        IF SPLOT = 1 THEN LINE (XP(KX, KZ) + 20, (ZP(KX, KZ) + 440 - YSCALE - .85 * DZ))-(XPR3(KX, KZ) + 20, (ZPR3(KX, KZ) + 440 - YSCALE - .85 * DZ))

NEXT KX
NEXT KZ

IF SPLOT = 1 THEN GOTO 336
IF TRAJ$ = "" THEN GOTO 340

    ZTOP = -THICK / 2 - THICK / 18
FOR KZ = 2 TO 10
    Z = ZTOP + (KZ - 1) * THICK / 9
FOR KX = 1 TO (13 + IFINE)
        X = (KX - 1) * LG * (XFINAL - XSTART) / (24 + 2 * IFINE)
          XP = X * 800 / (LG * (XFINAL - XSTART))
          ZP = (Z + THICK / 2 + THICK / 18) * (126 * FY) / THICK
          XPR2 = XP + 40 * SIN(THET(KX, KZ)) * ABS(S22(KX, KZ)) / MAXCOMP
          ZPR2 = ZP - 40 * COS(THET(KX, KZ)) * ABS(S22(KX, KZ)) / MAXCOMP
          XPR3 = XP - 40 * SIN(THET(KX, KZ)) * ABS(S22(KX, KZ)) / MAXCOMP
          ZPR3 = ZP + 40 * COS(THET(KX, KZ)) * ABS(S22(KX, KZ)) / MAXCOMP

           LINE (XP + 20, ZP + 120)-(XPR2 + 20, ZPR2 + 120)
           LINE (XP + 20, ZP + 120)-(XPR3 + 20, ZPR3 + 120)
NEXT KX
NEXT KZ

GOTO 336



340 ZTOP = -THICK / 2 - THICK / 18
    FLAGX = 0
    FLAGZ = 0

FOR KZ = 1 TO 10 STEP .5
    Z = ZTOP + (KZ - 1) * THICK / 9

      FLAGX = 0

FOR KX = (13 + IFINE) TO 1 STEP -.1


        IF FLAGX = 0 THEN X = (KX - 1) * LG * (XFINAL - XSTART) / (24 + 2 * IFINE)

1630 Z0 = Z + THICK / 2
        Z1 = THICK - Z0
        SZT = (SR / LENG ^ 2) * (THICK ^ 2 - 2 * Z1 * THICK + Z1 ^ 2) + (Z0 * RHO)
        SXT = (SR * X ^ 2 / LENG ^ 2) + (POI / (1 - POI)) * Z0 * RHO * (X * (1 - X / LENG) / LENG)
        SXZT = (2 * SR / LENG ^ 2) * X * (-THICK + Z1)




        S1 = .5 * (SZT + SXT) + SQR(SXZT ^ 2 + .25 * (SXT - SZT) ^ 2)
        S2 = .5 * (SZT + SXT) - SQR(SXZT ^ 2 + .25 * (SXT - SZT) ^ 2)
              IF SXT = SZT THEN TET = 10000
              IF SXT = SZT AND SXT < 0 THEN TET = -10000
              IF SXT = SZT THEN THETA = ATN(TET) / 2
              IF SXT = SZT THEN GOTO 608
              TET = ABS(2 * SXZT / (SXT - SZT))
              THETA = ATN(TET) / 2
        IF SXT > SZT AND SXZT > 0 THEN GOTO 1608
        IF SXT > SZT AND SXZT < 0 THEN GOTO 1602
        IF SXT < SZT AND SXZT > 0 THEN GOTO 1603
        IF SXT < SZT AND SXZT < 0 THEN GOTO 1604
1602 THETA = -THETA
        GOTO 1608
1603 THETA = -THETA + PI / 2
        GOTO 1608
1604 THETA = THETA - PI / 2
1608
         
         XP = X * 800 / (LG * (XFINAL - XSTART))
         ZP = (Z + THICK / 2 + THICK / 18) * (126 * FY) / THICK
IF ZP > 310 OR XP < 1 OR XP > 400 OR ZP < 1 THEN GOTO 1610
        del = .1
          XPR2 = XP + 40 * SIN(THETA) * del
          ZPR2 = ZP - 40 * COS(THETA) * del
          XPR3 = XP - 40 * SIN(THETA) * del
          ZPR3 = ZP + 40 * COS(THETA) * del

           'LINE (XP + 20, ZP + 120)-(XPR2 + 20, ZPR2 + 120)
           LINE (XP + 20, ZP + 120)-(XPR3 + 20, ZPR3 + 120)
          X1 = XPR3 * (LG * (XFINAL - XSTART)) / 800
          Z1 = (ZPR3 * THICK / (126 * FY)) - THICK / 2 - THICK / 18
X = X1: Z = Z1
FLAGX = 1

IF ZP < 310 AND XP < 1 AND XP > 400 AND ZP < 1 THEN GOTO 1630

1610 NEXT KX


FLAGX = 0
FLAGZ = 1
NEXT KZ


336 IF SPLOT <> 1 THEN LINE (20, 57 * FY)-(420, 183 * FY), , B
    IF SPLOT = 1 THEN LINE (20, 440 - YSCALE)-(420, 440), , B

FOR J = 1 TO 10
    COL1 = 11.2 - J
    IF FLAGCOL = 1 THEN CALL SETCOL(COL1, COL2)
    IF FLAGCOL <> 1 THEN COL2 = 11 - J
        LINE (500, 140 + (J - 1) * 20)-(520, 140 + J * 20), COL2, BF
        LINE (500, 140 + (J - 1) * 20)-(520, 140 + J * 20), , B
NEXT J

    LOCATE 8, 60: PRINT "Highest Shear="
    LOCATE 9, 60: PRINT USING "##.##^^^^"; MAX
    LOCATE 22, 60: PRINT "Lowest Shear=";
    LOCATE 23, 60: PRINT USING "##.##^^^^"; MIN
    LOCATE 24, 60: PRINT "Shear intensity step=";
    LOCATE 25, 60: PRINT USING "##.##^^^^"; (MAX - MIN) / 10


'Plotting displacement field
   
FOR JX = 1 TO 41
FOR KZ = 1 TO 5
        IF SPLOT <> 1 THEN DZ = 57 * 2.4 + 31.4 * 2.4 * (KZ - 1)
        X = 10 + JX * 10
        X1 = X - UZ(JX, KZ) * XPLOT * FACT
        Y = DZ
        Y1 = Y - WZ(JX, KZ) * XPLOT

             IF SPLOT <> 1 THEN LINE (X, Y)-(X1, Y1)
        IF JX = 41 THEN GOTO 113
        X = 10 + (JX + 1) * 10
        X2 = X - UZ((JX + 1), KZ) * XPLOT * FACT
        Y2 = Y - WZ((JX + 1), KZ) * XPLOT
          IF SPLOT <> 1 THEN LINE (X1, Y1)-(X2, Y2)
NEXT KZ
113 NEXT JX
FOR I = 1 TO 11
             LINE (20 + 40 * (I - 1), 186 * FY)-(20 + 40 * (I - 1), 183 * FY)
NEXT I
  
    VER = THICK / (126 * 2.4): HOR = LG / 800
    VERT1 = VERT + .00001
    DOWN = VERT * 25: SIDE = DOWN * HORIZ / VERT1
    SIDE = SIDE / HOR

    LOCATE 29, 1: PRINT XSTART * LG / 2; " m ";
    LOCATE 29, 51: PRINT XFINAL * LG / 2; " m ";
    ILINE = INT((440 - YSCALE) * 31 / 480)
    IF SPLOT = 1 THEN LOCATE ILINE, 56: PRINT "0 m"
    IF SPLOT <> 1 THEN LOCATE 9, 56: PRINT "0 m"
    LOCATE 28, 56: PRINT "-"; THICK; "m"
    LOCATE 5, 54

    LOCATE 1, 1
    IF NAME$ = "" THEN NAME$ = "DEFAULT"
    IF ZSTR$ = "S" THEN PRINT "Stress field in an overthrust layer.                "; DATE$
    IF ZSTR$ = "S" THEN PRINT "Length: "; LENG; "m, Height: "; THICK; "m, Poisson's: "; POI; " Density: ";
    IF ZSTR$ = "S" THEN PRINT USING " #### "; -RHO * 100000;
    IF ZSTR$ = "S" THEN PRINT " kg/m3"
    IF ZSTR$ = "S" THEN PRINT "Load on right side: "; SR; "MPa, Uniform load: "; PCONF; "MPa."
    IF ZSTR$ = "E" THEN PRINT "Displ./strain, Layer "; LAYER; ", "; NAME$; ", Basal displ.: "; FA$; "  "; DATE$
    IF ZRO$ = "" THEN PRINT "Short lines: trend + magnitude of max. compression. "
    IF ZRO$ <> "" THEN PRINT "Short lines: trend/mag.  max. compres. Circles: Tensile mean pressure."
    IF ZRO$ = "" AND ZSTR$ = "S" THEN PRINT "Shear stress:";
    IF ZRO$ <> "" AND ZSTR$ = "S" THEN PRINT "Shear/overburden:";
    IF ZSTR$ = "E" THEN PRINT "Shear strain:";
    PRINT "MAX. in X,Z square:"; XMAX; ","; ZMAX; "& MIN. in  X,Z square:"; XMIN; ","; ZMIN
    IF ZSTR$ = "S" THEN INPUT "Stress option-hit 1, Change colors-hit C, [Plot stress trends]"; CONT$
    IF ZSTR$ = "E" THEN INPUT "[Plot compression trends + displacements]"; CONT$
    IF CONT$ = "c" OR CONT$ = "C" THEN CONT$ = "C"
    IF CONT$ = "C" AND FLAGCOL = 1 THEN GOTO 1202
    IF CONT$ = "C" AND FLAGCOL = 0 THEN FLAGCOL = 1
    GOTO 1203
1202    FLAGCOL = 0
1203    IF CONT$ = "1" THEN GOTO 208

1201 'PLOTTING PRINCIPAL AXES
      CLS
      SCREEN 12
      DX = INT(400 / 43)
      DZ = INT(126 * FY / 17)
      LINE (20, 57 * FY)-(420, 183 * FY), , B

'Plotting the displacement field on the screen
  
FOR JX = 1 TO 41
FOR KZ = 1 TO 5
        DZ = 57 * 2.4 + 31.4 * 2.4 * (KZ - 1)
        X = 10 + JX * 10
        X1 = X - UZ(JX, KZ) * XPLOT * FACT
        Y = DZ
        Y1 = Y - WZ(JX, KZ) * XPLOT
             LINE (X, Y)-(X1, Y1)
        IF JX = 41 THEN GOTO 115
        X = 10 + (JX + 1) * 10
        X2 = X - UZ((JX + 1), KZ) * XPLOT * FACT
        Y2 = Y - WZ((JX + 1), KZ) * XPLOT
          LINE (X1, Y1)-(X2, Y2)

115 NEXT KZ
NEXT JX
        LINE (20, 183 * FY)-(420, 183 * FY)
FOR I = 1 TO 11
             LINE (20 + 40 * (I - 1), 186 * FY)-(20 + 40 * (I - 1), 183 * FY)
NEXT I

    ZTOP = -THICK / 2 - THICK / 18
FOR KZ = 2 TO 10
    Z = ZTOP + (KZ - 1) * THICK / 9
FOR KX = 1 TO (13 + IFINE)
        X = (KX - 1) * LG * (XFINAL - XSTART) / (24 + 2 * IFINE)
          XP = X * 800 / (LG * (XFINAL - XSTART))
          ZP = (Z + THICK / 2 + THICK / 18) * (126 * FY) / THICK
          XPR2 = XP + 10 * SIN(THET(KX, KZ))
          ZPR2 = ZP - 10 * COS(THET(KX, KZ))
          XPR3 = XP - 10 * SIN(THET(KX, KZ))
          ZPR3 = ZP + 10 * COS(THET(KX, KZ))
           LINE (XP + 20, ZP + 120)-(XPR2 + 20, ZPR2 + 120)
           LINE (XP + 20, ZP + 120)-(XPR3 + 20, ZPR3 + 120)
NEXT KX
NEXT KZ
    VER = THICK / (126 * 2.4): HOR = LG / 800
    VERT1 = VERT + .00001
    DOWN = VER * 40: SIDE = DOWN * HORIZ / VERT1
    SIDE = SIDE / HOR


    LOCATE 29, 1: PRINT XSTART * LG / 2; " m ";
    LOCATE 29, 51: PRINT XFINAL * LG / 2; " m ";
    LOCATE 9, 56: PRINT "0 m"
    LOCATE 28, 56: PRINT "-"; THICK; "m"

    LOCATE 1, 1
    IF NAME$ = "" THEN NAME$ = "DEFAULT"
    PRINT "Stress orientations in overthrust layer.                  "; DATE$
    PRINT " Short lines: trend of axes of maximum compression (magnitudes not indicated)."
    PRINT " Mean ratio of {shear stress/(normal stress - pore pressure} on the base"
    PRINT "  of the block is:";
    PRINT USING " #.### "; ABS(BASAL / KBASE);
    PRINT "  Note:  pore pressure factor is "; LAM
    IF ZSTR$ = "S" THEN INPUT "1-to stop, any key to restart calculations [Re-plot stress field] "; CONT$
    IF ZSTR$ = "E" THEN INPUT "1-to stop, any key to restart calculations [Re-plot stress field] "; CONT$
    IF CONT$ = "1" THEN GOTO 211
    IF CONT$ = "" THEN GOTO 29
    IF CONT$ <> "" THEN GOTO 12

208 CLS
    PRINT "The stress intensity maps have two plotting options:"
    PRINT "  1. Byerlee parameter BLF = ("; CHR$(229); "1 - "; CHR$(229); "3) / ("; CHR$(229); "1 + "; CHR$(229); "3)"
    PRINT "  2. {local maximum shear stress = 0.5 ("; CHR$(229); "1 - "; CHR$(229); "3)} (MPa)"
    PRINT
    PRINT "Stress intensity plotting is set for"
    IF ZRO$ <> "" THEN GOTO 209
    IF ZRO$ = "" THEN PRINT "                  {local maximum shear stress} "
    PRINT "You can change plotting parameter to BLF = ("; CHR$(229); "1 - "; CHR$(229); "3) / ("; CHR$(229); "1 + "; CHR$(229); "3)"
    PRINT "     According to Byerlee friction law,"; CHR$(231); " = 0.85 "; CHR$(229); "n; thus:"
    PRINT "     when BLF = 0.65  frictional shear occurs along ideally oriented fractures, "
    PRINT "     when 0.65 "; CHR$(243); " BLF "; CHR$(243); " 1, shear occurs also along poorly oriented fractures,"
    PRINT "     when BLF > 1, "; CHR$(229); "3 is tensile and tensile fractures are expected."
       
        INPUT "Change to BLF now-any key [NO]"; YS$
        IF YS$ <> "" THEN ZRO$ = "w"
        GOTO 210


209     PRINT "      the ratio BLF = ("; CHR$(229); "1 - "; CHR$(229); "3) / ("; CHR$(229); "1 + "; CHR$(229); "3)"
        INPUT "Change plotting to {local maximum shear stress} - any letter [NO CHANGE]"; YS$
        IF YS$ <> "" THEN ZRO$ = ""

        PRINT
210    CONT$ = ""
    STOPDISP = 1
    IF CONT$ = "" THEN GOTO 605
211 '
END SUB

SUB SETCOL (COL1, COL2) '

IF COL1 <= 1.5 THEN COL2 = 0
IF COL1 <= 2.5 AND COL1 > 1.5 THEN COL2 = 14
IF COL1 <= 3.5 AND COL1 > 2.5 THEN COL2 = 7
IF COL1 <= 4.5 AND COL1 > 3.5 THEN COL2 = 10
IF COL1 <= 5.5 AND COL1 > 4.5 THEN COL2 = 8
IF COL1 <= 6.5 AND COL1 > 5.5 THEN COL2 = 13
IF COL1 <= 7.5 AND COL1 > 6.5 THEN COL2 = 12
IF COL1 <= 8.5 AND COL1 > 7.5 THEN COL2 = 5
IF COL1 <= 9.5 AND COL1 > 8.5 THEN COL2 = 9
IF COL1 > 9.5 THEN COL2 = 1

END SUB

