CLS
PRINT "***       INPUT OF CALCITE TWIN DATA FROM U-STAGE            **"
PRINT "***    A BASIC PROGRAM FOR IBM-PC BY ZE'EV RECHES, FEB.1992  **"
30 DIM e#(6, 6), F#(6), R#(100), R2#(100), x#(6), CO(100), COMIN(100)
   DIM DF#(100), DD#(100), SP#(100), ST#(100), SS(100), FC(100), ST(100), DD(100)
   DIM N1#(100), N2#(100), N3#(100), S1#(100), S2#(100), S3#(100), IFAULT(100)
   DIM A#(100, 6), B1#(100), B2#(100), B3#(100), B#(100), ROTAT(100), K1#(100), K2#(100), K3#(100)
   DIM BW(10), BW1(10), BW2(10), BD(100), BF(100), DFR(100), DDR(100), SPR(100), STR(100)
40 PI# = 4 * ATN(1!): COUNT = 0: PI = PI#
   NA = 0
   PRINT
   COLOR (2)
117 PRINT
    PRINT "This program records, calculates and plots measurements of calcite "
    PRINT "  deformation twins in the 'dynamic' method (Turner & Wiess, 1953)."
    PRINT "It is assumed that measurements are conducted with a 5-axes universal "
    PRINT "  stage (Ziess or similar).  The program eliminates the need for plotting"
    PRINT "  and angles determinations on the stereonet."
    PRINT
    PRINT "Data and results are saved in three files (opened in the default directory):"
    PRINT "   *.RAW  with the raw input data as entered by user,"
    PRINT "   *.TWN  with ALL input data and calculations results,"
    PRINT "   *.STR  with slip surfaces (e-lamella), and the calculated "
    PRINT "          slip axes.  This file can be used for stress inversion."
    PRINT
    INPUT "Enter FILENAME, do not include .EXT (appended by program) [TWINTEMP] "; A$
    IF A$ = "" THEN A$ = "TWINTEMP"
    BADOT = INSTR(A$, ".")
    IF BADOT > 0 THEN RA$ = LEFT$(A$, BADOT - 1)
    IF BADOT = 0 THEN RA$ = A$
    H$ = RA$ + ".TWN"
    XH$ = RA$ + ".RTL"
    ST$ = RA$ + ".STR"
    PL$ = RA$ + ".PLT"
    RAW$ = RA$ + ".RAW"
    PRINT
    OPEN H$ FOR OUTPUT AS #3
    PRINT #3, "All data collected during calcite twinning measurements"
    PRINT #3, "Number, e/C angle, dip/direction of e-plane, plunge/trend of C-axis, plunge/trend of slip, plunge/trend Sig1, plunge/trend Sig3"
    CLOSE #3
    OPEN ST$ FOR OUTPUT AS #4
    PRINT #4, "Calcite twinning data to be used in stress inversion."
    PRINT #4, "The e-plane is equivalent to the fault surface with the slip axis"
    PRINT #4, "Each line:  dip amou'/dip dir' of e-plane, plunge/trend of slip axis"
    CLOSE #4
   
    OPEN RAW$ FOR OUTPUT AS #5
    PRINT #5, "Raw Data as typed: plunge/trend of normal to e-plane, plunge/trend of c axis"
    CLOSE #5
    PRINT "Enter angle of microscope-base corona when thin-section is set"
    INPUT "    in N-S direction [0 degrees] "; DS
    PRINT
     PRINT
     PRINT
     PRINT

    PRINT "Each data entry contains FOUR numbers separated by commas. Azimuth convention"
    PRINT "  with respect to microscope is assumed (N forward, E right, W left)."
    PRINT "First pair of numbers are PLUNGE, TREND of pole to e-lamella."
    PRINT " Note: 1. Set the e-plane vertical with its strike parallel to N-S axis "
    PRINT "       of the microscope; pole is horizontal in E-W direction."
    PRINT "       2. Microscope base tilt is PLUNGE, and microscope corona angle is TREND."
    PRINT "       3. Plunge is NEGATIVE when microscope base tilts to the left,"
    PRINT "       and is POSITIVE when microscope base tilts to the right"
    PRINT "Second pair of numbers are PLUNGE, TREND of C-axis:"
    PRINT " Note: 1. Set C-axis at horizontal position and parallel the E-W axis."
    PRINT "       2. Microscope base tilt is PLUNGE, and microscope corona angle is TREND."
    PRINT "       3. Plunge is NEGATIVE when microscope base tilts to the left,"
    PRINT "       and is POSITIVE when microscope base tilts to the right"
    COLOR (4)
    PRINT "After entering the measurements, the program returns a line with six items:"
    PRINT "e-lam   C-axs  e^C   Slip   "; CHR$(229); "1   "; CHR$(229); "3 "
    PRINT " where: 'e-lam' plunge/trend of pole to e-lamella"
    PRINT "        'C-axs' plunge/trend of C axis of the host calcite grain"
    PRINT "        'e^C'   angle between C axis and the e-lamella;  e^C=26"; CHR$(248)
    PRINT "        'Slip'  plunge/trend of slip axis on the e-lamella"
    PRINT "        "; CHR$(229); "1, "; CHR$(229); "3 the calculated principal stresses."
    PRINT "To finish: enter 999,1,1,1"
    PRINT
    COLOR (2)
    INPUT "Ready [YES] "; Y$
    CLS
    GOSUB 660
    LOCATE 1, 1
    COLOR (2)
    PRINT "e-lam   C-axs  e^C   Slip   "; CHR$(229); "1     "; CHR$(229); "3 "
    FOR I = 1 TO 100
140 OPEN H$ FOR APPEND AS #3
    OPEN ST$ FOR APPEND AS #4
    OPEN RAW$ FOR APPEND AS #5
    IF I <= 15 THEN JC = I
    IF I > 15 THEN JC = 15

    LOCATE 3, 1
    COLOR (JC)
    PRINT "Note data format:"
    PRINT "  plunge,trend(e-lam),plunge,trend(C-x)"

    PRINT "Enter set "; I;
    LOCATE 5, 13
    PRINT "                             "
    PRINT "                              "
    PRINT "                             "
    PRINT "                            "
    LOCATE 5, 14
    INPUT DF#(I), DD#(I), SP#(I), ST#(I)
    PRINT #5, DF#(I), DD#(I), SP#(I), ST#(I)
    LOCATE (2 + I), 30
    IF DF#(I) = 999 THEN GOTO 150
    DD#(I) = -DD#(I) + DS + 270: ST#(I) = -ST#(I) + DS + 270
    SIGNI = SGN(DF#(I)) * SGN(SP#(I))
    IF DF#(I) < 0 THEN DD#(I) = DD#(I) - 180
    IF SP#(I) < 0 THEN ST#(I) = ST#(I) - 180
    IF DF#(I) < 0 THEN DF#(I) = -DF#(I)
    IF SP#(I) < 0 THEN SP#(I) = -SP#(I)
    IF ST#(I) < 0 THEN ST#(I) = 360 + ST#(I)
    IF DD#(I) < 0 THEN DD#(I) = 360 + DD#(I)

DF#(I) = 90 - DF#(I): DD#(I) = DD#(I) + 180
IF DD#(I) > 360 THEN DD#(I) = DD#(I) - 360

300 N1#(I) = COS(DD#(I) * PI# / 180) * SIN(DF#(I) * PI# / 180)
310 N2#(I) = SIN(DD#(I) * PI# / 180) * SIN(DF#(I) * PI# / 180)
325 N3#(I) = COS((180 - DF#(I)) * PI# / 180)
330 S1#(I) = COS(ST#(I) * PI# / 180) * SIN((SP#(I) + 90) * PI# / 180)
340 S2#(I) = SIN(ST#(I) * PI# / 180) * SIN((SP#(I) + 90) * PI# / 180)
350 S3#(I) = -COS((SP#(I) + 90) * PI# / 180)

    B1#(I) = N2#(I) * S3#(I) - N3#(I) * S2#(I)
    B2#(I) = N3#(I) * S1#(I) - N1#(I) * S3#(I)
    B3#(I) = N1#(I) * S2#(I) - N2#(I) * S1#(I)
     BTT = SQR(B1#(I) ^ 2 + B2#(I) ^ 2 + B3#(I) ^ 2)
     B1#(I) = B1#(I) / BTT: B2#(I) = B2#(I) / BTT: B3#(I) = B3#(I) / BTT

    K1#(I) = B2#(I) * N3#(I) - B3#(I) * N2#(I)
    K2#(I) = B3#(I) * N1#(I) - B1#(I) * N3#(I)
    K3#(I) = B1#(I) * N2#(I) - B2#(I) * N1#(I)
    KS = SQR(K1#(I) ^ 2 + K2#(I) ^ 2 + K3#(I) ^ 2)
     K1#(I) = K1#(I) / KS: K2#(I) = K2#(I) / KS: K3#(I) = K3#(I) / KS

     L1 = K1#(I): L2 = K2#(I): L3 = K3#(I)
     IF K3#(I) > 0 THEN GOTO 4579
     L1 = -K1#(I): L2 = -K2#(I): L3 = -K3#(I)
4579 ALPHA = ATN(L2 / L1)
     IF L1 < 0 THEN ALPHA = PI + ALPHA
     IF L2 < 0 AND L1 > 0 THEN ALPHA = 2 * PI + ALPHA
     ALPHA = (180 * ALPHA / PI)
     IF L3 = 1 THEN L3 = .9999
     DIP = ATN(L3 / SQR(1 - L3 ^ 2))
     DIP = 180 * DIP / PI
   
    LOCATE 2, 1
    PRINT "                                          "
    LOCATE 2, 1
    COLOR (JC)
    RT1 = ABS(S1#(I) * N1#(I) + S2#(I) * N2#(I) + S3#(I) * N3#(I))
    IF RT1 >= 1 THEN RT1 = .99999
    RT1 = PI / 2 - ATN(RT1 / SQR(1 - RT1 ^ 2))
    RT1 = ABS(RT1 * 180 / PI#)
    PRINT USING "##"; ABS(INT(DF#(I) + .5));
    PRINT "/";
    PRINT USING "### "; INT(DD#(I) + .5);
    PRINT USING "###"; ABS(INT(SP#(I) + .5));
    PRINT "/";
    PRINT USING "### "; INT(ST#(I) + .5);
    PRINT USING "## "; (INT(100 * RT1) / 100);
   
    SLIPAXIS = -SGN(K3#(I)) * SIGNI
    PRINT USING "###"; SLIPAXIS * INT(DIP + .5);
     PRINT "/";
     PRINT USING "### "; INT(ALPHA + .5);
     GOSUB 8000
    
     L1 = G31: L2 = G32: L3 = G33
     IF G33 > 0 THEN GOTO 4581
     L1 = -G31: L2 = -G32: L3 = -G33
4581 IF ABS(L1) < .0001 THEN L1 = SGN(L1) * .0001
     ALPHA3 = ATN(L2 / L1)
     IF L1 < 0 THEN ALPHA3 = PI + ALPHA3
     IF L2 < 0 AND L1 > 0 THEN ALPHA3 = 2 * PI + ALPHA3
     ALPHA3 = (180 * ALPHA3 / PI)
     IF L3 = 1 THEN L3 = .9999
     DIP3 = ATN(L3 / SQR(1 - L3 ^ 2))
     DIP3 = 180 * DIP3 / PI
     PRINT USING "##"; INT(DIP3 + .5);
     PRINT "/";
     PRINT USING "### "; INT(ALPHA3 + .5);

     L1 = G11: L2 = G12: L3 = G13
     IF G13 > 0 THEN GOTO 4580
     L1 = -G11: L2 = -G12: L3 = -G13
4580 IF ABS(L1) < .0001 THEN L1 = SGN(L1) * .0001
     ALPHA1 = ATN(L2 / L1)
     IF L1 < 0 THEN ALPHA1 = PI + ALPHA1
     IF L2 < 0 AND L1 > 0 THEN ALPHA1 = 2 * PI + ALPHA1
     ALPHA1 = (180 * ALPHA1 / PI)
     IF L3 = 1 THEN L3 = .9999
     DIP1 = ATN(L3 / SQR(1 - L3 ^ 2))
     DIP1 = 180 * DIP1 / PI
     PRINT USING "##"; INT(DIP1 + .5);
     PRINT "/";
     PRINT USING "### "; INT(ALPHA1 + .5);

    LOCATE 6, 1
    INPUT "Confirm before plotting [OK]"; Y$
COLOR (JC)
    LOCATE 9, 1
    PRINT "                "
    FTWIN = 0
   ' PRINT I, RT1, DF#(I), DD#(I), SP#(I), ST#(I), DIP + .5, ALPHA + .5, DIP3, ALPHA3, DIP1, ALPHA1
    IF Y$ = "" THEN PRINT #3, I, RT1, DF#(I), DD#(I), SP#(I), ST#(I), INT(10 * SLIPAXIS * (DIP + .5)) / 10, INT(10 * (ALPHA + .5)) / 10, DIP3, ALPHA3, DIP1, ALPHA1
    CLOSE #3
    IF Y$ = "" THEN PRINT #4, DF#(I), DD#(I), INT(10 * SLIPAXIS * (DIP + .5)) / 10, INT(10 * (ALPHA + .5)) / 10
    CLOSE #4
    CLOSE #5
    IF Y$ = "" THEN FTWIN = 1
    IF Y$ = "" THEN GOSUB 680
    IF Y$ <> "" THEN PRINT " Re-measure!"
    IF Y$ <> "" THEN GOTO 140
    NEXT I
150 CLOSE
    LOCATE 7, 1
    PRINT "MUST END!"
    PRINT "GRAB PLOT!!"
    INPUT "End [YES] "; Y$
    IF Y$ = "" THEN STOP


'  The stereographic projection
     
660 CLS : SCREEN 12
'  The circle
    XFACT = 1
    'IF XFACT5 = 5 THEN GOTO 661
    FOR I = 1 TO 720
    ANN = 2 * PI / 720
    AN = ANN * I
    x = 200 * SIN(AN)
   Y = 200 * COS(AN)
    x = 400 + XFACT * x
    Y = 240 + Y
    PSET (x, Y)
    NEXT I
   
    AN = ANN * (720 - DS * 2)
    x = 200 * SIN(AN)
    Y = 200 * COS(AN)
    x = 400 + XFACT * x
    Y = 240 + Y
    X1 = 200 * 1.1 * SIN(AN)
    Y1 = 200 * 1.1 * COS(AN)
    X1 = 400 + XFACT * X1
    Y1 = 240 + Y1
    LINE (x, Y)-(X1, Y1)

    I = 1
661 IF XFACT5 = 5 THEN CIRCLE (400, 99.5), 238
    LINE (400 - 200, 240)-(400 + 200, 240)
    LINE (400, 40)-(400, 440)
    IF KBOOT <> 0 THEN RETURN
     
'   Plotting the data points
     
680 FLAG = 1
    IF S3#(I) < 0 THEN FLAG = 0
    N11 = -N1#(I): N22 = -N2#(I): N33 = -N3#(I)
    S11 = -S1#(I): S22 = -S2#(I): S33 = -S3#(I)
    RR# = SQR(N11 ^ 2 + N22 ^ 2)
    IF RR# < .000001 THEN GOTO 805
    XN# = N22 * 200 * SQR(2) * SIN(DF#(I) * PI# / 360) / RR#
    YN# = 240 - N11 * 200 * SQR(2) * SIN(DF#(I) * PI# / 360) / RR#
    RS = SQR(S11 ^ 2 + S22 ^ 2)
    IF RS < .000001 THEN GOTO 805
    XS# = -S22 * 200 * SQR(2) * SIN((90 - ABS(SP#(I))) * PI# / 360) / RS
    YS# = 240 + S11 * 200 * SQR(2) * SIN((90 - ABS(SP#(I))) * PI# / 360) / RS
    IF FLAG = 0 THEN XS# = S22 * 200 * SQR(2) * SIN((90 - ABS(SP#(I))) * PI# / 360) / RS
    IF FLAG = 0 THEN YS# = 240 - S11 * 200 * SQR(2) * SIN((90 - ABS(SP#(I))) * PI# / 360) / RS
    CIRCLE (400 + XFACT * XN#, YN#), 1
    IF FLAG = 0 THEN CIRCLE (400 + XFACT * XS#, YS#), 1
    IF FLAG = 0 THEN CIRCLE (400 + XFACT * XS#, YS#), 2
    IF FLAG = 0 THEN CIRCLE (400 + XFACT * XS#, YS#), 3
    IF FLAG = 1 THEN CIRCLE (400 + XFACT * XS#, YS#), 3
    IF FTWIN = 1 THEN RETURN
    x = 400 + XFACT * XS#
    Y = YS#
799    IF FTWIN = 1 THEN RETURN
     
805 KCONF = 0
     
'   Printing (on screen) the legend for sense of slip.

    LOCATE 13, 1: PRINT "POLE TO e-TWIN"
    CIRCLE (130, 198), 1

    PRINT "C-AXIS"
    CIRCLE (130, 216), 3
    GOTO 807

806 PRINT "SLIP normal"
    
807  LOCATE 23, 1
    PRINT "File: "; A$
    PRINT DATE$
    PRINT "To STOP: enter  999,1,1,1"
    IF KP = 9 THEN PRINT "FRICTION ";
    IF KP = 9 THEN PRINT USING "#.#"; MF;
    LOCATE 1, 43: PRINT "Equal area plot of e-planes & C-axes"

850 G$ = INKEY$
    IF G$ = "" THEN GOTO 850
RETURN


8000 RT = ABS(K1#(I) * N1#(I) + K2#(I) * N2#(I) + K3#(I) * N3#(I))
     IF RT >= 1 THEN RT = .99999
     RT = PI / 2 - ATN(RT / SQR(1 - RT ^ 2))
     RT = ABS(RT * 180 / PI#)
     MU = 0
     ALP = ATN(MU)
     ALP = PI / 4 - ALP / 2
     ALP1 = ALP * RT / 90
     ALP2 = RT * PI# / 180 - ALP1
     IF SIGNI < 1 THEN K1#(I) = -K1#(I)
     IF SIGNI < 1 THEN K2#(I) = -K2#(I)
     IF SIGNI < 1 THEN K3#(I) = -K3#(I)
     G11 = -N1#(I) * COS(ALP2) + K1#(I) * COS(ALP1)
     G12 = -N2#(I) * COS(ALP2) + K2#(I) * COS(ALP1)
     G13 = -N3#(I) * COS(ALP2) + K3#(I) * COS(ALP1)
     GTT = SQR(G11 ^ 2 + G12 ^ 2 + G13 ^ 2)
     G11 = G11 / GTT: G12 = G12 / GTT: G13 = G13 / GTT
     G31 = G12 * B3#(I) - G13 * B2#(I)
     G32 = G13 * B1#(I) - G11 * B3#(I)
     G33 = G11 * B2#(I) - G12 * B1#(I)
     GTT = SQR(G31 ^ 2 + G32 ^ 2 + G33 ^ 2)
     G31 = G31 / GTT: G32 = G32 / GTT: G33 = G33 / GTT

     G21 = B1#(I)
     G22 = B2#(I)
     G23 = B3#(I)
     RETURN

