'
'    ESHELBY 1.2, May, 1997
'
'Programming:   Ze'ev Reches
       
        DEFINT I-K
        DEFINT N, X-Z
        DEFDBL A-F, L-M, O-W
        DEFSTR H
   DECLARE FUNCTION ACOS# (AX#)
   DECLARE SUB PRINCIP (SXI#, SYI#, SZI#, SXYI#, SXZI#, SYZI#)
   DECLARE SUB INVERSE (N, A(), AINV(), IER)
   DECLARE SUB MATXMAT (A(), B(), C(), X, Y, Z)
   DECLARE SUB MOHR (SI(), SM(), A1EL, A2EL, A3EL, HNAME$, HMURA$)
   DECLARE SUB STEREO (HTITLE$, DAT(), BK1#, BK2#, BK3#, L1#, L2#, L3#, M1#, M2#, M3#)
'    SCREEN 12
'    GR = 63 * 256: RD = 63: WH = 65536 * 63 + 256 * 63 + 63: WYL = 65536 * 20 + 256 * 55 + 55
'    PALETTE 0, WH: PALETTE 15, 65536 * 63
'    PALETTE 0, 0: PALETTE 15, WYL
ON ERROR GOTO 7500

    CLS : COLOR (4): LOCATE 1, 20
    FOR I = 1 TO 36
        PRINT CHR$(219);
    NEXT I
    LOCATE 2, 20
    FOR I = 1 TO 36
        PRINT CHR$(219);
    NEXT I
    LOCATE 3, 20
    FOR I = 1 TO 36
        PRINT CHR$(219);
    NEXT I

    LOCATE 2, 33: COLOR (15)
    PRINT "ESHELBY"
    LOCATE 5, 1
    COLOR (2): PRINT "             3-D STRESSES IN ELLIPSOIDAL ELASTIC INCLUSIONS"
    PRINT
    COLOR (6)
    COLOR (9)
    PRINT "       A QuickBasic program by Ze'ev Reches following Eidelman, 1995"
    PRINT "                        Version 1.2, May, 1997"
    PRINT
    COLOR (15)
    FACT = 1
    PRINT "This is an interactive program that prompts for input and suggests defaults."
    PRINT "Defaults appear in [SQUARE BRACKETS] to be activated by hitting RETURN. "
    'INPUT "To read rights/disclaimer/instructions/bibliography- hit any letter [CONTINUE] "; Y$
    PRINT
PRINT "The program calculates the elastic stresses within an ellipsoidal inclusion"
PRINT "  embedded in elastic medium; the later is subjected to 3-D stresses."
PRINT "The original derivations were by Eshelby (1957); present formulations:"
PRINT "  Prolate (cigar-shape) & oblate (penny-shape) inclusions (Zhao & Weng, 1991),"
PRINT "  Fiber inclusion (very long elliptical inclusion) (Mura, 1982)."
PRINT "The solution depends on the aspect ratio of the inclusion and does not depend "
PRINT "  on the actual dimensions."
PRINT
PRINT
INPUT "Ready [YES] "; OK


30 REDIM BW(10), BW1(10), BW2(10), DAT(15), LT(6, 6), LT1(6, 6), LT2(6, 6), CM(6, 6)
   REDIM LM(6, 6), LI(6, 6), SE(6, 6), SIGR(6), SIGI(G), LMINV(6, 6), SI(3), SM(3)
   REDIM T(6, 6), LIN(6, 6), TEMP(6, 6), W(6, 6), WTEMP(6, 6), SREM(6, 1), SINC(6, 1)
   PI = 4 * ATN(1!): COUNT = 0: SMARK = 0: NA = 0: XFACT = 1
    CLS : SCREEN 12: COLOR (2): PRINT
    PRINT "   CALCULATIONS OF THE STRESS COMPONENTS IN AN ESHELBY INCLUSION"
        PRINT
        INPUT "Enter problem or user name [DEFAULT] "; HNAME$
        IF HNAME$ = "" THEN HNAME$ = "DEFAULT"
    HA$ = "ESHEL.OUT"
    OPEN HA$ FOR APPEND AS #3
    PRINT #3, "Run "; HNAME$; ", "; TIME$; "  "; DATE$
    PRINT #3, "Three axes, Young: Inclusion/matrix, Poisson: matrix, inclusion, Principal stresses: matrix, inclusion, Principal axes (degrees): matrix, inclusion"
    CLOSE #3


        INPUT "Do you wish to see intermediate results on screen [NO] "; HS$
        EOUNGI = 1E+11: POISSONI = .2
        PRINT "Young modulus, Poisson's ratio of the INCLUSION: ";
        PRINT USING "##.##^^^^,"; EOUNGI;
        PRINT USING "  #.##"; POISSONI
       
        INPUT " CHANGE? [NO] "; H$
        IF H$ = "" THEN GOTO 13
        INPUT "New INCLUSION parameters are: Young modulus, Poisson's "; EOUNGI, POISSONI
13 EOUNGM = 1E+10: POISSONM = .4
        PRINT "Young modulus, Poisson's ratio of the MATRIX: ";
        PRINT USING "##.##^^^^,"; EOUNGM;
        PRINT USING "  #.##"; POISSONM
        INPUT " CHANGE? [NO] "; H$
        IF H$ = "" THEN GOTO 14
        INPUT "New MATRIX parameters are: Young modulus, Poisson's "; EOUNGM, POISSONM
14 LAMDAI = EOUNGI * POISSONI / ((1 + POISSONI) * (1 - 2 * POISSONI))
        MUI = EOUNGI / (2 * (1 + POISSONI))
        LAMDAM = EOUNGM * POISSONM / ((1 + POISSONM) * (1 - 2 * POISSONM))
        MUM = EOUNGM / (2 * (1 + POISSONM))
        LI(1, 1) = LAMDAI + 2 * MUI: LI(1, 2) = LAMDAI: LI(1, 3) = LAMDAI
        LI(2, 1) = LAMDAI: LI(2, 2) = LAMDAI + 2 * MUI: LI(2, 3) = LAMDAI
        LI(3, 1) = LAMDAI: LI(3, 2) = LAMDAI: LI(3, 3) = LAMDAI + 2 * MUI
        LI(4, 4) = 2 * MUI: LI(5, 5) = 2 * MUI: LI(6, 6) = 2 * MUI

        LM(1, 1) = LAMDAM + 2 * MUM: LM(1, 2) = LAMDAM: LM(1, 3) = LAMDAM
        LM(2, 1) = LAMDAM: LM(2, 2) = LAMDAM + 2 * MUM: LM(2, 3) = LAMDAM
        LM(3, 1) = LAMDAM: LM(3, 2) = LAMDAM: LM(3, 3) = LAMDAM + 2 * MUM
        LM(4, 4) = 2 * MUM: LM(5, 5) = 2 * MUM: LM(6, 6) = 2 * MUM

        CM(1, 1) = 1 / EOUNGM: CM(1, 2) = -POISSONM / EOUNGM: CM(1, 3) = -POISSONM / EOUNGM
        CM(2, 1) = -POISSONM / EOUNGM: CM(2, 2) = 1 / EOUNGM: CM(2, 3) = -POISSONM / EOUNGM
        CM(3, 1) = -POISSONM / EOUNGM: CM(3, 2) = -POISSONM / EOUNGM: CM(3, 3) = 1 / EOUNGM
        CM(4, 4) = 1 / (2 * MUM): CM(5, 5) = 1 / (2 * MUM): CM(6, 6) = 1 / (2 * MUM)

'Printing intermediate results

IF HS$ <> "" THEN PRINT "THE MATRIX  LI() "
IF HS$ <> "" THEN PRINT
FOR I = 1 TO 6
FOR J = 1 TO 6
IF HS$ <> "" THEN PRINT USING "  +#.###^^^^"; LI(I, J);
NEXT J
IF HS$ <> "" THEN PRINT
NEXT I
IF HS$ <> "" THEN INPUT OK
IF HS$ <> "" THEN PRINT
IF HS$ <> "" THEN PRINT "THE MATRIX  LM() "
IF HS$ <> "" THEN PRINT
FOR I = 1 TO 6
FOR J = 1 TO 6
IF HS$ <> "" THEN PRINT USING "  +#.##^^^^"; LM(I, J);
NEXT J
IF HS$ <> "" THEN PRINT
NEXT I
IF HS$ <> "" THEN INPUT OK
IF HS$ <> "" THEN PRINT
IF HS$ <> "" THEN PRINT "THE MATRIX  CM() "
IF HS$ <> "" THEN PRINT
FOR I = 1 TO 6
FOR J = 1 TO 6
IF HS$ <> "" THEN PRINT USING "  +#.##^^^^"; CM(I, J);
NEXT J
IF HS$ <> "" THEN PRINT
NEXT I


' Enter the inclusion shape and calculate the Eshelby's matrix
'
        PRINT
        PRINT "Two types of inclusions may be considered: "
        PRINT "  A FIBER- a very long elliptical inclusion (any key), OR"
        INPUT "  [finite size inclusion of PENNY SHAPE or CIGAR SHAPE] "; HMURA$
        IF HMURA$ <> "" THEN GOTO 16
        PRINT
        PRINT "Calculations for OBLATE (penny-shape) or PROLATE (cigar-shape)."
        PRINT "The inclusion and matrix have the same coordinate system"
        PRINT "  that is defined by inclusion symmetry axes: "
        PRINT "Axis X (radius length RX) is the inclusion symmetry axis; RY=RZ always. "
        PRINT "Axis Y corresponds to radius RY and axis Z corresponds to radius RZ"
        PRINT "   For prolate: RX > RY = RZ; For oblate: RX < RY = RZ"
        A1EL = .3333: A2EL = 1: A3EL = 1
        PRINT "Current three axes of the inclusion:";
        PRINT USING " ####.#### "; A1EL, A2EL, A3EL
        INPUT "   CHANGE? [NO] "; H$
        IF H$ = "" THEN GOTO 12
        INPUT "The new axes are: (RX, RY, RZ) "; A1EL, A2EL, A3EL
12 P = POISSONM: RA = A3EL / A1EL
GOTO 18
'
'Mura's matrix
'
16      PRINT
        P = POISSONM
        PRINT "Calculations for an ELLIPTICAL FIBER."
        PRINT "The inclusion and the matrix have the same coordinates which are"
        PRINT "  defined by the inclusion axes."
        PRINT
        PRINT "Axis X is the long axis of the elliptical section, RX > RY,"
        PRINT "Axis Y is the short axis of the elliptical section,"
        PRINT "Axis Z is the fiber axis (infinite)."
        A1EL = 1: A2EL = .333
        PRINT "Current two axes of the elliptical section are:";
        PRINT USING " ####.## "; A1EL, A2EL
        INPUT "   CHANGE? [NO] "; H$
        IF H$ = "" THEN GOTO 11
        INPUT "The new axes are: (RX, RY) "; A1EL, A2EL
11 P = POISSONM: RA = A2EL / A1EL
       
        SE(1, 1) = (1 / (2 * (1 - P))) * ((RA ^ 2 + 2 * RA) / ((1 + RA) ^ 2) + (1 - 2 * P) * (RA / (1 + RA)))
        SE(2, 2) = (1 / (2 * (1 - P))) * ((1 + 2 * RA) / ((1 + RA) ^ 2) + (1 - 2 * P) * (1 / (1 + RA)))
        SE(3, 3) = 0
        SE(2, 3) = (1 / (2 * (1 - P))) * (2 * P / (1 + RA))
        SE(3, 1) = 0
        SE(1, 2) = (1 / (2 * (1 - P))) * ((RA ^ 2) / ((1 + RA) ^ 2) - (1 - 2 * P) * (RA / (1 + RA)))
        SE(1, 3) = (1 / (2 * (1 - P))) * (2 * P * RA / (1 + RA))
        SE(2, 1) = (1 / (2 * (1 - P))) * (1 / ((1 + RA) ^ 2) - (1 - 2 * P) * (1 / (1 + RA)))
        SE(3, 2) = 0
        SE(4, 4) = 1 / (2 * (1 + RA))
        SE(5, 5) = (RA / (2 * (1 + RA)))
        SE(6, 6) = (1 / (2 * (1 - P))) * ((1 + RA ^ 2) / (2 * (1 + RA) ^ 2) + (1 - 2 * P) / 2)


        GOTO 19
18      'Realtions after Mura
        A = A1EL / A3EL
        IF A1EL > A3EL THEN G = (A / ((A ^ 2 - 1) ^ 1.5)) * (A * (A ^ 2 - 1) ^ .5 - LOG(A + (A ^ 2 - 1) ^ .5))
        IF A1EL < A3EL THEN G = (A / ((1 - A ^ 2) ^ 1.5)) * (ACOS(A) - A * (1 - A ^ 2) ^ .5)
                SE(1, 1) = (1 / (2 * 1 - P)) * (1 - 2 * P + (3 * A ^ 2 - 1) / (A ^ 2 - 1) - (1 - 2 * P + (3 * A ^ 2 / (A ^ 2 - 1))) * G)
                SE(2, 2) = (3 / (8 * (1 - P))) * (A ^ 2 / (A ^ 2 - 1)) + (1 / (4 * (1 - P))) * (1 - 2 * P - 9 / (4 * (A ^ 2 - 1))) * G
                SE(3, 3) = SE(2, 2)
                SE(2, 3) = (1 / (4 * (1 - P))) * (A ^ 2 / (2 * (A ^ 2 - 1)) - (1 - 2 * P + 3 / (4 * (A ^ 2 - 1))) * G)
                SE(3, 2) = SE(2, 3)
                SE(2, 1) = -(1 / (2 * (1 - P))) * (A ^ 2 / (A ^ 2 - 1)) + (1 / (4 * (1 - P))) * (3 * A ^ 2 / (A ^ 2 - 1) - (1 - 2 * P)) * G
                SE(3, 1) = SE(2, 1)
                SE(1, 2) = -(1 / (2 * (1 - P))) * (1 - 2 * P + 1 / (A ^ 2 - 1)) + (1 / (2 * (1 - P))) * (1 - 2 * P + 3 / (2 * (A ^ 2 - 1))) * G
                SE(1, 3) = SE(1, 2)
                SE(4, 4) = (1 / (4 * (1 - P))) * (A ^ 2 / (2 * (A ^ 2 - 1)) + (1 - 2 * P - 3 / (4 * (A ^ 2 - 1))) * G)
                SE(5, 5) = (1 / (4 * (1 - P))) * (1 - 2 * P - (A ^ 2 + 1) / (A ^ 2 - 1) - .5 * (1 - 2 * P - (3 * (A ^ 2 + 1) / (A ^ 2 - 1))) * G)
                SE(6, 6) = SE(5, 5)
' Note the following relations:
'SE(1,1)=S1111: SE(2,2)=S2222:  SE(3,3)=S3333
'SE(2,3)=S2233: SE(3,2)=S3322:  SE(2,1)=S2211
'SE(3,1)=S3311: SE(1,2)=S1122:  SE(1,3)=S1133
'SE(4,4)=S2323: SE(5,5)=S1313:  SE(6,6)=S1212

19 'Printing intermediate results

IF HS$ <> "" THEN PRINT "THE MATRIX  SE() "
IF HS$ <> "" THEN PRINT
FOR I = 1 TO 6
FOR J = 1 TO 6
IF HS$ <> "" THEN PRINT USING "  +#.##^^^^"; SE(I, J);
NEXT J
IF HS$ <> "" THEN PRINT
NEXT I

' LI()-LM()
FOR I = 1 TO 6
FOR J = 1 TO 6
LT(I, J) = LI(I, J) - LM(I, J)
NEXT J
NEXT I
'
IF HS$ <> "" THEN PRINT "THE MATRIX  LI()-LM() "
IF HS$ <> "" THEN PRINT
FOR I = 1 TO 6
FOR J = 1 TO 6
IF HS$ <> "" THEN PRINT USING "  +#.##^^^^"; LT(I, J);
NEXT J
IF HS$ <> "" THEN PRINT
NEXT I

' GENERATING THE T() MATRIX

        N = 6
        CALL INVERSE(N, LM(), LMINV(), IER)

'Printing intermediate results

IF HS$ <> "" THEN PRINT "THE MATRIX  LMINV() "
IF HS$ <> "" THEN PRINT
FOR I = 1 TO 6
FOR J = 1 TO 6
IF HS$ <> "" THEN PRINT USING "  +#.##^^^^"; LMINV(I, J);
NEXT J
IF HS$ <> "" THEN PRINT
NEXT I
IF HS$ <> "" THEN INPUT OK
'PRINT
'PRINT
IF HS$ <> "" THEN PRINT "THE MATRIX  CM() "
IF HS$ <> "" THEN PRINT
FOR I = 1 TO 6
FOR J = 1 TO 6
IF HS$ <> "" THEN PRINT USING "  +#.##^^^^"; CM(I, J);
NEXT J
IF HS$ <> "" THEN PRINT
NEXT I


'Calculating the stress matrix

X = 6: Y = 6: Z = 6
CALL MATXMAT(SE(), LMINV(), LT1(), X, Y, Z)
CALL MATXMAT(LT1(), LT(), LT2(), X, Y, Z)

'Printing intermediate results

IF HS$ <> "" THEN PRINT "THE MATRIX  SE()*LMINV() "
IF HS$ <> "" THEN PRINT
FOR I = 1 TO 6
FOR J = 1 TO 6
IF HS$ <> "" THEN PRINT USING "  +#.##^^^^"; LT1(I, J);
NEXT J
IF HS$ <> "" THEN PRINT
NEXT I
IF HS$ <> "" THEN PRINT "THE MATRIX  SE()*LMINV()*(LI()-LM()) "
IF HS$ <> "" THEN PRINT
FOR I = 1 TO 6
FOR J = 1 TO 6
IF HS$ <> "" THEN PRINT USING "  +#.##^^^^"; LT2(I, J);
NEXT J
IF HS$ <> "" THEN PRINT
NEXT I


        LIN(1, 1) = 1: LIN(2, 2) = 1: LIN(3, 3) = 1: LIN(4, 4) = 1: LIN(5, 5) = 1: LIN(6, 6) = 1
        FOR I = 1 TO 6
        FOR J = 1 TO 6
                TEMP(I, J) = LT2(I, J) + LIN(I, J)
        NEXT J
        NEXT I
        CALL INVERSE(N, TEMP(), T(), IER)

'Printing intermediate results

IF HS$ <> "" THEN INPUT OK
IF HS$ <> "" THEN PRINT "THE MATRIX  T() "
IF HS$ <> "" THEN PRINT
FOR I = 1 TO 6
FOR J = 1 TO 6
IF HS$ <> "" THEN PRINT USING "  +#.##^^^^"; T(I, J);
NEXT J
IF HS$ <> "" THEN PRINT
NEXT I


        CALL MATXMAT(LI(), T(), WTEMP(), X, Y, Z)
        CALL MATXMAT(WTEMP(), CM(), W(), X, Y, Z)

'Printing intermediate results

IF HS$ <> "" THEN PRINT "THE MATRIX  W() "
IF HS$ <> "" THEN PRINT
FOR I = 1 TO 6
FOR J = 1 TO 6
IF HS$ <> "" THEN PRINT USING "  +#.##^^^^"; W(I, J);
NEXT J
IF HS$ <> "" THEN PRINT
NEXT I

 PRINT : PRINT "NOTE:"
        PRINT "Some stress components can be zero [default]. However, numerical difficulties"
        PRINT "  (mostly overflow) may arise when the stress components are exactly equal"
        PRINT "  to each other, or exactly zero.  "
        PRINT "If overflow is encountered, change slightly the stress components [by < 0.1%]."
        PRINT "Small, non-zero values (about 0.00001) are entered as default for the stresses."
        PRINT

    SXI# = -5!: SYI# = -2!: SZI# = -10!: SXYI# = .01: SXZI# = .01: SYZI# = 3
37  PRINT
    PRINT "Options to enter stress state (compression is negative):"
    PRINT "  Stress state in six tensor components (axes defined above),"
    PRINT "     Read from a file (enter FILENAME below)"
    PRINT "     Entered from the keyboard (select default below)"
    'PRINT "  2.  Three principal stresses entered from the keyboard (hit P below)"
    PRINT
    INPUT "Select stress entry: FILENAME or [KEYBOARD ENTRY OF STRESS TENSOR] "; FILE$
    IF FILE$ <> "" THEN OPEN FILE$ FOR INPUT AS #2
    IF FILE$ <> "" THEN INPUT #2, SXI#, SYI#, SZI#, SXYI#, SXZI#, SYZI#
    IF FILE$ <> "" THEN CLOSE #2

    PRINT "                                     "; CHR$(229); "x = [";
    PRINT USING " ###.## "; SXI#;
    PRINT "], new "; : INPUT SXVI#
    IF SXVI# <> 0 THEN SXI# = SXVI#
    PRINT "                                     "; CHR$(229); "y = [";
    PRINT USING " ###.## "; SYI#;
    PRINT "], new "; : INPUT SYVI#
    IF SYVI# <> 0 THEN SYI# = SYVI#
    PRINT "                                     "; CHR$(229); "z = [";
    PRINT USING " ###.## "; SZI#;
    PRINT "], new "; : INPUT SZVI#
    IF SZVI# <> 0 THEN SZI# = SZVI#
    PRINT "                                     "; CHR$(229); "xy= [";
    PRINT USING " ###.## "; SXYI#;
    PRINT "], new "; : INPUT SXYVI#
    IF SXYVI# <> 0 THEN SXYI# = SXYVI#
    PRINT "                                     "; CHR$(229); "xz= [";
    PRINT USING " ###.## "; SXZI#;
    PRINT "], new "; : INPUT SXZVI#
    IF SXZVI# <> 0 THEN SXZI# = SXZVI#
    PRINT "                                     "; CHR$(229); "yz= [";
    PRINT USING " ###.## "; SYZI#;
    PRINT "], new "; : INPUT SYZVI#
    IF SYZVI# <> 0 THEN SYZI# = SYZVI#

40   IF SXI# = 0 THEN SXI# = .00001#
     IF SYI# = 0 THEN SYI# = .00002#
     IF SZI# = 0 THEN SZI# = .00003#
     IF SXYI# = 0 THEN SXYI# = .00001#
     IF SXZI# = 0 THEN SXZI# = .00002#
     IF SYZI# = 0 THEN SYZI# = .00003#
     BK$ = "1": SI = 1
     INPUT " OK [YES] "; H$
     CLS
     PRINT "                                                    "; DATE$
     HTITLE$ = "REMOTE FIELD"
     GOSUB 999
   HTEMP$ = HTITLE$: BT1 = BK1#: BT2 = BK2#: BT3 = BK3#: LT1 = L1#: LT2 = L2#: LT3 = L3#
   MT1 = M1#: MT2 = M2#: MT3 = M3#
   PP1 = DAT(10): TT1 = DAT(11)
   PP2 = DAT(12): TT2 = DAT(13)
   PP3 = DAT(14): TT3 = DAT(15)
60 PRINT
   INPUT "1-Modify MATRIX stress state [CONTINUE] "; H$
   IF H$ = "" THEN GOTO 61
   IF H$ = "2" THEN CALL STEREO(HTITLE$, DAT(), BK1#, BK2#, BK3#, L1#, L2#, L3#, M1#, M2#, M3#)
   IF H$ = "1" THEN GOTO 37
61   SREM(1, 1) = SXI#: SREM(2, 1) = SYI#: SREM(3, 1) = SZI#
     SREM(4, 1) = SXYI#: SREM(5, 1) = SXZI#: SREM(6, 1) = SYZI#

        X = 6: Y = 6: Z = 1
        CALL MATXMAT(W(), SREM(), SINC(), X, Y, Z)
     HTITLE$ = "INCLUSION FIELD"
     SXI# = SINC(1, 1): SYI# = SINC(2, 1): SZI# = SINC(3, 1)
     SXYI# = SINC(4, 1): SXZI# = SINC(5, 1): SYZI# = SINC(6, 1)
     PRINT : PRINT

GOSUB 999
       
        PRINT
50 INPUT "1-Modify stress state, 2-New analysis, 3-STOP, [Mohr diagram] "; H$
    IF H$ = "1" THEN GOTO 37
    IF H$ = "2" THEN GOTO 30
    IF H$ = "3" THEN PRINT "Analysis of Eshelby's inclusions has been completed."
    IF H$ = "3" THEN END
    IF H$ = "" THEN CALL MOHR(SI(), SM(), A1EL, A2EL, A3EL, HNAME$, HMURA$)

                LOCATE 17, 1: PRINT "MATERIAL     Young    Poisson's"
                LOCATE 18, 1: PRINT "PROPERTIES: modulus:   ratio:"
                COLOR (4)
                PRINT "Matrix:   ";
                PRINT USING "##.##^^^^ "; EOUNGM;
                PRINT USING "   #.##"; POISSONM
                COLOR (9)
                PRINT "Inclusion:";
                PRINT USING "##.##^^^^ "; EOUNGI;
                PRINT USING "   #.##"; POISSONI
                COLOR (2)
                        'LINE (1, 302)-(220, 302), 10
                        'LINE (1, 318)-(220, 318), 13
        LOCATE 25, 1
        PRINT "STRESS AXES: plunge/trend [degrees] with respect to inclusion axes A1, A2, A3"
        COLOR (4)
        PRINT "Matrix:                                ";
        PRINT INT(PP1); "/"; INT(TT1); "   "; INT(PP2); "/"; INT(TT2); "   "; INT(PP3); "/"; INT(TT3)
        COLOR (9)
        PRINT "Inclusion:                             ";
        PRINT INT(DAT(10)); "/"; INT(DAT(11)); "   "; INT(DAT(12)); "/"; INT(DAT(13)); "   "; INT(DAT(14)); "/"; INT(DAT(15))
        COLOR (2)
        PRINT "   Note: "; CHR$(229); "1=maximum compression; stresses in input units "

    CALL STEREO(HTITLE$, DAT(), BK1#, BK2#, BK3#, L1#, L2#, L3#, M1#, M2#, M3#)
    CALL STEREO(HTEMP$, DAT(), BT1, BT2, BT3, LT1, LT2, LT3, MT1, MT2, MT3)
36    INPUT "1-Modify this stress state, 2-save this data set to ESHEL.OUT [CONTINUE] "; H$

     SXI# = SREM(1, 1): SYI# = SREM(2, 1): SZI# = SREM(3, 1)
     SXYI# = SREM(4, 1): SXZI# = SREM(5, 1): SYZI# = SREM(6, 1)
       

    IF H$ = "" THEN GOTO 35
    IF H$ = "1" THEN GOTO 37
    IF H$ = "2" THEN HA$ = "ESHEL.OUT"
    IF HA$ <> "" AND HA$ <> "1" THEN OPEN HA$ FOR APPEND AS #3
    IF HA$ <> "" AND HA$ <> "1" THEN PRINT #3, USING " #.####"; A1EL, A2EL, A3EL;
    IF HA$ <> "" AND HA$ <> "1" THEN PRINT #3, USING " ###.##"; EOUNGI / EOUNGM, POISSONM, POISSONI, SM(1), SM(2), SM(3), SI(1), SI(2), SI(3);
    IF HA$ <> "" AND HA$ <> "1" THEN PRINT #3, USING " ### "; PP1, TT1, PP2, TT2, PP3, TT3, DAT(10), DAT(11), DAT(12), DAT(13), DAT(14), DAT(15)
    IF HA$ <> "" AND HA$ <> "1" THEN CLOSE #3
    GOTO 36
35 INPUT "More analyses [YES] "; H$
   IF H$ = "" THEN GOTO 30
39 END

999  SX# = SXI#
     SY# = SYI#
     SZ# = SZI#
     SXY# = SXYI#
     SXZ# = SXZI#
     SYZ# = SYZI#
     PRINT "STRESSES OF "; HTITLE$; "   "
     PRINT "  Note: compression < 0, X is the symmetry axis and horizontal (north),"
     PRINT "        Y is horizontal (east) and Z is vertical"
     PRINT "Six component stress tensor: "
     PRINT "   "; CHR$(229); " x= ";
     PRINT USING " ####.## "; SX#;
     PRINT "   "; CHR$(229); " y= ";
     PRINT USING " ####.## "; SY#;
     PRINT "   "; CHR$(229); " z= ";
     PRINT USING " ####.## "; SZ#
     PRINT "   "; CHR$(229); " yz=";
     PRINT USING " ####.## "; SYZ#;
     PRINT "   "; CHR$(229); " xz=";
     PRINT USING " ####.## "; SXZ#;
     PRINT "   "; CHR$(229); " xy=";
     PRINT USING " ####.## "; SXY#
     SIG1H = (SX# + SY#) / 2 - SQR(.25 * (SX# - SY#) ^ 2 + SXY# ^ 2)
     SIG2H = (SX# + SY#) / 2 + SQR(.25 * (SX# - SY#) ^ 2 + SXY# ^ 2)
     THET = ATN(2 * SXY# / (SX# - SY#)) / 2
     THET = 180 * THET / PI
     IF SY# < SX# THEN THET = THET + 90
'     PRINT CHR$(229); " HMAX =  ";
'     PRINT USING " #.##^^^^ "; SIG1H;
'     PRINT CHR$(229); " hmin =  ";
'     PRINT USING " #.##^^^^ "; SIG2H;
'     PRINT " Trend (from North)= ";
'     PRINT USING " ###."; THET

'******* Invariant calculations***************
    
     A1# = -(SX# + SY# + SZ#)
     A2# = (SY# * SZ# + SZ# * SX# + SX# * SY#) - (SYZ# ^ 2 + SXZ# ^ 2 + SXY# ^ 2)
     A3# = -(SX# * SY# * SZ# + 2 * SYZ# * SXZ# * SXY# - SX# * (SYZ#) ^ 2 - SY# * (SXZ#) ^ 2 - SZ# * (SXY#) ^ 2)
     PI = 4 * ATN(1!)
     Q# = (3 * A2# - A1# ^ 2) / 9
     R# = (9 * A1# * A2# - 27 * A3# - 2 * A1# ^ 3) / 54
     C# = Q# ^ 3 + R# ^ 2
     IF C# > O THEN PRINT "No real roots"
     CT# = -R# / (SQR(-Q# ^ 3))
     T# = ATN(SQR(1 - CT# ^ 2) / CT#)
     T# = ATN(CT# / SQR(1 - CT# ^ 2)) + PI / 2
     X1# = 2 * SQR(-Q#) * COS(T# / 3) - A1# / 3
     X2# = 2 * SQR(-Q#) * COS(T# / 3 + 120 * PI / 180) - A1# / 3
     X3# = 2 * SQR(-Q#) * COS(T# / 3 + 240 * PI / 180) - A1# / 3

     T1# = X1#: T2# = X2#: T3# = X3#
     IF X1# <= X2# AND X2# <= X3# THEN GOTO 4327
     IF X1# <= X3# AND X3# <= X2# THEN GOTO 155
     IF X2# <= X3# AND X3# <= X1# THEN GOTO 156
     IF X2# <= X1# AND X1# <= X3# THEN GOTO 157
     IF X3# <= X1# AND X1# <= X2# THEN GOTO 158
     IF X3# <= X2# AND X2# <= X1# THEN GOTO 159
155  X1# = T1#: X2# = T3#: X3# = T2#
     GOTO 4327
156  X1# = T2#: X2# = T3#: X3# = T1#
     GOTO 4327
157  X1# = T2#: X2# = T1#: X3# = T3#
     GOTO 4327
158  X1# = T3#: X2# = T1#: X3# = T2#
     GOTO 4327
159  X1# = T3#: X2# = T2#: X3# = T1#
     GOTO 4327
4327 PRINT "PRINCIPAL STRESSES           "; CHR$(229); " 1       "; ; CHR$(229); " 2        "; CHR$(229); " 3 ("; CHR$(229);
PRINT "1=maximum compression)"
     PRINT "Magnitudes (input units):";
'     PRINT "   "; CHR$(229); " 1= ";
     PRINT USING " #.##^^^^  "; X1#;
'     PRINT "   "; CHR$(229); " 2= ";
     PRINT USING " #.##^^^^  "; X2#;
'     PRINT "   "; CHR$(229); " 3= ";
     PRINT USING " #.##^^^^  "; X3#
IF HTITLE$ = "REMOTE FIELD" THEN SM(1) = X1#
IF HTITLE$ = "REMOTE FIELD" THEN SM(2) = X2#
IF HTITLE$ = "REMOTE FIELD" THEN SM(3) = X3#
IF HTITLE$ = "INCLUSION FIELD" THEN SI(1) = X1#
IF HTITLE$ = "INCLUSION FIELD" THEN SI(2) = X2#
IF HTITLE$ = "INCLUSION FIELD" THEN SI(3) = X3#

    
     DAT(7) = X1#: DAT(8) = X2#: DAT(9) = X3#
     PRINT "Plunge/trend (degrees):  ";
     A11# = SX# - X1#: A12# = SXY#: A13# = SXZ#
     A21# = SXY#: A22# = SY# - X1#: A23# = SYZ#
     A31# = SXZ#: A32# = SYZ#: A33# = SZ# - X1#
     Z1# = (A11# * A23# - A21# * A13#) / (A12# * A23# - A22# * A13#)
     Z2# = (A11# - Z1# * A12#) / A13#
     BK1# = 1 / (SQR(1 + Z1# ^ 2 + Z2# ^ 2))
     BK2# = -BK1# * Z1#
     BK3# = -BK1# * Z2#
     BK1# = -BK1#: BK2# = -BK2#: BK3# = -BK3#
     RU# = A11# * BK1# + A12# * BK2# + A13# * BK3#
     RV# = A21# * BK1# + A22# * BK2# + A23# * BK3#
     RX# = A31# * BK1# + A32# * BK2# + A33# * BK3#
'     PRINT "  "; CHR$(229); " 1 ";
     'PRINT USING "######.###"; BK1#, BK2#, BK3#;
     BK1 = BK1#: BK2 = BK2#: BK3 = BK3#
     GOTO 4482
4465 BW1(1) = BK1: BW1(2) = BK2: BW1(3) = BK3
     GOTO 4482
4471 BW2(1) = BK1: BW2(2) = BK2: BW2(3) = BK3
4482 IF BK3# > 0 THEN GOTO 4685
     BK1 = -BK1#: BK2 = -BK2#: BK3 = -BK3#
4685 ALPHA = ATN(BK2# / BK1#)
     IF BK1 < 0 THEN ALPHA = PI + ALPHA
     IF BK2 < 0 AND BK1 > 0 THEN ALPHA = 2 * PI + ALPHA
     ALPHA = (180 * ALPHA / PI)
     IF BK3 = 1 THEN BK3 = .9999
     DIP = ATN(BK3 / SQR(1 - BK3 ^ 2))
     DIP = 180 * DIP / PI
     PRINT " "; INT(DIP); "/"; INT(ALPHA);
     DAT(10) = INT(DIP): DAT(11) = INT(ALPHA)
    
     A11# = SX# - X2#: A12# = SXY#: A13# = SXZ#
     A21# = SXY#: A22# = SY# - X2#: A23# = SYZ#
     A31# = SXZ#: A32# = SYZ#: A33# = SZ# - X2#
     Z1# = (A11# * A33# - A31# * A13#) / (A12# * A33# - A32# * A13#)
     Z2# = (A31# - Z1# * A32#) / A33#
     L1# = 1 / (SQR(1 + Z1# ^ 2 + Z2# ^ 2))
     L2# = -L1# * Z1#
     L3# = -L1# * Z2#
     L1# = -L1#: L2# = -L2#: L3# = -L3#
     RU# = A11# * L1# + A12# * L2# + A13# * L3#
     RV# = A21# * L1# + A22# * L2# + A23# * L3#
     RX# = A31# * L1# + A32# * L2# + A33# * L3#
'     PRINT "  "; CHR$(229); " 2 ";
     'PRINT USING "######.###"; L1#, L2#, L3#;
     L1 = L1#: L2 = L2#: L3 = L3#
4578 IF L3# > 0 THEN GOTO 4579
     L1 = -L1#: L2 = -L2#: L3 = -L3#
4579 ALPHA = ATN(L2 / L1)
     IF L1 < 0 THEN ALPHA = PI + ALPHA
     IF L2 < 0 AND L1 > 0 THEN ALPHA = 2 * PI + ALPHA
     ALPHA = (180 * ALPHA / PI)
     IF L3 = 1 THEN L3 = .9999
     DIP = ATN(L3 / SQR(1 - L3 ^ 2))
     DIP = 180 * DIP / PI
     PRINT "  "; INT(DIP); "/"; INT(ALPHA);
     DAT(12) = INT(DIP): DAT(13) = INT(ALPHA)
    
     A11# = SX# - X3#: A12# = SXY#: A13# = SXZ#
     A21# = SXY#: A22# = SY# - X3#: A23# = SYZ#
     A31# = SXZ#: A32# = SYZ#: A33# = SZ# - X3#
     Z1# = (A21# * A33# - A31# * A23#) / (A22# * A33# - A32# * A23#)
     Z2# = (A21# - Z1# * A22#) / A23#
     M1# = 1 / (SQR(1 + Z1# ^ 2 + Z2# ^ 2))
     M2# = -M1# * Z1#
     M3# = -M1# * Z2#
     RU# = A11# * M1# + A12# * M2# + A13# * M3#
     RV# = A21# * M1# + A22# * M2# + A23# * M3#
     RX# = A31# * M1# + A32# * M2# + A33# * M3#
'     PRINT "  "; CHR$(229); "  3 ";
     'PRINT USING "######.###"; M1#, M2#, M3#;
     M1 = M1#: M2 = M2#: M3 = M3#
     IF M3# > 0 THEN GOTO 4687
     M1 = -M1#: M2 = -M2#: M3 = -M3#
4687 ALPHA = ATN(M2 / M1)
     IF M1 < 0 THEN ALPHA = PI + ALPHA
     IF M2 < 0 AND M1 > 0 THEN ALPHA = 2 * PI + ALPHA
     ALPHA = (180 * ALPHA / PI)
     IF M3 = 1 THEN M3 = .9999
     DIP = ATN(M3 / SQR(1 - M3 ^ 2))
     DIP = 180 * DIP / PI
     PRINT "   "; INT(DIP); "/"; INT(ALPHA)
     DAT(14) = INT(DIP): DAT(15) = INT(ALPHA)
    
     W1# = BK1# * L1# + BK2# * L2# + BK3# * L3#
     W2# = BK1# * M1# + BK2# * M2# + BK3# * M3#
     W3# = L1# * M1# + L2# * M2# + L3# * M3#
     IF ABS(W1#) < .1 AND ABS(W2#) < .1 AND ABS(W3#) < .1 AND BK$ = "1" THEN RETURN
     IF ABS(W1#) < .1 AND ABS(W2#) < .1 AND ABS(W3#) < .1 THEN GOTO 8000
     PRINT
     INPUT "Principal stress axes are not perfectly normal to each other. Any key to stop [CONTINUE] "; H$
     PRINT
     IF H$ <> "" THEN STOP
7500 CLS
     PRINT
     PRINT "The program encountered an error."
     PRINT
     PRINT "The most likely error is overflow due to stress components that are zero"
     PRINT " OR stress components that are exactly equal to each other."
     PRINT
     PRINT "Continue, and change slightly the stress components [by < 0.1%]."
     PRINT
     INPUT "Continue [YES] "; H$
     IF H$ = "" THEN GOTO 30
    
8000 RETURN

FUNCTION ACOS (AX)
    ' Inverse cosine function

    ' Input

    '  AX = function argument

    ' Output

    '  ACOS = inverse cosine of AX ( radians )

    PIDIV2 = 1.570796326794897#

    IF ABS(AX) >= 1# THEN
       A = SGN(AX) * PIDIV2
    ELSE
       A = ATN(AX / SQR(1# - AX ^ 2))
    END IF

    ACOS = PIDIV2 - A


END FUNCTION

DEFINT L-M
DEFDBL G-H, X-Z
SUB INVERSE (N, A(), AINV(), IER) STATIC

    ' Inverse of a matrix subroutine

    ' solves [ AINV ] = inverse [ A ]

    ' Input

    '  N   = dimension of array
    '  A() = matrix of coefficients    ( N rows by N columns )

    ' Output

    '  AINV() = inverse of [ A ] ( N rows by N column )
    '  IER    = error flag ( 0 = no error, 1 = singular matrix or
    '                        factorization not possible )

    DIM INDEX(N), SCALE(N), X(N)

    FOR I = 1 TO N
        ROWMAX = 0#
        FOR J = 1 TO N
            IF ABS(A(I, J)) > ROWMAX THEN ROWMAX = ABS(A(I, J))
        NEXT J
        ' check for singular matrix
        IF ROWMAX = 0# THEN
           IER = 1
           GOTO EXITSUB
        ELSE
           SCALE(I) = 1# / ROWMAX
        END IF
    NEXT I

    FOR J = 1 TO N
        IF J > 1 THEN
           FOR I = 1 TO J - 1
               S = A(I, J)
               IF I > 1 THEN
                  FOR K = 1 TO I - 1
                      S = S - A(I, K) * A(K, J)
                  NEXT K
                  A(I, J) = S
               END IF
           NEXT I
        END IF

        PIVOTMAX = 0#

        FOR I = J TO N
            S = A(I, J)
            IF J > 1 THEN
               FOR K = 1 TO J - 1
                   S = S - A(I, K) * A(K, J)
               NEXT K
               A(I, J) = S
            END IF
            PIVOT = SCALE(I) * ABS(S)
            IF PIVOT >= PIVOTMAX THEN
               IMAX = I
               PIVOTMAX = PIVOT
            END IF
        NEXT I

        IF J <> IMAX THEN
           FOR K = 1 TO N
               TMP = A(IMAX, K)
               A(IMAX, K) = A(J, K)
               A(J, K) = TMP
           NEXT K
           SCALE(IMAX) = SCALE(J)
        END IF

        INDEX(J) = IMAX

        IF J <> N THEN
           ' check for singular matrix
           IF A(J, J) = 0# THEN
              IER = 1
              GOTO EXITSUB
           END IF
           TMP = 1# / A(J, J)
           FOR I = J + 1 TO N
               A(I, J) = A(I, J) * TMP
           NEXT I
        END IF
    NEXT J

    ' check for singular matrix

    IF A(N, N) = 0# THEN
       IER = 1
       GOTO EXITSUB
    END IF

    FOR II = 1 TO N
        FOR JJ = 1 TO N
            X(JJ) = 0#
            IF II = JJ THEN X(JJ) = 1#
        NEXT JJ

        I1 = 0

        FOR I = 1 TO N
            L = INDEX(I)
            S = X(L)
            X(L) = X(I)
            IF I1 <> 0 THEN
               FOR J = I1 TO I - 1
                   S = S - A(I, J) * X(J)
               NEXT J
            ELSEIF S <> 0# THEN
               I1 = I
            END IF
            X(I) = S
        NEXT I

        FOR I = N TO 1 STEP -1
            S = X(I)
            IF I < N THEN
               FOR J = I + 1 TO N
                   S = S - A(I, J) * X(J)
               NEXT J
            END IF
            X(I) = S / A(I, I)
        NEXT I

        FOR JJ = 1 TO N
            AINV(JJ, II) = X(JJ)
        NEXT JJ
    NEXT II

EXITSUB:
    ERASE INDEX, SCALE, X

END SUB

DEFINT X-Z
DEFSNG G
DEFDBL L-M
DEFSTR H
SUB MATXMAT (A(), B(), C(), X, Y, Z) STATIC

    ' Matrix multiplication subroutine

    ' [ C ] = [ A ] * [ B ]

    ' Input

    '  A() = matrix A ( X rows by Y columns )
    '  B() = matrix B ( Y rows by Z columns )

    ' Output
       
    '  C() = matrix C ( X rows by Z columns )

    FOR I = 1 TO X
        FOR J = 1 TO Z
            S = 0#
            FOR K = 1 TO Y
                S = S + A(I, K) * B(K, J)
            NEXT K
            C(I, J) = S
        NEXT J
    NEXT I

END SUB

SUB MOHR (SI(), SM(), A1EL, A2EL, A3EL, HNAME$, HMURA$)
IF HMURA$ <> "" THEN A3EL = A2EL
CLS
  RA = A1EL / A3EL
  PI = 3.14
  MIN = 1E+14: MAX = -1E+14
25 FOR I = 1 TO 3
        IF SI(I) < MIN THEN MIN = SI(I)
        IF SI(I) > MAX THEN MAX = SI(I)
        IF SM(I) < MIN THEN MIN = SM(I)
        IF SM(I) > MAX THEN MAX = SM(I)
  NEXT I
20      DEL = (MAX - MIN)
        IF DEL > 1! THEN DEL = INT(DEL)
        SCALE = DEL / 200
        LINE (1, 120)-(630, 120)
        LOCATE 14, 1: PRINT "Each stress division ";
        LOCATE 15, 1: PRINT "is";
        PRINT USING "##.##^^^^"; ABS(DEL / 10);
        PRINT " units"
        zero = 100 + MAX / SCALE
        LINE (zero, 20)-(zero, 220)
        FOR I = 1 TO 5
        LINE (zero - 3, 120 - 20 * I)-(zero + 3, 120 - 20 * I)
        LINE (zero - 3, 120 + 20 * I)-(zero + 3, 120 + 20 * I)
        NEXT I
        FOR I = 1 TO 20
        LINE (zero - 20 * I, 117)-(zero - 20 * I, 123)
        LINE (zero + 20 * I, 117)-(zero + 20 * I, 123)
        NEXT I
       
10 RI13 = -(SI(1) - SI(3)) / (2 * SCALE)
  RI12 = -(SI(1) - SI(2)) / (2 * SCALE)
  RI23 = -(SI(2) - SI(3)) / (2 * SCALE)
  RM13 = -(SM(1) - SM(3)) / (2 * SCALE)
  RM12 = -(SM(1) - SM(2)) / (2 * SCALE)
  RM23 = -(SM(2) - SM(3)) / (2 * SCALE)
  CIRCLE (zero - (SI(1) + SI(3)) / (2 * SCALE), 120), RI13, 9, 0, PI
  CIRCLE (zero - (SI(2) + SI(3)) / (2 * SCALE), 120), RI23, 9, 0, PI
  CIRCLE (zero - (SI(1) + SI(2)) / (2 * SCALE), 120), RI12, 9, 0, PI
  CIRCLE (zero - (SM(1) + SM(3)) / (2 * SCALE), 120), RM13, 4, PI, 0
  CIRCLE (zero - (SM(2) + SM(3)) / (2 * SCALE), 120), RM23, 4, PI, 0
  CIRCLE (zero - (SM(1) + SM(2)) / (2 * SCALE), 120), RM12, 4, PI, 0
  LOCATE 9, 55: PRINT "Compressive "; CHR$(229); " n"
  LOCATE 10, 55: PRINT "(negative)"
  LOCATE 9, 1: PRINT "Tensile "; CHR$(229); " n"
  LOCATE 10, 1: PRINT "(positive)"
LOCATE 12, 71
IF HMURA$ = "" THEN PRINT "east A2=A3"
IF HMURA$ <> "" THEN LOCATE 12, 52
IF HMURA$ <> "" THEN PRINT "A2=";
IF HMURA$ <> "" THEN PRINT USING "#.##"; A2EL
LOCATE 11, 53
IF HMURA$ = "" THEN PRINT "North=symmetry axis A1=";
IF HMURA$ <> "" THEN PRINT "  North= axis A1=";
PRINT USING "#.##"; A1EL
LOCATE 16, 40
PRINT "Vertical A3=";
IF HMURA$ = "" THEN PRINT USING "#.##"; A3EL
IF HMURA$ <> "" THEN PRINT "long"
LOCATE 18, 32: PRINT " STEREOGRAPHIC PROJECTION"
LOCATE 19, 32: PRINT "  with stress axes and"
LOCATE 20, 32: PRINT "  inclusion section (center)"
LOCATE 1, 45: PRINT "Shear "; CHR$(229); " s "
LOCATE 1, 1: PRINT "3-D MOHR CIRCLES IN INCLUSION/MATRIX SET"
        LOCATE 1, 67: PRINT DATE$
        LOCATE 2, 57: PRINT "Case:"; HNAME$
        LOCATE 22, 1
        PRINT "Magnitudes of principal stresses:          "; CHR$(229); " 1       "; ; CHR$(229); " 2        "; CHR$(229); " 3 "
        COLOR (4)
        PRINT "Matrix stresses (below "; CHR$(229); " n line):      ";
        PRINT USING " ##.##^^^^ "; SM(1), SM(2), SM(3)
        COLOR (9)
        PRINT "Inclusion stresses (above "; CHR$(229); " n line):   ";
        PRINT USING " ##.##^^^^ "; SI(1), SI(2), SI(3)
        COLOR (2)
     IF RA < 1 THEN RAD = 50
     IF RA > 1 THEN RAD = 50 / RA
CIRCLE (525, 250), 50, 12, , , RA
END SUB

DEFSNG A-F, H-Z
'Subroutine to input of principal stresses and their orientation
'and calcualtion of the six components of the stress tensor.
SUB PRINCIP (SXI#, SYI#, SZI#, SXYI#, SXZI#, SYZI#)
PI = 4 * ATN(1!)

PRINT
PRINT
PRINT "Compressive stresses MUST be negative.  Use any units (results in same units)."
PRINT "Principal axes given as PLUNGE (0-90) and TREND (0-360 from north)."
PRINT "Principal axes must be perpendicular to each other (about 2 degrees tolerance)"
PRINT "Using angles 0, 90, 180, 360 may cause overflow; change them by 0.1"
PRINT
INPUT "Maximum compression: MAGNITUDE, PLUNGE, TREND = "; M1, P1, T1
INPUT "Intermediate       : MAGNITUDE, PLUNGE, TREND = "; M2, P2, T2
INPUT "Least compression  : MAGNITUDE, PLUNGE, TREND = "; M3, P3, T3
   
    S11# = COS(T1 * PI / 180) * SIN((P1 + 90) * PI / 180)
    S12# = SIN(T1 * PI / 180) * SIN((P1 + 90) * PI / 180)
    S13# = -COS((P1 + 90) * PI / 180)
    S21# = COS(T2 * PI / 180) * SIN((P2 + 90) * PI / 180)
    S22# = SIN(T2 * PI / 180) * SIN((P2 + 90) * PI / 180)
    S23# = -COS((P2 + 90) * PI / 180)
    S31# = COS(T3 * PI / 180) * SIN((P3 + 90) * PI / 180)
    S32# = SIN(T3 * PI / 180) * SIN((P3 + 90) * PI / 180)
    S33# = -COS((P3 + 90) * PI / 180)
  
     A1 = S11# ^ 2: B1 = S11# * S12#
     A2 = S21# ^ 2: B2 = S21# * S22#
     A3 = S31# ^ 2: B3 = S31# * S32#
     SXI# = A1 * M1 + A2 * M2 + A3 * M3
     SXYI# = B1 * M1 + B2 * M2 + B3 * M3
     A1 = S12# ^ 2: B1 = S12# * S13#
     A2 = S22# ^ 2: B2 = S22# * S23#
     A3 = S32# ^ 2: B3 = S32# * S33#
     SYI# = A1 * M1 + A2 * M2 + A3 * M3
     SYZI# = B1 * M1 + B2 * M2 + B3 * M3
     A1 = S13# ^ 2: B1 = S13# * S11#
     A2 = S23# ^ 2: B2 = S23# * S21#
     A3 = S33# ^ 2: B3 = S33# * S31#
     SZI# = A1 * M1 + A2 * M2 + A3 * M3
     SXZI# = B1 * M1 + B2 * M2 + B3 * M3
END SUB

DEFINT I-K, N, X-Z
DEFDBL A-F, L-M, O-W
DEFSTR H
SUB STEREO (HTITLE$, DAT(), BK1#, BK2#, BK3#, L1#, L2#, L3#, M1#, M2#, M3#)
'  The stereographic projection
'  The circle
PI = 3.14: XFACT = 1
GR = 63 * 256: RD = 63
    FOR I = 1 TO 720
    ANN = 2 * PI / 720
    AN = ANN * I
    X = 75 * SIN(AN)
    Y = 75 * COS(AN)
    X = 525 + XFACT * X
    Y = 250 + Y
    PSET (X, Y)
    NEXT I
661 LINE (525 - 80 * XFACT, 250)-(525 + 75 * XFACT, 250)
    LINE (525, 170)-(525, 325)
    
'   Printing (on screen) the stress results on screen
GOTO 4820
880 PRINT
    PRINT "Principal stresses:"
    KD = 1
    PRINT CHR$(229); " 1";
     PRINT USING " ##"; DAT(10);
     PRINT "/";
     PRINT USING "### "; DAT(11);
     PRINT USING "+###.##"; DAT(7)
     PRINT CHR$(229); " 2";
     PRINT USING " ##"; DAT(12);
     PRINT "/";
     PRINT USING "### "; DAT(13);
     PRINT USING "+###.##"; DAT(8)
     PRINT CHR$(229); " 3";
     PRINT USING " ##"; DAT(14);
     PRINT "/";
     PRINT USING "### "; DAT(15);
     PRINT USING "+###.##"; DAT(9)
807 PRINT "File: "; HTITLE$; "             "
    'PRINT "Hit any key to continue "

'     Stereoplot of the principal stresses with the fault data.
'     Three tensor are presented: the least-square and the confidence level.
'
4820    IF HTITLE$ <> "REMOTE FIELD" THEN GOTO 5820
     C1 = BK1#: C2 = BK2#: C3 = BK3#: F = 1
4830 IF C3 > 0 THEN GOTO 4850
     C1 = -C1: C2 = -C2: C3 = -C3
4850 RR# = SQR(C1 ^ 2 + C2 ^ 2)
     TAX = ATN(SQR(1 - C3 ^ 2) / C3)
     XF# = C2 * 75 * SQR(2) * SIN(TAX / 2) / RR#
     YF# = 250 - C1 * 75 * SQR(2) * SIN(TAX / 2) / RR#
     IF F = 3 THEN GOTO 4980
     IF F <> 1 THEN GOTO 4940
     X = 525 + XFACT * XF#
     Y = YF#
     PSET (X, Y)
      PSET (X + 4, Y - 3)
      AP = 0
      DRAW "TA=" + VARPTR$(AP)
      DRAW "C4L6D1L1D1L1D3R1D1R1D1R4U1R1U6R3"
      PSET (X + 8, Y + 2)
      DRAW "C4D5L1U5"
     C1 = L1#: C2 = L2#: C3 = L3#: F = 2
     GOTO 4830
4940 IF F <> 2 THEN GOTO 4960
     X = 525 + XFACT * XF#
     Y = YF#
     PSET (X, Y)
      PSET (X + 4, Y - 3)
      DRAW "C4L6;D1;L1;D1;L1;D3;R1;D1;R1;D1;R4;U1;R1;U6;R3"
      PSET (X + 8, Y + 3)
      DRAW "C4R1;U1;R1;U1;R3;D1;R1;D1;R1;D1;L2;D1;L2;D1;L2;D1;R6"
4960 C1 = M1#: C2 = M2#: C3 = M3#: F = 3
     GOTO 4830
4980 X = 525 + XFACT * XF#
     Y = YF#
     PSET (X, Y)
      PSET (X + 4, Y - 3)
      DRAW "C4L6;D1;L1;D1;L1;D3;R1;D1;R1;D1;R4;U1;R1;U6;R3"
      PSET (X + 8, Y + 3)
      DRAW "C4R1;U1;R1;U1;R3;D1;R1;D1;L1;D1;L1;D1;R1;D1;R1;D1;L1;D1;L3;U1;L1"
      GOTO 6000
   
5820 C1 = BK1#: C2 = BK2#: C3 = BK3#: F = 1
5830 IF C3 > 0 THEN GOTO 5850
     C1 = -C1: C2 = -C2: C3 = -C3
5850 RR# = SQR(C1 ^ 2 + C2 ^ 2)
     TAX = ATN(SQR(1 - C3 ^ 2) / C3)
     XF# = C2 * 75 * SQR(2) * SIN(TAX / 2) / RR#
     YF# = 250 - C1 * 75 * SQR(2) * SIN(TAX / 2) / RR#
     IF F = 3 THEN GOTO 5980
     IF F <> 1 THEN GOTO 5940
     X = 525 + XFACT * XF#
     Y = YF#

      PSET (X, Y)
      PSET (X + 4, Y - 3)
      AP = 0
      DRAW "TA=" + VARPTR$(AP)
      DRAW "C9L6D1L1D1L1D3R1D1R1D1R4U1R1U6R3"
      PSET (X + 8, Y + 2)
      DRAW "C9D5L1U5"
     C1 = L1#: C2 = L2#: C3 = L3#: F = 2
     GOTO 5830
5940 IF F <> 2 THEN GOTO 5960
     X = 525 + XFACT * XF#
     Y = YF#
     PSET (X, Y)
      PSET (X + 4, Y - 3)
      DRAW "C9L6;D1;L1;D1;L1;D3;R1;D1;R1;D1;R4;U1;R1;U6;R3"
      PSET (X + 8, Y + 3)
      DRAW "C9R1;U1;R1;U1;R3;D1;R1;D1;R1;D1;L2;D1;L2;D1;L2;D1;R6"
5960 C1 = M1#: C2 = M2#: C3 = M3#: F = 3
     GOTO 5830
5980 X = 525 + XFACT * XF#
     Y = YF#
     PSET (X, Y)
      PSET (X + 4, Y - 3)
      DRAW "C9L6;D1;L1;D1;L1;D3;R1;D1;R1;D1;R4;U1;R1;U6;R3"
      PSET (X + 8, Y + 3)
      DRAW "C9R1;U1;R1;U1;R3;D1;R1;D1;L1;D1;L1;D1;R1;D1;R1;D1;L1;D1;L3;U1;L1"

6000
END SUB

