'MAIN PROGRAM FOR THE CALCULATION OF A FAULT-FOLD SYSTEM
'
'System of layers in plane strain, linear viscous/elastic incompressible
'
'The SUB include:
'
'   MULTILYR to select the multilayer (maximum 10 layers)
'   MATRIX to generate the matrix of coefficients
'   SOLVE to solve the linear system of equations
'   ALLAYERS to plot the solution for the entire sequence
'   ONELAYER to plot the details of one layer
'$DYNAMIC
DECLARE SUB MATRIX (FREE$, T(), G(), A#(), XT#(), NL, K#(), m#(), NW, LG, WN, TT, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$) '$DYNAMIC
DECLARE SUB MULTILYR (T(), G(), A#(), XT#(), NL, K#(), m#(), NW, LG, WN, TT, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$)     '$DYNAMIC
DECLARE SUB SOLVE (T(), G(), A#(), XT#(), NL, K#(), m#(), NW, LG, WN, TT, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$)        '$DYNAMIC
DECLARE SUB ONELAYER (FREE$, ZSTR$, T(), G(), A#(), XT#(), NL, K#(), m#(), NW, LG, WN, TT, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$) '$DYNAMIC
DECLARE SUB ALLAYERS (FREE$, ZSTR$, T(), G(), A#(), XT#(), NL, K#(), m#(), NW, LG, WN, LAYER, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$) '$DYNAMIC
DECLARE SUB FOURIER (T(), G(), A#(), XT#(), NL, BF#(), AF#(), m, LG, WN, TT, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$) '$DYNAMIC
DECLARE SUB GRAPH (L, X#(), Y#(), COL, MAX) '$DYNAMIC
DECLARE SUB CURVE (NX, X#(), Y#(), Y$) '$DYNAMIC
DECLARE SUB SETCOL (COL1, COL2) '$DYNAMIC
MAXWAVE = 321: MAXLAYER = 11
99 DIM T(25), G(25), A#(4 * MAXLAYER, 4 * MAXLAYER + 1), XT#(MAXLAYER * 4, MAXWAVE), K#(2 * MAXWAVE), m#(2 * MAXWAVE), COLNUM%(20)
DIM X#(200), Y#(200)
'
'Default values
'
    LG = 80000: W = LG / 2: VERT = 1: HORIZ = 0
    FT = 1: FY = 2.4: PI = 4 * ATN(1)
    GI = 10: N = 1: ZSTR$ = "S": CLS
    COLOR (4)
    LOCATE 1, 20
FOR I = 1 TO 36
    PRINT CHR$(219);
NEXT I
    LOCATE 2, 20
FOR I = 1 TO 36
    PRINT CHR$(219);
NEXT I
    LOCATE 3, 20
FOR I = 1 TO 36
    PRINT CHR$(219);
NEXT I
    LOCATE 4, 20
FOR I = 1 TO 36
    PRINT CHR$(219);
NEXT I

    LOCATE 2, 35
    COLOR (15)
    PRINT "FOLTING"
    LOCATE 3, 28
    PRINT "FOL";
    COLOR (2): PRINT "ding and faul";
    COLOR (15): PRINT "TING"
    COLOR (2)
    'PRINT " of a layered sequence";
    LOCATE 6, 1
    PRINT "Deformation of an elastic (or viscous) multilayer due to basement displacement"
    PRINT
    COLOR (6)
    PRINT "                    A QuickBasic program by Ze'ev Reches"
    PRINT "                         Version 2.0 January, 1996"
    PRINT
    COLOR (15)
    FACT = 1
    PRINT "This is an interactive program that prompts for input and suggests defaults."
    PRINT "Defaults appear in [SQUARE BRACKETS] that are activated by hitting RETURN. "
    PRINT "Input units: model dimensions in kilometers; displacements in meters;"
    PRINT "             shear moduli and stress output in MPa; density in kg/m3"
    INPUT "To read instructions/bibliography- hit any letter [CONTINUE] "; Y$
    IF Y$ = "" THEN GOTO 1
    CLS
    COLOR (15)
    PRINT
    PRINT "                           GENERAL INSTRUCTIONS"
    PRINT
    PRINT "This is an interactive program, prompting for input data and user's response. "
    PRINT "Input files *.LYR for the multilayer properties and *.DSP for the basement"
    PRINT "  displacements, can be prepared either on a wordprocessor OR in this program."
    PRINT "  Some input files are enclosed (ASCII format, extensions *.DSP or *.LYR); "
    PRINT "  they should reside in the default directory."
    PRINT "For hard copies: run FOLTING in DOS window under WINDOWS 3.1; hit PrintScreen"
    PRINT "  to copy screen display to clipboard; paste into a Windows graphic program."
    PRINT "Screen plots can be displayed in two color schemes.  The default is red-green "
    PRINT "  grading that suits the VGA monitor but produces poor results on B&W printer."
    PRINT "  The second produces good grading in gray tunes on AppleLaser printer after "
    PRINT "  pasting into PowerPoint of Windows 3.1."
    PRINT "Main running stages are: "
    PRINT "  A.     Entering mechanical parameters of the multilayer;"
    PRINT "  B.     Entering basement displacement;"
    PRINT "  C.     Running and displaying selected screen plots."
    PRINT
    PRINT "If you enter wrong data during stages A. or B., stop (Ctrl-Break) and rerun."
    PRINT "  Stage C. repeats itself as many times as you wish; no need to rerun."
    PRINT
    INPUT "For bibliography list - hit any letter [CONTINUE] "; Y$
    IF Y$ = "" THEN GOTO 1
    CLS
    PRINT
    PRINT "References in which the analytical basis of FOLTING is presented:"
    PRINT
    PRINT "Sanford, A., R., 1959, Analytical and experimental study os simple geological"
    PRINT "     structures, Geol. Soc. Am. Bull., 70, 19-52"
    PRINT "Gangi, A. F., et al., 1977, Experimental folding of rocks under confining"
    PRINT "     pressure: Part IV-theoretical analysis of faulted drape-folds, "
    PRINT "     Tectonphysics, 42, 227-260"
    PRINT "Reches, Z., and A.M. Johnson, 1978, The development of monoclines,"
    PRINT "     Part II:  Mechanical analysis of monoclines, in Laramide Folding..."
    PRINT "     Geol. Soc. Am. Mem. 151, 278-311."
    PRINT "Reches, Z. and G. Schubert, 1987, The tectonic deformation of the"
    PRINT "     Arabian plate since the Miocene, Tectonics, 6, 707-725."
    PRINT "Patton, T.L., and Fletcher, R.C., 1995, Mathematical block-motion model for "
    PRINT "     deformation of a layer above a buried fault of arbitrary dip and send of"
    PRINT "     slip, J. Structural Geology, 17, 1455-1472."
    PRINT "Reches, Z., and Zoback, M. D., 1995, Mechanical modelling of a fault-fold"
    PRINT "     system with application to the Loma Prieta earthquake, 1989, in "
    PRINT "     US Geological Survey Professional Paper #1550, Vol. 1, Ch. H (in press)"
    PRINT "Reches, Z., 1996, Deformation of the layered sequence in a fault-fold system"
    PRINT "     due to basement faulting: calculations with the program FOLTING,"
    PRINT "     J. Structural Geology (submitted)"
    PRINT
    INPUT "Ready to continue [YES] "; OK
    CLS
1   PRINT : PRINT "ENTER PROPERTIES OF THE DEFORMING MULTILAYER"
    PRINT
    NAME$ = "ONE.LYR"
   
    PRINT "Multilayer files (*.LYR) available in directory ";
    FILES "*.lyr"
    PRINT
    PRINT "Above names indicate either rock sequence site or mulitlayer properties."
    PRINT "Legend for multilayer properties:"
    PRINT "  First digit=number of layers;"
    PRINT "  Letters that follow _  indicate position of stiffer layers in the sequence:"
    PRINT "     CENTer, UP, DWon, UPWaRd, DoWnWaRd (upward or downward stiffening);"
    PRINT "  Last digits = total thickness in 100 m."
    PRINT
    PRINT "Options:"
    PRINT "  1. Examine properties of listed multilayers or make a new one- hit a letter"
    PRINT "  2. Enter FILENAME of selected multilayer from above list"
    PRINT "  3. [Run ONE.LYR] the fastest file to run ";
    INPUT Y$
    TT = LEN(Y$)
IF Y$ <> "" AND TT = 1 THEN CALL MULTILYR(T(), G(), A#(), XT#(), NL, K#(), m#(), NW, LG, WN, TT, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$)

    IF Y$ <> "" AND TT > 1 THEN NAME$ = Y$
OPEN NAME$ FOR INPUT AS #2
INPUT #2, NL
FOR I = 1 TO NL
INPUT #2, T(I), G(I)
NEXT I
CLOSE

18  PRINT
     PRINT "Present analysis is set for BONDED (no slip) contacts between layers."
     INPUT "For analysis with FREE SLIP contacts- hit any letter [BONDED LAYER CONTACTS] "; FREE$
     IF FREE$ <> "" THEN FREE$ = "F"
    PRINT : PRINT
    PRINT "Gravity stresses within incompressible layers induces isotropic, lithostatic"
    PRINT "  pressure that equals to the vertical load. Gravity stresses are used here"
    PRINT "  to plot stress intensity maps.  Two options are offered for these maps:"
    PRINT "  1. Byerlee Law Factor: BLF = ("; CHR$(229); "1 - "; CHR$(229); "3) / ("; CHR$(229); "1 + "; CHR$(229); "3) "
    PRINT "     According to Byerlee law,"; CHR$(231); " = 0.85 "; CHR$(229); "n; thus:"
    PRINT "     when BLF = 0.65  yielding occurs along ideally oriented fractures, "
    PRINT "     when 0.65 "; CHR$(242); " BLF "; CHR$(242); " 1, yielding occurs also along poorly oriented fractures,"
    PRINT "     when BLF > 1, "; CHR$(229); "3 is tensile and tensile fractures are expected."

    PRINT "  2. {local maximum shear stress = 0.5 ("; CHR$(229); "1 - "; CHR$(229); "3)} (in units of shear moduli)"
    PRINT "Enter rock density for the calculation of the vertical load"
    INPUT "                  (same density is assumed for all layers) (kg/m3) [2650] "; RHO
    IF RHO = 0 THEN RHO = 2650
    RHO = -RHO
    PRINT
    RHO = RHO * GI / 1000000
    CLS
    PRINT "Several displacement files are enclosed (all with 161 points unless specified): "
    COLOR (2)
    PRINT " VERTICAL.DSP- displacement of rigid basement with vertical fault,"
    PRINT " REVERSE.DSP - displacement of rigid basement with 45 degrees reverse fault,"
    PRINT " NORMAL.DSP - displacement of rigid basement with 45 degrees normal fault,"
    PRINT " RAMON.DSP- displacement of rigid basement plug with vertical walls,"
    PRINT " COMPRESS.DSP - linear horizontal shortening of the base,"
    PRINT " TENSION.DSP - linear horizontal extension of the base."
    PRINT " PALI.DSP - interpreted displacement for the Palisades monocline (Reches, 1978)"
    PRINT " ZERO.DSP - very small basal displacement "
    PRINT " RVRSFINE.DSP - same as REVERSE.DSP with ultra resolution (321 points)"
    PRINT " RAMP.DSP - assumed basal displacement for a ramp structure (Rich's model)"
    PRINT " BASIN.DSP - subsiding basin along a curved surface (not faulted)"
    PRINT " DETACH.DSP - basal displacement along a discontinuous detachment surface"
    COLOR (15)
    PRINT "These files provide the displacements for half-a-cycle of an infinitely long"
    PRINT " periodic displacement."
    PRINT ""
    INPUT "Want instructions to make a basement displacement file [NO] "; in$
    IF in$ = "" THEN GOTO 114
    COLOR (2)
    PRINT
    PRINT
    PRINT "A variety of displacement profiles along multilayer base are given in "
    PRINT "  the enclosed files of *.DSP.  Each line in these files includes three numbers:"
    PRINT "  distance from origin (km); vertical, horizontal displacements at the point (m)"
    PRINT "The enclosed *.DSP files are of two type: files with 161 lines that generate"
    PRINT "  fine resolution of 160 wavelengths in the analysis, and files with 321 lines"
    PRINT "  that generate ultra-fine resolution with 320 wavelengths in the Fourier "
    PRINT "  analysis. Running ultra-fine files provides better resolution in the basal"
    PRINT "  displacement, but the program may run into numerical overflow.  In case of "
    PRINT "  overflow use lower resolution in the *.DSP files (number of lines can be as "
    PRINT "  as 21), OR use thinner layers.  Example: run RVRSFINE.DSP once with ONE.LYR"
    PRINT "  (1 km thick) and get overflow, and again with ONE_025.LYR (0.25 km thick)."
    PRINT
    PRINT "Note: the 'width' of a fault specified by basal displacement is approximately"
    PRINT "  the ratio of {length of LONGEST wave = 2 * max. distance in *.DSP file} to"
    PRINT "  {number of waves in the Fourier analysis = number of the point in *.DSP file}"
    PRINT "  (see Patton and Fletcher, 1995, J. Structural Geology)."
    PRINT
    COLOR (15)
    PRINT "Basement displacement may be entered in one of these options:"
    PRINT " 1. Make an ASCII file similar to *.DSP (use spreadsheet) (best option)"
    PRINT " 2. Prepare file graphically when asked later for KEYBOARD entry of displacement"
    PRINT " 3. Choose one of the displacement files to be listed next [CONTINUE] ";
    INPUT BASAL$
    IF BASAL$ = "C" OR BASAL$ = "c" THEN CALL CURVE(NX, X#(), Y#(), Y$)
114 PRINT
    IF TEMPV <> 0 THEN VERT = TEMPV
    HORIZ = VERT
    PRINT
    IF BASAL$ = "" THEN CALL FOURIER(T(), G(), A#(), XT#(), NL, K#(), m#(), NW, LG, WN, TT, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$)

     LOCATE 28, 1
     PRINT "       Solving for "; NL; " layers.  Now the          out of "; NW; "wavelengths";
FOR I = 1 TO NW
     TT = I
     WN = 2 * PI * I / LG
     LOCATE 28, 42: PRINT I;
        CALL MATRIX(FREE$, T(), G(), A#(), XT#(), NL, K#(), m#(), NW, LG, WN, TT, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$)
        CALL SOLVE(T(), G(), A#(), XT#(), NL, K#(), m#(), NW, LG, WN, TT, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$)
NEXT I

500     CLS : SCREEN 0
      COLOR (4)
      PRINT "SCREEN DISPLAY"
      PRINT "  Output is presented in two dimensional sections of the analyzed sequence."
      PRINT "  Intensities are divided into 10 levels shown in red-green scale for:"
      PRINT "     {local maximum shear stress} = ("; CHR$(229); "1 - "; CHR$(229); "3) / 2,   OR"
      PRINT "     the ratio BLF = ("; CHR$(229); "1 - "; CHR$(229); "3) / ("; CHR$(229); "1 + "; CHR$(229); "3) OR"
      PRINT "     {local maximum shear strain} = ("; CHR$(238); "1 - "; CHR$(238); "3) /2."
      PRINT "  Small circles show that ("; CHR$(229); "1 + "; CHR$(229); "3)  is TENSILE."
      
      PRINT "     Tensile mean pressure indicates jointing and fracture dilation."
      PRINT "  Displacements shown in white lines."
      PRINT "  Trends of maximum local compression are shown in short white lines."
      PRINT "  Positions within cross-sections are given by # of layer (top=#1), and by "
      PRINT "     X,Z square. Square(1,1) is top-left for each layer; X counts left to right"
      PRINT "     and Z points downward."
      PRINT "HARD-COPIES"
      PRINT "     Run program as DOS window under WINDOWS; capture by PrintScreen; paste "
      PRINT "     into a WINDOWS program (e.g., PaintBrush, PowerPoint); modify; print"
COLOR (2)
        PRINT "Screen display options:"
        PRINT "      -   Plot stresses and displacements for all layers [DEFAULT]"
        PRINT "      -   Enter the number of a single layer for its plot "
        PRINT "      -   Enter 55 to select STRAIN intensity plot, or STRESS intensity plot"
        PRINT "      -   Enter 66 to select TYPE of stress intensity plot"
        PRINT "      -   Enter 88 to stop"
       
        INPUT "Enter selection [PLOT ALL LAYERS] "; LAYER
COLOR (15)
        PRINT
        PRINT
        IF LAYER = 88 THEN STOP
        IF LAYER > NL AND LAYER < 20 THEN PRINT
        IF LAYER > NL AND LAYER < 20 THEN PRINT "Error in option selection"
        IF LAYER > NL AND LAYER < 20 THEN GOTO 500

                IF LAYER = 0 THEN CALL ALLAYERS(FREE$, ZSTR$, T(), G(), A#(), XT#(), NL, K#(), m#(), NW, LG, WN, LAYER, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$)
                IF LAYER = 0 THEN GOTO 500
                IF LAYER < 20 THEN CALL ONELAYER(FREE$, ZSTR$, T(), G(), A#(), XT#(), NL, K#(), m#(), NW, LG, WN, LAYER, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$)
    IF LAYER = 66 THEN PRINT "The stress intensity maps have two plotting options:"

    IF LAYER = 66 THEN PRINT "  1. Byerlee Law Factor: BLF = ("; CHR$(229); "1 - "; CHR$(229); "3) / ("; CHR$(229); "1 + "; CHR$(229); "3) "
    IF LAYER = 66 THEN PRINT "     According to Byerlee law,"; CHR$(231); " = 0.85 "; CHR$(229); "n; thus:"
    IF LAYER = 66 THEN PRINT "     when BLF = 0.65  yielding occurs along ideally oriented fractures, "
    IF LAYER = 66 THEN PRINT "     when 0.65 "; CHR$(242); " BLF "; CHR$(242); " 1, yielding occurs also along poorly oriented fractures,"
    IF LAYER = 66 THEN PRINT "     when BLF > 1, "; CHR$(229); "3 is tensile and tensile fractures are expected."

    IF LAYER = 66 THEN PRINT "  2. {local maximum shear stress = 0.5 ("; CHR$(229); "1 - "; CHR$(229); "3)} (in units of shear moduli)"
    IF LAYER = 66 THEN PRINT
    IF LAYER = 66 THEN PRINT "Stress intensity plotting is currently set for"
        IF LAYER = 66 AND ZRO$ <> "" THEN GOTO 501
        IF LAYER = 66 AND ZRO$ = "" THEN PRINT "                   {local maximum shear stress} "
        IF LAYER = 66 THEN PRINT "Change plotting to BLF = ("; CHR$(229); "1 - "; CHR$(229); "3) / ("; CHR$(229); "1 + "; CHR$(229); "3) -any key [NO]";
        IF LAYER = 66 THEN INPUT YS$
        IF YS$ <> "" THEN ZRO$ = "w"
        IF LAYER = 66 THEN GOTO 500
501     IF LAYER = 66 THEN PRINT "                 BLF = ("; CHR$(229); "1 - "; CHR$(229); "3) / ("; CHR$(229); "1 + "; CHR$(229); "3)"
        IF LAYER = 66 THEN INPUT "Change plotting to {local maximum shear stress} - any letter [NO CHANGE]"; YS$
        IF YS$ <> "" THEN ZRO$ = ""
        IF LAYER = 66 THEN GOTO 500
   
    IF LAYER = 55 THEN PRINT "Intensity maps display either stresses or strains:"
    IF LAYER = 55 THEN PRINT "   1. Stresses (more details in option 66 above)"
    IF LAYER = 55 THEN PRINT "   2. Strains- intensity of {local maximum shear strain} = ("; CHR$(238); "1 - "; CHR$(238); "3) /2"
    PRINT
    IF LAYER = 55 AND ZSTR$ = "E" THEN GOTO 507
    IF LAYER = 55 AND ZSTR$ = "S" THEN PRINT "Intensity plots are set for STRESS (check option 66 above)"
    IF LAYER = 55 THEN PRINT "Change to {maximum shear strain=("; CHR$(238); "1 - "; CHR$(238); "3) /2} - hit any letter [NO CHANGE]";
    IF LAYER = 55 THEN INPUT YSTR$
    IF YSTR$ <> "" THEN ZSTR$ = "E"
    GOTO 500
507 '
    IF LAYER = 55 AND ZSTR$ = "E" THEN PRINT "Intensity plots are set for STRAIN, plotting "
    IF LAYER = 55 AND ZSTR$ = "E" THEN PRINT "           {local maximum shear strain} = ("; CHR$(238); "1 - "; CHR$(238); "3) /2"
    IF LAYER = 55 THEN INPUT "For plotting stresses- any letter and select option 66 later [NO CHANGE]"; YSTR$
    IF YSTR$ <> "" THEN ZSTR$ = "S"
    GOTO 500

SUB ALLAYERS (FREE$, ZSTR$, T(), G(), A#(), XT#(), NL, K#(), m#(), NW, LG, WN, LAYER, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$) '

   DIM WZ(41, 11), UZ(41, 11), COLNUM%(40)
   DIM S11(23, 6, 11), S22(23, 6, 11), THET(23, 6, 11), XAF(500), YAF(500), FTYPE(500)
6   CLS : SCREEN 0
    RO = RHO: IFINE1 = 0: IFINE2 = 0: IFINE3 = 0: IFINE4 = 0
    THICK = 0
FOR I = 1 TO NL
        THICK = THICK + T(I)
NEXT I
    SCDISP = 35
    PRINT
    PRINT
    PRINT " PARAMETER SELECTION FOR PLOTTING STRESSES AND DISPLACEMENTS OF ALL LAYERS"
    PRINT
    INPUT "Enter new facor for plotting displacement vectors [FACTOR=1] "; FF
    IF FF = 0 THEN FF = 1
    PRINT
'    INPUT "Use color suitable for B&W prints on AppleLaser-any key, [RED-GREEN GRADING] "; YC$
'    IF YC$ <> "" THEN FLAGCOL = 1
'    PRINT
    XPLOT = SCDISP * FF
    FT = 1: FY = 2.4: PI = 4 * ATN(1): GM = 1:  FYC = 400 / 360
    XFINAL = .75: XSTART = .5
   IF ZSTR$ = "S" THEN MAXBLACK = .01
   IF ZSTR$ = "E" THEN MAXBLACK = 0!
   XSCALE = ((XFINAL - XSTART) * LG / 2) / 400
   YSCALE = THICK / XSCALE
   PRINT "Stress intensity plot can be displayed in true scale (no vertical exaggeration) "
   INPUT "Hit 1 for true scale [FULL SCREEN PLOT]"; SPLOT
   PRINT
   INPUT "Enter uniform confinement (MPa) [0] "; PCONF
   PRINT
   IFINE4 = 1
   'INPUT "Plot fine grid (23 by 10)-any key, or [COARSE GRID 13 by 10] "; F$
   F$ = "A"
   IF F$ <> "" THEN IFINE1 = 3
   IF F$ <> "" THEN IFINE2 = 10
   IF F$ <> "" THEN IFINE3 = 1
   IF F$ <> "" THEN IFINE4 = 1.8
   IF F$ <> "" THEN IFINE5 = .8
   PRINT
   PRINT "The plot extends from "; XSTART * LG / 2000; " to "; XFINAL * LG / 2000; " km, "
   PRINT "               that is "; LG / 4000; " km wide (or 1/4 of the longest wavelength)"
   PRINT
   INPUT "Change the width of the plot [NO CHANGE] "; DS$
   IF DS$ = "" THEN GOTO 13
   PRINT "Enter width of plot by START, END as fraction of the 1/2 wavelength."
   INPUT "         Note:       0.0 =<  START < END =< 1.0 "; XSTART, XFINAL
   XSCALE = ((XFINAL - XSTART) * LG / 2) / 400
   YSCALE = THICK / XSCALE


13     CLS : PRINT "   Calculating stresses (or strains)...."
       PRINT "                cycles calculated.  Total is:  "; ((13 + IFINE2) * (3 + IFINE1) - 1) * NW * NL
       NCYCLE = 0
FOR KL = 1 TO NL
     LY = (KL - 1) * 4
     Z = -2 * T(KL) / 3
FOR KZ = 1 TO (3 + IFINE1)
     Z = Z + T(KL) / (IFINE1 + 3)
FOR KX = 1 TO (13 + IFINE2)
        X = (KX - 1) * LG / (24 + 2 * IFINE2)
        X = XSTART * LG / 2 + (KX - 1) * LG * (XFINAL - XSTART) / (24 + 2 * IFINE2)
        SXT = 0: SZT = 0: SXZT = 0
        LOCATE 2, 5: PRINT NCYCLE
FOR I = 1 TO NW
        LAM = 2 * I * PI / LG
        EPZ = EXP(LAM * Z)
        ENZ = EXP(-LAM * Z)
                  SZ = -2 * LAM * ((XT#(LY + 1, I) + XT#(LY + 2, I) * (LAM * Z - 1)) * EPZ + (XT#(LY + 3, I) + XT#(LY + 4, I) * (LAM * Z + 1)) * ENZ) * SIN(LAM * X)
                  SX = 2 * LAM * ((XT#(LY + 1, I) + XT#(LY + 2, I) * (LAM * Z + 1)) * EPZ + (XT#(LY + 3, I) + XT#(LY + 4, I) * (LAM * Z - 1)) * ENZ) * SIN(LAM * X)
                  SXZ = -2 * LAM * ((XT#(LY + 1, I) + XT#(LY + 2, I) * LAM * Z) * EPZ - (XT#(LY + 3, I) + XT#(LY + 4, I) * LAM * Z) * ENZ) * COS(LAM * X)
                  IF ZSTR$ = "S" THEN SZT = SZT + SZ * G(KL)
                  IF ZSTR$ = "E" THEN SZT = SZT + SZ
                  IF ZSTR$ = "S" THEN SXT = SXT + SX * G(KL)
                 
                  IF ZSTR$ = "E" THEN SXT = SXT + SX
                  IF ZSTR$ = "S" THEN SXZT = SXZT + SXZ * G(KL)
                  IF ZSTR$ = "E" THEN SXZT = SXZT + SXZ
        NCYCLE = NCYCLE + 1
NEXT I
        S1 = .5 * (SZT + SXT) + SQR(SXZT ^ 2 + .25 * (SXT - SZT) ^ 2)
        S2 = .5 * (SZT + SXT) - SQR(SXZT ^ 2 + .25 * (SXT - SZT) ^ 2)
              IF SXT = SZT THEN TET = 10000
              IF SXT = SZT AND SXT < 0 THEN TET = -10000
              IF SXT = SZT THEN THETA = ATN(TET) / 2
              IF SXT = SZT THEN GOTO 708
              TET = ABS(2 * SXZT / (SXT - SZT))
              THETA = ATN(TET) / 2
        IF SXT > SZT AND SXZT > 0 THEN GOTO 708
        IF SXT > SZT AND SXZT < 0 THEN GOTO 702
        IF SXT < SZT AND SXZT > 0 THEN GOTO 703
        IF SXT < SZT AND SXZT < 0 THEN GOTO 704
702 THETA = -THETA
        GOTO 708
703 THETA = -THETA + PI / 2
        GOTO 708
704 THETA = THETA - PI / 2
708
    S11(KX, KZ, KL) = S1 + PCONF
    S22(KX, KZ, KL) = S2 + PCONF
    THET(KX, KZ, KL) = THETA


NEXT KX
NEXT KZ
NEXT KL

'Calculations of stress trajectories and magnitude of shear stress/vertical stress

705 MAX = 0: MIN = 100000: MAXCOMP = 0: Z = 0: ZABOVE = 0
FOR KL = 1 TO NL
        Z = Z + T(KL) / (6 + 2 * IFINE1)
FOR KZ = 1 TO (3 + IFINE1)
FOR KX = 1 TO (13 + IFINE2)
 

IF ZRO$ <> "" THEN RO = RHO
        IF ABS(S22(KX, KZ, KL)) > MAXCOMP THEN MAXCOMP = ABS(S22(KX, KZ, KL))
        IF ZRO$ <> "" THEN SNN = .5 * (Z * RO + S11(KX, KZ, KL) + S22(KX, KZ, KL))
        IF ZRO$ = "" THEN SNN = 1


                IF ABS(.5 * (S11(KX, KZ, KL) - S22(KX, KZ, KL)) / SNN) > MAX THEN XMAX = KX
                IF ABS(.5 * (S11(KX, KZ, KL) - S22(KX, KZ, KL)) / SNN) < MIN THEN XMIN = KX
                IF ABS(.5 * (S11(KX, KZ, KL) - S22(KX, KZ, KL)) / SNN) > MAX THEN ZMAX = KZ
                IF ABS(.5 * (S11(KX, KZ, KL) - S22(KX, KZ, KL)) / SNN) < MIN THEN ZMIN = KZ
                IF ABS(.5 * (S11(KX, KZ, KL) - S22(KX, KZ, KL)) / SNN) > MAX THEN NLMAX = KL
                IF ABS(.5 * (S11(KX, KZ, KL) - S22(KX, KZ, KL)) / SNN) < MIN THEN NLMIN = KL
                IF ABS(.5 * (S11(KX, KZ, KL) - S22(KX, KZ, KL)) / SNN) > MAX THEN MAX = ABS(.5 * (S11(KX, KZ, KL) - S22(KX, KZ, KL)) / SNN)
                IF ABS(.5 * (S11(KX, KZ, KL) - S22(KX, KZ, KL)) / SNN) < MIN THEN MIN = ABS(.5 * (S11(KX, KZ, KL) - S22(KX, KZ, KL)) / SNN)

NEXT KX
     Z = Z + T(KL) / (3 + IFINE1)
NEXT KZ
     Z = Z - T(KL) / (6 + 2 * IFINE1)
NEXT KL
'        IF ZRO$ <> "" THEN MAX = 2
        IF ZRO$ <> "" THEN MIN = 0

       
' Calculating  the displacements

777    LOCATE 3, 1: PRINT "   Calculating displacements...."
       PRINT "                cycles calculated.  Total is:  "; 41 * (NL + 1) * NW
    NCYCLE = 0

FOR KZ = 1 TO NL + 1
        IF KZ <= NL THEN LY = (KZ - 1) * 4
        IF KZ > NL THEN LY = (NL - 1) * 4
        IF KZ <= NL THEN Z = -T(KZ) / 2
        IF KZ > NL THEN Z = T(NL) / 2
FOR KX = 1 TO 41
        WZ(KX, KZ) = 0
        UZ(KX, KZ) = 0
        X = (KX - 1) * (LG / 80)
        X = XSTART * LG / 2 + (KX - 1) * (XFINAL - XSTART) * (LG / 80)
        LOCATE 4, 5
        PRINT NCYCLE
FOR I = 1 TO NW
        LAM = 2 * I * PI / LG
        EPZ = EXP(LAM * Z)
        ENZ = EXP(-LAM * Z)
              W = ((XT#(LY + 1, I) + XT#(LY + 2, I) * (LAM * Z - 1)) * EPZ - (XT#(LY + 3, I) + XT#(LY + 4, I) * (LAM * Z + 1)) * ENZ) * SIN(LAM * X)
              U = ((XT#(LY + 1, I) + XT#(LY + 2, I) * LAM * Z) * EPZ + (XT#(LY + 3, I) + XT#(LY + 4, I) * LAM * Z) * ENZ) * COS(LAM * X)
        WZ(KX, KZ) = WZ(KX, KZ) + W
        UZ(KX, KZ) = UZ(KX, KZ) + U
    NCYCLE = NCYCLE + 1
NEXT I
NEXT KX
NEXT KZ


'        plotting

1101
PRINT
PRINT "Currently maximum, minimum stresses are: ";
PRINT USING " ####.##"; MIN, MAX
INPUT "  Change these values [NO] "; CH$
IF CH$ = "" THEN GOTO 1103
INPUT "Enter NEW maximum, minimum stresses are: "; MIN, MAX

1103 CLS : SCREEN 12
FOR I = 0 TO 10
            IF FLAGCOL <> 1 THEN COLNUM%(I) = 256 * I * 4 + (10 - I) * 6
NEXT I
FOR J = 1 TO 10
            IF FLAGCOL <> 1 THEN PALETTE J, COLNUM%(J)
NEXT J
        IF FLAGCOL <> 1 THEN PALETTE 1, 0

    DX = 400 / (12 + IFINE2)
    IF SPLOT <> 1 THEN ZB = 100
    IF SPLOT = 1 THEN ZB = 460 - YSCALE
    ZABOVE = 0: Z = 0
      IF SPLOT <> 1 THEN DF = 360 / THICK
      IF SPLOT = 1 THEN DF = YSCALE / THICK

FOR KL = 1 TO NL
        ZB = ZB + (T(KL - 1) * DF)
        Z = Z + T(KL) / (6 + 2 * IFINE1)
FOR KZ = 1 TO (3 + IFINE1)
FOR KX = 1 TO (13 + IFINE2)
        XLU = 20 + (KX + IFINE5) * DX - DX / 2
        ZLU = ZB - T(KL) * DF / (6 + 2 * IFINE1) + (KZ - 1) * T(KL) * DF / (3 + IFINE1) + (T(KL) * DF / (6 + 2 * IFINE1))
        XRD = 20 + (KX + IFINE5) * DX + DX / 2
        ZRD = ZB + T(KL) * DF / (6 + 2 * IFINE1) + (KZ - 1) * T(KL) * DF / (3 + IFINE1) + (T(KL) * DF / (6 + 2 * IFINE1))
        IF ZRO$ = "" AND ((ABS(.5 * (S11(KX, KZ, KL) - S22(KX, KZ, KL)) / (Z * RO)))) < MAXBLACK THEN GOTO 333
         
          IF ZRO$ <> "" THEN SNN = .5 * (Z * RO + S11(KX, KZ, KL) + S22(KX, KZ, KL))
          IF ZRO$ = "" THEN SNN = 1
       
        COL1 = 1.2 + 9 * ((ABS(.5 * (S11(KX, KZ, KL) - S22(KX, KZ, KL)) / SNN)) - MIN) / (MAX - MIN)
        IF COL1 < 1.2 THEN COL1 = 0
        IF ZRO$ <> "" AND SNN > 0 THEN COL1 = 10
        IF FLAGCOL = 1 THEN CALL SETCOL(COL1, COL2)
        IF FLAGCOL <> 1 THEN COL2 = COL1
        IF FLAGCOL <> 1 AND COL1 >= 10 THEN COL2 = 10

        IF KX <> 1 AND KX <> (13 + IFINE2) THEN LINE (XLU, ZLU)-(XRD, ZRD), COL2, BF
        IF KX = 1 THEN LINE (XLU + DX / 2, ZLU)-(XRD, ZRD), COL2, BF
        IF KX = (13 + IFINE2) THEN LINE (XLU, ZLU)-(XRD - DX / 2, ZRD), COL2, BF
        IF ZRO$ <> "" AND SNN > 0 THEN CIRCLE ((XRD + XLU) / 2, (ZRD + ZLU) / 2), 1, 0
        IF ZRO$ <> "" AND SNN > 0 THEN CIRCLE ((XRD + XLU) / 2, (ZRD + ZLU) / 2), 2, 0
         
333 XP = (XLU + XRD) / 2
          ZP = (ZLU + ZRD) / 2
          XPR2 = XP + 5 * SIN(THET(KX, KZ, KL))
          ZPR2 = ZP - 5 * COS(THET(KX, KZ, KL))
          XPR3 = XP - 5 * SIN(THET(KX, KZ, KL))
          ZPR3 = ZP + 5 * COS(THET(KX, KZ, KL))
           LINE (XP, ZP)-(XPR2, ZPR2)
           LINE (XP, ZP)-(XPR3, ZPR3)
NEXT KX
     Z = Z + T(KL) / (3 + IFINE1)
NEXT KZ
     Z = Z - T(KL) / (6 + 2 * IFINE1)
NEXT KL
FOR J = 1 TO 10
    COL1 = 11.2 - J
    IF FLAGCOL = 1 THEN CALL SETCOL(COL1, COL2)
    IF FLAGCOL <> 1 THEN COL2 = 11 - J
        LINE (500, 140 + (J - 1) * 20)-(520, 140 + J * 20), COL2, BF
        LINE (500, 140 + (J - 1) * 20)-(520, 140 + J * 20), , B
NEXT J
    LOCATE 8, 60: PRINT "Highest Shear="
    LOCATE 9, 60: PRINT USING "##.##^^^^"; MAX
    LOCATE 22, 60: PRINT "Lowest Shear=";
    LOCATE 23, 60: PRINT USING "##.##^^^^"; MIN
    LOCATE 24, 60: PRINT "Shear intensity step=";
    LOCATE 25, 60: PRINT USING "##.##^^^^"; (MAX - MIN) / 10
    LOCATE 30, 5: PRINT XSTART * LG / 2; " m ";
    LOCATE 30, 54: PRINT XFINAL * LG / 2; " m ";
    LOCATE 29, 60: PRINT "-"; THICK; "m";
    ILINE = INT((440 - YSCALE) * 31 / 480)
    IF SPLOT = 1 THEN LINE (20 + DX * IFINE4, 460 - YSCALE)-(420 + DX * IFINE4, 460), , B
    IF SPLOT <> 1 THEN LINE (20 + DX * IFINE4, 100)-(420 + DX * IFINE4, 460), , B
    LOCATE 4, 54
    IF FREE$ <> "F" THEN PRINT "Bonded layer contacts"
    IF FREE$ = "F" THEN PRINT "Free-slip along contacts"
    LOCATE 5, 54: PRINT "Incompressible layers"
    IF SPLOT = 1 THEN LOCATE ILINE + 1, 60: PRINT "0 m"
    IF SPLOT = 1 THEN LOCATE ILINE, 1: PRINT "Rigidity"
    IF SPLOT = 1 THEN LOCATE ILINE + 1, 1: PRINT "(MPa)"
    IF SPLOT <> 1 THEN LOCATE 6, 59: PRINT "Depth"
    IF SPLOT <> 1 THEN LOCATE 7, 60: PRINT "0 m"
    IF SPLOT <> 1 THEN LOCATE 6, 1: PRINT "Rigidity"
    IF SPLOT <> 1 THEN LOCATE 7, 1: PRINT "(MPa)"

      MAXI = 0: MINI = 1000000!
FOR I = 1 TO NL
      IF G(I) > MAXI THEN MAXI = G(I)
      IF G(I) < MINI THEN MINI = G(I)
NEXT I
    ZB = 100: XLU = 0
    LOCATE 6, 1
    IF SPLOT = 1 THEN DMOD = 30 * (YSCALE / 480) / NL
    IF SPLOT = 1 THEN LD = (30 * (480 - YSCALE) / 480 + DMOD / 2) - 1
    IF SPLOT <> 1 THEN DMOD = 24 / NL
    IF SPLOT <> 1 THEN LD = 6 + DMOD / 2
FOR I = 1 TO NL
    LOCATE LD, 1
    PRINT G(I)
    LD = LD + DMOD
    IF LD >= 29 THEN LD = 29
NEXT I

'Plotting the displacement field on the screen
1091
    LINE (550, 240)-(550 + 2 * SCDISP, 240 + 2 * SCDISP), , B
    LOCATE 13, 68: PRINT "Displacement"
    LOCATE 14, 69: PRINT "  scale="
    LOCATE 15, 69: PRINT USING "##.####"; 2 / FF;
    PRINT "m"

    DX = 400 / 40
    IF SPLOT <> 1 THEN ZB = 100
    IF SPLOT = 1 THEN ZB = 460 - YSCALE
    ZABOVE = 0: Z = 0
      IF SPLOT <> 1 THEN DF = 360 / THICK
      IF SPLOT = 1 THEN DF = YSCALE / THICK
FOR KZ = 1 TO NL + 1
        ZB = ZB + (T(KZ - 1) * DF)
FOR KX = 1 TO 41
        XB1 = 20 + 400 / 12 + (KX - 1) * DX
        XB2 = XB1 - UZ(KX, KZ) * XPLOT * FACT
        ZB2 = ZB - WZ(KX, KZ) * XPLOT
             LINE (XB1, ZB)-(XB2, ZB2)
        IF KX < 41 THEN XB3 = XB1 + DX - UZ(KX + 1, KZ) * XPLOT * FACT
        IF KX < 41 THEN ZB3 = ZB - WZ(KX + 1, KZ) * XPLOT
            IF KX < 41 THEN LINE (XB2, ZB2)-(XB3, ZB3)
NEXT KX
NEXT KZ

        LINE (20 + 400 / 12, 460)-(420 + 400 / 12, 460)
FOR I = 1 TO 11
             LINE (20 + 400 / 12 + 40 * (I - 1), 463)-(20 + 400 / 12 + 40 * (I - 1), 460)
NEXT I
   
   
    VER = THICK / (126 * 2.4): HOR = LG / 800
    VERT1 = VERT + .00001
    DOWN = VER * 40: SIDE = DOWN * HORIZ / VERT1
    SIDE = SIDE / HOR
    'LOCATE 17, 71: PRINT "2m by 2m";
    IF NAME$ = "" THEN NAME$ = "DEFAULT"
    LOCATE 1, 1

    IF ZSTR$ = "S" THEN PRINT "Displ./stress,"; NL; "layers of "; NAME$; ", Basal displ.: "; FA$; "  "; DATE$
    IF ZSTR$ = "E" THEN PRINT "Displ./strain,"; NL; "layers of "; NAME$; ", Basal displ.: "; FA$; "  "; DATE$

    PRINT "Max. vert. displ."; VERT; "m, Short lines: trend (not magnitude) of max compression. "
    IF ZRO$ = "" AND ZSTR$ = "S" THEN PRINT "Shear stress:";
    IF ZRO$ <> "" AND ZSTR$ = "S" THEN PRINT "Shear/overburden:";
    IF ZSTR$ = "E" THEN PRINT "Shear strain:";
    PRINT "MAX. in LAYER#"; NLMAX; "X,Z:"; XMAX; ","; ZMAX; "& MIN. in LAYER#"; NLMIN; " X,Z:"; XMIN; ","; ZMIN
    INPUT "C- change colors, 1- back to menu [new max/min] "; CONT$
    IF CONT$ = "1" THEN GOTO 308
    IF CONT$ = "" THEN GOTO 1101
    IF CONT$ = "c" OR CONT$ = "C" THEN CONT$ = "C"
    IF CONT$ = "C" AND FLAGCOL = 1 THEN GOTO 1302
    IF CONT$ = "C" AND FLAGCOL = 0 THEN FLAGCOL = 1
    GOTO 1303
1302    FLAGCOL = 0
1303   GOTO 1101
    CLS
308 END SUB

SUB CURVE (NU, XL#(), YL#(), Y$) '
        CLS : SCREEN 12
        PRINT "The following procedure is recommended for tinkering with various basal"
        PRINT "  displacements and exploring their effects on the Fourier spectra."
        PRINT "Entering basal displacements in this procedure is faster then"
        PRINT "  preparing a *.DSP file on a spreadsheet. However, the control on the"
        PRINT "  entries is more limited here, and it is not practical to utilize the"
        PRINT "  full possible resolution of the program (160-320 wavelengths)."
        PRINT
        PRINT "To continue with this procedure, push the CapsLock key and use the keys listed "
        PRINT "  below to draw the basal displacement. For each point enter"
        PRINT "      vertical displacement, V, with I & M keys, and"
        PRINT "      horizontal displacement, U, with J & K keys."
        PRINT
        INPUT "Length of the basement stretch for which displacement is entered (km) [10 km]"; GLEN
        IF GLEN = 0 THEN GLEN = 10
        PRINT "Number of points along above basement stretch for X,Y displacements"
        PRINT "  entry (=< 161 points) [21] "
        INPUT "(note: number of points=number of wavelengths the Fourier analysis) "; NU
                IF NU = 0 THEN NU = 20
        INPUT "Cursor speed (1-5) [2] "; CS
        IF CS = 0 THEN CS = 2
        IF Y$ <> "Y" AND Y$ <> "y" THEN GOTO 20
                MAX = 0
      FOR I = 0 TO NU
                        IF ABS(XL#(I)) > MAX THEN MAX = ABS(XL#(I))
                        IF ABS(YL#(I)) > MAX THEN MAX = ABS(YL#(I))
    NEXT I
FOR I = 0 TO NU
                XL#(I) = XL#(I) * CS * 20 / MAX: YL#(I) = YL#(I) * CS * 20 / MAX
NEXT I

20 CLS
FOR I = 0 TO NU
                X = 100 + I * 300 / NU: Y = 240
                CIRCLE (X, Y), 1
NEXT I
                LOCATE 1, 7: PRINT "I=up"
                LOCATE 2, 1: PRINT "J=left"
                LOCATE 2, 10: PRINT "K=right"
                LOCATE 3, 7: PRINT "M=down"
                LOCATE 5, 1: PRINT "L= forward point   H= backward point"
                LOCATE 6, 1: PRINT "      S= redraw the entire line"
                LOCATE 2, 40: PRINT "NOTE:    SET CAPS LOCK"
                LOCATE 26, 1: PRINT "Current Point (km)   Vertical (m)  Horizontal (m)"
FOR I = 0 TO NU
FOR J = 1 TO NU
               
                LINE (100 + (J - 1) * 300 / NU + XL#(J - 1), 240 + YL#(J - 1))-(100 + J * 300 / NU + XL#(J), 240 + YL#(J)), 7
NEXT J
11 DO
        CIRCLE (100 + I * 300 / NU, 240), 1, 3
        A$ = INKEY$
        IF A$ = "L" THEN GOTO 103
        IF A$ = "S" THEN GOTO 120
        IF A$ = "H" THEN I = I - 1
                IF A$ = "I" THEN YL#(I) = YL#(I) - CS
                IF A$ = "M" THEN YL#(I) = YL#(I) + CS
                IF A$ = "J" THEN XL#(I) = XL#(I) - CS
                IF A$ = "K" THEN XL#(I) = XL#(I) + CS
        X = 100 + I * 300 / NU + XL#(I): Y = 240 + YL#(I)
        LINE (100 + I * 300 / NU, 240)-(X1, Y1), 0
                PSET (X, Y)
        LINE (100 + I * 300 / NU, 240)-(X, Y)
        X1 = X: Y1 = Y
        LOCATE 28, 1: PRINT USING "        ##.##   "; I * GLEN / NU, YL#(I) / 20, XL#(I) / 20
LOOP
103 NEXT I
120 CLS
        LINE (1, 240)-(100, 240)
FOR I = 1 TO NU + 1
                LINE (100 + (I - 1) * 300 / NU + XL#(I - 1), 240 + YL#(I - 1))-(100 + I * 300 / NU + XL#(I), 240 + YL#(I)), 7
NEXT I
        BB$ = "TEMP.DSP"
        PRINT "Displacement data is saved in file TEMP.DSP (rename later is needed)"
        INPUT "Hit R - to correct curve [NO CORRECTION] "; B$
        IF B$ = "R" OR B$ = "r" THEN GOTO 20
OPEN BB$ FOR OUTPUT AS #3
FOR I = 0 TO NU
                PRINT #3, I * GLEN / NU;
                PRINT #3, USING ", ###.###,"; YL#(I) / 20;
                PRINT #3, USING " ###.###"; XL#(I) / 20
NEXT I
CLOSE
31 CLS
END SUB

SUB FOURIER (T(), G(), A#(), XT#(), NL, BF#(), AF#(), m, LG, WN, TT, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$) '
DIM X#(750), Y#(750), C#(750), D#(750), DIST(750)
PI = ATN(1!) * 4
IF MAXNU = 0 THEN MAXNU = 321
FA$ = "RAMON.DSP"


4 PRINT "Available displacement files (*.DSP) in: ";
FILES "*.dsp"
PRINT
PRINT "Selected basal displacement:"
PRINT "   1.  Enter displacement FILENAME (from above list or your own)"
PRINT "   2.  Enter the basal displacement through the keyboard - hit K"
PRINT "   3.  Use default displacement file ["; FA$; "] ";
INPUT A$
        IF A$ = "K" OR A$ = "k" THEN CALL CURVE(NX, X#(), Y#(), Y$)
        IF A$ = "K" OR A$ = "k" THEN FA$ = "TEMP.DSP"
        IF A$ <> "" AND LEN(A$) > 1 THEN FA$ = A$
        OPEN FA$ FOR INPUT AS #2
    NX = -1
        WHILE NOT EOF(2)
                NX = NX + 1

               INPUT #2, DIST(NX), Y#(NX), X#(NX)
        WEND
    CLOSE #2
    SA$ = ""
FOR I = 0 TO NX - 1
    J = 2 * NX - I
    X#(J) = X#(I)
    Y#(J) = -Y#(I)
    DIST(J) = 2 * DIST(NX) - DIST(I)
NEXT I
    LG = 1000 * DIST(2 * NX)
    NX = 2 * NX
    FACNU = INT(NX / MAXNU)
    IF FACNU < 2 OR NX <= MAXNU THEN GOTO 78
    J = 0
FOR I = 0 TO NX STEP FACNU
    J = J + 1
    X#(J) = X#(I)
    Y#(J) = Y#(I)
NEXT I
    NX = J
78  CLS : Y$ = "JUNK"
    L = INT(NX / 2): m = L
    LM = 2 * PI / (2 * L + 1)
    IF L < 40 THEN LM = 2 * PI / (2 * L)
FOR J = 1 TO 2 * L
        X#(J) = HORIZ * X#(J)
        Y#(J) = VERT * Y#(J)
NEXT J
101    COL = 5
        CALL GRAPH(L, X#(), Y#(), COL, MAX)
LINE (1, 371)-(50, 371), 5
LINE (200, 371)-(250, 371), 2
LINE (400, 371)-(450, 371), 11

LOCATE 24, 10: PRINT "Initial form"
LOCATE 24, 33: PRINT "Recalculated"
LOCATE 24, 60: PRINT "Frequency spectrum"

LOCATE 2, 1
PRINT "VERTICAL basal displacement"
LOCATE 2, 44
PRINT "HORIZONTAL basal displacement"
LOCATE 25, 1

5 PRINT "File "; FA$; " starts at: "; DIST(0); " km, ends at: "; DIST(NX / 2); " km."
PRINT "Longest wave: "; LG / 1000; " km, Maximum displacement is "; MAX; " meters."
PRINT "Vertical displacement plotted on left, horizontal displacement plotted on right."
INPUT "To try another *.DSP file-hit any key [CONTINUE WITH THIS ONE]"; C$
IF C$ <> "" THEN CLS
IF C$ <> "" THEN GOTO 4

IF C$ = "" THEN LINE (0, 385)-(640, 480), 0, BF

7     LOCATE 25, 1


PRINT "I am working on Fourier analysis of basal displacement. Multi-purpose plots:"
PRINT " Purple: amplitude vs distance of basal displacement; light blue: amplitude vs"
PRINT " wavenumber of the Fourier spectrum; green: recalculated basal displacements."
PRINT " Please wait.... ";

FOR K = 1 TO m
        BF#(K) = 0
FOR NX = 1 TO 2 * m
        BF#(K) = BF#(K) + Y#(NX) * SIN(LM * NX * K)
NEXT NX
        BF#(K) = BF#(K) * 2 / (2 * L + 1)
NEXT K
PRINT " Please wait.... ";
FOR NX = 1 TO 2 * m
        C#(NX) = 0
FOR J = 1 TO m
        C#(NX) = C#(NX) + BF#(J) * SIN(LM * J * NX)
NEXT J
NEXT NX
        PRINT " Please wait.... ";
FOR K = 1 TO m
        AF#(K) = 0
FOR NX = 1 TO 2 * m
        AF#(K) = AF#(K) + X#(NX) * COS(LM * NX * K)
NEXT NX
        AF#(K) = AF#(K) * 2 / (2 * L + 1)
NEXT K
        PRINT " Please wait.... "
FOR I = 1 TO 2 * m
        D#(I) = 0
FOR J = 1 TO m
        D#(I) = D#(I) + AF#(J) * COS(LM * J * I)
NEXT J
NEXT I

COL = 2
CALL GRAPH(L, D#(), C#(), COL, MAX)

FX = 150 / L
MAX = 0
FOR J = 1 TO 2 * L
        IF ABS(AF#(J)) > MAX THEN MAX = ABS(AF#(J))
        IF ABS(BF#(J)) > MAX THEN MAX = ABS(BF#(J))
NEXT J

COL = 11
        CALL GRAPH(L, AF#(), BF#(), COL, MAX)
   
FOR J = 1 TO 2 * L
        AF#(J) = -AF#(J)
        BF#(J) = -BF#(J)
NEXT J
LOCATE 29, 1
INPUT "I finished... [CONTINUE] "; OK
END SUB

SUB GRAPH (L, X#(), Y#(), COL, MAX) '

FX = 300 / L
SCREEN 12
LINE (0, 200)-(300, 200)
LINE (330, 200)-(630, 200)
LINE (1, 40)-(300, 360), , B
LINE (330, 40)-(630, 360), , B

MAX = 0
FOR J = 0 TO L
        IF ABS(X#(J)) > MAX THEN MAX = ABS(X#(J))
        IF ABS(Y#(J)) > MAX THEN MAX = ABS(Y#(J))
NEXT J
LOCATE 3, 30
PRINT "Maximum = ";
PRINT USING " ##.##^^^^"; MAX
LOCATE 4, 30
PRINT "Input of "; L; " points ";

PSET (0, 200 + Y#(0) * 150 / MAX)
FOR NX = 1 TO L
        LINE -(NX * FX, 200 + Y#(NX) * 150 / MAX), COL
NEXT NX

PSET (330, 200 + X#(0) * 150 / MAX)
FOR NX = 1 TO L
        LINE -(330 + NX * FX, 200 + X#(NX) * 150 / MAX), COL
NEXT NX
END SUB

SUB MATRIX (FREE$, T(), G(), A#(), XT#(), NL, K#(), m#(), NW, LG, WN, TT, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$) '

'  Filling the matrix of the coefficients
'
        KC = -1: PI = 4 * ATN(1): NB = NL * 4 + 1
FOR I = 1 TO NL * 4
FOR J = 1 TO NB
        A#(I, J) = 0
NEXT J
NEXT I


FOR I = 1 TO NL
G(I) = G(I) / 2000
NEXT I
'
'  Calculating the B.A. at the top surface, layer #1, at z=0
'
        EP1 = EXP(-WN * T(1) / 2): EN1 = EXP(WN * T(1) / 2)
        A#(1, 1) = G(1) * EP1
        A#(1, 2) = G(1) * (-1 - (WN * T(1) / 2)) * EP1
        A#(1, 3) = G(1) * EN1
        A#(1, 4) = G(1) * (1 - (WN * T(1) / 2)) * EN1
        A#(1, NB) = 0
        A#(2, 1) = G(1) * EP1
        A#(2, 2) = -G(1) * WN * T(1) * EP1 / 2
        A#(2, 3) = -G(1) * EN1
        A#(2, 4) = G(1) * WN * T(1) * EN1 / 2
        A#(2, NB) = 0
'
' zero depth for each layer is at the center, with -T/2 is the top and +T/2 is the base.
'
FOR I = 1 TO NL - 1
        IE = 3 + (I - 1) * 4
        I1 = I + 1
        J = IE - 3
        EP1 = EXP(WN * T(I) / 2): EN1 = EXP(-WN * T(I) / 2)
        EP2 = EXP(-WN * T(I1) / 2): EN2 = EXP(WN * T(I1) / 2)

' The normal stresses across the contact
'first, the layer above  depth at T/2
       
        A#(IE, J + 1) = G(I) * EP1
        A#(IE, J + 2) = G(I) * ((WN * T(I) / 2) - 1) * EP1
        A#(IE, J + 3) = G(I) * EN1
        A#(IE, J + 4) = G(I) * ((WN * T(I) / 2) + 1) * EN1

        A#(IE, J + 5) = KC * G(I1) * EP2
        A#(IE, J + 6) = KC * G(I1) * (-(WN * T(I1) / 2) - 1) * EP2
        A#(IE, J + 7) = KC * G(I1) * EN2
        A#(IE, J + 8) = KC * G(I1) * (-(WN * T(I1)) / 2 + 1) * EN2

        A#(IE, NB) = 0

'The shear stresses across the contact

        IE = IE + 1
        A#(IE, J + 1) = G(I) * EP1
        A#(IE, J + 2) = G(I) * WN * .5 * T(I) * EP1
        A#(IE, J + 3) = -G(I) * EN1
        A#(IE, J + 4) = -G(I) * WN * .5 * T(I) * EN1
        IF FREE$ = "F" THEN A#(IE, NB) = 0

        IF FREE$ = "F" THEN IE = IE + 1
        A#(IE, J + 5) = KC * G(I1) * EP2
        A#(IE, J + 6) = -KC * G(I1) * WN * .5 * T(I1) * EP2
        A#(IE, J + 7) = -KC * G(I1) * EN2
        A#(IE, J + 8) = KC * G(I1) * WN * .5 * T(I1) * EN2
        A#(IE, NB) = 0

        IF FREE$ = "F" THEN GOTO 49

' The horizontal displacement across the contact

        IE = IE + 1
        A#(IE, J + 1) = EP1
        A#(IE, J + 2) = WN * .5 * T(I) * EP1
        A#(IE, J + 3) = EN1
        A#(IE, J + 4) = WN * .5 * T(I) * EN1
       
        A#(IE, J + 5) = KC * EP2
        A#(IE, J + 6) = -KC * WN * .5 * T(I1) * EP2
        A#(IE, J + 7) = KC * EN2
        A#(IE, J + 8) = -KC * WN * .5 * T(I1) * EN2
        A#(IE, NB) = 0

49  'The vertical displacements across the contact

        IE = IE + 1
        A#(IE, J + 1) = EP1
        A#(IE, J + 2) = ((WN * T(I) / 2) - 1) * EP1
        A#(IE, J + 3) = -EN1
        A#(IE, J + 4) = -((WN * T(I) / 2) + 1) * EN1
       
        A#(IE, J + 5) = KC * EP2
        A#(IE, J + 6) = KC * (-WN * .5 * T(I1) - 1) * EP2
        A#(IE, J + 7) = -KC * EN2
        A#(IE, J + 8) = -KC * (-WN * .5 * T(I1) + 1) * EN2
        A#(IE, NB) = 0

NEXT I

'
'Basal displacements
'
K = 3 + (NL - 1) * 4
m = (NL - 1) * 4
        A#(K, m + 1) = EXP(WN * T(NL) / 2)
        A#(K, m + 2) = EXP(WN * T(NL) / 2) * WN * T(NL) / 2
        A#(K, m + 3) = EXP(-WN * T(NL) / 2)
        A#(K, m + 4) = EXP(-WN * T(NL) / 2) * WN * T(NL) / 2
        A#(K, NB) = m#(TT)
        K = K + 1
        A#(K, m + 1) = EXP(WN * T(NL) / 2)
        A#(K, m + 2) = EXP(WN * T(NL) / 2) * ((WN * T(NL) / 2) - 1)
        A#(K, m + 3) = -EXP(-WN * T(NL) / 2)
        A#(K, m + 4) = -EXP(-WN * T(NL) / 2) * ((WN * T(NL) / 2) + 1)
        A#(K, NB) = K#(TT)
GOTO 250
FOR I = 1 TO NL * 4
        PRINT I;
FOR J = 1 TO NL * 4 + 1

IF J < NB THEN PRINT USING "##.###^^^^"; A#(I, J);
IF J = NB THEN PRINT USING "##.###^^^^"; A#(I, J)
NEXT J
NEXT I
INPUT OK
250 '
FOR I = 1 TO NL
G(I) = G(I) * 2000
NEXT I

END SUB

SUB MULTILYR (T(), G(), A#(), XT#(), NL, K#(), m#(), NW, LG, WN, TT, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$) '
      DIM COLNUM%(40)
10    CLS : GM = 1: THICK = 0
FOR L = 1 TO NL
           THICK = THICK + T(L)
NEXT L

      MAXI = 0: MINI = 1000000!
FOR I = 1 TO NL
      IF G(I) > MAXI THEN MAXI = G(I)
      IF G(I) < MINI THEN MINI = G(I)
NEXT I
        PRINT "Multilayer of the present analysis:"
        PRINT "         Layer #      Thickness (m)    Shear modulus (MPa)"
FOR I = 1 TO NL
        PRINT "          "; I; "         "; T(I); "             "; G(I) * GM
NEXT I
        PRINT "Available multilayer files (*.LYR files) in directory ";
        FILES "*.lyr"
    PRINT "Above names indicate either rock sequence site or mulitlayer properties."
    PRINT "Legend for multilayer properties:"
    PRINT "  First digit=number of layers;"
    PRINT "  Letters that follow _  indicate position of stiffer layers in the sequence:"
    PRINT "     CENTer, UP, DWon, UPWaRd, DoWnWaRd (upward or downward stiffening);"
    PRINT "  Last digits = total thickness in 100 m."
        PRINT "Options:   Hit 1 for graphic display of present multilayer,"
        PRINT "           Enter FILENAME your want to examine"
        PRINT "           Type   K   to make your own multilayer"
        INPUT "           [ACCEPT CURRENT MULTILAYER] "; AA$
        IF AA$ = "1" THEN GOTO 27
        IF AA$ = "" THEN GOTO 100
        IF AA$ <> "" AND LEN(AA$) > 1 THEN NAME$ = AA$
        IF AA$ <> "" AND LEN(AA$) > 1 THEN GOTO 30
        IF AA$ = "K" OR AA$ = "k" THEN GOTO 50

'Plotting the selected multilayer

27    CLS : SCREEN 12
FOR I = 0 TO 10
            COLNUM%(I) = 256 * I * 4 + (10 - I) * 6
NEXT I
FOR J = 1 TO 10
            PALETTE J, COLNUM%(J)
NEXT J


      DX = 400 / 12: DF = 360 / THICK: ZB = 100
FOR KL = 1 TO NL
        ZB = ZB + (T(KL - 1) * DF)
FOR K = 0 TO 2
FOR KX = 1 TO 13
        XLU = 20 + KX * DX - DX / 2
        YLU = ZB - T(KL) * DF / 6 + K * T(KL) * DF / 3 + (T(KL) * DF / 6)
        XRD = 20 + KX * DX + DX / 2
        YRD = ZB + T(KL) * DF / 6 + K * T(KL) * DF / 3 + (T(KL) * DF / 6)
        IF MAXI <> MINI THEN LINE (XLU, YLU)-(XRD, YRD), 1 + 9 * (G(KL) - MINI) / (MAXI - MINI), BF
NEXT KX
NEXT K
NEXT KL
FOR J = 1 TO 10
        LINE (500, 140 + (J - 1) * 30)-(530, 140 + J * 30), (11 - J), BF
NEXT J
    LOCATE 9, 70: PRINT "STRONG"
    LOCATE 28, 70: PRINT "WEAK"
    LOCATE 30, 5: PRINT .5 * LG; " m ";
    LOCATE 30, 54: PRINT LG; " m ";
    LOCATE 7, 62: PRINT "0 m"
    LOCATE 29, 62: PRINT "-"; THICK; "m";
    LINE (20 + DX, 100)-(420 + DX, 460), , B



LOCATE 1, 1
PRINT "The selected multilayer for the analysis. "
PRINT
INPUT "     Hit any key to revise [ACCEPT] "; AA$
IF AA$ = "" THEN GOTO 100
IF AA$ <> "" THEN GOTO 10
PRINT
CLS

30
OPEN NAME$ FOR INPUT AS #2
INPUT #2, NL
FOR I = 1 TO NL
INPUT #2, T(I), G(I)
NEXT I
CLOSE : GOTO 10

50  CLS : SCREEN 0
INPUT "How many layers ( < 10 ) "; NL
PRINT
PRINT "Enter data on the layers from top (layer #1) to bottom. "
PRINT
FOR I = 1 TO NL
PRINT "Layer #"; I; " thickness (meters), rigidity (MPa) ";
INPUT T(I), G(I)
NEXT I
INPUT "Want to save the multilayer data in file- enter  NAME (including *.LYR) [NO] "; new$

IF new$ = "" THEN GOTO 10
IF new$ = "" THEN NAME$ = ""
    NAME$ = new$
    OPEN NAME$ FOR OUTPUT AS #3
PRINT #3, NL
FOR I = 1 TO NL
PRINT #3, T(I), G(I)
NEXT I
CLOSE
GOTO 10

100 '
END SUB

SUB ONELAYER (FREE$, ZSTR$, T(), G(), A#(), XT#(), NL, K#(), m#(), NW, LG, WN, LAYER, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$) '
12  REDIM WZ(42, 6), UZ(42, 6), COLNUM%(40)
    REDIM S11(25, 25), S22(25, 25), THET(25, 25)
    REDIM XP(25, 25), ZP(25, 25), XPR2(25, 25), ZPR2(25, 25), XPR3(25, 25), ZPR3(25, 25)
CLS : SCREEN 0
    LENG = LG: THICK = T(LAYER): FT = 1: FY = 2.4: PI = 4 * ATN(1)
    STOPDISP = 0: SCDISP = 35: RO = RHO: GM = 1
    PRINT
    PRINT "  PARAMETER SELECTION FOR PLOTTING STRESSES AND DISPLACEMENTS OF LAYER "; LAYER
    PRINT
    INPUT "Enter new facor for plotting displacement vectors [FACTOR=1] "; FF
    IF FF = 0 THEN FF = 1
    XPLOT = SCDISP * FF
    'iNPUT "Use color suitable for B&W prints on AppleLaser-any key, [RED-GREEN GRADING] "; YC$
    'IF YC$ <> "" THEN FLAGCOL = 1
  
   XFINAL = .75: XSTART = .5:
   IF ZSTR$ = "S" THEN MAXBLACK = .01
   IF ZSTR$ = "E" THEN MAXBLACK = 0!
   XSCALE = ((XFINAL - XSTART) * LG / 2) / 400
   YSCALE = THICK / XSCALE
   PRINT
   PRINT "Stress intensity plot can be displayed in true scale (no vertical exaggeration) "
   INPUT "Hit 1 for true scale [FULL SCREEN PLOT]"; SPLOT
   PRINT
   INPUT "Enter uniform confinement pressure (e.g, to simulate overburden) (MPa) [0] "; PCONF
   PRINT
'   INPUT "Plot fine grid (23 by 10)-any key, or [COARSE GRID 13 by 10] "; F$
   F$ = "A"
   IF F$ <> "" THEN IFINE = 10
   PRINT
   PRINT "The current plot extends from "; XSTART * LG / 2000; " to "; XFINAL * LG / 2000; " km, "
   PRINT "               that is "; LG / 4000; " km wide (or 1/4 of the longest wavelength)"
   INPUT "Change the width of the plot [NO CHANGE] "; DS$
   IF DS$ = "" THEN GOTO 17
   PRINT "Enter width of plot by START, END as fraction of HALF the longest wavelength."
   INPUT "         Note:       0.0 =<  START < END =< 1.0 "; XSTART, XFINAL

   XSCALE = ((XFINAL - XSTART) * LG / 2) / 400
   YSCALE = THICK / XSCALE

17     CLS
       LY = (LAYER - 1) * 4
       LOCATE 1, 1
       PRINT "   Calculating stresses (or strains)...."
       PRINT "                cycles calculated.  Total is:  "; (13 + IFINE) * 9 * (NW - 1)
       NCYCLE = 0
       ZTOP = -THICK / 2 - THICK / 18
FOR KZ = 2 TO 10
    Z = ZTOP + (KZ - 1) * THICK / 9
FOR KX = 1 TO 13 + IFINE
    LOCATE 2, 5
    PRINT NCYCLE
        X = XSTART * LG / 2 + (KX - 1) * LG * (XFINAL - XSTART) / (24 + 2 * IFINE)
        SXT = 0: SZT = 0: SXZT = 0
FOR I = 1 TO NW
        LAM = 2 * I * PI / LG
        EPZ = EXP(LAM * Z)
        ENZ = EXP(-LAM * Z)
                  SZ = -2 * LAM * ((XT#(LY + 1, I) + XT#(LY + 2, I) * (LAM * Z - 1)) * EPZ + (XT#(LY + 3, I) + XT#(LY + 4, I) * (LAM * Z + 1)) * ENZ) * SIN(LAM * X)
                  SX = 2 * LAM * ((XT#(LY + 1, I) + XT#(LY + 2, I) * (LAM * Z + 1)) * EPZ + (XT#(LY + 3, I) + XT#(LY + 4, I) * (LAM * Z - 1)) * ENZ) * SIN(LAM * X)
                  SXZ = -2 * LAM * ((XT#(LY + 1, I) + XT#(LY + 2, I) * LAM * Z) * EPZ - (XT#(LY + 3, I) + XT#(LY + 4, I) * LAM * Z) * ENZ) * COS(LAM * X)
                  IF ZSTR$ = "S" THEN SZT = SZT + SZ * G(LAYER)
                  IF ZSTR$ = "E" THEN SZT = SZT + SZ
                  IF ZSTR$ = "S" THEN SXT = SXT + SX * G(LAYER)
                  IF ZSTR$ = "E" THEN SXT = SXT + SX
                  IF ZSTR$ = "S" THEN SXZT = SXZT + SXZ * G(LAYER)
                  IF ZSTR$ = "E" THEN SXZT = SXZT + SXZ
        NCYCLE = NCYCLE + 1
NEXT I
        S1 = .5 * (SZT + SXT) + SQR(SXZT ^ 2 + .25 * (SXT - SZT) ^ 2)
        S2 = .5 * (SZT + SXT) - SQR(SXZT ^ 2 + .25 * (SXT - SZT) ^ 2)
              IF SXT = SZT THEN TET = 10000
              IF SXT = SZT AND SXT < 0 THEN TET = -10000
              IF SXT = SZT THEN THETA = ATN(TET) / 2
              IF SXT = SZT THEN GOTO 608
              TET = ABS(2 * SXZT / (SXT - SZT))
              THETA = ATN(TET) / 2
        IF SXT > SZT AND SXZT > 0 THEN GOTO 608
        IF SXT > SZT AND SXZT < 0 THEN GOTO 602
        IF SXT < SZT AND SXZT > 0 THEN GOTO 603
        IF SXT < SZT AND SXZT < 0 THEN GOTO 604
602 THETA = -THETA
        GOTO 608
603 THETA = -THETA + PI / 2
        GOTO 608
604 THETA = THETA - PI / 2
608
    S11(KX, KZ) = S1 + PCONF
    S22(KX, KZ) = S2 + PCONF
    THET(KX, KZ) = THETA
NEXT KX
NEXT KZ

'Calculations of stress trajectories and magnitude of shear stress/vertical stress

605 ZABOVE = 0
   IF LAYER = 1 THEN GOTO 14
FOR I = 1 TO LAYER - 1
   ZABOVE = ZABOVE + T(I)
NEXT I

14 CONT$ = "": MAX = 0: MIN = 10000: MAXCOMP = -10000
       ZTOP = -THICK / 18
FOR KZ = 2 TO 10
    Z = ZTOP + (KZ - 1) * THICK / 9
FOR KX = 1 TO 13 + IFINE
          IF ZRO$ <> "" THEN RO = RHO
          X = XSTART * LG / 2 + (KX - 1) * LG * (XFINAL - XSTART) / (24 + 2 * IFINE)
          IF ABS(S22(KX, KZ)) > MAXCOMP THEN MAXCOMP = ABS(S22(KX, KZ))
          IF ZRO$ <> "" THEN SNN = .5 * ((Z + ZABOVE) * RO + S11(KX, KZ) + S22(KX, KZ))
          IF ZRO$ = "" THEN SNN = 1
                IF ABS(.5 * (S11(KX, KZ) - S22(KX, KZ)) / SNN) > MAX THEN XMAX = KX
                IF ABS(.5 * (S11(KX, KZ) - S22(KX, KZ)) / SNN) < MIN THEN XMIN = KX
                IF ABS(.5 * (S11(KX, KZ) - S22(KX, KZ)) / SNN) > MAX THEN ZMAX = KZ
                IF ABS(.5 * (S11(KX, KZ) - S22(KX, KZ)) / SNN) < MIN THEN ZMIN = KZ
                IF ABS(.5 * (S11(KX, KZ) - S22(KX, KZ)) / SNN) > MAX THEN MAX = ABS(.5 * (S11(KX, KZ) - S22(KX, KZ)) / SNN)
                IF ABS(.5 * (S11(KX, KZ) - S22(KX, KZ)) / SNN) < MIN THEN MIN = ABS(.5 * (S11(KX, KZ) - S22(KX, KZ)) / SNN)
    NCYCLE = NCYCLE + 1
NEXT KX
NEXT KZ
       
       
'        IF ZRO$ <> "" THEN MAX = 2
        IF ZRO$ <> "" THEN MIN = 0


    ZTOP = -THICK / 2 - THICK / 18
FOR KZ = 2 TO 10
         Z = ZTOP + (KZ - 1) * THICK / 9
FOR KX = 1 TO 13 + IFINE
          X = (KX - 1) * LG * (XFINAL - XSTART) / (24 + 2 * IFINE)
          XP(KX, KZ) = X * 800 / (LG * (XFINAL - XSTART))
       IF SPLOT <> 1 THEN ZP(KX, KZ) = (Z + THICK / 2 + THICK / 18) * 126 / THICK
       IF SPLOT = 1 THEN ZP(KX, KZ) = (Z + THICK / 2 + THICK / 18) * YSCALE / THICK
          XPR2(KX, KZ) = XP(KX, KZ) + 25 * SIN(THET(KX, KZ)) * ABS(S22(KX, KZ)) / MAXCOMP
          ZPR2(KX, KZ) = ZP(KX, KZ) - 25 * COS(THET(KX, KZ)) * ABS(S22(KX, KZ)) / MAXCOMP
          XPR3(KX, KZ) = XP(KX, KZ) - 25 * SIN(THET(KX, KZ)) * ABS(S22(KX, KZ)) / MAXCOMP
          ZPR3(KX, KZ) = ZP(KX, KZ) + 25 * COS(THET(KX, KZ)) * ABS(S22(KX, KZ)) / MAXCOMP
NEXT KX
NEXT KZ
        IF STOPDISP = 1 THEN GOTO 29

' Calculating  the displacements
   
    PRINT "   Calculating displacements...."
       PRINT "                cycles calculated.  Total is:  "; 210 * NW
       NCYCLE = 0
       ZTOP = -THICK / 2
FOR KZ = 1 TO 5
    Z = THICK * .01 * RND + ZTOP + (KZ - 1) * THICK / 4
FOR JX = 1 TO 41
        WZ(JX, KZ) = 0
        UZ(JX, KZ) = 0
        X = XSTART * LG / 2 + (JX - 1) * (XFINAL - XSTART) * (LG / 80)
FOR I = 1 TO NW
        LAM = 2 * I * PI / LG
        EPZ = EXP(LAM * Z)
        ENZ = EXP(-LAM * Z)
              W = ((XT#(LY + 1, I) + XT#(LY + 2, I) * (LAM * Z - 1)) * EPZ - (XT#(LY + 3, I) + XT#(LY + 4, I) * (LAM * Z + 1)) * ENZ) * SIN(LAM * X)
              U = ((XT#(LY + 1, I) + XT#(LY + 2, I) * LAM * Z) * EPZ + (XT#(LY + 3, I) + XT#(LY + 4, I) * LAM * Z) * ENZ) * COS(LAM * X)
        WZ(JX, KZ) = WZ(JX, KZ) + W
        UZ(JX, KZ) = UZ(JX, KZ) + U
    NCYCLE = NCYCLE + 1
NEXT I
    LOCATE 4, 5
    PRINT NCYCLE
NEXT JX
NEXT KZ



'
29
PRINT
PRINT "Currently maximum, minimum stresses are: ";
PRINT USING " ####.##"; MIN, MAX
INPUT "  Change these values [NO] "; CH$
IF CH$ = "" THEN GOTO 39
INPUT "Enter NEW maximum, minimum stresses are: "; MIN, MAX


39 'start plotting
'
CONT$ = ""
1001       CLS
            SCREEN 12
FOR I = 0 TO 10
            IF FLAGCOL <> 1 THEN COLNUM%(I) = 256 * I * 4 + (10 - I) * 6
NEXT I
FOR J = 1 TO 10
            IF FLAGCOL <> 1 THEN PALETTE J, COLNUM%(J)
NEXT J
      IF FLAGCOL <> 1 THEN PALETTE 1, 0

      DX = 400 / (23 + 2 * IFINE)
      IF SPLOT <> 1 THEN DZ = 126 * FY / 17
      IF SPLOT = 1 THEN DZ = (THICK / XSCALE) / 17
      
    ZTOP = -THICK / 18
FOR KZ = 2 TO 10
    Z = ZTOP + (KZ - 1) * THICK / 9
FOR KX = 1 TO 23

        X = (KX - 1) * LG * (XFINAL - XSTART) / 44
        IF ZRO$ = "" THEN SNN = 1
        IF ZRO$ <> "" THEN SNN = .5 * ((Z + ZABOVE) * RO + S11(KX, KZ) + S22(KX, KZ))
        IF ZRO$ = "" AND (ABS(.5 * (S11(KX, KZ) - S22(KX, KZ)) / SNN)) < MAXBLACK THEN GOTO 334
       
        COL1 = 1.2 + 9 * ((ABS(.5 * (S11(KX, KZ) - S22(KX, KZ)) / SNN)) - MIN) / (MAX - MIN)
        IF COL1 < 1.2 THEN COL1 = 0

        'IF COL1 > 10.3 THEN COL1 = 0

        IF ZRO$ <> "" AND SNN > 0 THEN COL1 = 10
        IF FLAGCOL = 1 THEN CALL SETCOL(COL1, COL2)
        IF FLAGCOL <> 1 THEN COL2 = COL1
        IF FLAGCOL <> 1 AND COL1 > 10 THEN COL2 = 10

        IF SPLOT <> 1 AND KX <> 1 AND KX <> (13 + IFINE) THEN LINE (XP(KX, KZ) + 20 - DX, (ZP(KX, KZ) + 50) * FY - DZ)-(XP(KX, KZ) + 20 + DX, (ZP(KX, KZ) + 50) * FY + DZ), COL2, BF
        IF SPLOT <> 1 AND KX = 1 THEN LINE (XP(KX, KZ) + 20, (ZP(KX, KZ) + 50) * FY - DZ)-(XP(KX, KZ) + 20 + DX, (ZP(KX, KZ) + 50) * FY + DZ), COL2, BF
        IF SPLOT <> 1 AND KX = (13 + IFINE) THEN LINE (XP(KX, KZ) + 20 - DX, (ZP(KX, KZ) + 50) * FY - DZ)-(XP(KX, KZ) + 20, (ZP(KX, KZ) + 50) * FY + DZ), COL2, BF
       
        IF SPLOT = 1 AND KX <> 1 AND KX <> (13 + IFINE) THEN LINE (XP(KX, KZ) + 20 - DX, (ZP(KX, KZ) + (440 - YSCALE - .85 * DZ) - DZ))-(XP(KX, KZ) + 20 + DX, (ZP(KX, KZ) + (440 - YSCALE - .85 * DZ)) + DZ), COL2, BF
        IF SPLOT = 1 AND KX = 1 THEN LINE (XP(KX, KZ) + 20, (ZP(KX, KZ) + (440 - YSCALE - .85 * DZ) - DZ))-(XP(KX, KZ) + 20 + DX, (ZP(KX, KZ) + (440 - YSCALE - .85 * DZ)) + DZ), COL2, BF
        IF SPLOT = 1 AND KX = (13 + IFINE) THEN LINE (XP(KX, KZ) + 20 - DX, (ZP(KX, KZ) + (440 - YSCALE - .85 * DZ) - DZ))-(XP(KX, KZ) + 20, (ZP(KX, KZ) + (440 - YSCALE - .85 * DZ)) + DZ), COL2, BF
       
        IF ZRO$ <> "" AND SPLOT <> 1 AND SNN > 0 THEN CIRCLE (XP(KX, KZ) + 20, (ZP(KX, KZ) + 50) * FY), 2, 0
        IF ZRO$ <> "" AND SPLOT = 1 AND SNN > 0 THEN CIRCLE (XP(KX, KZ) + 20, (ZP(KX, KZ) + (440 - YSCALE - .85 * DZ))), 2, 0
        IF ZRO$ <> "" AND SPLOT <> 1 AND SNN > 0 THEN CIRCLE (XP(KX, KZ) + 20, (ZP(KX, KZ) + 50) * FY), 1, 0
        IF ZRO$ <> "" AND SPLOT = 1 AND SNN > 0 THEN CIRCLE (XP(KX, KZ) + 20, (ZP(KX, KZ) + (440 - YSCALE - .85 * DZ))), 1, 0


334     IF SPLOT = 1 THEN LINE (XP(KX, KZ) + 20, (ZP(KX, KZ) + 440 - YSCALE - .85 * DZ))-(XPR2(KX, KZ) + 20, (ZPR2(KX, KZ) + 440 - YSCALE - .85 * DZ))
        IF SPLOT = 1 THEN LINE (XP(KX, KZ) + 20, (ZP(KX, KZ) + 440 - YSCALE - .85 * DZ))-(XPR3(KX, KZ) + 20, (ZPR3(KX, KZ) + 440 - YSCALE - .85 * DZ))

NEXT KX
NEXT KZ

IF SPLOT = 1 THEN GOTO 336
    ZTOP = -THICK / 2 - THICK / 18
FOR KZ = 2 TO 10
    Z = ZTOP + (KZ - 1) * THICK / 9
FOR KX = 1 TO (13 + IFINE)
        X = (KX - 1) * LG * (XFINAL - XSTART) / (24 + 2 * IFINE)
          XP = X * 800 / (LG * (XFINAL - XSTART))
          ZP = (Z + THICK / 2 + THICK / 18) * (126 * FY) / THICK
          XPR2 = XP + 40 * SIN(THET(KX, KZ)) * ABS(S22(KX, KZ)) / MAXCOMP
          ZPR2 = ZP - 40 * COS(THET(KX, KZ)) * ABS(S22(KX, KZ)) / MAXCOMP
          XPR3 = XP - 40 * SIN(THET(KX, KZ)) * ABS(S22(KX, KZ)) / MAXCOMP
          ZPR3 = ZP + 40 * COS(THET(KX, KZ)) * ABS(S22(KX, KZ)) / MAXCOMP

           LINE (XP + 20, ZP + 120)-(XPR2 + 20, ZPR2 + 120)
           LINE (XP + 20, ZP + 120)-(XPR3 + 20, ZPR3 + 120)
NEXT KX
NEXT KZ

336 IF SPLOT <> 1 THEN LINE (20, 57 * FY)-(420, 183 * FY), , B
    IF SPLOT = 1 THEN LINE (20, 440 - YSCALE)-(420, 440), , B
FOR J = 1 TO 10
    COL1 = 11.2 - J
    IF FLAGCOL = 1 THEN CALL SETCOL(COL1, COL2)
    IF FLAGCOL <> 1 THEN COL2 = 11 - J
        LINE (500, 140 + (J - 1) * 20)-(520, 140 + J * 20), COL2, BF
        LINE (500, 140 + (J - 1) * 20)-(520, 140 + J * 20), , B
NEXT J

    LOCATE 8, 60: PRINT "Highest Shear="
    LOCATE 9, 60: PRINT USING "##.##^^^^"; MAX
    LOCATE 22, 60: PRINT "Lowest Shear=";
    LOCATE 23, 60: PRINT USING "##.##^^^^"; MIN
    LOCATE 24, 60: PRINT "Shear intensity step=";
    LOCATE 25, 60: PRINT USING "##.##^^^^"; (MAX - MIN) / 10


'Plotting displacement field
   
FOR JX = 1 TO 41
FOR KZ = 1 TO 5
        IF SPLOT <> 1 THEN DZ = 57 * 2.4 + 31.4 * 2.4 * (KZ - 1)
        X = 10 + JX * 10
        X1 = X - UZ(JX, KZ) * XPLOT * FACT
        Y = DZ
        Y1 = Y - WZ(JX, KZ) * XPLOT

             IF SPLOT <> 1 THEN LINE (X, Y)-(X1, Y1)
        IF JX = 41 THEN GOTO 113
        X = 10 + (JX + 1) * 10
        X2 = X - UZ((JX + 1), KZ) * XPLOT * FACT
        Y2 = Y - WZ((JX + 1), KZ) * XPLOT
          IF SPLOT <> 1 THEN LINE (X1, Y1)-(X2, Y2)
NEXT KZ
113 NEXT JX
FOR I = 1 TO 11
             LINE (20 + 40 * (I - 1), 186 * FY)-(20 + 40 * (I - 1), 183 * FY)
NEXT I
  
    VER = THICK / (126 * 2.4): HOR = LG / 800
    VERT1 = VERT + .00001
    DOWN = VERT * 25: SIDE = DOWN * HORIZ / VERT1
    SIDE = SIDE / HOR
    LINE (550, 240)-(550 + 2 * SCDISP, 240 + 2 * SCDISP), , B
    LOCATE 13, 68: PRINT "Displacement"
    LOCATE 14, 69: PRINT "  scale="
    LOCATE 15, 69: PRINT USING "##.####"; 2 / FF;
    PRINT "m"
    LOCATE 29, 1: PRINT XSTART * LG / 2; " m ";
    LOCATE 29, 51: PRINT XFINAL * LG / 2; " m ";
    ILINE = INT((440 - YSCALE) * 31 / 480)
    IF SPLOT = 1 THEN LOCATE ILINE, 56: PRINT "0 m"
    IF SPLOT <> 1 THEN LOCATE 9, 56: PRINT "0 m"
    LOCATE 28, 56: PRINT "-"; THICK; "m"
    LOCATE 5, 54
    IF FREE$ <> "F" THEN PRINT "Bonded layer contacts"
    IF FREE$ = "F" THEN PRINT "Free-slip along contacts"
    LOCATE 6, 54: PRINT "Incompressible layer with"
    LOCATE 7, 54
    PRINT "rigidity of "; G(LAYER); " MPa"

    LOCATE 1, 1
    IF NAME$ = "" THEN NAME$ = "DEFAULT"
    IF ZSTR$ = "S" THEN PRINT "Displ./stress, Layer "; LAYER; ", "; NAME$; ", Basal displ.: "; FA$; "  "; DATE$
    IF ZSTR$ = "E" THEN PRINT "Displ./strain, Layer "; LAYER; ", "; NAME$; ", Basal displ.: "; FA$; "  "; DATE$
    IF ZRO$ = "" THEN PRINT "Short lines: trend + magnitude of max. compression. "
    IF ZRO$ <> "" THEN PRINT "Short lines: trend/mag.  max. compres. Circles: Tensile mean pressure."
    IF ZRO$ = "" AND ZSTR$ = "S" THEN PRINT "Shear stress:";
    IF ZRO$ <> "" AND ZSTR$ = "S" THEN PRINT "Shear/overburden:";
    IF ZSTR$ = "E" THEN PRINT "Shear strain:";
    PRINT "MAX. in X,Z square:"; XMAX; ","; ZMAX; "& MIN. in  X,Z square:"; XMIN; ","; ZMIN
    IF ZSTR$ = "S" THEN INPUT "Stress option-hit 1, Change colors-hit C, [Plot trends + displacements]"; CONT$
    IF ZSTR$ = "E" THEN INPUT "[Plot compression trends + displacements]"; CONT$
    IF CONT$ = "c" OR CONT$ = "C" THEN CONT$ = "C"
    IF CONT$ = "C" AND FLAGCOL = 1 THEN GOTO 1202
    IF CONT$ = "C" AND FLAGCOL = 0 THEN FLAGCOL = 1
    GOTO 1203
1202    FLAGCOL = 0
1203    IF CONT$ = "1" THEN GOTO 208

1201 'PLOTTING PRINCIPAL AXES
      CLS
      SCREEN 12
      DX = INT(400 / 43)
      DZ = INT(126 * FY / 17)
      LINE (20, 57 * FY)-(420, 183 * FY), , B

'Plotting the displacement field on the screen
  
FOR JX = 1 TO 41
FOR KZ = 1 TO 5
        DZ = 57 * 2.4 + 31.4 * 2.4 * (KZ - 1)
        X = 10 + JX * 10
        X1 = X - UZ(JX, KZ) * XPLOT * FACT
        Y = DZ
        Y1 = Y - WZ(JX, KZ) * XPLOT
             LINE (X, Y)-(X1, Y1)
        IF JX = 41 THEN GOTO 115
        X = 10 + (JX + 1) * 10
        X2 = X - UZ((JX + 1), KZ) * XPLOT * FACT
        Y2 = Y - WZ((JX + 1), KZ) * XPLOT
          LINE (X1, Y1)-(X2, Y2)

115 NEXT KZ
NEXT JX
        LINE (20, 183 * FY)-(420, 183 * FY)
FOR I = 1 TO 11
             LINE (20 + 40 * (I - 1), 186 * FY)-(20 + 40 * (I - 1), 183 * FY)
NEXT I

    ZTOP = -THICK / 2 - THICK / 18
FOR KZ = 2 TO 10
    Z = ZTOP + (KZ - 1) * THICK / 9
FOR KX = 1 TO (13 + IFINE)
        X = (KX - 1) * LG * (XFINAL - XSTART) / (24 + 2 * IFINE)
          XP = X * 800 / (LG * (XFINAL - XSTART))
          ZP = (Z + THICK / 2 + THICK / 18) * (126 * FY) / THICK
          XPR2 = XP + 10 * SIN(THET(KX, KZ))
          ZPR2 = ZP - 10 * COS(THET(KX, KZ))
          XPR3 = XP - 10 * SIN(THET(KX, KZ))
          ZPR3 = ZP + 10 * COS(THET(KX, KZ))
           LINE (XP + 20, ZP + 120)-(XPR2 + 20, ZPR2 + 120)
           LINE (XP + 20, ZP + 120)-(XPR3 + 20, ZPR3 + 120)
NEXT KX
NEXT KZ
    VER = THICK / (126 * 2.4): HOR = LG / 800
    VERT1 = VERT + .00001
    DOWN = VER * 40: SIDE = DOWN * HORIZ / VERT1
    SIDE = SIDE / HOR

    LINE (550, 240)-(550 + 2 * SCDISP, 240 + 2 * SCDISP), , B
    LOCATE 13, 68: PRINT "Displacement"
    LOCATE 14, 69: PRINT "  scale="
    LOCATE 15, 69: PRINT USING "##.####"; 2 / FF;
    PRINT "m"

    LOCATE 29, 1: PRINT XSTART * LG / 2; " m ";
    LOCATE 29, 51: PRINT XFINAL * LG / 2; " m ";
    LOCATE 9, 56: PRINT "0 m"
    LOCATE 28, 56: PRINT "-"; THICK; "m"
    LOCATE 5, 50
    IF FREE$ <> "F" THEN PRINT "Bonded contacts, incompress"
    IF FREE$ = "F" THEN PRINT "Free-slip contacts, incompress"
    LOCATE 6, 54: PRINT "Rigidity= "; G(LAYER); " MPa"

    LOCATE 1, 1
    IF NAME$ = "" THEN NAME$ = "DEFAULT"
    PRINT "Displ./stress orientations. Layer "; LAYER; ", "; NAME$; ", "; FA$; "  "; DATE$
    PRINT " Short lines: trend of axes of maximum compression (magnitudes not indicated)."
    IF ZSTR$ = "S" THEN INPUT "Any key to return to menu [Plot stress intensity] "; CONT$
    IF ZSTR$ = "E" THEN INPUT "Any key to return to menu [Plot strain intensity] "; CONT$
    IF CONT$ = "" THEN GOTO 29
    IF CONT$ <> "" THEN GOTO 211

208 CLS
    PRINT "The stress intensity maps have two plotting options:"
    PRINT "  1. The ratio BLF = ("; CHR$(229); "1 - "; CHR$(229); "3) / ("; CHR$(229); "1 + "; CHR$(229); "3)"
    PRINT "  2. {local maximum shear stress = 0.5 ("; CHR$(229); "1 - "; CHR$(229); "3)} (in units of shear moduli)"
    PRINT
    PRINT "Stress intensity plotting is set for"
    IF ZRO$ <> "" THEN GOTO 209
    IF ZRO$ = "" THEN PRINT "                  {local maximum shear stress} "
    PRINT "Change plotting to BLF = ("; CHR$(229); "1 - "; CHR$(229); "3) / ("; CHR$(229); "1 + "; CHR$(229); "3)-any key [NO]";
        INPUT YS$
        IF YS$ <> "" THEN ZRO$ = "w"
        GOTO 210


209     PRINT "      the ratio BLF = ("; CHR$(229); "1 - "; CHR$(229); "3) / ("; CHR$(229); "1 + "; CHR$(229); "3)"
        INPUT "Change plotting to {local maximum shear stress} - any letter [NO CHANGE]"; YS$
        IF YS$ <> "" THEN ZRO$ = ""

        PRINT
210    INPUT "Exit to main menu-any key [REPLOT WITH NEW SETTING] "; CONT$
    STOPDISP = 1
    IF CONT$ = "" THEN GOTO 605
211 '
END SUB

SUB SETCOL (COL1, COL2) '

IF COL1 <= 1.5 THEN COL2 = 0
IF COL1 <= 2.5 AND COL1 > 1.5 THEN COL2 = 14
IF COL1 <= 3.5 AND COL1 > 2.5 THEN COL2 = 7
IF COL1 <= 4.5 AND COL1 > 3.5 THEN COL2 = 10
IF COL1 <= 5.5 AND COL1 > 4.5 THEN COL2 = 8
IF COL1 <= 6.5 AND COL1 > 5.5 THEN COL2 = 13
IF COL1 <= 7.5 AND COL1 > 6.5 THEN COL2 = 12
IF COL1 <= 8.5 AND COL1 > 7.5 THEN COL2 = 5
IF COL1 <= 9.5 AND COL1 > 8.5 THEN COL2 = 9
IF COL1 > 9.5 THEN COL2 = 1

END SUB

SUB SOLVE (T(), G(), A#(), XT#(), NL, K#(), m#(), NW, LG, WN, TT, VERT, HORIZ, FACT, NAME$, ZRO$, RHO, FA$) '
    
        m = NL * 4: N = NL * 4
     DIM B(m + 1), e(m + 1, m + 1), R(m + 1), F(N)
   
 FOR I = 1 TO m
        B(I) = A#(I, N + 1)
 NEXT I
15   m = m + 1
 FOR J = 1 TO N
     A#(m, J) = A#(1, J)
 NEXT J
     B(m) = B(1)

 
     '  Calculating the symmetric equivalent matrix
 
 FOR I = 1 TO N
 FOR J = 1 TO N
 FOR K = 1 TO m
     e(I, J) = e(I, J) + A#(K, I) * A#(K, J)
 NEXT K
 NEXT J
 NEXT I
 FOR J = 1 TO N
 FOR K = 1 TO m
     F(J) = F(J) + A#(K, J) * B(K)
 NEXT K
 NEXT J
     NN = N - 1
 FOR K = 1 TO NN
     KK = K + 1
 FOR I = KK TO N
     Z = e(I, K) / e(K, K)
     F(I) = F(I) - F(K) * Z
 FOR J = 1 TO N
     e(I, J) = e(I, J) - e(K, J) * Z
 NEXT J
 NEXT I
 NEXT K
    
 FOR I = 1 TO N
     Z# = e(I, I)
 FOR J = 1 TO N
     e(I, J) = e(I, J) / Z#
 NEXT J
     F(I) = F(I) / Z#
 NEXT I
 
     '  Solution by substitution
     '
1000 XT#(N, TT) = F(N) / e(N, N)
     'IF KCONF = 0 THEN PRINT
 FOR L = 1 TO NN
     K = N - L
     KL = K + 1
     G = 0
 FOR J = KL TO N
     G = G + e(K, J) * XT#(J, TT) / e(K, K)
 NEXT J
     XT#(K, TT) = F(K) - G
 NEXT L
GOTO 96
     '  Calculating the mean square error
 
 FOR I = 1 TO m
     R4 = 0
     R(I) = 0
 NEXT I
 FOR I = 1 TO m
 FOR J = 1 TO N
     R(I) = R(I) + A#(I, J) * XT#(J, TT)
 NEXT J
     R(I) = R(I) - B(I)
     R2 = R(I) ^ 2
     R4 = R4 + R2
 NEXT I
     RMS = SQR(R4 / m)
96 END SUB

