CLS
'$DYNAMIC
PRINT "          FAULT GROWTH IN WESTERLY GRANITE SAMPLE"
PRINT "   By Dave Lockner, US Geological Survey, Menlo Park, California, and"
PRINT "   Ze'ev Reches, Geology Department, Hebrew University, Jerusalem, Israel"; ""
PRINT ""
PRINT "This program displays the growth of a fault in a Westerly granite sample that"
PRINT "is 78mm in diameter and 190mm tall.  The fault growth was monitored by the"
PRINT "locations of acoustic emission events (AE) as described by"
PRINT "Lockner et al., 1990 and Reches and Lockner, 1993."
PRINT "AE locations are plotted on two mutually perpendicular sections of the sample, "
PRINT "left one parallels the fault strike, right is face-on fault surface."
PRINT "This program displays the FAULT SURFACE associated with the faulting"
PRINT "by plotting the AE events in divided into three stages:"
PRINT "  NUCLEATION, GROWTH and FINAL.  The AE events are plotted in colors"
PRINT "ranging from deep red = earliest events to deep green = latest events"
PRINT "for each of the stages."
PRINT "Hit   f   for faster display; hit several times for very fast."
PRINT "Hit   s   for slower display; hit several times for very slow."
PRINT "Hit   q   to quit"
PRINT "Copy all files to the hard disk before running."
PRINT "                   FREE FOR DUPLICATION AND DISTRIBUTION"
INPUT "READY [YES] "; ok
PRINT

DIM COLNUM&(40), PT(13500, 3)
INPUT "Fraction of data points to be plotted, 1-all, 4- quarter.. [default=ALL] "; NF
IF NF = 0 THEN NF = 1
INPUT "Enter starting event for the acoustic emmission plot [1] "; SAE
IF SAE <> 0 THEN NST1 = SAE
IF SAE <> 0 THEN ISAE = 1
IF SAE = 0 THEN NST1 = 1

SCREEN 12
          FOR I = 0 TO 15
                    IF I <= 8 THEN COLNUM&(I) = (8 - I) * 7 + 65536 * I * 7
                    IF I >= 8 THEN COLNUM&(I) = 256 * (I - 8) * 8 + 65536 * (15 - I) * 8
          NEXT I
          FOR j = 1 TO 15
                PALETTE j, COLNUM&(j)
          NEXT j
          a$ = "LOCATION"
          OPEN a$ FOR INPUT AS #2
 FOR I = 1 TO 13160
        INPUT #2, PT(I, 1), PT(I, 2), PT(I, 3)
 NEXT I
 CLOSE

N1 = 212: N2 = 5010: N3 = 13160
X1 = 79: Y1 = 50
sp1# = -1E+07
sp2# = 1E+07

LOCATE 1, 1: PRINT "                       events plotted out of "; N1 + N3
LINE (X1 - 38.1 * 2, Y1)-(X1 + 38.1 * 2, Y1 + 190.5 * 2), , B
X2 = 239: Y2 = 50
LINE (X2 - 38.1 * 2, Y2)-(X2 + 38.1 * 2, Y2 + 190.5 * 2), , B
LOCATE 29, 12: PRINT "FAULT NUCLEATION";

FOR I = 1 TO N1
20 'INPUT #2, X, Y, Z
    X = PT(I, 1): Y = PT(I, 2): Z = PT(I, 3)
K$ = "T"
LINE (1 + 300 * I / N1, 20)-(1 + 300 * I / N1, 30), 1 + 15 * I / N1
LOCATE 1, 1
IF I >= NST1 THEN PRINT " ", I

IF I < NST1 THEN GOTO 21
sp# = sp1#
19 sp# = sp# + 1000!
K$ = INKEY$
IF K$ = "F" OR K$ = "f" THEN sp2# = sp2# - 100000!
IF K$ = "S" OR K$ = "s" THEN sp2# = sp2# + 100000!
IF K$ = "Q" OR K$ = "q" THEN STOP
IF sp# > sp2# THEN GOTO 18
GOTO 19

18 LINE (X1 + Y * 2 - 2, Y1 + Z * 2 - 2)-(X1 + Y * 2 + 2, Y1 + Z * 2 + 2), 1 + 15 * I / N1, BF
LINE (X2 - X * 2 - 2, Y1 + Z * 2 - 2)-(X2 - X * 2 + 2, Y1 + Z * 2 + 2), 1 + 15 * I / N1, BF

21 NEXT I


X1 = 399: X2 = 559: Y2 = 50
LINE (X1 - 38.1 * 2, Y2)-(X1 + 38.1 * 2, Y2 + 190.5 * 2), , B
LINE (X2 - 38.1 * 2, Y2)-(X2 + 38.1 * 2, Y2 + 190.5 * 2), , B
LOCATE 29, 53: PRINT "FAULT PROPAGATION";
MF = 0

FOR I = N1 TO N2
25 'INPUT #2, X, Y, Z
X = PT(I, 1): Y = PT(I, 2): Z = PT(I, 3)
LINE (320 + 300 * I / N2, 20)-(320 + 300 * I / N2, 30), 1 + 15 * I / N2
LOCATE 1, 1
IF I > NST1 THEN PRINT " ", I
IF INT(I / NF) <> I / NF THEN GOTO 33
IF I < NST1 THEN GOTO 33

sp# = sp1#
29 sp# = sp# + 1000!
K$ = INKEY$
IF K$ = "F" OR K$ = "f" THEN sp2# = sp2# - 100000!
IF K$ = "S" OR K$ = "s" THEN sp2# = sp2# + 100000!
IF K$ = "Q" OR K$ = "q" THEN STOP
IF sp# > sp2# THEN GOTO 31
GOTO 29

31 LINE (X1 + Y * 2 - 2, Y1 + Z * 2 - 2)-(X1 + Y * 2 + 2, Y1 + Z * 2 + 2), 1 + 15 * I / N2, BF
LINE (X2 - X * 2 - 2, Y1 + Z * 2 - 2)-(X2 - X * 2 + 2, Y1 + Z * 2 + 2), 1 + 15 * I / N2, BF

33 NEXT I

LOCATE 1, 1
INPUT "Continue [YES] "; Y$
LINE (1, 15)-(320, 479), 0, BF
X1 = 79: Y1 = 50
LINE (X1 - 38.1 * 2, Y1)-(X1 + 38.1 * 2, Y1 + 190.5 * 2), , B
X2 = 239: Y2 = 50
LINE (X2 - 38.1 * 2, Y2)-(X2 + 38.1 * 2, Y2 + 190.5 * 2), , B
LOCATE 29, 12: PRINT "   FINAL STAGE  ";

MF = 0: N4 = N3 - N2

FOR I = N2 TO N3
j = I - N2
LINE (320 + 300 * j / N4, 20)-(320 + 300 * j / N4, 30), 1 + 15 * j / N4
LOCATE 1, 1
IF I > NST1 THEN PRINT " ", I

30 'INPUT #2, X, Y, Z
X = PT(I, 1): Y = PT(I, 2): Z = PT(I, 3)
'IF INT(I / NF) <> I / NF THEN GOTO 34
IF I < NST1 THEN GOTO 34

sp# = sp1#
49 sp# = sp# + 1000!
K$ = INKEY$
IF K$ = "F" OR K$ = "f" THEN sp2# = sp2# - 100000!
IF K$ = "S" OR K$ = "s" THEN sp2# = sp2# + 100000!
IF K$ = "Q" OR K$ = "q" THEN STOP
IF sp# > sp2# THEN GOTO 41
GOTO 49

41 LINE (X1 + Y * 2 - 2, Y1 + Z * 2 - 2)-(X1 + Y * 2 + 2, Y1 + Z * 2 + 2), 1 + 15 * j / N4, BF
LINE (X2 - X * 2 - 2, Y1 + Z * 2 - 2)-(X2 - X * 2 + 2, Y1 + Z * 2 + 2), 1 + 15 * j / N4, BF
34 NEXT I
'CLOSE
INPUT KL

