'  MOHR 1.2
'  CALCULATIONS OF THE PRINCIPAL STRESSES AND PLOT OF MOHR CIRCLES
'                By Ze'ev Reches, January, 1996

'PARAMETERS
'
'$DYNAMIC
31      DEFINT I-K
        DEFINT N, X-Z
        DEFDBL A-F, L-M, O-W
        DEFSTR H
   DECLARE SUB MOHR2 (SI#(), SM#(), HNAME$, BMOR$, MINMR#, MAXMR#, MANY$, MANYMOR, SXI#, SYI#, SXYI#)
   DECLARE SUB MOHR (SI(), SM#(), HNAME$, BMOR$, MINMR, MAXMR, MANY$, MANYMOR, SCALE, ZERO, SXI#, SYI#, SZI#, SXYI#, SXZI#, SYZI#, DF, DD)
   DECLARE SUB STEREO (HTITLE$, DAT(), BK1#, BK2#, BK3#, L1#, L2#, L3#, M1#, M2#, M3#, MANYMOR)
   DECLARE SUB SHEAR (SX#, SY#, SZ#, SXY#, SXZ#, SYZ#, SIGN, SIGS, NR, SCALE, ZERO, SXI#, SYI#, SZI#, SXYI#, SXZI#, SYZI#, DF, DD)
    SCREEN 12
'    GR = 63 * 256: RD = 63: WH = 65536 * 63 + 256 * 63 + 63: WYL = 65536 * 20 + 256 * 55 + 55
'    PALETTE 0, WH: PALETTE 15, 65536 * 63
'    PALETTE 15, WYL: PALETTE 0, 0
COLOR (4)
'
' Printing program information on screen
'
    CLS
    PRINT
    PRINT "                MOHR DIAGRAM FOR A 3-D STRESS STATE"
    PRINT "                    Programmed by Ze'ev Reches"
    PRINT "                     Ver. 1.2, January, 1996"
    PRINT
COLOR (10)
PRINT "Calculations and plotting of:    2-D and 3-D Mohr circles"
PRINT "                                 yielding envelope"
PRINT "                                 stress components on fractures"
PRINT "                                 stereographic projections of stress axes."
PRINT
PRINT "Program defaults appear in [square brackets] "
INPUT "For information on hard copy- hit any key [CONTINUE] "; HC$
IF HC$ = "" THEN GOTO 30
  PRINT
      PRINT "For HARD-COPIES:"
      PRINT "     Run program as DOS window under WINDOWS"
      PRINT "     Capture the display to the clipboard by hitting PrintScreen"
      PRINT "     Switch to WINDOWS and open a graphic program (PaintBrush, PowerPoint..)"
      PRINT "     Select Paste in the Edit menu of the graphic program "
      PRINT "     Modify figure if necessary and print"
PRINT
30 REDIM BW(10), BW1(10), BW2(10), DAT(15), LT(6, 6), LT1(6, 6), LT2(6, 6), CM(6, 6)
   REDIM LM(6, 6), LI(6, 6), SE(6, 6), SIGR(6), SIGI(G), LMINV(6, 6), SI(3), SM(3)
   REDIM t(6, 6), LIN(6, 6), TEMP(6, 6), W(6, 6), WTEMP(6, 6), SREM(6, 1), SINC(6, 1)
   PI = 4 * ATN(1!): COUNT = 0: SMARK = 0: NA = 0: XFACT = 1
'   ON ERROR GOTO 7500
'
'Input of case data by user
'


INPUT "Enter problem name.  Results will be saved to a file under this name [DEFAULT] "; HNAME$
       IF HNAME$ = "" THEN HNAME$ = "DEFAULT"
       OPEN HNAME$ FOR OUTPUT AS #3
       PRINT #3, "Results of MOHR calculations."
PRINT #3, "Input, 6 stresses; Output, 3 principals, 6 angles; normal stress, shear stress"
       MINMR = -100: MAXMR = 20
       BMOR$ = "B": MANY$ = "M"
'       CLS
'       LOCATE 3, 1
       PRINT "The expected values for maximum and minimum stresses are ["; MINMR; ","; MAXMR; "]"
       PRINT "    Note: compression is negative."
     INPUT "Do you wish to set different maximum and minimum values [NO] "; B$
     IF B$ = "" THEN GOTO 38
     PRINT
     PRINT "Select a scale for the Mohr diagram."
     PRINT "  Select minimum and maximum values that are integer multiplications of 5"
     INPUT "Enter MINIMUM stress, MAXIMUM stress (compression is NEGATIVE)"; MINMR, MAXMR
38 INPUT "Two-dimensional stress state OR [three-dimensional] "; TWODI$
       IF TWODI$ <> "" THEN PRINT "Note: yielding envelopes and fracture stresses are available only "
       IF TWODI$ <> "" THEN PRINT "  for 3-D cases.  If you need these parameters run 3-D as 'pseudo' 2-D"
       IF TWODI$ <> "" THEN GOTO 36
       INPUT "Plot a Coulomb envelope (type C), a Griffith envelope (type G), or [NONE]"; YL$
       IF YL$ = "" THEN GOTO 36
       IF YL$ = "G" OR YL$ = "g" THEN GOTO 32
       IF YL$ = "C" OR YL$ = "c" THEN INPUT "Enter COHESION, FRICTION of Coulomb envelope "; COH, FRIC
       DIST = COH / FRIC
       DISC = (110 / FRIC) - DIST
       IF YL$ = "C" OR YL$ = "c" THEN GOTO 36
32     INPUT "Tensile strength of Griffith's yielding parabola (tension is positive) "; T0
36      PRINT
        PRINT "ENTERING STRESS COMPONENTS"
        PRINT "Some stress components can be zero [default]. However, numerical difficulties"
        PRINT "  (mostly overflow) may arise when the stress components are exactly equal"
        PRINT "  to each other, or exactly zero.  "
        PRINT "If overflow is encountered, change slightly the stress components [by < 0.1%]."
        PRINT
    IF TWODI$ <> "" THEN GOTO 237
37  PRINT "Stresses can be entered in one of two forms:"
    PRINT " Stress components, ";
    PRINT CHR$(229); "x,"; CHR$(229); "y,"; CHR$(229); "z,";
    PRINT CHR$(229); "xy,"; CHR$(229); "xz,"; CHR$(229); "yz,";
    PRINT " from a file: type FILENAME"
    INPUT " [ Six stress components from the keyboard ] "; file$
    IF file$ = "" THEN GOTO 41

    OPEN file$ FOR INPUT AS #2
    INPUT #2, SXI#, SYI#, SZI#, SXYI#, SXZI#, SYZI#
    CLOSE #2
    GOTO 40
    LOCATE 29, 1
41  PRINT "   "; CHR$(229); " x = "; : INPUT SXI#
    LOCATE 28, 1
    PRINT "                                                       "
    LOCATE 28, 1
    PRINT "   "; CHR$(229); " y = "; : INPUT SYI#
    LOCATE 28, 1
    PRINT "                                                       "
    LOCATE 28, 1
    PRINT "   "; CHR$(229); " z = "; : INPUT SZI#
    LOCATE 28, 1
    PRINT "                                                       "
    LOCATE 28, 1
    PRINT "   "; CHR$(229); " xy= "; : INPUT SXYI#
    LOCATE 28, 1
    PRINT "                                                       "
    LOCATE 28, 1
    PRINT "   "; CHR$(229); " xz= "; : INPUT SXZI#
    LOCATE 28, 1
    PRINT "                                                       "
    LOCATE 28, 1
    PRINT "   "; CHR$(229); " yz= "; : INPUT SYZI#
    GOTO 40
47  LOCATE 27, 1
40   IF SXI# = 0# THEN SXI# = .0001#
     IF SYI# = 0# THEN SYI# = .00015#
     IF SZI# = 0# THEN SZI# = .0002#
     IF SXYI# = 0# THEN SXYI# = .0001#
     IF SXZI# = 0# THEN SXZI# = .00015#
     IF SYZI# = 0# THEN SYZI# = .0002#
     GOTO 340
237  PRINT "Stresses can be entered in one of two forms:"
    PRINT " Stress components, ";
    PRINT CHR$(229); "x,"; CHR$(229); "y,"; CHR$(229); "xy"
    PRINT " from a file: type FILENAME"
    INPUT " [ Three stress components from the keyboard ] "; file$
    IF file$ <> "" THEN OPEN file$ FOR INPUT AS #2
    IF file$ <> "" THEN INPUT #2, SXI#, SYI#, SXYI#
    IF file$ <> "" THEN CLOSE #2
    IF file$ <> "" THEN GOTO 40
    LOCATE 29, 1
241  PRINT "   "; CHR$(229); " x = "; : INPUT SXI#
    LOCATE 28, 1
    PRINT "                                                       "
    LOCATE 28, 1
    PRINT "   "; CHR$(229); " y = "; : INPUT SYI#
    LOCATE 28, 1
    PRINT "                                                       "
    LOCATE 28, 1
    PRINT "   "; CHR$(229); " xy= "; : INPUT SXYI#
    LOCATE 28, 1
    GOTO 240
247  LOCATE 27, 1
240   IF SXI# = 0# THEN SXI# = .0001#
     IF SYI# = 0# THEN SYI# = .00015#
     IF SZI# = 0# THEN SZI# = .0002#
     IF SXYI# = 0# THEN SXYI# = .0001#
     IF SXZI# = 0# THEN SXZI# = .00015#
     IF SYZI# = 0# THEN SYZI# = .0002#




340               BK$ = "1": SI = 1
     IF MANY$ = "" THEN INPUT " OK [YES] "; H$
                IF MANY$ = "" THEN CLS :
                IF MANY$ = "" THEN PRINT "                                                    "; DATE$
                HTITLE$ = "REMOTE FIELD"
'
'Calculate principal stresses and their orientations
'
IF TWODI$ = "" THEN GOSUB 999
IF TWODI$ <> "" THEN GOSUB 2999

   HTEMP$ = HTITLE$: BT1 = BK1#: BT2 = BK2#: BT3 = BK3#: LT1 = L1#: LT2 = L2#: LT3 = L3#
   MT1 = M1#: MT2 = M2#: MT3 = M3#
   PM1 = DAT(10): TM1 = DAT(11): PM2 = DAT(12): TM2 = DAT(13): PM3 = DAT(14): TM3 = DAT(15)
60 IF MANY$ = "" THEN PRINT
   IF MANY$ = "" THEN INPUT "1-Modify stress state [CONTINUE] "; H$
   IF H$ = "" THEN GOTO 68
   IF H$ = "1" AND MANY$ = "" THEN GOTO 37
68  MANYMOR = MANYMOR + 1
    IF MANYMOR >= 15 THEN MANYMOR = 15
    IF MANYMOR = 1 THEN CLS
   
    IF TWODI$ = "" THEN CALL MOHR(SM(), SM(), HNAME$, BMOR$, MINMR, MAXMR, MANY$, MANYMOR, SCALE, ZERO, SXI#, SYI#, SZI#, SXYI#, SXZI#, SYZI#, DF, DD)
   
    IF TWODI$ <> "" THEN CALL MOHR2(SM(), SM(), HNAME$, BMOR$, MINMR, MAXMR, MANY$, MANYMOR, SXI#, SYI#, SXYI#)
    
     IF TWODI$ <> "" OR YL$ = "" THEN GOTO 55
     IF YD = 1 THEN GOTO 55
     YD = 1
     IF YL$ <> "C" AND YL$ <> "c" THEN GOTO 54
     DIST = COH / FRIC
     DISC = (210 * SCALE / FRIC) - DIST
     IF YL$ = "C" OR YL$ = "c" THEN LINE (ZERO - DIST / SCALE, 220)-(ZERO + DISC / SCALE, 10)
54   IF YL$ <> "g" AND YL$ <> "G" THEN GOTO 55
     T0 = T0 / SCALE
     X1 = -T0: Y1 = 0
     FOR I = 1 TO 100
     X2 = X1 + I
     Y2 = SQR(4 * T0 * (X2 + T0))
     IF Y2 >= 210 THEN GOTO 55
     LINE (ZERO + X1, 220 - Y1)-(ZERO + X2, 220 - Y2)
     X1 = X2: Y1 = Y2
     NEXT I

55              IF TWODI$ = "" THEN LOCATE 24, 1
                IF TWODI$ = "" THEN PRINT "Principal stress orientations:         ";
                IF TWODI$ = "" THEN PRINT INT(PM1); "/"; INT(TM1); "   "; INT(PM2); "/"; INT(TM2); "   "; INT(PM3); "/"; INT(TM3)
                IF TWODI$ = "" THEN PRINT "Stress orientations as plunge/trend [degrees] "
                IF TWODI$ = "" THEN PRINT "   "; CHR$(229); "1=maximum tension; stresses in input units"
IF TWODI$ = "" THEN CALL STEREO(HTITLE$, DAT(), BK1#, BK2#, BK3#, L1#, L2#, L3#, M1#, M2#, M3#, MANYMOR)
IF TWODI$ = "" THEN CALL STEREO(HTEMP$, DAT(), BT1, BT2, BT3, LT1, LT2, LT3, MT1, MT2, MT3, MANYMOR)
56      IF MANY$ = "" THEN INPUT "1-Modify this stress state [CONTINUE] "; H$
        IF TWODI$ <> "" THEN LOCATE 25, 1
        IF MANY$ <> "" AND TWODI$ <> "" THEN INPUT "2- stop, [Add more stress states] "; H$
        IF MANY$ <> "" AND TWODI$ = "" THEN INPUT "1- plot stress state on fractures, 2- stop, [Add more stress states] "; H$
PRINT #3, USING " ######.### "; SX#, SY#, SZ#, SXY#, SXZ#, SYZ#;
PRINT #3, USING " ######.### "; X1#, X2#, X3#;
PRINT #3, USING " ### "; INT(PM1), INT(TM1), INT(PM2), INT(TM2), INT(PM3), INT(TM3)

        IF H$ = "2" THEN GOTO 35
        IF H$ = "" AND MANY$ = "" THEN GOTO 37
        IF H$ = "" AND MANY$ <> "" AND TWODI$ = "" THEN GOTO 41
        IF H$ = "" AND MANY$ <> "" AND TWODI$ <> "" THEN GOTO 241
       
        IF H$ <> "1" OR TWODI$ <> "" THEN GOTO 35
        LOCATE 27, 1
        PRINT "                                                                          "
        LOCATE 27, 1
        INPUT "Enter number of fractures to plotted "; NR
        FOR I = 1 TO NR
        LOCATE 27, 1
        PRINT "                                                                          "
        LOCATE 27, 1

        CALL SHEAR(SX#, SY#, SZ#, SXY#, SXZ#, SYZ#, SIGN, SIGS, NR, SCALE, ZERO, SXI#, SYI#, SZI#, SXYI#, SXZI#, SYZI#, DF, DD)
        PRINT "Fracture "; I; ", normal =";
        PRINT USING " ####.## "; SIGN;
        PRINT ", shear =";
        PRINT USING " ####.## "; SIGS;
        PRINT ", shear/normal=";
        PRINT USING " #.## "; ABS(SIGS / SIGN);
        CIRCLE (ZERO - SIGN / SCALE, 220 - SIGS / SCALE), 1, MANYMOR
        CIRCLE (ZERO - SIGN / SCALE, 220 - SIGS / SCALE), 2, MANYMOR
        PRINT #3, "Dip,Dip dir, Sig N, Sig S ";
        PRINT #3, USING " ### "; DF, DD;
        PRINT #3, USING " #######.## "; SIGN, SIGS
        INPUT OK
        NEXT I
        LOCATE 27, 1
        PRINT "                                                                                "
        PRINT "                                                                                "
        'LOCATE 25, 1
        'INPUT "Continue "; ok
        LOCATE 27, 1
   GOTO 56

35 INPUT "Stop and CLOSE file (any key) [MORE CALCULATIONS] "; H$
CLOSE
   IF H$ = "" THEN CLS
   IF H$ = "" THEN GOTO 31
39 END


'
'SUB to calculate the principal stresses and their orientations
'
999  SX# = SXI#
     SY# = SYI#
     SZ# = SZI#
     SXY# = SXYI#
     SXZ# = SXZI#
     SYZ# = SYZI#
     IF MANY$ = "" THEN PRINT "STRESSES OF "; HTITLE$; "   "
     IF MANY$ = "" THEN PRINT "  Note: compression < 0, X is the symmetry axis and horizontal (north),"
     IF MANY$ = "" THEN PRINT "        Y is horizontal (east) and Z is vertical"
     IF MANY$ = "" THEN PRINT "Six component stress tensor: "
     IF MANY$ = "" THEN PRINT "   "; CHR$(229); " x= ";
     IF MANY$ = "" THEN PRINT USING " ####.## "; SX#;
     IF MANY$ = "" THEN PRINT "   "; CHR$(229); " y= ";
     IF MANY$ = "" THEN PRINT USING " ####.## "; SY#;
     IF MANY$ = "" THEN PRINT "   "; CHR$(229); " z= ";
     IF MANY$ = "" THEN PRINT USING " ####.## "; SZ#
     IF MANY$ = "" THEN PRINT "   "; CHR$(229); " yz=";
     IF MANY$ = "" THEN PRINT USING " ####.## "; SYZ#;
     IF MANY$ = "" THEN PRINT "   "; CHR$(229); " xz=";
     IF MANY$ = "" THEN PRINT USING " ####.## "; SXZ#;
     IF MANY$ = "" THEN PRINT "   "; CHR$(229); " xy=";
     IF MANY$ = "" THEN PRINT USING " ####.## "; SXY#
     SIG1H = (SX# + SY#) / 2 - SQR(.25 * (SX# - SY#) ^ 2 + SXY# ^ 2)
     SIG2H = (SX# + SY#) / 2 + SQR(.25 * (SX# - SY#) ^ 2 + SXY# ^ 2)
     IF SX# = SY# THEN GOTO 87
     THET = ATN(2 * SXY# / (SX# - SY#)) / 2
     GOTO 88
87   THET = 1000
88   THET = 180 * THET / PI
     IF SY# < SX# THEN THET = THET + 90

'******* Invariant calculations***************
    
     A1# = -(SX# + SY# + SZ#)
     A2# = (SY# * SZ# + SZ# * SX# + SX# * SY#) - (SYZ# ^ 2 + SXZ# ^ 2 + SXY# ^ 2)
     A3# = -(SX# * SY# * SZ# + 2 * SYZ# * SXZ# * SXY# - SX# * (SYZ#) ^ 2 - SY# * (SXZ#) ^ 2 - SZ# * (SXY#) ^ 2)
     PI = 4 * ATN(1!)
     Q# = (3 * A2# - A1# ^ 2) / 9
     R# = (9 * A1# * A2# - 27 * A3# - 2 * A1# ^ 3) / 54
     C# = Q# ^ 3 + R# ^ 2
     IF C# > O THEN PRINT "No real roots"
     CT# = -R# / (SQR(-Q# ^ 3))
     t# = ATN(SQR(1 - CT# ^ 2) / CT#)
     t# = ATN(CT# / SQR(1 - CT# ^ 2)) + PI / 2
     X1# = 2 * SQR(-Q#) * COS(t# / 3) - A1# / 3
     X2# = 2 * SQR(-Q#) * COS(t# / 3 + 120 * PI / 180) - A1# / 3
     X3# = 2 * SQR(-Q#) * COS(t# / 3 + 240 * PI / 180) - A1# / 3

     T1# = X1#: T2# = X2#: T3# = X3#
     IF X1# <= X2# AND X2# <= X3# THEN GOTO 4327
     IF X1# <= X3# AND X3# <= X2# THEN GOTO 155
     IF X2# <= X3# AND X3# <= X1# THEN GOTO 156
     IF X2# <= X1# AND X1# <= X3# THEN GOTO 157
     IF X3# <= X1# AND X1# <= X2# THEN GOTO 158
     IF X3# <= X2# AND X2# <= X1# THEN GOTO 159
155  X1# = T1#: X2# = T3#: X3# = T2#
     GOTO 4327
156  X1# = T2#: X2# = T3#: X3# = T1#
     GOTO 4327
157  X1# = T2#: X2# = T1#: X3# = T3#
     GOTO 4327
158  X1# = T3#: X2# = T1#: X3# = T2#
     GOTO 4327
159  X1# = T3#: X2# = T2#: X3# = T1#
     GOTO 4327
4327 IF MANY$ = "" THEN PRINT "PRINCIPAL STRESSES           "; CHR$(229); " 1       "; ; CHR$(229); " 2        "; CHR$(229); " 3 ("; CHR$(229);
IF MANY$ = "" THEN PRINT "1=maximum compression)"
     IF MANY$ = "" THEN PRINT "Magnitudes (input units):";
'     PRINT "   "; CHR$(229); " 1= ";
     IF MANY$ = "" THEN PRINT USING " #.##^^^^  "; X1#;
'     PRINT "   "; CHR$(229); " 2= ";
     IF MANY$ = "" THEN PRINT USING " #.##^^^^  "; X2#;
'     PRINT "   "; CHR$(229); " 3= ";
     IF MANY$ = "" THEN PRINT USING " #.##^^^^  "; X3#
IF HTITLE$ = "REMOTE FIELD" THEN SM(1) = X3#
IF HTITLE$ = "REMOTE FIELD" THEN SM(2) = X2#
IF HTITLE$ = "REMOTE FIELD" THEN SM(3) = X1#
IF HTITLE$ = "INCLUSION FIELD" THEN SI(1) = X1#
IF HTITLE$ = "INCLUSION FIELD" THEN SI(2) = X2#
IF HTITLE$ = "INCLUSION FIELD" THEN SI(3) = X3#

    
     DAT(7) = X1#: DAT(8) = X2#: DAT(9) = X3#
     IF MANY$ = "" THEN PRINT "Plunge/trend (degrees):  ";
     A11# = SX# - X1#: A12# = SXY#: A13# = SXZ#
     A21# = SXY#: A22# = SY# - X1#: A23# = SYZ#
     A31# = SXZ#: A32# = SYZ#: A33# = SZ# - X1#
     Z1# = (A11# * A23# - A21# * A13#) / (A12# * A23# - A22# * A13#)
     Z2# = (A11# - Z1# * A12#) / A13#
     BK1# = 1 / (SQR(1 + Z1# ^ 2 + Z2# ^ 2))
     BK2# = -BK1# * Z1#
     BK3# = -BK1# * Z2#
     BK1# = -BK1#: BK2# = -BK2#: BK3# = -BK3#
     RU# = A11# * BK1# + A12# * BK2# + A13# * BK3#
     RV# = A21# * BK1# + A22# * BK2# + A23# * BK3#
     RX# = A31# * BK1# + A32# * BK2# + A33# * BK3#
'     PRINT "  "; CHR$(229); " 1 ";
     'PRINT USING "######.###"; BK1#, BK2#, BK3#;
     BK1 = BK1#: BK2 = BK2#: BK3 = BK3#
     GOTO 4482
4465 BW1(1) = BK1: BW1(2) = BK2: BW1(3) = BK3
     GOTO 4482
4471 BW2(1) = BK1: BW2(2) = BK2: BW2(3) = BK3
4482 IF BK3# > 0 THEN GOTO 4685
     BK1 = -BK1#: BK2 = -BK2#: BK3 = -BK3#
4685 ALPHA = ATN(BK2# / BK1#)
     IF BK1 < 0 THEN ALPHA = PI + ALPHA
     IF BK2 < 0 AND BK1 > 0 THEN ALPHA = 2 * PI + ALPHA
     ALPHA = (180 * ALPHA / PI)
     IF BK3 = 1 THEN BK3 = .9999
     DIP = ATN(BK3 / SQR(1 - BK3 ^ 2))
     DIP = 180 * DIP / PI
     IF MANY$ = "" THEN PRINT " "; INT(DIP); "/"; INT(ALPHA);
     DAT(10) = INT(DIP): DAT(11) = INT(ALPHA)
    
     A11# = SX# - X2#: A12# = SXY#: A13# = SXZ#
     A21# = SXY#: A22# = SY# - X2#: A23# = SYZ#
     A31# = SXZ#: A32# = SYZ#: A33# = SZ# - X2#
     Z1# = (A11# * A33# - A31# * A13#) / (A12# * A33# - A32# * A13#)
     Z2# = (A31# - Z1# * A32#) / A33#
     L1# = 1 / (SQR(1 + Z1# ^ 2 + Z2# ^ 2))
     L2# = -L1# * Z1#
     L3# = -L1# * Z2#
     L1# = -L1#: L2# = -L2#: L3# = -L3#
     RU# = A11# * L1# + A12# * L2# + A13# * L3#
     RV# = A21# * L1# + A22# * L2# + A23# * L3#
     RX# = A31# * L1# + A32# * L2# + A33# * L3#
'     PRINT "  "; CHR$(229); " 2 ";
     'PRINT USING "######.###"; L1#, L2#, L3#;
     L1 = L1#: L2 = L2#: L3 = L3#
4578 IF L3# > 0 THEN GOTO 4579
     L1 = -L1#: L2 = -L2#: L3 = -L3#
4579 ALPHA = ATN(L2 / L1)
     IF L1 < 0 THEN ALPHA = PI + ALPHA
     IF L2 < 0 AND L1 > 0 THEN ALPHA = 2 * PI + ALPHA
     ALPHA = (180 * ALPHA / PI)
     IF L3 = 1 THEN L3 = .9999
     DIP = ATN(L3 / SQR(1 - L3 ^ 2))
     DIP = 180 * DIP / PI
     IF MANY$ = "" THEN PRINT "  "; INT(DIP); "/"; INT(ALPHA);
     DAT(12) = INT(DIP): DAT(13) = INT(ALPHA)
    
     A11# = SX# - X3#: A12# = SXY#: A13# = SXZ#
     A21# = SXY#: A22# = SY# - X3#: A23# = SYZ#
     A31# = SXZ#: A32# = SYZ#: A33# = SZ# - X3#
     Z1# = (A21# * A33# - A31# * A23#) / (A22# * A33# - A32# * A23#)
     Z2# = (A21# - Z1# * A22#) / A23#
     M1# = 1 / (SQR(1 + Z1# ^ 2 + Z2# ^ 2))
     M2# = -M1# * Z1#
     M3# = -M1# * Z2#
     RU# = A11# * M1# + A12# * M2# + A13# * M3#
     RV# = A21# * M1# + A22# * M2# + A23# * M3#
     RX# = A31# * M1# + A32# * M2# + A33# * M3#
'     PRINT "  "; CHR$(229); "  3 ";
     'PRINT USING "######.###"; M1#, M2#, M3#;
     M1 = M1#: M2 = M2#: M3 = M3#
     IF M3# > 0 THEN GOTO 4687
     M1 = -M1#: M2 = -M2#: M3 = -M3#
4687 ALPHA = ATN(M2 / M1)
     IF M1 < 0 THEN ALPHA = PI + ALPHA
     IF M2 < 0 AND M1 > 0 THEN ALPHA = 2 * PI + ALPHA
     ALPHA = (180 * ALPHA / PI)
     IF M3 = 1 THEN M3 = .9999
     DIP = ATN(M3 / SQR(1 - M3 ^ 2))
     DIP = 180 * DIP / PI
     IF MANY$ = "" THEN PRINT "   "; INT(DIP); "/"; INT(ALPHA)
     DAT(14) = INT(DIP): DAT(15) = INT(ALPHA)
    
     W1# = BK1# * L1# + BK2# * L2# + BK3# * L3#
     W2# = BK1# * M1# + BK2# * M2# + BK3# * M3#
     W3# = L1# * M1# + L2# * M2# + L3# * M3#
     IF ABS(W1#) < .1 AND ABS(W2#) < .1 AND ABS(W3#) < .1 AND BK$ = "1" THEN RETURN
     IF ABS(W1#) < .1 AND ABS(W2#) < .1 AND ABS(W3#) < .1 THEN GOTO 8000
     IF MANY$ = "" THEN PRINT
     INPUT "Principal stress axes are not perfectly normal to each other [CONTINUE] "; H$
     IF MANY$ = "" THEN PRINT
     IF H$ <> "" THEN END

2999  SX# = SXI#
     SY# = SYI#
     SXY# = SXYI#
     SIG1H = (SX# + SY#) / 2 - SQR(.25 * (SX# - SY#) ^ 2 + SXY# ^ 2)
     SIG2H = (SX# + SY#) / 2 + SQR(.25 * (SX# - SY#) ^ 2 + SXY# ^ 2)
     IF SX# = SY# THEN GOTO 87
     THET = ATN(2 * SXY# / (SX# - SY#)) / 2
     GOTO 2088
2087   THET = 1000
2088   THET = 180 * THET / PI
     IF SY# < SX# THEN THET = THET + 90
     SM(1) = SIG2H
     SM(2) = SIG1H
     SM(3) = THET
     RETURN




7500 CLS
     PRINT
     PRINT "The program encountered an error."
     PRINT
     PRINT "The most likely error is overflow due to stress components that are zero"
     PRINT " OR stress components that are exactly equal to each other."
     PRINT
     PRINT "Continue, and change slightly the stress components [by < 0.1%]."
     PRINT
     INPUT "Continue [YES] "; H$
     IF H$ = "" THEN GOTO 30



8000 RETURN

REM $STATIC
'
'Calculating and plotting 3-D Mohr diagram
'
SUB MOHR (SI(), SM(), HNAME$, BMOR$, MINMR, MAXMR, MANY$, MANYMOR, SCALE, ZERO, SXI#, SYI#, SZI#, SXYI#, SXZI#, SYZI#, DF, DD)
        RA = .5: PI = 3.14
        MIN = 1E+14: MAX = -1E+14
  IF ABS((SI(1) - SI(2)) / SI(1)) < .01 THEN SI(2) = SI(1)
  IF ABS((SI(2) - SI(3)) / SI(2)) < .01 THEN SI(3) = SI(2)

  IF BMOR$ = "" THEN GOTO 25
  IF BMOR$ <> "" THEN MIN = MINMR
  IF BMOR$ <> "" THEN MAX = MAXMR
  GOTO 20
25 FOR I = 1 TO 3
        IF SI(I) < MIN THEN MIN = SI(I)
        IF SI(I) > MAX THEN MAX = SI(I)
   NEXT I
20      DEL = MAX - MIN
        SCALE = DEL / 400
        IF MANY$ = "" THEN CLS
        LINE (1, 220)-(460, 220)
        LOCATE 4, 60: PRINT "Each stress division ";
        LOCATE 5, 60: PRINT "is";
        PRINT USING "##.##^^^^"; ABS(DEL / 20);
        PRINT " units"
  'ZERO = 200 + MAX / SCALE
  ZERO = MAX / SCALE
  LINE (ZERO, 20)-(ZERO, 220)
        FOR I = 1 TO 10
        LINE (ZERO - 3, 220 - 20 * I)-(ZERO + 3, 220 - 20 * I)
        'LINE (ZERO - 3, 120 + 20 * I)-(ZERO + 3, 120 + 20 * I)
        NEXT I
        FOR I = 1 TO 18
        LINE (ZERO - 20 * I, 217)-(ZERO - 20 * I, 223)
        LINE (ZERO + 20 * I, 217)-(ZERO + 20 * I, 223)
        NEXT I
       
11      'PLOTTING THE CIRCLES
        RI13 = ABS((SI(1) - SI(3)) / (2 * SCALE))
        RI12 = ABS((SI(1) - SI(2)) / (2 * SCALE))
        RI23 = ABS((SI(2) - SI(3)) / (2 * SCALE))
                CIRCLE (ZERO - (SI(1) + SI(3)) / (2 * SCALE), 220), RI13, MANYMOR, 0, PI
                CIRCLE (ZERO - (SI(2) + SI(3)) / (2 * SCALE), 220), RI23, MANYMOR, 0, PI
                CIRCLE (ZERO - (SI(1) + SI(2)) / (2 * SCALE), 220), RI12, MANYMOR, 0, PI

'ENTERING DATA
        LOCATE 15, 25: PRINT "Compressive "; CHR$(229); " n"
        LOCATE 16, 25: PRINT "(negative)"
        LOCATE 15, 1: PRINT "Tensile "; CHR$(229); " n"
        LOCATE 16, 1: PRINT "(positive)"


        LOCATE 15, 77: PRINT "Y="
        LOCATE 16, 76: PRINT "East"
        LOCATE 11, 63: PRINT "X=north";
        LOCATE 16, 46: PRINT "Z-Vertical";
        LOCATE 18, 32: PRINT " STEREOGRAPHIC PROJECTION"
        LOCATE 19, 32: PRINT "  with stress axes"
        LOCATE 3, 1: PRINT "Shear "; CHR$(229); " s "
        '"(vertical axis)"
        LOCATE 1, 1: PRINT "3-D MOHR STRESS CIRCLES "
        LOCATE 1, 67: PRINT DATE$
        LOCATE 2, 57: PRINT "Case:"; HNAME$
        LOCATE 21, 1: PRINT "Data of LAST circle:"
        LOCATE 22, 1
                PRINT "Axes of the principal stresses:          "; CHR$(229); " 1       "; ; CHR$(229); " 2        "; CHR$(229); " 3 "
                PRINT "Principal stress magnitudes:          ";
        PRINT USING " #.##^^^^  "; SM(1), SM(2), SM(3)
END SUB

'
'Calculating and plotting 2-D Mohr diagram
'
SUB MOHR2 (SI(), SM(), HNAME$, BMOR$, MINMR, MAXMR, MANY$, MANYMOR, SXI#, SYI#, SXYI#)
'IF MANY$ <> "" THEN MANYMOR = MANYMOR + 1
        RA = .5: PI = 3.14
        MIN = 1E+14: MAX = -1E+14
        LOCATE 11, 60
        PRINT "DATA SUMMARY:"
        LOCATE 12, 60
        PRINT CHR$(229); "1      "; CHR$(229); "2    "; " Angle"

        LOCATE 12 + MANYMOR, 57
        PRINT USING " ###.## "; SM(1), SM(2);
        PRINT USING " ###.#"; 90 - SM(3)

  IF ABS((SI(1) - SI(2)) / SI(1)) < .01 THEN SI(2) = SI(1)
  IF ABS((SI(2) - SI(3)) / SI(2)) < .01 THEN SI(3) = SI(2)

  IF BMOR$ = "" THEN GOTO 225
  IF BMOR$ <> "" THEN MIN = MINMR
  IF BMOR$ <> "" THEN MAX = MAXMR
  GOTO 220
225 FOR I = 1 TO 2
        IF SI(I) < MIN THEN MIN = SI(I)
        IF SI(I) > MAX THEN MAX = SI(I)
   NEXT I
220      DEL = MAX - MIN: SCALE = DEL / 200
        IF MANY$ = "" THEN CLS
        LINE (1, 120)-(630, 120)
        LOCATE 15, 1: PRINT "Each stress devision ";
        LOCATE 16, 1: PRINT "is";
        PRINT USING "##.##^^^^"; ABS(DEL / 10);
        PRINT " units"
        PRINT " "
        PRINT "Small circle:";
        PRINT CHR$(229); "xx,"; CHR$(229); "xy"
        PRINT " with line to:"; CHR$(229); "yy,"; CHR$(229); "yx"
  ZERO = 200 + MAX / SCALE
  LINE (ZERO, 20)-(ZERO, 220)
        FOR I = 1 TO 5
        LINE (ZERO - 3, 120 - 20 * I)-(ZERO + 3, 120 - 20 * I)
        LINE (ZERO - 3, 120 + 20 * I)-(ZERO + 3, 120 + 20 * I)
        NEXT I
        FOR I = 1 TO 20
        LINE (ZERO - 20 * I, 117)-(ZERO - 20 * I, 123)
        LINE (ZERO + 20 * I, 117)-(ZERO + 20 * I, 123)
        NEXT I
      
211      'PLOTTING THE CIRCLES
        RI12 = ABS((SI(1) - SI(2)) / (2 * SCALE))
                CIRCLE (ZERO + (SI(1) + SI(2)) / (2 * SCALE), 120), RI12, MANYMOR
'PRINT SXI#, SYI#, SXYI#
'INPUT OK
                CIRCLE (ZERO + SXI# / SCALE, 120 - SXYI# / SCALE), 3, MANYMOR
                CIRCLE (ZERO + SXI# / SCALE, 120 - SXYI# / SCALE), 2, MANYMOR
                LINE (ZERO + SXI# / SCALE, 120 - SXYI# / SCALE)-(ZERO + SYI# / SCALE, 120 + SXYI# / SCALE), MANYMOR
'ENTERING DATA

        LOCATE 9, 1: PRINT "Compressive "; CHR$(229); " n"
        LOCATE 10, 1: PRINT "(negative)"
        LOCATE 9, 55: PRINT "Tensile "; CHR$(229); " n"
        LOCATE 10, 55: PRINT "(positive)"


        LOCATE 18, 61: PRINT "X"
        S3 = SM(3) * 3.14 / 180
        LINE (355, 280)-(455, 280)
        LINE (355, 280)-(355, 180)
        'LINE (355, 280)-(355 + COS(S3) * 80, 280 - SIN(S3) * 80), 4
        'LINE (355, 280)-(355 - COS(S3) * 80, 280 + SIN(S3) * 80), 4
        'LINE (355, 280)-(355 + SIN(S3) * 30, 280 + COS(S3) * 30), 5
        'LINE (355, 280)-(355 - SIN(S3) * 30, 280 - COS(S3) * 30), 5
'INPUT OK
        LINE (355, 280)-(355 + COS(S3) * SI(2) / (2 * SCALE), 280 - SIN(S3) * SI(2) / (2 * SCALE)), 4
        LINE (355, 280)-(355 - COS(S3) * SI(2) / (2 * SCALE), 280 + SIN(S3) * SI(2) / (2 * SCALE)), 4
        LINE (355, 280)-(355 + SIN(S3) * SI(1) / (2 * SCALE), 280 + COS(S3) * SI(1) / (2 * SCALE)), 5
        LINE (355, 280)-(355 - SIN(S3) * SI(1) / (2 * SCALE), 280 - COS(S3) * SI(1) / (2 * SCALE)), 5

       
        'LOCATE 16, 76: PRINT "East"
        LOCATE 11, 45: PRINT "Y"
        'LOCATE 16, 46: PRINT "Z-Vertical";
        'LOCATE 18, 32: PRINT " STEREOGRAPHIC PROJECTION"
        'LOCATE 19, 32: PRINT "  with stress axes"
        LOCATE 1, 38: PRINT "Shear "; CHR$(229); " s "; "(vertical axis)"
        LOCATE 1, 1: PRINT "2-D MOHR STRESS CIRCLES "
        LOCATE 1, 67: PRINT DATE$
        LOCATE 2, 57: PRINT "Case:"; HNAME$
        LOCATE 21, 1: PRINT "Data of LAST circle:"
        LOCATE 22, 1
                PRINT "Axes of the principal stresses:          "; CHR$(229); " 1       "; CHR$(229); " 2        "
                PRINT "Principal stress magnitudes:          ";
        PRINT USING " #.##^^^^  "; SM(1), SM(2)
        PRINT "Clockwise angle of "; CHR$(229); " 1 with X axis (degrees)= ";
        PRINT USING " ###.# "; 90 - SM(3)
        'INPUT ok


END SUB

SUB SHEAR (SX#, SY#, SZ#, SXY#, SXZ#, SYZ#, SIGN, SIGS, NR, SCALE, ZERO, SXI#, SYI#, SZI#, SXYI#, SXZI#, SYZI#, DF, DD)
PI# = 4 * ATN(1)
INPUT "Enter  DIP AMOUNT (deg) , DIP DIRECTION (azimuth deg) of the fracture "; DF, DD
    SN1 = COS(DD * PI# / 180) * SIN(DF * PI# / 180)
    SN2 = SIN(DD * PI# / 180) * SIN(DF * PI# / 180)
    SN3 = COS((180 - DF) * PI# / 180)
    SUM = SQR(SN1 ^ 2 + SN2 ^ 2 + SN3 ^ 2)
    SN1 = SN1 / SUM: SN2 = SN2 / SUM: SN3 = SN3 / SUM

                RX = (SN1 * SX# + SN2 * SXY# + SN3 * SXZ#)
                RY = (SN1 * SXY# + SN2 * SY# + SN3 * SYZ#)
                RZ = (SN1 * SXZ# + SN2 * SYZ# + SN3 * SZ#)
                RP = SQR(RX ^ 2 + RY ^ 2 + RZ ^ 2)
        SIGN = SN1 * RX + SN2 * RY + SN3 * RZ
        SIGS = SQR(RP ^ 2 - SIGN ^ 2)

     C1 = SN1: C2 = SN2: C3 = SN3
     IF C3 > 0 THEN GOTO 24850
     C1 = -C1: C2 = -C2: C3 = -C3
24850 RR# = SQR(C1 ^ 2 + C2 ^ 2)
     TAX = ATN(SQR(1 - C3 ^ 2) / C3)
     XF# = C2 * 75 * SQR(2) * SIN(TAX / 2) / RR#
     YF# = 250 - C1 * 75 * SQR(2) * SIN(TAX / 2) / RR#
     X = 525 + XF#
     Y = YF#
     CIRCLE (X, Y), 1
END SUB

'
'Plot a stereo projection of the principal stress axes
'
SUB STEREO (HTITLE$, DAT(), BK1#, BK2#, BK3#, L1#, L2#, L3#, M1#, M2#, M3#, MANYMOR)
'  The circle
'
PI = 3.14: XFACT = 1: GR = 63 * 256: RD = 63
    FOR I = 1 TO 720
    ANN = 2 * PI / 720
    an = ANN * I
    X = 75 * SIN(an)
    Y = 75 * COS(an)
    X = 525 + XFACT * X
    Y = 250 + Y
    PSET (X, Y)
    NEXT I
661 LINE (525 - 80 * XFACT, 250)-(525 + 75 * XFACT, 250)
    LINE (525, 170)-(525, 325)
    
'     Stereoplot of the principal stresses
'
     C1 = BK1#: C2 = BK2#: C3 = BK3#: F = 1
4830 IF C3 > 0 THEN GOTO 4850
     C1 = -C1: C2 = -C2: C3 = -C3
4850 RR# = SQR(C1 ^ 2 + C2 ^ 2)
     TAX = ATN(SQR(1 - C3 ^ 2) / C3)
     XF# = C2 * 75 * SQR(2) * SIN(TAX / 2) / RR#
     YF# = 250 - C1 * 75 * SQR(2) * SIN(TAX / 2) / RR#
     IF F = 3 THEN GOTO 4980
     IF F <> 1 THEN GOTO 4940
     X = 525 + XFACT * XF#
     Y = YF#
      COLOR (MANYMOR)
      PSET (X, Y)
      PSET (X + 4, Y - 3)
      AP = 0
      DRAW "TA=" + VARPTR$(AP)
      'DRAW "C10L6D1L1D1L1D3R1D1R1D1R4U1R1U6R3"
      DRAW "L6D1L1D1L1D3R1D1R1D1R4U1R1U6R3"
      PSET (X + 8, Y + 2)
      'DRAW "C10D5L1U5"
      DRAW "D5L1U5"
     C1 = L1#: C2 = L2#: C3 = L3#: F = 2
     GOTO 4830
4940 IF F <> 2 THEN GOTO 4960
     X = 525 + XFACT * XF#
     Y = YF#
     PSET (X, Y)
      PSET (X + 4, Y - 3)
      'DRAW "C10L6;D1;L1;D1;L1;D3;R1;D1;R1;D1;R4;U1;R1;U6;R3"
      DRAW "L6;D1;L1;D1;L1;D3;R1;D1;R1;D1;R4;U1;R1;U6;R3"
      PSET (X + 8, Y + 3)
      'DRAW "C10R1;U1;R1;U1;R3;D1;R1;D1;R1;D1;L2;D1;L2;D1;L2;D1;R6"
      DRAW "R1;U1;R1;U1;R3;D1;R1;D1;R1;D1;L2;D1;L2;D1;L2;D1;R6"
4960 C1 = M1#: C2 = M2#: C3 = M3#: F = 3
     GOTO 4830
4980 X = 525 + XFACT * XF#
     Y = YF#
     PSET (X, Y)
      PSET (X + 4, Y - 3)
      'DRAW "C10L6;D1;L1;D1;L1;D3;R1;D1;R1;D1;R4;U1;R1;U6;R3"
      DRAW "L6;D1;L1;D1;L1;D3;R1;D1;R1;D1;R4;U1;R1;U6;R3"
      PSET (X + 8, Y + 3)
      'DRAW "C10R1;U1;R1;U1;R3;D1;R1;D1;L1;D1;L1;D1;R1;D1;R1;D1;L1;D1;L3;U1;L1"
      DRAW "R1;U1;R1;U1;R3;D1;R1;D1;L1;D1;L1;D1;R1;D1;R1;D1;L1;D1;L3;U1;L1"
COLOR (10)
      GOTO 6000

6000
END SUB

