10 CLS
'$DYNAMIC
    CLOSE
    PRINT "**********************************************************************"
    PRINT
    PRINT "                        DISPLAY OF DIS3D RESULTS"
    PRINT "Plotting displacements and stresses calculated by DIS3D version 1.2.  "
    PRINT "Input file is the output file of DIS3D."
    PRINT "Output of DIS3D SHOULD be in the following order:"
    PRINT "   1.  REQUIRED: Input (material properties, # of points<3400, # of dislocations)"
    PRINT "   2.  REQUIRED: Dislocation data"
    PRINT "   3.  REQUIRED: Displacement results"
    PRINT "   4.  REQUIRED: Stress results (six components) "
    PRINT "   5.  Principal stresses results (optional)"
    PRINT "   6.  Strain results (six components) (optional)"
    PRINT "   7.  Principal strains (optional)"
    PRINT "Only maps can be plotted"
    PRINT "Defaults in [square brackets]"
    PRINT
    PRINT "**********************************************************************"
    PRINT
    LENGTH = 3400: DEN = 1
    DIM HALFLEN(50), UPPDEPTH(50), LOWDEPTH(50), DIP(50), STRIKE(50), X1C(50), X2C(50), SS(50), DS(50), OP(50)
    DIM X1G(LENGTH), X2G(LENGTH), X3G(LENGTH), U1(LENGTH), U2(LENGTH), U3(LENGTH), COLNUM&(30)
    DIM S11(LENGTH), S22(LENGTH), S33(LENGTH), S12(LENGTH), S13(LENGTH), S23(LENGTH), MIS(20)
    DIM GRID(10, 2), SEAS(200, 4), SHMAX(LENGTH), SHMIN(LENGTH), THMAX(LENGTH), GRIDS(10, 2), STS(200, 4), TRS(200)
    DIM SI11(LENGTH), SI22(LENGTH), SI33(LENGTH), SI12(LENGTH), RNK(200)
20 SCOL = 12
    INPUT "Screen plots in B & W [COLOR] "; BW$
    PI = 4 * ATN(1!)
    PRINT "These are the files in the default directory:"
    FILES
    PRINT
    INPUT "Geography input file [no file] "; GIS$
    IF GIS$ = "" THEN GIS$ = "no"
    INPUT "Stress observations file [no file] "; SIS$
    IF SIS$ = "" THEN SIS$ = "no"
25  INPUT "Input File  (D for directory) [DIS3D.OUT] "; N$
    IF N$ = "" THEN N$ = "DIS3D.OUT"
    IF N$ = "D" OR N$ = "d" THEN FILES "*.*"
    IF N$ = "D" OR N$ = "d" THEN GOTO 25
    'INPUT "Gradient of overburden stress (MPa/km) [0] "; OB
    'IF OB = 0 THEN OB = 26
    'INPUT "Output File [OUTP] "; OUT$
    IF OUT$ = "" THEN OUT$ = "OUTP"
    CLOSE
   
    IF GIS$ = "NO" OR GIS$ = "no" THEN GOTO 15
    OPEN GIS$ FOR INPUT AS #2
    FOR I = 1 TO 4
    INPUT #2, GRID(I, 1), GRID(I, 2)
    NEXT I
    FOR I = 1 TO 200
    INPUT #2, SEAS(I, 1), SEAS(I, 2), SEAS(I, 3), SEAS(I, 4)
    IF SEAS(I, 1) = 1 AND SEAS(I, 2) = 1 AND SEAS(I, 3) = 1 AND SEAS(I, 4) = 1 THEN GOTO 14
    NUMSEAS = I
    NEXT I
14  CLOSE #2
   
    IF SIS$ = "NO" OR SIS$ = "no" THEN GOTO 15
    OPEN SIS$ FOR INPUT AS #2
    FOR I = 1 TO 4
    INPUT #2, GRIDS(I, 1), GRIDS(I, 2)
    NEXT I
    FOR I = 1 TO 200
    INPUT #2, STS(I, 1), STS(I, 2), TRS(I), RANK$
    IF RANK$ = "A" THEN RNK(I) = 4
    IF RANK$ = "B" THEN RNK(I) = 3
    IF RANK$ = "C" THEN RNK(I) = 2
    IF RANK$ = "D" THEN RNK(I) = 1

    IF STS(I, 1) = 1 AND STS(I, 2) = 1 AND TRS(I) = 1 THEN GOTO 15
    NUMSTS = I
    NEXT I
15  CLOSE

'DATA READING
   
    OPEN N$ FOR INPUT AS #2
100 INPUT #2, A$
    CLS
    PRINT "**********************************************************************"
    PRINT "        INPUT DATA"
    PRINT
    PRINT "File name: "; A$;
    S$ = INPUT$(99, #2)
    PRINT S$;
    INPUT #2, NUMP
    PRINT "  "; NUMP
    S$ = INPUT$(36, #2)
    PRINT S$;
    INPUT #2, NUMDIS
    PRINT "  "; NUMDIS
    S$ = INPUT$(35, #2)
    PRINT S$;
    INPUT #2, POIS
    PRINT "  "; POIS
    S$ = INPUT$(35, #2)
    PRINT S$;
    INPUT #2, SHEAR
    PRINT "  "; SHEAR
    PRINT
    PRINT "**********************************************************************"
    PRINT
    INPUT "Type dislocation data on screen [NO] "; C$
    S$ = INPUT$(263, #2)
    IF C$ <> "" THEN CLS
    IF C$ <> "" THEN PRINT S$
    IF C$ <> "" THEN INPUT "Continue [YES] "; ok$
    FOR I = 1 TO NUMDIS
    INPUT #2, SN, HALFLEN(I), UPPDEPTH(I), LOWDEPTH(I), DIP(I), STRIKE(I), X1C(I), X2C(I), SS(I), DS(I), OP(I)
    IF C$ <> "" THEN PRINT USING "   ###.#### "; I, HALFLEN(I), UPPDEPTH(I), LOWDEPTH(I), DIP(I), STRIKE(I)
    IF C$ <> "" THEN PRINT USING "   ###.#### "; X1C(I), X2C(I), SS(I), DS(I), OP(I)
    NEXT I
PRINT "Bounding magnitude for plotting displacements/stresses that are close"
INPUT "     to zero (0.0001 means plot all data, 1 means plot none) [0.03] "; CUT
IF CUT = 0 THEN CUT = .03

    INPUT "Analyze first displacements OR stress [displacements] "; CS$
    IF CS$ <> "" THEN GOTO 220
   
    INPUT "Type displacement data on screen [NO] "; C$
    S$ = INPUT$(184, #2)
    IF C$ <> "" THEN PRINT S$
    IF C$ <> "" THEN INPUT "Continue [YES] "; ok$

    FOR I = 1 TO NUMP
    INPUT #2, X1G(I), X2G(I), X3G(I), U1(I), U2(I), U3(I)
    IF U1(I) = 100000 THEN U1(I) = 0
    IF U2(I) = 100000 THEN U2(I) = 0
    IF U3(I) = 100000 THEN U3(I) = 0
    IF C$ <> "" THEN PRINT USING " #.###^^^^ "; X1G(I), X2G(I), X3G(I), U1(I), U2(I), U3(I)
    NEXT I
115 S$ = INPUT$(9, #2)

'Reading stress data
220 IF CS$ = "" THEN S$ = INPUT$(195, #2)
    IF CS$ <> "" THEN S$ = INPUT$(202, #2)
    INPUT "Type stress data on the screen [NO] "; C$
    IF C$ <> "" THEN PRINT S$
    IF C$ <> "" THEN INPUT "Continue [YES] "; ok$
    INPUT "Want to add a uniform, horizontal stress field [NO] "; SF$
    IF SF$ = "" THEN GOTO 222
    PRINT "   Stress additions:"
    INPUT "   N-S (X1) normal, to E-W (X2) normal, N-S/E-W shear "; DELS11, DELS22, DELS12

222 FOR I = 1 TO NUMP
    'INPUT #2, X1G(I), X2G(I), X3G(I), S11(I), S22(I), S33(I), S12(I), S13(I), S23(I)
    INPUT #2, XJUNK1, XJUNK2, XJUNK3, S11(I), S22(I), S33(I), S12(I), S13(I), S23(I)
    IF S11(I) = 100000 THEN S11(I) = 0
    IF S22(I) = 100000 THEN S22(I) = 0
    IF S33(I) = 100000 THEN S33(I) = 0
    IF S12(I) = 100000 THEN S12(I) = 0
    IF S13(I) = 100000 THEN S13(I) = 0
    IF S23(I) = 100000 THEN S23(I) = 0
    SI11(I) = S11(I): SI22(I) = S22(I): SI33(I) = S33(I): SI12(I) = S12(I)
333 IF C$ <> "" THEN PRINT USING " #.###^^^^ "; X1G(I), X2G(I), X3G(I), S11(I), S22(I), S33(I), S12(I), S13(I), S23(I)
    NEXT I

334 BURDEN3 = Z * OB: BURDEN2 = Z * OB * (POIS / (1 - POIS)): BURDEN1 = Z * OB * (POIS / (1 - POIS))
    FOR I = 1 TO NUMP
    S11(I) = SI11(I) - BURDEN1 + DELS11
    S22(I) = SI22(I) - BURDEN2 + DELS22
    S33(I) = SI33(I) - BURDEN3
    S12(I) = SI12(I) + DELS12
     SHMAX(I) = (S11(I) + S22(I)) / 2 - SQR(.25 * (S11(I) - S22(I)) ^ 2 + S12(I) ^ 2)
     SHMIN(I) = (S11(I) + S22(I)) / 2 + SQR(.25 * (S11(I) - S22(I)) ^ 2 + S12(I) ^ 2)
     IF S11(I) = S22(I) THEN GOTO 1333
     THMAX(I) = ATN(2 * S12(I) / (S11(I) - S22(I))) / 2
     THMAX(I) = 180 * THMAX(I) / PI

     IF S22(I) < S11(I) THEN THMAX(I) = THMAX(I) + 90
     IF THMAX(I) < 0 THEN THMAX(I) = THMAX(I) + 180
'NOTE THE CHANGE BELOW
     S12(I) = -(SHMAX(I) - SHMIN(I)) / 2
1333  NEXT I
   
    IF OBZ <> 1 THEN GOTO 122
    PRINT "Calculate mean deviation between OBSERVED and PREDICTED "; CHR$(229); "Hmax [NO] ";
    INPUT DT$
    IF DT$ = "" THEN GOTO 122
    OPEN "CALC_STR" FOR OUTPUT AS 10
    DTHETA = 0: KDT = 1: RSUM = 0
    FOR I = 1 TO NUMSTS
    IF STS(I, 1) < X1MIN OR STS(I, 1) > X1MAX OR STS(I, 2) < X2MIN OR STS(I, 2) > X2MAX THEN GOTO 125
    KDT = KDT + 1
    R = 1000000
    'INPUT #2, STS(I, 1), STS(I, 2), TRS(I)
    FOR J = 1 TO NUMP
    R1 = ((X1G(J) - STS(I, 1)) ^ 2 + (X2G(J) - STS(I, 2)) ^ 2)
    IF R1 < R THEN BEST = THMAX(J)
    IF R1 < R THEN R = R1
    NEXT J
    DT = ABS(TRS(I) - BEST)
    IF DT > 90 THEN DT = 180 - DT
    PRINT #10, TRS(I)
    DTHETA = DTHETA + DT
    'PRINT I, R
    'INPUT OK
    RSUM = RSUM + SQR(R)
125 NEXT I
    PRINT
    PRINT "The mean angle between the trend of OBSERVED and PREDICTED SHmax (nearest point)"
    PRINT "  for "; KDT - 1; " observation points is "; INT(100 * DTHETA / KDT) / 100; " degrees; mean distance between "
    PRINT "  an observation point to the nearest calcualtion point is "; INT(RSUM * 100 / KDT) / 100; " km."
    PRINT
    INPUT "Continue [YES] "; junk



122  IF OBZ = 1 THEN RETURN
     IF CS$ <> "" THEN GOTO 117


116 'INPUT "Map (M) or Section (S) [MAP] "; MAP$
        IF MAP$ = "" THEN MAP$ = "M"
        IF MAP$ = "S" OR MAP$ = "s" THEN GOTO 1000

        X1MIN = 10000: X1MAX = -10000: X2MIN = 10000: X2MAX = -10000
        U1MAX = -10000: U2MAX = -10000: U1MIN = 10000: U2MIN = 10000: U3MAX = -10000: U3MIN = 10000

        FOR I = 1 TO NUMP
        IF X1G(I) < X1MIN THEN X1MIN = X1G(I)
        IF X1G(I) > X1MAX THEN X1MAX = X1G(I)
        IF X2G(I) < X2MIN THEN X2MIN = X2G(I)
        IF X2G(I) > X2MAX THEN X2MAX = X2G(I)
        IF U1(I) > U1MAX THEN U1MAX = U1(I)
        IF U2(I) > U2MAX THEN U2MAX = U2(I)
        IF U1(I) < U1MIN THEN U1MIN = U1(I)
        IF U2(I) < U2MIN THEN U2MIN = U2(I)
        IF U3(I) > U3MAX THEN U3MAX = U3(I)
        IF U3(I) < U3MIN THEN U3MIN = U3(I)
        NEXT I
260 CLS
    
     SCREEN 0
     IF SCOL = 12 THEN COLOR 10, 4
     FOR J = 1 TO 18
     MIS(J) = 0
     NEXT J
        FOR J = 1 TO NUMP
                IF X1G(J) < X1MIN OR X1G(J) > X1MAX OR X2G(J) < X2MIN OR X2G(J) > X2MAX THEN GOTO 270
                LP = 1 + 17 * (U3(J) - U3MIN) / (U3MAX - U3MIN)
                IF LP > 18 OR LP < 1 THEN GOTO 270
                IF LP > 18 OR LP < 1 THEN PRINT J, U3(J), U3MIN, U3MAX, LP, MIS(LP)
                IF LP > 18 OR LP < 1 THEN INPUT ok
                MIS(LP) = MIS(LP) + 1
270 NEXT J

     PRINT "Frequency of vertical displacement U3 (negative is up)"
     PRINT " U3     FREQUENCY  "
     MAXP = 0: MAXS = 0
     FOR I = 1 TO 18
     IF MIS(I) > MAXP THEN MAXP = MIS(I)
     NEXT I
     FOR I = 1 TO 18
     IF MIS(I) <> 0 THEN MIS(I) = INT(1 + MIS(I) * 24 / MAXP)
     IF MIS(I) <> 0 THEN PRINT USING "#.##"; U3MIN + (I - 1) * (U3MAX - U3MIN) / 18;
     IF MIS(I) = 0 THEN PRINT USING "#.##"; U3MIN + (I - 1) * (U3MAX - U3MIN) / 18
     IF SCOL = 12 THEN COLOR 10, 4
     IF MIS(I) = 0 THEN GOTO 280
     FOR J = 1 TO MIS(I)
     IF J < MIS(I) THEN PRINT CHR$(178);
     IF J = MIS(I) THEN PRINT CHR$(178)
     NEXT J
280 NEXT I
    
     PRINT
     PRINT "Use the plot above to select better bounding values for the plot."
     PRINT "Current U3minimum (UP), and U3maximum (DOWN): "; U3MIN, U3MAX
     PRINT "Select new minimum and maximum values [NO] ";
     INPUT C$
     IF C$ = "" THEN GOTO 225
     PRINT
     INPUT "New selected U3minimum, U3maximum points= "; U3MIN, U3MAX
     GOTO 260


224 X1MIN = 10000: X1MAX = -10000: X2MIN = 10000: X2MAX = -10000
        U1MAX = -10000: U2MAX = -10000: U1MIN = 10000: U2MIN = 10000: U3MAX = -10000: U3MIN = 10000

        FOR I = 1 TO NUMP
                IF X1G(I) < X1MIN THEN X1MIN = X1G(I)
                IF X1G(I) > X1MAX THEN X1MAX = X1G(I)
                IF X2G(I) < X2MIN THEN X2MIN = X2G(I)
                IF X2G(I) > X2MAX THEN X2MAX = X2G(I)
                IF U1(I) > U1MAX THEN U1MAX = U1(I)
                IF U2(I) > U2MAX THEN U2MAX = U2(I)
                IF U1(I) < U1MIN THEN U1MIN = U1(I)
                IF U2(I) < U2MIN THEN U2MIN = U2(I)
                IF U3(I) > U3MAX THEN U3MAX = U3(I)
                IF U3(I) < U3MIN THEN U3MIN = U3(I)
        NEXT I
225 CLS

SCREEN 12
IF BW$ <> "" THEN SCREEN 11
IF BW$ <> "" THEN GOTO 990
'Setting screen colors
        FOR I = 0 TO 15
                    IF I <= 8 THEN COLNUM&(I) = (8 - I) * 7 + 65536 * I * 7
                    IF I >= 8 THEN COLNUM&(I) = 256 * (I - 8) * 8 + 65536 * (15 - I) * 8
          NEXT I
          FOR I = 0 TO 15
                    IF NOBLUE = 1 THEN COLNUM&(I) = (15 - I) * 4 + 256 * I * 4
          NEXT I
      
          FOR J = 1 TO 15
                PALETTE J, COLNUM&(J)
          NEXT J
          FOR J = 1 TO 15
                LINE (250 + (J - 1) * 20, 1)-(250 + J * 20, 10), J, BF
          NEXT J

'Scale calculations for the maps
990 SCALE1 = 10000: SCALE2 = 10000
IF (X1MAX - X1MIN) > .0001 THEN SCALE1 = 630 / (X1MAX - X1MIN)
IF (X2MAX - X2MIN) > .0001 THEN SCALE2 = 210 / (X2MAX - X2MIN)
SCALE = SCALE2
IF SCALE1 < SCALE2 THEN SCALE = SCALE1

SIZE1 = ABS(X1G(2) - X1G(1)) * SCALE / 2
'SIZE2 = ABS(X2G(2) - X2G(1)) * SCALE2 / 2
SIZE2 = SIZE1

IF ABS(U1MAX) > ABS(U1MIN) THEN UMAX1 = ABS(U1MAX)
IF ABS(U1MAX) <= ABS(U1MIN) THEN UMAX1 = ABS(U1MIN)
IF ABS(U2MAX) > ABS(U2MIN) THEN UMAX2 = ABS(U2MAX)
IF ABS(U2MAX) <= ABS(U2MIN) THEN UMAX2 = ABS(U2MIN)
UMAX = UMAX1
IF UMAX2 > UMAX1 THEN UMAX = UMAX2

BS1 = (X1MAX - X1MIN) * SCALE
BS2 = (X2MAX - X2MIN) * SCALE

'Plotting frames of maps
K1 = .01: K2 = .01
M1 = 0: M2 = 0
IF X1MAX = X1MIN THEN M1 = 330
IF X2MAX = X2MIN THEN M2 = 365
IF (X1MAX - X1MIN) < .0001 THEN GOTO 170
IF BS1 / (X1MAX - X1MIN) > 300 THEN K1 = .2
IF BS1 / (X1MAX - X1MIN) > 100 AND BS1 / (X1MAX - X1MIN) <= 300 THEN K1 = 1
IF BS1 / (X1MAX - X1MIN) > 10 AND BS1 / (X1MAX - X1MIN) <= 100 THEN K1 = 5
IF BS1 / (X1MAX - X1MIN) > 5 AND BS1 / (X1MAX - X1MIN) <= 10 THEN K1 = 10
IF BS1 / (X1MAX - X1MIN) <= 5 THEN K1 = 25

IF (X2MAX - X2MIN) < .0001 THEN GOTO 175
170 IF BS2 / (X2MAX - X2MIN) > 300 THEN K2 = .25
IF BS2 / (X2MAX - X2MIN) > 100 AND BS2 / (X2MAX - X2MIN) <= 300 THEN K2 = 1
IF BS2 / (X2MAX - X2MIN) > 10 AND BS2 / (X2MAX - X2MIN) <= 100 THEN K2 = 5
IF BS2 / (X2MAX - X2MIN) > 5 AND BS2 / (X2MAX - X2MIN) <= 10 THEN K2 = 10
IF BS2 / (X2MAX - X2MIN) <= 5 THEN K2 = 25
175 IF K1 >= K2 THEN KS = K1
IF K1 < K2 THEN KS = K2
IF CS$ = "" THEN GOTO 192
LOCATE 1, 1: PRINT "                            "


LINE (10, 260)-(639, 470), 2, B
FOR J = 10 TO 639 STEP KS * SCALE
LINE (J, 260)-(J, 470), 2
NEXT J
FOR J = 260 TO 470 STEP KS * SCALE
LINE (10, J)-(639, J), 2
NEXT J
IF CS$ <> "" THEN RETURN


'Plotting horizontal displacements
192 FOR J = 1 TO NUMP STEP DEN
IF X1G(J) < X1MIN OR X1G(J) > X1MAX OR X2G(J) < X2MIN OR X2G(J) > X2MAX THEN GOTO 470
LINE (10 + (X1G(J) - X1MIN) * SCALE + M1, 260 + (X2G(J) - X2MIN) * SCALE + M2)-(10 + M1 + (X1G(J) - X1MIN) * SCALE + U1(J) * 50 / UMAX, 260 + M2 + (X2G(J) - X2MIN) * SCALE + U2(J) * 50 / UMAX), 15
CIRCLE (10 + M1 + (X1G(J) - X1MIN) * SCALE, 260 + M2 + (X2G(J) - X2MIN) * SCALE), 1, 15
470 NEXT J


'Plotting all dislocations listed
FOR J = 1 TO NUMDIS
IF SS(J) = 0 AND DS(J) = 0 AND OP(J) = 0 THEN GOTO 190
LINE (10 + M1 + (X1C(J) - X1MIN) * SCALE - HALFLEN(J) * SCALE * COS(STRIKE(J) * PI / 180), 260 + M2 + (X2C(J) - X2MIN) * SCALE - HALFLEN(J) * SCALE * SIN(STRIKE(J) * PI / 180))-(10 + M1 + (X1C(J) - X1MIN) * SCALE + HALFLEN(J) * SCALE * COS(STRIKE(J) _
 * PI / 180), 260 + M2 + (X2C(J) - X2MIN) * SCALE + HALFLEN(J) * SCALE * SIN(STRIKE(J) * PI / 180)), 15
CIRCLE (10 + M1 + (X1C(J) - X1MIN) * SCALE, 260 + M2 + (X2C(J) - X2MIN) * SCALE), 2, 15
190 NEXT J

215 'Plotting vertical displacement U3
LOCATE 2, 1: PRINT "U1m,U1x="; INT(100 * U1MIN) / 100; ","; INT(100 * U1MAX) / 100;
PRINT "U2m,U2x="; INT(100 * U2MIN) / 100; ","; INT(100 * U2MAX) / 100; "Umax="; INT(1000 * UMAX) / 1000; "Red,Down<="; INT(100 * U3MAX) / 100; "Green,Up>="; INT(100 * U3MIN) / 100

'SIZE1 = ABS(X1G(2) - X1G(1)) * SCALE / 2
'SIZE2 = ABS(X2G(2) - X2G(1)) * SCALE / 2
'SIZE = SIZE * 1.5



FOR J = 1 TO NUMP

IF X1G(J) < X1MIN OR X1G(J) > X1MAX OR X2G(J) < X2MIN OR X2G(J) > X2MAX THEN GOTO 471
COL = 1 + 15 * ((U3MAX - U3(J)) / (U3MAX - U3MIN))
IF U3(J) < U3MIN THEN COL = 15
IF U3(J) > U3MAX THEN COL = 1
IF ABS(U3(J)) < CUT * (U3MAX - U3MIN) THEN COL = 0
LINE (10 + M1 + (X1G(J) - X1MIN) * SCALE - SIZE1, 40 + M2 + (X2G(J) - X2MIN) * SCALE - SIZE2)-(10 + M1 + (X1G(J) - X1MIN) * SCALE + SIZE1, 40 + M2 + (X2G(J) - X2MIN) * SCALE + SIZE2), INT(COL), BF
'LOCATE 1, 1: INPUT ok
471 NEXT J

481 STS$ = ""
'Replotting the frames
LINE (9, 40)-(9 + (X1MAX - X1MIN) * SCALE, 40 + (X2MAX - X2MIN) * SCALE), 2, B
BS1 = 9 + (X1MAX - X1MIN) * SCALE
BS2 = 40 + (X2MAX - X2MIN) * SCALE

FOR J = 9 TO BS1 STEP KS * SCALE
'LINE (J, 40)-(J, BS2), 2
LINE (J, 40)-(J, 50), 2
LINE (J, BS2 - 10)-(J, BS2), 2
NEXT J

FOR J = 40 TO BS2 STEP KS * SCALE
'LINE (9, J)-(BS1, J), 2
LINE (9, J)-(19, J), 2
LINE (BS1 - 10, J)-(BS1, J), 2
NEXT J
LINE (9, BS2)-(BS1, BS2), 2
LINE (BS1, 40)-(BS1, BS2), 2
'LINE (10, 260)-(639, 470), 2, B
LINE (9, 260)-(9 + (X1MAX - X1MIN) * SCALE, 260 + (X2MAX - X2MIN) * SCALE), 15, B

FOR J = 9 TO BS1 STEP KS * SCALE
'LINE (J, 260)-(J, 220 + BS2), 2
LINE (J, 260)-(J, 270), 2
LINE (J, 210 + BS2)-(J, 220 + BS2), 2
NEXT J
FOR J = 260 TO 220 + BS2 STEP KS * SCALE
'LINE (9, J)-(BS1, J), 2
LINE (9, J)-(19, J), 2
LINE (BS1 - 10, J)-(BS1, J), 2
NEXT J
LINE (9, 220 + BS2)-(BS1, 220 + BS2), 2
LINE (BS1, 260)-(BS1, 220 + BS2), 2
LINE (9, 260)-(BS1, 220 + BS2), 2, B

'Plotting the geographic features
FOR J = 1 TO NUMSEAS
IF SEAS(J, 1) < X1MIN OR SEAS(J, 1) > X1MAX OR SEAS(J, 2) < X2MIN OR SEAS(J, 2) > X2MAX THEN GOTO 472
LINE (10 + M1 + (SEAS(J, 1) - X1MIN) * SCALE, 260 + M2 + (SEAS(J, 2) - X2MIN) * SCALE)-(10 + M1 + (SEAS(J, 3) - X1MIN) * SCALE, 260 + M2 + (SEAS(J, 4) - X2MIN) * SCALE), 7
472 NEXT J

IF SIS$ = "NO" OR SIS$ = "no" THEN GOTO 490

FOR J = 1 TO NUMSTS

IF STS(J, 1) < X1MIN OR STS(J, 1) > X1MAX OR STS(J, 2) < X2MIN OR STS(J, 2) > X2MAX THEN GOTO 473
LINE (10 + M1 + (STS(J, 1) - X1MIN) * SCALE - 10 * RNK(J) * COS(TRS(J) * PI / 180), 260 + M2 + (STS(J, 2) - X2MIN) * SCALE - 10 * RNK(J) * SIN(TRS(J) * PI / 180))-(10 + M1 + (STS(J, 1) - X1MIN) * SCALE + 10 * RNK(J) * COS(TRS(J) * PI / 180), 260 +  _
M2 + (STS(J, 2) - X2MIN) * SCALE + 10 * RNK(J) * SIN(TRS(J) * PI / 180)), 8
CIRCLE (10 + M1 + (STS(J, 1) - X1MIN) * SCALE, 260 + M2 + (STS(J, 2) - X2MIN) * SCALE), 1, 8
CIRCLE (10 + M1 + (STS(J, 1) - X1MIN) * SCALE, 260 + M2 + (STS(J, 2) - X2MIN) * SCALE), 2, 8
'CIRCLE (10 + M1 + (STS(J, 1) - X1MIN) * SCALE, 260 + M2 + (STS(J, 2) - X2MIN) * SCALE), 3, 8
473 NEXT J

'Plotting the active dislocations
490 FOR J = 1 TO NUMDIS
IF SS(J) = 0 AND DS(J) = 0 AND OP(J) = 0 THEN GOTO 191
LINE (10 + M1 + (X1C(J) - X1MIN) * SCALE - HALFLEN(J) * SCALE * COS(STRIKE(J) * PI / 180), 40 + M2 + (X2C(J) - X2MIN) * SCALE - HALFLEN(J) * SCALE * SIN(STRIKE(J) * PI / 180))-(10 + M1 + (X1C(J) - X1MIN) * SCALE + HALFLEN(J) * SCALE * COS(STRIKE(J)  _
* PI / 180), 40 + M2 + (X2C(J) - X2MIN) * SCALE + HALFLEN(J) * SCALE * SIN(STRIKE(J) * PI / 180)), 15
CIRCLE (10 + M1 + (X1C(J) - X1MIN) * SCALE, 40 + M2 + (X2C(J) - X2MIN) * SCALE), 2, 15
LINE (10 + M1 + (X1C(J) - X1MIN) * SCALE - HALFLEN(J) * SCALE * COS(STRIKE(J) * PI / 180), 260 + M2 + (X2C(J) - X2MIN) * SCALE - HALFLEN(J) * SCALE * SIN(STRIKE(J) * PI / 180))-(10 + M1 + (X1C(J) - X1MIN) * SCALE + HALFLEN(J) * SCALE * COS(STRIKE(J) _
 * PI / 180), 260 + M2 + (X2C(J) - X2MIN) * SCALE + HALFLEN(J) * SCALE * SIN(STRIKE(J) * PI / 180)), 15
CIRCLE (10 + M1 + (X1C(J) - X1MIN) * SCALE, 260 + M2 + (X2C(J) - X2MIN) * SCALE), 2, 15
191 NEXT J

'Plotting scale of horizontal displacements
LINE (293, 474)-(295 + 52, 477), 0, BF
LINE (295, 475)-(295 + 50, 476), 15, BF
LINE (309, 12)-(310 + 52, 15), 0, BF
LINE (310, 13)-(310 + 50, 14), 15, BF

LOCATE 1, 1: PRINT INT(10 * X1MIN) / 10; "km"
LOCATE 1, 72: PRINT INT(10 * X1MAX) / 10; "km"
LOCATE 3, 1: PRINT INT(10 * X2MIN) / 10; "km"
LOCATE 16, 1: PRINT INT(10 * X2MAX) / 10; "km"
LOCATE 9, 1: PRINT "S": LOCATE 9, 80: PRINT "N"
LOCATE 1, 10: INPUT "Change field [NO] "; C$

IF C$ <> "" THEN CLS
IF C$ <> "" THEN PRINT "Current X1min, X2min= "; X1MIN, X1MAX
IF C$ <> "" THEN PRINT "Current X2min, X2max= "; X2MIN, X2MAX
IF C$ <> "" THEN INPUT "   New X1min, X2min= "; X1MIN, X1MAX
IF C$ <> "" THEN INPUT "   New X2min, X2max= "; X2MIN, X2MAX
CUT1 = CUT
IF C$ <> "" THEN PRINT "   New cutoff value ["; CUT; "] ";
IF C$ <> "" THEN INPUT CUT
IF CUT = 0 THEN CUT = CUT1
IF C$ <> "" THEN INPUT "Plot density (1-all observation points, 2-half, 3-third..) [1] "; DEN
IF DEN = 0 THEN DEN = 1
IF C$ <> "" THEN INPUT "Plot only stress observations and geography [NO] "; STS$
IF STS$ <> "" THEN CLS
IF STS$ <> "" THEN GOTO 481
IF C$ <> "" THEN GOTO 260


117 CLS
    PRINT
    PRINT "The horizontal stresses will be plotted next."
    PRINT "Above: map of the maximum horizontal shear  MHS=("; CHR$(229); "MAX-"; CHR$(229); "hmin)/2"
    PRINT "Below: map of the trends of "; CHR$(229); "HMAX"
    PRINT "      Note: "; CHR$(229); "HMAX is the axis of maximum horizontal COMPRESSION!!"
    PRINT
    OBZ = 0
    INPUT "Gradient of overburden stress (MPa/km) [0] "; OB
    OBZ = 1: Z = 0
    INPUT "Depth of calculation (km below surface) [0] "; Z
    GOSUB 334
335 PRINT CHR$(229); "HMAX axis in constant length OR proportional to stress [CONSTANT] ";
    INPUT LL$
    IF LL$ <> "" THEN INPUT "Length of proportional axes [100] "; LENGTH
    IF LL$ <> "" AND LENGTH = 0 THEN LENGTH = 100
    IF CS$ <> "" THEN GOSUB 224

285 S11MAX = 0: S22MAX = 0: S12MAX = -10000: S12MIN = 10000: SHMAX = 10000: SHMIN = -10000
SHX = 10000: SHN = -10000
        FOR I = 1 TO NUMP
                IF S12(I) > S12MAX THEN S12MAX = S12(I)
                IF S12(I) < S12MIN THEN S12MIN = S12(I)
                IF SHMAX(I) < SHMAX THEN SHMAX = SHMAX(I)
                IF SHMIN(I) > SHMIN THEN SHMIN = SHMIN(I)
        NEXT I

290 CLS
     SCREEN 0
     IF SCOL = 12 THEN COLOR 10, 4
     FOR J = 1 TO 18
     MIS(J) = 0
     NEXT J

FOR J = 1 TO NUMP
IF X1G(J) < X1MIN OR X1G(J) > X1MAX OR X2G(J) < X2MIN OR X2G(J) > X2MAX THEN GOTO 272
LP = 1 + 17 * (S12(J) - S12MIN) / (S12MAX - S12MIN)
IF LP > 18 OR LP < 1 THEN GOTO 272
IF LP > 18 OR LP < 1 THEN PRINT J, S12(J), S12MIN, S12MAX, LP, MIS(LP)
IF LP > 18 OR LP < 1 THEN INPUT ok
MIS(LP) = MIS(LP) + 1
272 NEXT J

     PRINT "Frequency of maximum horizontal shear MHS=("; CHR$(229); "HMAX-"; CHR$(229); "hmin)/2"
     PRINT " MHS    FREQUENCY  "
     MAXP = 0: MAXS = 0
     FOR I = 1 TO 18
     IF MIS(I) > MAXP THEN MAXP = MIS(I)
     NEXT I
     FOR I = 1 TO 18
     IF MIS(I) <> 0 THEN MIS(I) = INT(1 + MIS(I) * 24 / MAXP)
     IF MIS(I) <> 0 THEN PRINT USING "####.### "; S12MIN + (I - 1) * (S12MAX - S12MIN) / 18;
     IF MIS(I) = 0 THEN PRINT USING "####.### "; S12MIN + (I - 1) * (S12MAX - S12MIN) / 18
     IF SCOL = 12 THEN COLOR 10, 4
     IF MIS(I) = 0 THEN GOTO 282
     FOR J = 1 TO MIS(I)
     IF J < MIS(I) THEN PRINT CHR$(178);
     IF J = MIS(I) THEN PRINT CHR$(178)
     NEXT J
282 NEXT I

     PRINT
     PRINT "Use the plot above to select better bounding values for the plot."
     PRINT "Current MHSminimum (RIGHT), MHSmaximum (LEFT):"; INT(1000 * S12MIN) / 1000, INT(1000 * S12MAX) / 1000
     PRINT "Select new minimum and maximum values [NO] ";
     INPUT C$
     IF C$ = "" THEN GOTO 226
     PRINT
     INPUT "New selected MHSminimum, MHSmaximum = "; S12MIN, S12MAX
     GOTO 290

'Plotting horizontal shear stress on map
226 CLS
SCREEN 12
IF BW$ <> "" THEN SCREEN 11
IF BW$ <> "" THEN GOTO 991

        FOR I = 0 TO 15
                    IF I <= 8 THEN COLNUM&(I) = (8 - I) * 7 + 65536 * I * 7
                    IF I >= 8 THEN COLNUM&(I) = 256 * (I - 8) * 8 + 65536 * (15 - I) * 8
          NEXT I
          FOR I = 0 TO 15
                    IF NOBLUE = 1 THEN COLNUM&(I) = (15 - I) * 4 + 256 * I * 4
          NEXT I
      
          FOR J = 1 TO 15
                PALETTE J, COLNUM&(J)
          NEXT J
          FOR J = 1 TO 15
                LINE (250 + (J - 1) * 20, 1)-(250 + J * 20, 10), J, BF
          NEXT J

'Plotting the stresses
991 FOR J = 1 TO NUMP
IF X1G(J) < X1MIN OR X1G(J) > X1MAX OR X2G(J) < X2MIN OR X2G(J) > X2MAX THEN GOTO 670


COL = 1 + 15 * ((S12(J) - S12MIN) / (S12MAX - S12MIN))
IF COL < 1 THEN COL = 1
IF COL >= 17 THEN COL = 16
LINE (10 + M1 + (X1G(J) - X1MIN) * SCALE - SIZE1, 40 + M2 + (X2G(J) - X2MIN) * SCALE - SIZE2)-(10 + M1 + (X1G(J) - X1MIN) * SCALE + SIZE1, 40 + M2 + (X2G(J) - X2MIN) * SCALE + SIZE2), COL, BF
IF ABS(S12(J)) < CUT * ABS(S12MIN - S12MAX) THEN LINE (10 + M1 + (X1G(J) - X1MIN) * SCALE - SIZE1, 40 + M2 + (X2G(J) - X2MIN) * SCALE - SIZE2)-(10 + M1 + (X1G(J) - X1MIN) * SCALE + SIZE1, 40 + M2 + (X2G(J) - X2MIN) * SCALE + SIZE2), 0, BF
670 NEXT J

LOCATE 2, 1: PRINT "MHS=("; CHR$(229); "HX-"; CHR$(229); "hm)/2, Black<"; CUT; ",Red:<="; INT(100 * S12MIN) / 100; ",Green:>="; INT(100 * S12MAX) / 100; "Compression axes below"


'Plotting direction of SIG HMAX
FOR J = 1 TO NUMP STEP DEN
IF X1G(J) < X1MIN OR X1G(J) > X1MAX OR X2G(J) < X2MIN OR X2G(J) > X2MAX THEN GOTO 570
LLX = 10: LLY = 0
IF LL$ <> "" THEN LLX = ABS(LENGTH * (SHMAX(J)) / (SHMIN - SHMAX))
IF LL$ <> "" THEN LLY = ABS(LENGTH * (SHMIN(J)) / (SHMIN - SHMAX))
'PRINT USING " ####. "; J, LLX, LLY
IF SHMAX(J) < 0 THEN COLX = 15
IF SHMAX(J) > 0 THEN COLX = 8
IF SHMIN(J) < 0 THEN COLN = 15
IF SHMIN(J) > 0 THEN COLN = 8
IF LL$ = "" THEN COLX = 15
IF LL$ = "" THEN COLN = 0
LINE (10 + M1 + (X1G(J) - X1MIN) * SCALE + LLX * COS(THMAX(J) * PI / 180), 260 + M2 + (X2G(J) - X2MIN) * SCALE + LLX * SIN(THMAX(J) * PI / 180))-(10 + M1 + (X1G(J) - X1MIN) * SCALE - LLX * COS(THMAX(J) * PI / 180), 260 + M2 + (X2G(J) - X2MIN) *  _
SCALE - LLX * SIN(THMAX(J) * PI / 180)), COLX
IF BW$ <> "" THEN GOTO 570
THMIN = THMAX(J) + 90
IF LL$ <> "" THEN LINE (10 + M1 + (X1G(J) - X1MIN) * SCALE + LLY * COS(THMIN * PI / 180), 260 + M2 + (X2G(J) - X2MIN) * SCALE + LLY * SIN(THMIN * PI / 180))-(10 + M1 + (X1G(J) - X1MIN) * SCALE - LLY * COS(THMIN * PI / 180), 260 + M2 + (X2G(J) -  _
X2MIN) * SCALE - LLY * SIN(THMIN * PI / 180)), COLN
570 NEXT J

'Replotting the frames
LINE (9, 40)-(9 + (X1MAX - X1MIN) * SCALE, 40 + (X2MAX - X2MIN) * SCALE), 2, B
BS1 = 9 + (X1MAX - X1MIN) * SCALE
BS2 = 40 + (X2MAX - X2MIN) * SCALE
FOR J = 9 TO BS1 STEP KS * SCALE
'LINE (J, 40)-(J, BS2), 2
LINE (J, 40)-(J, 50), 2
LINE (J, BS2 - 10)-(J, BS2), 2
NEXT J

FOR J = 40 TO BS2 STEP KS * SCALE
'LINE (9, J)-(BS1, J), 2
LINE (9, J)-(19, J), 2
LINE (BS1 - 10, J)-(BS1, J), 2
NEXT J
LINE (9, BS2)-(BS1, BS2), 2
LINE (BS1, 40)-(BS1, BS2), 2
'LINE (10, 260)-(639, 470), 2, B
LINE (9, 260)-(9 + (X1MAX - X1MIN) * SCALE, 260 + (X2MAX - X2MIN) * SCALE), 15, B

FOR J = 9 TO BS1 STEP KS * SCALE
'LINE (J, 260)-(J, 220 + BS2), 2
LINE (J, 260)-(J, 270), 2
LINE (J, 210 + BS2)-(J, 220 + BS2), 2
NEXT J
FOR J = 260 TO 220 + BS2 STEP KS * SCALE
'LINE (9, J)-(BS1, J), 2
LINE (9, J)-(19, J), 2
LINE (BS1 - 10, J)-(BS1, J), 2
NEXT J
LINE (9, 220 + BS2)-(BS1, 220 + BS2), 2
LINE (BS1, 260)-(BS1, 220 + BS2), 2
LINE (9, 260)-(BS1, 220 + BS2), 2, B

'Plotting the dislocations
FOR J = 1 TO NUMDIS
IF SS(J) = 0 AND DS(J) = 0 AND OP(J) = 0 THEN GOTO 193
LINE (10 + M1 + (X1C(J) - X1MIN) * SCALE - HALFLEN(J) * SCALE * COS(STRIKE(J) * PI / 180), 40 + M2 + (X2C(J) - X2MIN) * SCALE - HALFLEN(J) * SCALE * SIN(STRIKE(J) * PI / 180))-(10 + M1 + (X1C(J) - X1MIN) * SCALE + HALFLEN(J) * SCALE * COS(STRIKE(J)  _
* PI / 180), 40 + M2 + (X2C(J) - X2MIN) * SCALE + HALFLEN(J) * SCALE * SIN(STRIKE(J) * PI / 180)), 15
LINE (10 + M1 + (X1C(J) - X1MIN) * SCALE - HALFLEN(J) * SCALE * COS(STRIKE(J) * PI / 180), 260 + M2 + (X2C(J) - X2MIN) * SCALE - HALFLEN(J) * SCALE * SIN(STRIKE(J) * PI / 180))-(10 + M1 + (X1C(J) - X1MIN) * SCALE + HALFLEN(J) * SCALE * COS(STRIKE(J) _
 * PI / 180), 260 + M2 + (X2C(J) - X2MIN) * SCALE + HALFLEN(J) * SCALE * SIN(STRIKE(J) * PI / 180)), 15
CIRCLE (10 + M1 + (X1C(J) - X1MIN) * SCALE, 40 + M2 + (X2C(J) - X2MIN) * SCALE), 2, 15
CIRCLE (10 + M1 + (X1C(J) - X1MIN) * SCALE, 260 + M2 + (X2C(J) - X2MIN) * SCALE), 2, 15
193 NEXT J


'Plotting the geographic features
FOR J = 1 TO NUMSEAS
IF SEAS(J, 1) < X1MIN OR SEAS(J, 1) > X1MAX OR SEAS(J, 2) < X2MIN OR SEAS(J, 2) > X2MAX THEN GOTO 475
LINE (10 + M1 + (SEAS(J, 1) - X1MIN) * SCALE, 260 + M2 + (SEAS(J, 2) - X2MIN) * SCALE)-(10 + M1 + (SEAS(J, 3) - X1MIN) * SCALE, 260 + M2 + (SEAS(J, 4) - X2MIN) * SCALE), 7
475 NEXT J

IF SIS$ = "NO" OR SIS$ = "no" THEN GOTO 315
FOR J = 1 TO NUMSTS
IF STS(J, 1) < X1MIN OR STS(J, 1) > X1MAX OR STS(J, 2) < X2MIN OR STS(J, 2) > X2MAX THEN GOTO 476
LINE (10 + M1 + (STS(J, 1) - X1MIN) * SCALE - 10 * RNK(J) * COS(TRS(J) * PI / 180), 260 + M2 + (STS(J, 2) - X2MIN) * SCALE - 10 * RNK(J) * SIN(TRS(J) * PI / 180))-(10 + M1 + (STS(J, 1) - X1MIN) * SCALE + 10 * RNK(J) * COS(TRS(J) * PI / 180), 260 +  _
M2 + (STS(J, 2) - X2MIN) * SCALE + 10 * RNK(J) * SIN(TRS(J) * PI / 180)), 8
CIRCLE (10 + M1 + (STS(J, 1) - X1MIN) * SCALE, 260 + M2 + (STS(J, 2) - X2MIN) * SCALE), 1, 8
CIRCLE (10 + M1 + (STS(J, 1) - X1MIN) * SCALE, 260 + M2 + (STS(J, 2) - X2MIN) * SCALE), 2, 8
'CIRCLE (10 + M1 + (STS(J, 1) - X1MIN) * SCALE, 260 + M2 + (STS(J, 2) - X2MIN) * SCALE), 3, 8
476 NEXT J

315 LOCATE 1, 1: PRINT INT(100 * X1MIN) / 100; "km"
LOCATE 1, 68: PRINT INT(100 * X1MAX) / 100; "km"
LOCATE 3, 1: PRINT INT(100 * X2MIN) / 100; "km"
LOCATE 16, 1: PRINT INT(X2MAX * 100) / 100; "km"
LOCATE 9, 1: PRINT "S": LOCATE 9, 80: PRINT "N"
    'S$ = INPUT$(10, #2)
672 LOCATE 1, 10
    INPUT "A-Restart, B-REGIMES [NO] "; C$
    IF C$ = "A" OR C$ = "a" THEN C$ = "A"
    IF C$ = "B" OR C$ = "b" THEN C$ = "B"
    IF C$ = "" THEN GOTO 671
    IF C$ = "A" THEN CLS
    IF C$ = "A" AND CS$ <> "" THEN GOTO 117
    IF C$ = "A" THEN GOTO 260
    IF C$ <> "B" THEN GOTO 671

'SIZE = ABS(X1G(2) - X1G(1)) * SCALE / 2
'SIZE = SIZE * 1.05

FOR J = 1 TO NUMP
IF X1G(J) < X1MIN OR X1G(J) > X1MAX OR X2G(J) < X2MIN OR X2G(J) > X2MAX THEN GOTO 273
IF SHMAX(J) <= S33(J) AND S33(J) <= SHMIN(J) THEN COL = 1
IF S33(J) <= SHMAX(J) THEN COL = 8
IF SHMIN(J) <= S33(J) THEN COL = 15
LINE (10 + M1 + (X1G(J) - X1MIN) * SCALE - SIZE1, 40 + M2 + (X2G(J) - X2MIN) * SCALE - SIZE2)-(10 + M1 + (X1G(J) - X1MIN) * SCALE + SIZE1, 40 + M2 + (X2G(J) - X2MIN) * SCALE + SIZE2), COL, BF
IF ABS(S12(J)) < CUT * ABS(S12MIN - S12MAX) THEN LINE (10 + M1 + (X1G(J) - X1MIN) * SCALE - SIZE1, 40 + M2 + (X2G(J) - X2MIN) * SCALE - SIZE2)-(10 + M1 + (X1G(J) - X1MIN) * SCALE + SIZE1, 40 + M2 + (X2G(J) - X2MIN) * SCALE + SIZE2), 0, BF
'IF ABS(S12(J)) < CUT * ABS(S12MIN - S12MAX) THEN LINE (10 + M1 + (X1G(J) - X1MIN) * SCALE - SIZE1, 40 + M2 + (X2G(J) - X2MIN) * SCALE - SIZE2)-(10 + M1 + (X1G(J) - X1MIN) * SCALE + SIZE1, 40 + M2 + (X2G(J) - X2MIN) * SCALE + SIZE2), 0, BF
273 NEXT J
LINE (1, 250)-(639, 300), 0, BF
LOCATE 18, 1
PRINT "SSF      NORMAL        REVERSE"
LINE (32, 270)-(52, 290), 1, BF
LINE (152, 270)-(172, 290), 8, BF
LINE (272, 270)-(292, 290), 15, BF
GOTO 672
671 CLOSE
    GOTO 260
    IF CS$ <> "" THEN GOTO 10
    STOP
1000 STOP

