CLS
PRINT
PRINT "          THE PROCESS ZONE OF A GROWING FAULT IN WESTERLY GRANITE"
PRINT "   By Dave Lockner, US Geological Survey, Menlo Park, California, and"
PRINT "   Ze'ev Reches, Geology Department, Hebrew University, Jerusalem, Israel"; ""
PRINT ""
PRINT "This program displays the growth of a fault in a Westerly granite sample that"
PRINT "is 78mm in diameter and 190mm tall.  The fault growth was monitored by the"
PRINT "locations of acoustic emission events (AE) as described by"
PRINT "Lockner et al., 1990 and Reches and Lockner, 1993."
PRINT "AE locations are plotted on two mutually perpendicular sections of the sample, "
PRINT "left one parallels the fault strike, right is face-on fault surface."
PRINT "This program displays the PROCESS ZONE associated with the faulting"
PRINT "by plotting the last N events in green and all previous events in blue."
PRINT "The first 212 events belong to the nucleation stage; they are plotted in colors"
PRINT "ranging from deep red = earliest events to deep green = latest events."
PRINT "Hit   f   for faster display; hit several times for very fast."
PRINT "Hit   s   for slower display; hit several times for very slow."
PRINT "Hit   q   to quit"
PRINT "Copy all files to the hard disk before running."
PRINT "*************************************************************************"
PRINT
INPUT "READY [YES] "; ok
PRINT
PRINT "The width of the process zone is displayed here by the N last events."
INPUT "Select width of the process zone (# of events <1000) [default=300] "; WID
IF WID = 0 THEN WID = 300
DIM COLNUM&(40), XP(WID + 1), YP(WID + 1), ZP(WID + 1)
SCREEN 12
          FOR I = 0 TO 15
                    IF I <= 8 THEN COLNUM&(I) = (8 - I) * 7 + 65536 * I * 7
                    IF I >= 8 THEN COLNUM&(I) = 256 * (I - 8) * 8 + 65536 * (15 - I) * 8
          NEXT I
          FOR J = 1 TO 15
                PALETTE J, COLNUM&(J)
          NEXT J
          A$ = "LOCATION"
          OPEN A$ FOR INPUT AS #2
N1 = 212: N2 = 5010: N3 = 13160
X1 = 239: X2 = 399: Y1 = 50: Y2 = 50
NS = 5000
LOCATE 1, 1: PRINT "                       events plotted out of "; N1 + N3
LINE (X1 - 38.1 * 2, Y1)-(X1 + 38.1 * 2, Y1 + 190.5 * 2), , B
LINE (X2 - 38.1 * 2, Y2)-(X2 + 38.1 * 2, Y2 + 190.5 * 2), , B
LOCATE 29, 25: PRINT "FAULT NUCLEATION               ";
FOR I = 1 TO N1
K$ = INKEY$

IF K$ = "F" OR K$ = "f" THEN NS = NS / 50
IF NS < 2 THEN NS = 1
IF K$ = "Q" OR K$ = "q" THEN STOP
IF K$ = "R" OR K$ = "r" THEN MF = 1
IF K$ = "s" OR K$ = "S" THEN NS = NS * 50
IF NS > 25000 THEN NS = 25000
FOR J = 1 TO NS
A = COS(1.5) ^ 2
NEXT J
K$ = "T"
LINE (1 + 300 * I / N1, 20)-(1 + 300 * I / N1, 30), 1 + 15 * I / N1
LOCATE 1, 1: PRINT " ", I

20 INPUT #2, X, Y, Z
LINE (X2 - X * 2 - 2, Y1 + Z * 2 - 2)-(X2 - X * 2 + 2, Y1 + Z * 2 + 2), 1 + 15 * I / N1, BF
LINE (X1 + Y * 2 - 2, Y1 + Z * 2 - 2)-(X1 + Y * 2 + 2, Y1 + Z * 2 + 2), 1 + 15 * I / N1, BF


NEXT I
'CLOSE
'          A$ = "AE3"
'          OPEN A$ FOR INPUT AS #2
X1 = 239: X2 = 399: Y2 = 50
LOCATE 29, 25: PRINT "FAULT PROPAGATION               ";
MF = 0: J = 0: NS = 1
FOR I = 1 TO N2
K$ = INKEY$
IF K$ = "F" OR K$ = "f" THEN NS = NS / 20
IF NS < 2 THEN NS = 1
IF K$ = "Q" OR K$ = "q" THEN STOP
IF K$ = "R" OR K$ = "r" THEN MF = 1
IF K$ = "s" OR K$ = "S" THEN NS = NS * 20
IF NS > 25000 THEN NS = 25000
IF MF = 1 THEN GOTO 25
LINE (320 + 300 * I / N2, 20)-(320 + 300 * I / N2, 30), 1 + 15 * I / N2
LOCATE 1, 1: PRINT " ", I + N1
25 INPUT #2, X, Y, Z
IF J > WID THEN J = 0
J = J + 1
XP(J) = X: YP(J) = Y: ZP(J) = Z
LINE (X2 - X * 2 - 2, Y1 + Z * 2 - 2)-(X2 - X * 2 + 2, Y1 + Z * 2 + 2), 15, BF
LINE (X1 + Y * 2 - 2, Y1 + Z * 2 - 2)-(X1 + Y * 2 + 2, Y1 + Z * 2 + 2), 15, BF

IF I <= WID THEN GOTO 28
K = J + 1
IF J = WID + 1 THEN K = 1
LINE (X1 + YP(K) * 2 - 2, Y1 + ZP(K) * 2 - 2)-(X1 + YP(K) * 2 + 2, Y1 + ZP(K) * 2 + 2), 7, BF
LINE (X2 - XP(K) * 2 - 2, Y1 + ZP(K) * 2 - 2)-(X2 - XP(K) * 2 + 2, Y1 + ZP(K) * 2 + 2), 7, BF

26 FOR L = 1 TO NS
A = SQR(L)
NEXT L
28 NEXT I


999 'LINE (1, 15)-(320, 479), 0, BF
X1 = 239: X2 = 399: Y2 = 50
LINE (X1 - 38.1 * 2, Y1)-(X1 + 38.1 * 2, Y1 + 190.5 * 2), , B
LINE (X2 - 38.1 * 2, Y2)-(X2 + 38.1 * 2, Y2 + 190.5 * 2), , B
LOCATE 29, 25: PRINT "   FINAL STAGE                           ";

MF = 0
N4 = N3 - N2
J2 = 0
FOR I = N2 TO N3
J = I - N2
K$ = INKEY$

IF K$ = "F" OR K$ = "f" THEN NS = NS / 20
IF NS < 2 THEN NS = 1
IF K$ = "Q" OR K$ = "q" THEN STOP
IF K$ = "R" OR K$ = "r" THEN MF = 1
IF K$ = "s" OR K$ = "S" THEN NS = NS * 20
IF NS > 25000 THEN NS = 25000
IF MF = 1 THEN GOTO 30


LINE (320 + 300 * J / N4, 20)-(320 + 300 * J / N4, 30), 1 + 15 * J / N4
LOCATE 1, 1: PRINT " ", I + N1
30 INPUT #2, X, Y, Z
IF J2 > WID THEN J2 = 0
J2 = J2 + 1
XP(J2) = X: YP(J2) = Y: ZP(J2) = Z

LINE (X2 - X * 2 - 2, Y1 + Z * 2 - 2)-(X2 - X * 2 + 2, Y1 + Z * 2 + 2), 15, BF
LINE (X1 + Y * 2 - 2, Y1 + Z * 2 - 2)-(X1 + Y * 2 + 2, Y1 + Z * 2 + 2), 15, BF



IF I < WID THEN GOTO 38
K = J2 + 1

IF J2 = WID + 1 THEN K = 1


LINE (X1 + YP(K) * 2 - 2, Y1 + ZP(K) * 2 - 2)-(X1 + YP(K) * 2 + 2, Y1 + ZP(K) * 2 + 2), 7, BF
LINE (X2 - XP(K) * 2 - 2, Y1 + ZP(K) * 2 - 2)-(X2 - XP(K) * 2 + 2, Y1 + ZP(K) * 2 + 2), 7, BF

FOR L = 1 TO NS
A = SQR(L)
NEXT L
38 NEXT I
CLOSE
INPUT KL

