DEFSNG A
DEFDBL B-C, E-H, O-Z
DEFINT D, I-N
'$DYNAMIC
DECLARE FUNCTION ANormal (AMean, ASTDev, DISTYPE)
DIM COEF(3), X(100), Y(100), COLNUM&(40), AL(600), F(20), D(102, 102)
CLS
COLOR (4)
PRINT "                          THE EARTHQUAKE GAME"
PRINT "            Numerical simulation of yielding events along a fault"
PRINT "                      By Ze'ev Reches, November, 1996"
COLOR (2)
PRINT
PRINT "RULES OF THE GAME:"
PRINT "  1. A 2-D fault surface is represented by 8281 cells in a 91x91 grid."
PRINT "     Each cell is connected by eight springs to its neighbors."
PRINT "  2. The cells have non-uniform, initial distribution of 'energy' "
PRINT "     marked E {energy units/cell}. Form of distribution selecetd by user."
PRINT "  3. The fault is continuously 'loaded' by increasing E of all cells"
PRINT "     by an increment, for example, 0.0002 unit/cell."
PRINT "  4. A cell 'yields' and 'slips' when E exceeds 1.0 units. Pseudo-static "
PRINT "     slip is considered and dynamic effects are ignored."
PRINT "  5. Once a cell yields, its 'energy' drops and it loses 0.01-0.99 energy units."
PRINT "     Part of the 'ENERGY DROP' is transferred to neighbors, and another part"
PRINT "     is 'HEAT LOST' (determined by the user). To reduce 'edge effects',"
PRINT "     calculations are conducted for a larger fault with 101x101 cells."
PRINT "  6. A 'loading event' becomes a 'yielding event' when E exceeds 1.0 at "
PRINT "     one cell or more. The 'size of a yielding event'='earthquake magnitude' "
PRINT "     is the number of yielding cells associated with ONE loading event."
PRINT "Yielding events are saved in a file (ASCII format). "
PRINT
INPUT "Read more on program (file READQUAK should be in default directory [NO] "; ym$
IF ym$ = "" THEN GOTO 11

read$ = "readquak"
CLS
OPEN read$ FOR INPUT AS #2
FOR I = 1 TO 19
INPUT #2, B$
PRINT B$
NEXT I
PRINT
INPUT "1 out of 5 screens, More [YES] "; Y$
PRINT
FOR I = 1 TO 22
INPUT #2, B$
PRINT B$
NEXT I
PRINT
INPUT "2 out of 5 screens, More [YES] "; Y$
FOR I = 1 TO 24
INPUT #2, B$
IF I < 24 THEN PRINT B$
IF I = 24 THEN PRINT B$;
NEXT I
INPUT "3 out of 5 screens,  [RETURN] "; Y$
PRINT : PRINT : PRINT : PRINT : PRINT
FOR I = 1 TO 17
INPUT #2, B$
PRINT B$
NEXT I
PRINT
PRINT
INPUT "4 out of 5 screens,  [RETURN] "; Y$
PRINT : PRINT : PRINT : PRINT : PRINT : PRINT
PRINT : PRINT : PRINT : PRINT
FOR I = 1 TO 13
INPUT #2, B$
PRINT B$
NEXT I
PRINT
PRINT
INPUT "5 out of 5 screens,  [RETURN] "; Y$
CLOSE

11 CLS
QINI$ = "QUAKE.INI"
OPEN QINI$ FOR INPUT AS #2
INPUT #2, DISTYPE, AMGR, ASTDev, AFREQ, NGR, UNILOAD, BB, ADROP, ALOST
CLOSE #2

PRINT
COLOR (15)
INPUT "Enter file name for recording of the results [QUAKES] "; PROB$
IF PROB$ = "" THEN PROB$ = "QUAKES"
PRINT
PRINT "Setting the distribution of energy along the non-uniform fault."
PRINT "Three options:"
PRINT "   1. Normal ditribution, or "
PRINT "   2. Exponential distribution with MANY 'strong' cells and few 'weak' ones, or"
PRINT "   3. Exponential distribution with FEW 'strong' cells and MANY 'weak' ones."

PRINT "Choose distribution option: 1, 2 or 3 ["; DISTYPE; "]";
INPUT DISTYPE1
IF DISTYPE1 <> 0 THEN DISTYPE = DISTYPE1
IF DISTYPE = 2 THEN GOTO 22
IF DISTYPE = 3 THEN GOTO 23

PRINT
PRINT "Enter mean E in {units/cell} ["; AMGR; "]";
INPUT AMGR1
IF AMGR1 <> 0 THEN AMGR = AMGR1
PRINT "Enter standard deviation for E distribution ["; ASTDev; "]";
INPUT ASTDev1
IF ASTDev1 <> 0 THEN ASTDev = ASTDev1
GOTO 24
22 PRINT
PRINT "You chose exponential energy distribution with frequency of energy level x:"
PRINT "      f(x) = L exp (-L x)"
PRINT "where: L is the power the exponential distribution."
PRINT "The program displays actual values of MEAN and standard deviation and graphic"
PRINT "  plot of actual frequency. Note that high energy implies 'weak' cell."
PRINT
IF AMGR1 <> 0 THEN AMGR = AMGR1
PRINT "Enter exponential power, L ["; ASTDev; "]";
INPUT ASTDev1
IF ASTDev1 <> 0 THEN ASTDev = ASTDev1
GOTO 24

23 PRINT
PRINT "You chose exponential energy distribution with frequency of energy level x:"
PRINT "      f(x) = 1 - L exp (-L x)"
PRINT "where: L is the power of the exponential distribution."
PRINT "The program displays actual values of MEAN and standard deviation and graphic"
PRINT "  plot of actual frequency. Note that high energy implies 'weak' cell."
PRINT
IF AMGR1 <> 0 THEN AMGR = AMGR1
PRINT "Enter exponential power ["; ASTDev; "]";
INPUT ASTDev1
IF ASTDev1 <> 0 THEN ASTDev = ASTDev1
 
24 PRINT
PRINT "Enter frequency for calculating the Mean E and Standard deviation:"
PRINT " 1-each loading event, 10-every tenth event (high frequency slows run) ["; AFREQ; "]";
INPUT AFREQ1
IF AFREQ1 <> 0 THEN AFREQ = AFREQ1
PRINT
PRINT "Number of loading events, up to 15,000 (user can stop at any stage) [ "; NGR; "]";
INPUT NGR1
IF NGR1 <> 0 THEN NGR = NGR1
PRINT

NW = 103
DIM A(NW, NW), AKAL(NGR + 100), ADENS(NGR + 100, 3)
PRINT "Loading is conducted in one of two forms of E increase: "
PRINT "  Increase at a random cell by 1.0 units: Enter 1 now, OR "
PRINT "  Uniform increase of ALL cells:  Enter ratio {units/ cell} ["; UNILOAD; "]";
INPUT UNILOAD1
IF UNILOAD1 <> 0 THEN UNILOAD = UNILOAD1
PRINT
BBXH = .25 * (2! / (SQR(2!) + 1!)): BBXD = .25 * (SQR(2!) / (SQR(2!) + 1)): BBXV = 0
BBSUM = 2 * BBXH + 4 * BBXD + 2 * BBXV
PRINT "Energy transfer from the yielding cell is user-controlled:"
PRINT " A cell on the fault is assumed to be connected to eight neighbors by springs."
PRINT " The 'energy drop' of a yielding (slipping) cell is partly transfered via"
PRINT " these springs.  Slip is assumed to occur in the positive X direction (right)."
PRINT "RIGHT-LATERAL TRANSFER is proportional to linear length change of springs:"
PRINT "a. Energy increase in horizontal cells (H below): 0.2071*{energy drop}"
PRINT "b. Energy increase in diagonal cells (D below): 0.7071*0.2071*{energy drop}"
PRINT "c. No energy increase in the vertical cells (V below)"
PRINT "Energy transfer for 'energy drop'=1.0 and 'heat lost'=0.2:"
PRINT "----------------------------"
PRINT "|        |        |        |"
PRINT "|+ 0.1172|        |+ 0.1172|"
PRINT "----------------------------"
PRINT "|        |yielding|        |"
PRINT "|+ 0.1652| point: |+ 0.1652|"
PRINT "|        |  -1.0  |        |"
PRINT "----------------------------"
PRINT "|        |        |        |"
PRINT "|+ 0.1172|        |+ 0.1172|"
PRINT "----------------------------"

PRINT "Choice of transfer 1-right-lateral transfer,"
PRINT "                   2-radial transfer (equal amount to all neighbors)"
PRINT "                   3-design your own   ["; BB; "]";
INPUT BB1
IF BB1 <> 0 THEN BB = BB1
IF BB = 1 THEN BBXH = .25 * (2! / (SQR(2!) + 1!))
IF BB = 1 THEN BBXD = .25 * (SQR(2!) / (SQR(2!) + 1))
IF BB = 1 THEN BBXV = 0
IF BB = 2 THEN BBXH = .125
IF BB = 2 THEN BBXD = .125
IF BB = 2 THEN BBXV = .125
IF BB <> 3 THEN GOTO 17
18 PRINT
PRINT "Note the sum of the relative contributions is 1.0, including:"
PRINT "  TWO horizontal cells"
PRINT "  FOUR diagonal cells"
PRINT "  and TWO vertical cells"
PRINT
INPUT "Enter values of relative energy transfer: Horizontal, Diagonal, Vertical"; BBXH, BBXD, BBXV
BBSUM = 2 * BBXH + 4 * BBXD + 2 * BBXV
PRINT "Your sum is "; BBSUM;
INPUT " is this OK [YES] "; Y$
IF Y$ <> "" THEN GOTO 18

17 PRINT
PRINT "The energy level of a yielding cell (E >= 1.00) drops by as much as 0.99 units."
PRINT "Enter ENERGY DROP in number of units (0.01-0.99) ["; ADROP; " units]";
INPUT ADROP1
IF ADROP1 <> 0 THEN ADROP = ADROP1

BBXH = BBXH * ADROP: BBXD = BBXD * ADROP: BBXV = BBXV * ADROP

ADROP = ADROP

PRINT
ENER = 0
PRINT "Part of the ENERGY DROP is transferred to neighbors, and part is lost as"
PRINT "   'HEAT LOST' (frictional heat etc..)."
PRINT "Enter HEAT LOST as fraction of ENERGY DROP ["; ALOST; "]";
INPUT ALOST1
IF ALOST1 <> 0 THEN ALOST = ALOST1
PRINT
PRINT "  Note: available energy is "; ADROP * (1 - ALOST)
INPUT "Want to redefine Energy Drop and Heat Lost [NO]"; Y$
IF Y$ <> "" THEN GOTO 17

QINI$ = "QUAKE.INI"
OPEN QINI$ FOR OUTPUT AS #3
PRINT #3, DISTYPE, AMGR, ASTDev, AFREQ, NGR, UNILOAD, BB, ADROP, ALOST
CLOSE #3

ALOST = 1 - ALOST
PRINT
INPUT "Special screen colors [NO] "; SC$
INPUT "Run with 'single yield' option [NO] "; BS$
IF BS$ = "" THEN DS = 0
IF BS$ <> "" THEN DS = 1
INPUT "Run without screen display (runs faster..) [Screen Display] "; FAST$
IF FAST$ <> "" THEN CLS
IF FAST$ = "" THEN SCREEN 12
          FOR I = 0 TO 15
                    IF I <= 8 THEN COLNUM&(I) = (8 - I) * 7 + 65536 * I * 7
                    IF I >= 8 THEN COLNUM&(I) = 256 * (I - 8) * 8 + 65536 * (15 - I) * 8
          NEXT I
          IF SC$ <> "" THEN GOTO 289
          COLNUM&(10) = COLNUM&(12)
          COLNUM&(11) = COLNUM&(12)
          COLNUM&(13) = COLNUM&(15)
          COLNUM&(14) = COLNUM&(15)
          COLNUM&(8) = COLNUM&(7)
          COLNUM&(9) = COLNUM&(7)
          COLNUM&(4) = COLNUM&(3)
          COLNUM&(5) = COLNUM&(3)
          COLNUM&(6) = COLNUM&(3)
          COLNUM&(3) = COLNUM&(1)
          COLNUM&(2) = COLNUM&(1)

289 FOR J = 1 TO 15
                IF FAST$ = "" THEN PALETTE J, COLNUM&(J)
          NEXT J
FOR I = 1 TO 15
        XK = I * 15
        IF FAST$ = "" THEN LINE (20 + XK, 320)-(40 + XK, 335), I, BF
NEXT I
        IF FAST$ = "" THEN LOCATE 21, 3: COLOR (1): PRINT "0"
        IF FAST$ = "" THEN LOCATE 21, 35: COLOR (15): PRINT "1"

COLOR (15)
IDENS = 0:      SUMI = 0
AMean = AMGR
ICOUNT = 0
RANDOMIZE TIMER
FOR I = 1 TO 101
FOR J = 1 TO 101
        'RANDOMIZE (TIMER * EXP(-.9))
                'FOR KK = 1 TO 100 * RND
                '        DD = SIN(KK)
                'NEXT KK
99 ATEMP = ANormal(AMean, ASTDev, DISTYPE)
        IF ATEMP < 0! OR ATEMP >= 1! THEN ICOUNT = ICOUNT + 1
        IF ICOUNT > 8000 THEN GOTO 199
        IF ATEMP < 0! OR ATEMP >= 1! THEN GOTO 99
199     IF ICOUNT > 8000 THEN PRINT
        IF ICOUNT > 8000 THEN PRINT "Too many attempts to calcualte the exponential distribution"
        IF ICOUNT > 8000 THEN PRINT "Restart and Choose a higher power."
        IF ICOUNT > 8000 THEN STOP
        A(I, J) = ATEMP
        IF DISTYPE = 3 THEN A(I, J) = 1 - ATEMP
        SUMI = SUMI + A(I, J)
        'RANDOMIZE SQR(TIMER)
NEXT J
NEXT I

ATMAX = 0!: ATMIN = 100!
FOR I = 1 TO 101
FOR J = 1 TO 101
        IF A(I, J) > ATMAX THEN ATMAX = A(I, J)
        IF A(I, J) < ATMIN THEN ATMIN = A(I, J)
NEXT J
NEXT I

FOR I = 6 TO 96
FOR J = 6 TO 96
        IF FAST$ = "" THEN LINE (10 + I * 3, 10 + J * 3)-(12 + I * 3, 12 + J * 3), 15 * A(I, J), BF
NEXT J
NEXT I

IF FAST$ = "" THEN LINE (13, 13)-(315, 315), , B
IF FAST$ = "" THEN LINE (323, 13)-(625, 315), , B
KL = 0
IF FAST$ = "" THEN LOCATE 1, 3: PRINT "Initial E on the fault"
IF FAST$ = "" THEN IF FAST$ = "" THEN LOCATE 1, 43: PRINT "Yielding events marked by E values"
IF FAST$ = "" THEN LOCATE 28, 57: PRINT "Any key to stop."
IF FAST$ = "" THEN LOCATE 23, 1: PRINT "Number of LOADING events: "
IF FAST$ = "" THEN LOCATE 24, 1: PRINT "Number of YIELDING events: "
IF FAST$ = "" THEN LOCATE 25, 1: PRINT "Size of last yielding event:          "

IF FAST$ = "" THEN LOCATE 22, 40: PRINT "Initial values:"
IF FAST$ = "" AND DISTYPE = 1 THEN LOCATE 23, 40: PRINT "Mean E initially: ";
IF FAST$ = "" AND DISTYPE = 1 THEN PRINT USING " #.###"; SUMI / 10201;
IF FAST$ = "" AND DISTYPE = 1 THEN PRINT " "; CHR$(241); " ";
IF FAST$ = "" AND DISTYPE = 1 THEN PRINT USING " ##.###"; ASTDev

IF FAST$ = "" AND DISTYPE = 2 THEN LOCATE 23, 40: PRINT "E minimum: ";
IF FAST$ = "" AND DISTYPE = 2 THEN PRINT USING " #.###"; ATMIN;
IF FAST$ = "" AND DISTYPE = 2 THEN PRINT " Power:";
IF FAST$ = "" AND DISTYPE = 2 THEN PRINT USING " ##.###"; ASTDev

IF FAST$ = "" AND DISTYPE = 3 THEN LOCATE 23, 40: PRINT "E maximum: ";
IF FAST$ = "" AND DISTYPE = 3 THEN PRINT USING " #.###"; ATMAX;
IF FAST$ = "" AND DISTYPE = 3 THEN PRINT " Power:";
IF FAST$ = "" AND DISTYPE = 3 THEN PRINT USING " ##.###"; ASTDev



KFINI = 1
GOSUB 37
KFINI = 0


10      A$ = INKEY$: IF A$ <> "" THEN GOTO 200
31      KL = KL + 1
        IF FAST$ = "" THEN LOCATE 23, 30: IF FAST$ = "" THEN PRINT KL
        IF FAST$ <> "" THEN LOCATE 10, 30: IF FAST$ <> "" THEN PRINT KL

IF INT(KL / AFREQ) <> KL / AFREQ THEN GOTO 38
IDENS = KL: SX2 = 0: SX = 0: SUMT = 0
FOR I = 6 TO 96
FOR J = 6 TO 96
        SX2 = SX2 + A(I, J) ^ 2
        SUMT = SUMT + A(I, J)
NEXT J
NEXT I
        ADENS(IDENS, 1) = SUMT / 8281.001
        STD = (SX2 - SUMT ^ 2 / 8281.001)
        STD = STD / 8280.001
        STD = SQR(STD)
        ADENS(IDENS, 2) = STD
        ADENS(IDENS, 3) = UUNILOAD
        IF FAST$ = "" THEN LOCATE 24, 40:
IF FAST$ = "" THEN PRINT "Mean E for "; KL; "is:";
IF FAST$ = "" THEN PRINT USING " #.###"; ADENS(IDENS, 1);
IF FAST$ = "" THEN PRINT " "; CHR$(241); " ";
IF FAST$ = "" THEN PRINT USING " #.###"; ADENS(IDENS, 2)
IF FAST$ = "" THEN LOCATE 25, 53: PRINT "Size of loading: ";
IF FAST$ = "" THEN LOCATE 25, 70: PRINT USING "#.#####"; UUNILOAD

KF = KF + 1
IF KF < 10 THEN GOTO 38

37 REDIM F(20)
FOR I = 6 TO 96
FOR J = 6 TO 96
IF A(I, J) >= 0 AND A(I, J) < .05 THEN F(1) = F(1) + 1
IF A(I, J) >= .05 AND A(I, J) < .1 THEN F(2) = F(2) + 1
IF A(I, J) >= .1 AND A(I, J) < .15 THEN F(3) = F(3) + 1
IF A(I, J) >= .15 AND A(I, J) < .2 THEN F(4) = F(4) + 1
IF A(I, J) >= .2 AND A(I, J) < .25 THEN F(5) = F(5) + 1
IF A(I, J) >= .25 AND A(I, J) < .3 THEN F(6) = F(6) + 1
IF A(I, J) >= .3 AND A(I, J) < .35 THEN F(7) = F(7) + 1
IF A(I, J) >= .35 AND A(I, J) < .4 THEN F(8) = F(8) + 1
IF A(I, J) >= .4 AND A(I, J) < .45 THEN F(9) = F(9) + 1
IF A(I, J) >= .45 AND A(I, J) < .5 THEN F(10) = F(10) + 1
IF A(I, J) >= .5 AND A(I, J) < .55 THEN F(11) = F(11) + 1
IF A(I, J) >= .55 AND A(I, J) < .6 THEN F(12) = F(12) + 1
IF A(I, J) >= .6 AND A(I, J) < .65 THEN F(13) = F(13) + 1
IF A(I, J) >= .65 AND A(I, J) < .7 THEN F(14) = F(14) + 1
IF A(I, J) >= .7 AND A(I, J) < .75 THEN F(15) = F(15) + 1
IF A(I, J) >= .75 AND A(I, J) < .8 THEN F(16) = F(16) + 1
IF A(I, J) >= .8 AND A(I, J) < .85 THEN F(17) = F(17) + 1
IF A(I, J) >= .85 AND A(I, J) < .9 THEN F(18) = F(18) + 1
IF A(I, J) >= .9 AND A(I, J) < .95 THEN F(19) = F(19) + 1
IF A(I, J) >= .95 AND A(I, J) <= 1! THEN F(20) = F(20) + 1

NEXT J
NEXT I
IF FAST$ = "" THEN LINE (320, 478)-(420, 388), 0, BF
IF FAST$ = "" THEN LINE (330, 478)-(410, 388), 15, B
FMAX = 0
FOR I = 1 TO 20
IF F(I) <= 0 THEN GOTO 25
F(I) = LOG(F(I))
IF F(I) > FMAX THEN FMAX = F(I)
25 NEXT I

IF FAST$ = "" THEN LOCATE 26, 20: IF FAST$ = "" THEN PRINT "Log 'frequency of E'"
IF FAST$ = "" THEN LOCATE 27, 20: IF FAST$ = "" THEN PRINT "vs 'magnitue of E'"
FACT = FMAX
FOR I = 1 TO 20
IF F(I) = 0 THEN Y1 = 0
IF F(I) <> 0 THEN Y1 = (F(I) / FMAX) * 78 * 1.1
'PRINT F(I), FMAX, (F(I) / FMAX) * 80.01
IF FAST$ = "" THEN LINE (330 + (I - 1) * 4, 478 - Y1)-(330 + I * 4, 478), 1, BF
NEXT I
KF = 0
IF KFINI = 1 THEN RETURN


38  IF FAST$ = "" THEN LOCATE 24, 30: IF FAST$ = "" THEN PRINT NUMEVENT

AMAX = .001
FOR I = 2 TO 100
FOR J = 2 TO 100
      IF A(I, J) >= AMAX THEN AMAXI = I
      IF A(I, J) >= AMAX THEN AMAXJ = J
      IF A(I, J) >= AMAX THEN AMAX = A(I, J)
NEXT J
NEXT I
IF AMAX < 1! AND AMAX + UNILOAD > 1! THEN UUNILOAD = 1! - AMAX + .00002
IF AMAX > 1! THEN UUNILOAD = 0!
IF AMAX + UNILOAD < 1! THEN UUNILOAD = UNILOAD
'UUNILOAD = UNILOAD

FOR I = 1 TO 101
FOR J = 1 TO 101
      A(I, J) = A(I, J) + UUNILOAD
NEXT J
NEXT I

AMAX = 5
FOR I = 1 TO 101
FOR J = 1 TO 101
      DI = I: DJ = J
      IF A(I, J) > 1! THEN GOTO 19
NEXT J
NEXT I
'PRINT USING " ##.########"; UUNILOAD, ADENS(IDENS, 1)

GOTO 10


19      KLOOP = 0
        IF DI >= 6 AND DI <= 96 AND DJ >= 6 AND DJ <= 96 THEN NUMEVENT = NUMEVENT + 1
        AKAL(KL) = 1: DAKAL = 0
FOR I = 1 TO 102
FOR J = 1 TO 102
      D(I, J) = 0
NEXT J
NEXT I

20      A(DI, DJ) = A(DI, DJ) - ADROP
D(DI, DJ) = DS
IF D(DI - 1, DJ) = 0 THEN A(DI - 1, DJ) = A(DI - 1, DJ) + ALOST * BBXH
IF D(DI + 1, DJ) = 0 THEN A(DI + 1, DJ) = A(DI + 1, DJ) + ALOST * BBXH
                                       
IF D(DI, DJ - 1) = 0 THEN A(DI, DJ - 1) = A(DI, DJ - 1) + ALOST * BBXV
IF D(DI, DJ + 1) = 0 THEN A(DI, DJ + 1) = A(DI, DJ + 1) + ALOST * BBXV

IF D(DI - 1, DJ - 1) = 0 THEN A(DI - 1, DJ - 1) = A(DI - 1, DJ - 1) + ALOST * BBXD
IF D(DI + 1, DJ + 1) = 0 THEN A(DI + 1, DJ + 1) = A(DI + 1, DJ + 1) + ALOST * BBXD

IF D(DI + 1, DJ - 1) = 0 THEN A(DI + 1, DJ - 1) = A(DI + 1, DJ - 1) + ALOST * BBXD
IF D(DI - 1, DJ + 1) = 0 THEN A(DI - 1, DJ + 1) = A(DI - 1, DJ + 1) + ALOST * BBXD

FOR I = DI - 1 TO DI + 1
FOR J = DJ - 1 TO DJ + 1
        IF I < 6 OR I > 96 OR J < 6 OR J > 96 THEN GOTO 33
        IF FAST$ = "" THEN LINE (320 + I * 3, 10 + J * 3)-(322 + I * 3, 12 + J * 3), 15 * A(I, J), BF
33 NEXT J
   NEXT I
IF KLOOP = 1 THEN RETURN

30      IF FAST$ = "" THEN LOCATE 25, 30: IF FAST$ = "" THEN PRINT "        "
        IF FAST$ = "" THEN LOCATE 25, 30: IF FAST$ = "" THEN PRINT AKAL(KL) - DAKAL
        TAKAL = AKAL(KL): KLOOP = 1
FOR ILOOP = 1 TO 101
FOR JLOOP = 1 TO 101
        IF A(ILOOP, JLOOP) < 1! + UUNILOAD THEN GOTO 32
        DI = ILOOP: DJ = JLOOP
        AKAL(KL) = AKAL(KL) + 1
        IF ILOOP < 6 OR ILOOP > 96 OR JLOOP < 6 OR JLOOP > 96 THEN AKAL(KL) = AKAL(KL) - 1
332     GOSUB 20
32 NEXT JLOOP
   NEXT ILOOP
        
        IF TAKAL <> AKAL(KL) THEN GOTO 30
        'AKAL(KL) = AKAL(KL) - DAKAL
        'IF FAST$ <> "" THEN PRINT KL
301     IF KL < NGR THEN GOTO 10




200     IF FAST$ = "" THEN LOCATE 26, 1
        IF FAST$ = "" THEN PRINT "Number of loading, yielding events: "; KL, NUMEVENT
        IF FAST$ <> "" AND KL >= NGR THEN BEEP
        INPUT "Do you want to continue the calcualtions [YES] "; RET$
        IF RET$ = "" THEN GOTO 31


INPUT "DONE!! Plot E map in final stage [YES]"; Y$
FAST$ = ""
IF Y$ <> "" THEN GOTO 201

SCREEN 12
          FOR I = 0 TO 15
                    IF I <= 8 THEN COLNUM&(I) = (8 - I) * 7 + 65536 * I * 7
                    IF I >= 8 THEN COLNUM&(I) = 256 * (I - 8) * 8 + 65536 * (15 - I) * 8
          NEXT I

          FOR J = 1 TO 15
                PALETTE J, COLNUM&(J)
          NEXT J

FOR I = 6 TO 96
FOR J = 6 TO 96
       LINE (320 + I * 3, 10 + J * 3)-(322 + I * 3, 12 + J * 3), 15 * A(I, J), BF
NEXT J
NEXT I
LINE (323, 13)-(625, 315), , B

201 OPEN PROB$ FOR OUTPUT AS #3
        PRINT #3, "NUMBER OF EVENTS IN EARTHQUAKE SIMULATION, SIZE 101 X 101"
        PRINT #3, "MEAN VALUE OF dgama: "; SUMI; "  NUMBER OF EVENTS: "; NUMEVENT
        PRINT #3, "Mean, STD, TYPE= "; AMGR, ASTDev, DISTYPE
        PRINT #3, "Recording (mean, STD) every "; AFREQ; "loading.  Rate of unifrom loading";
        PRINT #3, USING " #.#### "; UNILOAD
        PRINT #3, "Energy drop="; ADROP; " Heat lost="; 1 - ALOST
        PRINT #3, "Enregy transfer: horizontal, diagonal,vertical=";
        PRINT #3, USING " ##.#### "; BBXH / ADROP, BBXD / ADROP, BBXV / ADROP
        PRINT #3, "Size of yielding events in time order (first column)"
        PRINT #3, "    Mean energy density (second column) Standard deviation (third)"

FOR I = 1 TO KL
        PRINT #3, USING " #####.######## "; AKAL(I), ADENS(I, 1), ADENS(I, 2), ADENS(I, 3)
NEXT I
CLOSE

IF FAST$ = "" THEN LOCATE 27, 1
PRINT "End of calculations.  Results saved in file NUMEVENT.DAT in default directory."

INPUT "Continue with the statistical analysis [YES] "; ok
FAST$ = ""

        SUMF = 0
FOR I = 1 TO 101
FOR J = 1 TO 101
        SUMF = SUMF + A(I, J)
NEXT J
NEXT I

FOR I = 1 TO KL
        IF AKAL(I) <= 0 THEN AKAL(I) = -1
        IF AKAL(I) <= 0 THEN GOTO 27
        AKAL(I) = LOG(AKAL(I)) / LOG(10)
27 NEXT I
Y$ = ""


28 CLS
IF Y$ = "" THEN AST = 1
IF Y$ = "" THEN AFI = KL
REDIM AL(700)
AMAXMAG = -10
FOR I = 1 TO KL
        IF AKAL(I) > AMAXMAG THEN AMAXMAG = AKAL(I)
NEXT I

LINE (20, 20)-(620, 400), , B

IF FAST$ = "" THEN LOCATE 1, 50: PRINT PROB$, DATE$
IF FAST$ = "" THEN LOCATE 2, 1: COLOR (2)
PRINT "Mean E changes (Initial E=";
PRINT USING "##.###"; ADENS(1, 1);
PRINT ")"
COLOR (6)
IF FAST$ = "" THEN LOCATE 3, 1: PRINT "STD Deviation (Initial STD=";
PRINT USING "##.###"; ADENS(1, 2);
PRINT ")"
IF FAST$ = "" THEN LOCATE 11, 4: IF Y$ = "" THEN PRINT USING "##.###"; ADENS(1, 2)
LINE (20, 189)-(10, 190), , BF
LINE (620, 189)-(630, 190), , BF
COLOR (2)
IF FAST$ = "" THEN LOCATE 6, 1: PRINT ".1 E units"
IF FAST$ = "" THEN LOCATE 12, 4: IF Y$ = "" THEN PRINT USING "##.##"; ADENS(1, 1)
LINE (20, 75)-(20, 105)

FOR J = 0 TO 10
        LINE (620, 45 + J * 30)-(624, 45 + J * 30)
        LINE (16, 45 + J * 30)-(20, 45 + J * 30)
NEXT J
LINE (620, 190)-(630, 191), , BF
LINE (20, 190)-(10, 191), , BF



IAST = INT(AST): IAFI = INT(AFI)

COLOR (15)
AIDENS = 600! / (IAFI - IAST)
PSET (20, 190)
FOR I = IAST TO IAFI
        IF ADENS(I, 1) = 0 THEN GOTO 161
        LINE -(20 + (I - IAST + 1) * AIDENS, 190 - 300 * 5 * (ADENS(I, 1) - ADENS(1, 1))), 2
161 NEXT I

PSET (20, 190)
FOR I = IAST TO IAFI
        IF ADENS(I, 1) = 0 THEN GOTO 162
        LINE -(20 + (I - IAST + 1) * AIDENS, 190 - 300 * 5 * (ADENS(I, 2) - ADENS(1, 2))), 6
162 NEXT I



ANUM = (AFI - AST) * 1!
IF FSTEP <> 0 THEN GOTO 140

FOR I = IAST TO IAFI
        BJ = (I - IAST + 1) * 600! / ANUM
        J = INT(BJ)
        IF AKAL(I) < 0 THEN GOTO 150
        AL(J) = AL(J) + 10 ^ AKAL(I)
150 NEXT I

GOTO 141

140 FOR JI = 1 TO 600
        IST = IAST + FSTEP / 2
        ILA = IAFI - FSTEP / 2
        IJ = IST + (JI - 1) * (ANUM - FSTEP) / 600!
FOR K = IJ - FSTEP / 2 TO IJ + FSTEP / 2
        IF AKAL(K) < 0 THEN GOTO 149
        AL(JI) = AL(JI) + 10 ^ AKAL(K)
149 NEXT K
NEXT JI


141 FOR I = 1 TO 600
        IF AL(I) <= 0 THEN GOTO 151
        AL(I) = LOG(AL(I)) / LOG(10)
151 NEXT I


AMAX2 = -10
FOR I = 1 TO 600
        IF AL(I) > AMAX2 THEN AMAX2 = AL(I)
NEXT I

K = INT(AMAX2 + 1)
INC = 380 / K

PSET (20, 400)
FOR I = 1 TO 600
        IF FSTEP = 0 THEN LINE (20 + I, 400)-(20 + I, 400 - AL(I) * INC)
        IF FSTEP <> 0 THEN LINE -(20 + I, 400 - AL(I) * INC)
169 NEXT I
FOR I = 1 TO 11
        LINE (20 + I * 60, 400)-(20 + I * 60, 407)
NEXT I

FOR I = 0 TO K
        LINE (20, 399 - I * INC)-(5, 400 - I * INC), , BF
        LINE (620, 399 - I * INC)-(635, 400 - I * INC), , BF
29 NEXT I

IF FAST$ = "" THEN LOCATE 27, 5: PRINT "Time from ";
PRINT USING "#####"; AST;
PRINT " to ";
PRINT USING "#####"; AFI;
PRINT " out of ";
PRINT USING "#####"; KL;
PRINT " loadings. Events of M =< 1 not shown"
IF FAST$ = "" THEN LOCATE 1, 1: PRINT "Relative 'energy' per time unit (log)"
IF FAST$ = "" THEN LOCATE 26, 2: PRINT "1"
IF FAST$ = "" THEN LOCATE (400 - INC) / 15, 1: PRINT "10"
'IF FAST$="" THEN LOCATE  2 * INC / 15.5, 1: PRINT "100"



1128 IF FAST$ = "" THEN LOCATE 28, 1: INPUT "Replot partial range-any key; Energy/STD plot-A key [CONTINUE] "; Y$
IF Y$ = "" THEN GOTO 50
IF Y$ = "A" OR Y$ = "a" THEN GOTO 26
INPUT "Range for plotting by event number and window width: START, FINISH, WIDTH"; AST, AFI, FSTEP
GOTO 28

26 CLS
AST = 1: AFI = KL
LINE (20, 20)-(620, 400), , B

IF FAST$ = "" THEN LOCATE 1, 50: PRINT PROB$, DATE$
IF FAST$ = "" THEN LOCATE 2, 1: COLOR (2)
PRINT "Initial E=";
PRINT USING "##.###"; SUMI / 10201
COLOR (6)
IF FAST$ = "" THEN LOCATE 3, 1: PRINT "Initial STD=";
PRINT USING "##.###"; ASTDev
LINE (20, 75)-(20, 105)
COLOR (15)
FOR J = 0 TO 10
        LINE (620, 20 + J * 38)-(624, 20 + J * 38)
        LINE (16, 20 + J * 38)-(20, 20 + J * 38)
        LINE (20 + J * 60, 397)-(20 + J * 60, 403)
NEXT J

IAST = INT(AST): IAFI = INT(AFI)
COLOR (15)
AIDENS = 600! / (IAFI - IAST)

FLAG = 0
FOR I = IAST + AFREQ + 1 TO IAFI
        IF ADENS(I, 1) = 0 THEN GOTO 1161
        FLAG = FLAG + 1
        X1 = 20 + 240 * 5 * (ADENS(I, 1) - .5)
        Y1 = 400 - ADENS(I, 2) * 380 * 5 / 1.25
        IF FLAG = 1 THEN PSET (X1, Y1)
         LINE -(X1, Y1)
         LINE (X1, Y1)-(2 + X1, 2 + Y1), 2, BF

1161 NEXT I

IF FAST$ = "" THEN LOCATE 27, 1: PRINT "Loading events:";
PRINT USING "#####"; AST;
PRINT " to ";
PRINT USING "#####"; AFI;
PRINT ". Emean: 0.5-1.0 & STD: 0.0-0.25 of yielding"
IF FAST$ = "" THEN LOCATE 1, 1: PRINT "Standard deviation STD versus mean energy E"
IF FAST$ = "" THEN LOCATE 26, 2: PRINT "0.5"
IF FAST$ = "" THEN LOCATE 26, 39: PRINT "0.75"
IF FAST$ = "" THEN LOCATE 26, 77: PRINT "1.0"
IF FAST$ = "" THEN LOCATE 7, 1: PRINT ".2"
IF FAST$ = "" THEN LOCATE 25, 1: PRINT ".0"
IF FAST$ = "" THEN LOCATE 16, 1: PRINT ".1"

GOTO 1128

50 CLS
Y$ = ""
PRINT KL;
INPUT " loading events were applied. Analyze ALL events [YES] "; YD$
IF YD$ = "" THEN AINI = 1
IF YD$ = "" THEN AFINI = KL
IF YD$ = "" THEN GOTO 36
INPUT "Enter range of events to be analyzed: INITIAL, FINAL events "; AINI, AFINI

36 AMAXMAG = -10
FOR I = AINI TO AFINI
        IF AKAL(I) > AMAXMAG THEN AMAXMAG = AKAL(I)
NEXT I

INPUT "Number of intervals [20] "; NUC
IF NUC = 0 THEN NUC = 20
PRINT "Plot the frequency of the separate magnitude intervals (any key) "
INPUT "     OR the [CUMULATIVE FREQUENCY] of the magnitude groups "; FLAGCOM$
REDIM AKC(100), ZX(100), ZY(100), ATEMP(100)

CLS
FOR I = AINI TO AFINI
        IF AKAL(I) <= 0 THEN GOTO 34
        NA = INT(.999 + NUC * (AKAL(I) / AMAXMAG))
        IF NA = 0 THEN NA = 1
        ATEMP(NA) = ATEMP(NA) + 1
34 NEXT I

FOR I = 1 TO NUC
        IF FLAGCOM$ <> "" THEN AKC(I) = ATEMP(I)
NEXT I

IF FLAGCOM$ <> "" THEN GOTO 35
FOR J = 1 TO NUC
FOR I = AINI TO AFINI
        IF AKAL(I) <= 0 THEN GOTO 134
        NA = INT(.999 + NUC * (AKAL(I) / AMAXMAG))
        IF NA >= J THEN AKC(J) = AKC(J) + 1
134 NEXT I
NEXT J

35 IK = 0
FOR I = 1 TO NUC
         IF AKC(I) <= 0 THEN AKC(I) = -1
         IF AKC(I) <= 0 THEN GOTO 63
         IK = IK + 1
         AKC(I) = LOG(AKC(I)) / LOG(10)
63 NEXT I

AMAXFRQ = -10
AMAX = AMAXMAG
FOR I = 1 TO NUC
        IF AKC(I) > AMAXFRQ THEN AMAXFRQ = AKC(I)
NEXT I
        IF AMAXFRQ > AMAXMAG THEN AMAX = AMAXFRQ

WIDE = (AMAXMAG / NUC)
'INC = 230 / AMAX
K = INT(AMAX) + 1
INC = 300 / K
LINE (200, 20)-(500, 320), , B

43 FOR I = 0 TO K
IF 320 - I * INC < 20 OR 200 + I * INC > 500 THEN GOTO 39
        LINE (195, 320 - I * INC)-(500, 320 - I * INC)
        LINE (200 + I * INC, 20)-(200 + I * INC, 325)
39 NEXT I



IF FAST$ = "" THEN LOCATE 22, 25: PRINT "1"
IF FAST$ = "" THEN LOCATE 22, (200 + INC) / 8: PRINT "10"
IF FAST$ = "" THEN LOCATE 22, (200 + 2 * INC) / 8: PRINT "100"

IF FAST$ = "" THEN LOCATE 21, 23: PRINT "1"
IF FAST$ = "" THEN LOCATE (320 - INC) / 15.5, 22: PRINT "10"
IF FAST$ = "" THEN LOCATE (320 - 2 * INC) / 15.5, 21: PRINT "100"
'GOTO 28

IF FAST$ = "" THEN LOCATE 1, 50: PRINT PROB$, DATE$
IF FAST$ = "" THEN LOCATE 5, 1:
IF FLAGCOM$ = "" THEN PRINT "Log of cumulative"
IF FLAGCOM$ = "" THEN IF FAST$ = "" THEN LOCATE 6, 5: PRINT "frequency"
IF FLAGCOM$ <> "" THEN PRINT "Log of frequency"
IF FAST$ = "" THEN LOCATE 23, 50: PRINT "Log size of events"
IF FAST$ = "" THEN LOCATE 24, 1: PRINT KL; "loading events, "; NUMEVENT; "yielding events, analysis for events"; AINI; "-"; AFINI

IF FAST$ = "" THEN LOCATE 25, 1
PRINT "ENERGY (units/cell):";
PRINT " Mean initial=";
PRINT USING " #.##"; SUMI / 10201;
PRINT ", Mean final=";
PRINT USING " #.##"; SUMF / 10201;
PRINT ","
PRINT "   Loading rate=";
PRINT USING " #.#####"; UNILOAD;
PRINT ", Drop during yielding=";
PRINT USING " #.##"; ADROP;
PRINT ", heat lost=";
PRINT USING " ##.##"; (1 - ALOST)

IK = 0
FOR I = 1 TO NUC
        IF AKC(I) < 0 THEN GOTO 40
        IK = IK + 1
                ZX(IK) = (I - .5) * WIDE
                ZY(IK) = AKC(I)
        LINE (200 + ZX(IK) * INC, 320 - ZY(IK) * INC)-(203 + ZX(IK) * INC, 317 - ZY(IK) * INC), 2, BF
40 NEXT I

IF FLAGCOM$ <> "" THEN NUC = IK

'Linear regression

FOR I = NUC TO 1 STEP -1
        IF ZX(I) >= AU THEN JU = I
        IF ZX(I) < AL THEN JL = I + 1
        IF ZX(I) < AL THEN GOTO 42
NEXT I

42 IF YB$ = "" THEN GOTO 44
        IF FAST$ = "" THEN LOCATE 27, 1
        PRINT "Frequency-magnitude line calculated for ";
        PRINT USING " ####.## "; 10 ^ AL;
        PRINT " < SIZE < ";
        PRINT USING "####.##"; 10 ^ AU
GOTO 45

44 JL = 1: JU = NUC
        PRINT "Frequency-magnitude line calculated for all size range"

45 ILIN = 0
FOR I = JL TO JU
ILIN = ILIN + 1
        X(ILIN) = ZX(I)
        Y(ILIN) = ZY(I)
NEXT I

NPTS = JU - JL + 1
MDEG = 1

SX = 0: SY = 0: SXY = 0: SX2 = 0
FOR I = 1 TO NPTS
       SX = SX + X(I)
       SY = SY + Y(I)
       SXY = SXY + X(I) * Y(I)
       SX2 = SX2 + (X(I)) ^ 2
NEXT I

B = (NPTS * SXY - SX * SY) / (NPTS * SX2 - SX ^ 2)
A = (SY * SX2 - SX * SXY) / (NPTS * SX2 - SX ^ 2)
COEF(1) = A: COEF(2) = B
PRINT "Intercept a= ";
PRINT USING " ###.##"; COEF(1);
PRINT ",   Slope b= ";
PRINT USING "###.##"; COEF(2);
PRINT ",   Largest event=";
PRINT USING "#####"; 10 ^ AMAXMAG;
PRINT " cells. "


Y1 = 320 - COEF(1) * INC
X2 = 200 - (COEF(1) / COEF(2)) * INC

      LINE (200, Y1)-(X2, 320)
INPUT "Select lower, upper bounds for the frequency-magnitude line [MIN to AMAX] "; YB$
IF YB$ = "" THEN GOTO 41
INPUT "Enter new lower, upper bounds as MAGNITUDE SIZES "; AL, AU
AL = LOG(AL) / LOG(10)
AU = LOG(AU) / LOG(10)
PRINT
41 INPUT "1- Replot Energy/Time, Any key-stop [Replot Frequency/Magnitude] "; Y1$
IF Y1$ = "1" THEN GOTO 28
IF Y1$ <> "" THEN STOP
CLS
IF Y1$ = "" THEN GOTO 50

REM $STATIC
FUNCTION ANormal (AMean, ASTDev, DISTYPE)
' Function Normal
'   - generates a normally distributed random number with a mean of
'     Mean and a standard deviation of StDev
'   - The random number generator is reset by the randomize statement,
'     using TIMER as its seed
'   - uses Box-Muller algorithm, mentioned under 'Normal Distribution'
'     in help files in MathCad Plus 5.0, and is described on page 953 of
'     Abramowitz and Stegun, Nov. 1964
CONST Pi = 3.1415927#
'RANDOMIZE TIMER
IF DISTYPE = 1 THEN ANormal = AMean + ASTDev * (SQR(-2! * LOG(RND)) * COS(2 * Pi * RND))

AT = -LOG(RND / ASTDev) / ASTDev
IF DISTYPE = 2 OR DISTYPE = 3 THEN ANormal = AT
END FUNCTION

