
    CLS
    COLOR (4)
    FOR J = 1 TO 5
    LOCATE J, 1
    FOR I = 1 TO 80
    PRINT CHR$(219);
    NEXT I
    NEXT J
    COLOR (15)
LOCATE 2, 20
PRINT "DEPTH DEPENDENT STRENGTH OF THE LITHOSPHERE"
LOCATE 3, 21
PRINT "by Ze'ev Reches; version 1.5, January, 1995"
PRINT
PRINT
PRINT
COLOR (2)
CLOSE

PRINT "Lithosphere strength concept after Brace and Kohlestadt, 1980"
PRINT "Temperature calculations after Turcotte and Schubert, 1982, P. 148."
PRINT "Rheological calculations after KIRBY, 1983, Kirby and Kronenberg, 1987."
PRINT "Brittle/ ductile ratio after Agnon and Reches, 1992."
PRINT
PRINT "Defaults in [SQUARE BRACKETS] "
PRINT
INPUT "FILENAME for saving the results [STRENGTH.OUT] "; A$
IF A$ = "" THEN A$ = "STRENGTH.OUT"

OPEN A$ FOR OUTPUT AS #3

20 NS = 5
REDIM BD(NS, NS, NS), TEMP(NS, NS), STG(NS, NS, NS), STGC(NS, NS, NS)
IF IP$ = "" THEN IP = 1
IF IP$ <> "" THEN IP = 0
IF CYCLE = 0 THEN CYCLE = 1000
PRINT
INPUT "Ready to enter input data [YES] "; ok
CLS
PRINT
PRINT "Enter CRUSTAL data:"
INPUT "         Lithosphere thickness (km) [120] "; LT
IF LT = 0 THEN LT = 120
INPUT "         Surface temperature (oC) [10] "; TS
IF TS = 0 THEN TS = 10
INPUT "         Mantle heat flow (base of crust) (mWm) [50] "; MHF
IF MHF = 0 THEN MHF = 50
INPUT "         Lithospheric heat conductivity (WmK) [2.5] "; HC
IF HC = 0 THEN HC = 2.5
INPUT "         Chracteristic depth (km) [10] "; CD
IF CD = 0 THEN CD = 10
INPUT "         Strain rate (compressive) [1E-15] "; SR
IF SR = 0 THEN SR = 1E-15
INPUT "         Friction coefficient [0.6] "; FR
IF FR = 0 THEN FR = .6
INPUT "         Vertical density  (kg m3) [2600] "; GDC
IF GDC = 0 THEN GDC = 2600
GDC = GDC / 100
PRINT "Ductile parameters of CRUST (defaults are for quartzite after Kirby, 1983)"
INPUT "         The A coefficient (MPa-n S-1) [0.000258] "; ACTIVE
IF ACTIVE = 0 THEN ACTIVE = .000258
INPUT "         Non linear power [2.4] "; N
IF N = 0 THEN N = 2.4
'INPUT "Ready to enter MANTLE data [YES] "; ok

ACTIVEL = 100000
PRINT
PRINT "Enter MANTLE data:"
PRINT "         Mantle heat conductivity (WmK) ["; HC; "] ";
INPUT HCL
IF HCL = 0 THEN HCL = HC
PRINT "         Friction coefficient ["; FR; "] ";
INPUT FRL
IF FRL = 0 THEN FRL = FR
INPUT "         Vertical density  (kg m3) [3300] "; GDL
IF GDL = 0 THEN GDL = 3300
GDL = GDL / 100
PRINT "Ductile patrameters of MANTLE:"
INPUT "         The A coefficient (MPa-n S-1) [100000] "; ACTIVEL
IF ACTIVEL = 0 THEN ACTIVEL = 100000
INPUT "         Activation energy (k J mol-1) [500] "; QTL
IF QTL = 0 THEN QTL = 500
INPUT "         Non linear power [3.5] "; NL
IF NL = 0 THEN NL = 3.5
PRINT

CLS
COLOR (2)
PRINT "Summary of CRUSTAL data:"
PRINT "         Lithosphere thickness (km)= "; LT
PRINT "         Surface temperature (oC)= "; TS
PRINT "         Mantle heat flow (base of crust) (mWm)= "; MHF
PRINT "         Lithospheric heat conductivity (WmK)= "; HC
PRINT "         Chracteristic depth (km)= "; CD
PRINT "         Strain rate (compressive)= "; SR
PRINT "         Friction coefficient= "; FR
PRINT "         Vertical density gradient in {kg m3}/km= "; GDC
PRINT "         The A coefficient (MPa-n S-1)= "; ACTIVE
PRINT "         Non linear power= "; N
COLOR (4)
PRINT "Summary of MANTLE data:"
PRINT "         Mantle heat conductivity (WmK)= "; HC
PRINT "         Friction coefficient= "; FR
PRINT "         Vertical density gradient  {kg m3}/km= "; GDL
PRINT "         The A coefficient (MPa-n S-1)= "; ACTIVEL
PRINT "         Activation energy (k J mol-1)= "; QTL
PRINT "         Non linear power= "; NL
COLOR (2)
PRINT "Ranges of parameters to be used in following computations:"
PRINT "         Surface heat flow (mWm):                [60 to 90] "
PRINT "         Crustal thickness (km):                 [20 to 50] "
PRINT "         Crustal activation energy (k J mol-1):  [100 to 350] "
COLOR (4)
INPUT "Enter number of STEPS between minimum and maximum of above ranges, < 5, [1] "; NS
IF NS = 0 THEN NS = 1

PRINT #3, "Summary of CRUSTAL data:"
PRINT #3, "         Lithosphere thickness (km),                 "; LT
PRINT #3, "         Surface temperature (oC),                   "; TS
PRINT #3, "         Mantle heat flow (base of crust) (mWm),     "; MHF
PRINT #3, "         Lithospheric heat conductivity (WmK),       "; HC
PRINT #3, "         Chracteristic depth (km),                   "; CD
PRINT #3, "         Strain rate (compressive),                  "; SR
PRINT #3, "         Friction coefficient,                       "; FR
PRINT #3, "         Vertical density gradient in {kg m3}/km,    "; GDC
PRINT #3, "         The A coefficient (MPa-n S-1),              "; ACTIVE
PRINT #3, "         Non linear power,                           "; N
PRINT #3, "Summary of MANTLE data:"
PRINT #3, "         Mantle heat conductivity (WmK),             "; HC
PRINT #3, "         Friction coefficient,                       "; FR
PRINT #3, "         Vertical density gradient  {kg m3}/km,      "; GDL
PRINT #3, "         The A coefficient (MPa-n S-1),              "; ACTIVEL
PRINT #3, "         Activation energy (k J mol-1),              "; QTL
PRINT #3, "         Non linear power,                           "; NL
PRINT #3, "Ranges of parameters to be used in following computations:"
PRINT #3, "    Surface heat flow (mWm),                [60 to 90] "
PRINT #3, "    Crustal thickness (km),                 [20 to 50] "
PRINT #3, "    Crustal activation energy (k J mol-1),  [100 to 350] "
PRINT #3, "Number of STEPS between minimum and maximum of above ranges, "; NS
PRINT #3,
PRINT #3, "Results of the stepped calculations appear below:"

INPUT "Change input [NO] "; Y$
IF Y$ <> "" THEN GOTO 20
GOTO 100

CLS
LINE (10, 10)-(370, 10)
LINE (10, 10)-(10, 160)
FOR I = 1 TO 10
LINE (10, 10 + I * 15)-(13, 10 + I * 15)
LINE (10 + I * 36, 10)-(10 + I * 36, 13)
NEXT I
TMAX = 0
FOR J = 0 TO 50
Y = J * MAX / 50
T = TS + MHF * Y / HC + (HF - MHF) * CD * (1 - EXP(-Y / CD)) / HC
IF T > TMAX THEN TMAX = T
NEXT J
LOCATE 1, 2: PRINT "0"
LOCATE 1, 45: PRINT INT(TMAX * 10) / 10; " DEG."
LOCATE 21, 3: PRINT MAX; " km"
LOCATE 3, 46: PRINT "360 MPa"

'IF FILE$ <> "" THEN PRINT #3, "Non-linear viscosity parameters"
'IF FILE$ <> "" THEN PRINT #3, "Surface temperature oC  "; TS
'IF FILE$ <> "" THEN PRINT #3, "Heat flow (mWm)  "; HF
'IF FILE$ <> "" THEN PRINT #3, "Mantle heat flow (mWm) "; MHF
'IF FILE$ <> "" THEN PRINT #3, "Chracteristic depth (km) "; CD
'IF FILE$ <> "" THEN PRINT #3, "Heat conductivity (WmK) "; HC
'IF RT$ = "Q" OR RT$ = "q" THEN IF FILE$ <> "" THEN PRINT #3, "  quartzitic with "
'IF RT$ = "D" OR RT$ = "d" THEN IF FILE$ <> "" THEN PRINT #3, "  diabase with "
'IF FILE$ <> "" THEN PRINT #3, "A= "; ACTIVE; "  Q= "; QT; "  N= "; N
'IF FILE$ <> "" THEN PRINT #3, "Friction "; FR
'IF FILE$ <> "" THEN PRINT #3, " depth (km)      temp (oC)    strain/stress coeff.      power"
LOCATE 1, 10: PRINT "STRENGTH (MPa), TEMP (oC)"
LOCATE 5, 50: PRINT "Crustal strength, temp profile"

LOCATE 7, 50: PRINT "Surface temperature oC  "; TS
LOCATE 8, 50: PRINT "Heat flow (mWm)  "; HF
LOCATE 9, 50: PRINT "Mantle heat flow (mWm) "; MHF
LOCATE 10, 50: PRINT "Chracteristic depth (km) "; CD
LOCATE 11, 50: PRINT "Heat conductivity (WmK) "; HC
LOCATE 12, 50: PRINT "  Rock flow parameters:"
LOCATE 13, 50: PRINT "A="; ACTIVE; " Q= "; QT; " N="; N
LOCATE 14, 50: PRINT "Friction "; FR; " SSF conditions "
LOCATE 15, 50: PRINT "Strain rate (s-1)"; SR


100 CLS
LOCATE 1, 1
PRINT "Surface temperature oC  "; TS; "  Mantle heat flow (mWm) "; MHF; "        "; DATE$
PRINT "Chracteristic depth (km) "; CD; "  Heat conductivity (WmK) "; HC
PRINT " Crust flow parameters:"; " A= "; " N = "; N; "  Strain rate (s-1)"; SR

'PRINT #3, "Surface temperature oC  "; TS; "  Mantle heat flow (mWm) "; MHF; "        "; DATE$
'PRINT #3, "Chracteristic depth (km) "; CD; "  Heat conductivity (WmK) "; HC
'PRINT #3, "  Rock flow parameters:"; " A= "; ACTIVE; "  Q= as below "; " N = "; N
'PRINT #3, "Strain rate (s-1)"; SR

650 CLS
SCREEN 12

'Setting crustal parameters
COLOR (4)
PRINT "Strength curves can be plotted for fixed values of two CRUSTAL variables:"
PRINT "     Thickness, Heat flow or Activation energy."
PRINT ""
INPUT "Hit any key to fix two variables "; ok$
IF ok$ = "" THEN CLS
IF ok$ = "" THEN GOTO 500
PRINT
PRINT "Enter FIXED variables in actual values, and enter 0 for CHANGING variable"
PRINT
PRINT "Enter in the following order:"
PRINT "   Crustal thickness (km), heat flow (mWm), activation energy (k J mol-1)";
MAX = 0: HF = 0: QT = 0
INPUT "     "; IMAX, IHF, IQT
IF IMAX <> 0 THEN MAX = IMAX
IF IHF <> 0 THEN HF = IHF
IF IQT <> 0 THEN QT = IQT

CLS
500     IF IMAX <> 0 THEN K = 1
        IF IMAX <> 0 THEN GOTO 510
        FOR K = 0 TO NS
        MAX = 20 + K * 30 / NS
510     IF IHF <> 0 THEN I = 1
        IF IHF <> 0 THEN GOTO 520
        FOR I = 0 TO NS
        HF = 60 + I * 30 / NS
520     IF IQT <> 0 THEN M = 1
        IF IQT <> 0 THEN GOTO 530
        FOR M = 0 TO NS
        QT = 100 + M * 250 / NS
530 IF ok$ = "" THEN CLS
IF IMAX = 0 THEN COL = K + 2
IF IHF = 0 THEN COL = I + 2
IF IQT = 0 THEN COL = M + 2

BRIT = 0: IBRIT = 0: DUC = 0: IDUC = 0

'Setting mantle parameters (NOT controlled)
' generally after Kirby and Kronenberg (1987)

BRITL = 0: IBRITL = 0: DUCL = 0: IDUCL = 0
IF IP = 1 THEN LINE (0, 0)-(639, LT * 4 - 1), 5, B

FOR IL = 0 TO 12
LINE (IL * 50, 0)-(IL * 50, 10), 2
LINE (629, IL * 40)-(639, IL * 40), 2
NEXT IL

LINE (550, 51)-(551, 91), 2, BF
LINE (500, 50)-(550, 51), 2, BF
LOCATE 3, 64: PRINT "50 MPa"
LOCATE 5, 71: PRINT "10 km"
IF IP = 1 THEN PSET (0, 0)

FOR ND = 0 TO CYCLE
Y = ND * MAX / CYCLE
T = TS + MHF * Y / HC + (HF - MHF) * CD * (1 - EXP(-Y / CD)) / HC
TAU = (SR / ACTIVE) ^ (1 / N)
TAU = TAU * EXP((QT * 1000 / ((T + 273) * 8.317)) * (1 / N))
GAMA = 2 * FR * (SQR(1 + FR ^ 2) + FR)
BYERL = .5 * GDC * Y * (GAMA / (GAMA + 1))
IF TAU > BYERL THEN BRIT = BRIT + BYERL * 1000000 * (1000 * MAX / CYCLE)
IF TAU < BYERL THEN DUC = DUC + TAU * 1000000 * (1000 * MAX / CYCLE)
IF TAU > BYERL AND IP = 1 THEN LINE -(BYERL, Y * 4), COL
IF TAU < BYERL AND IP = 1 THEN LINE -(TAU, Y * 4), COL

NEXT ND

TEMP(I, K) = T
TSL = T
PR = ACTIVE * EXP(-QT * 1000 / ((T + 273) * 8.317))

FOR ND = 0 TO CYCLE
YL = MAX + ND * (LT - MAX) / CYCLE
TL = T + (1200 - T) * (YL - MAX) / (LT - MAX)
TAUL = (SR / ACTIVEL) ^ (1 / NL)
TAUL = TAUL * EXP((QTL * 1000 / ((TL + 273) * 8.317)) * (1 / NL))
GAMAL = 2 * FRL * (SQR(1 + FRL ^ 2) + FRL)
BYERL = .5 * (GDC * MAX + GDL * (YL - MAX)) * (GAMAL / (GAMAL + 1))
IF TAUL > BYERL THEN BRITL = BRITL + BYERL * 1000000 * (1000 * (LT - MAX) / CYCLE)
IF TAUL < BYERL THEN DUCL = DUCL + TAUL * 1000000 * (1000 * (LT - MAX) / CYCLE)
IF TAUL > BYERL AND IP = 1 THEN LINE -(BYERL, YL * 4), COL
IF TAUL < BYERL AND IP = 1 THEN LINE -(TAUL, YL * 4), COL
NEXT ND

IF IP = 1 THEN LOCATE 19, 30: PRINT "Lithosphere thickness: "; LT
IF IP = 1 THEN LOCATE 20, 30: PRINT "Crust thickness: ";
IF IP = 1 THEN LOCATE 21, 30: PRINT "Heat flow: ";
IF IP = 1 THEN LOCATE 22, 30: PRINT "Friction: "; FR
IF IP = 1 THEN LOCATE 23, 30: PRINT "Activation: ";
IF IP = 1 THEN LOCATE 24, 30: PRINT "Moho temp: ";
IF IP = 1 THEN LOCATE 25, 30: PRINT "B/D:    "
IF IP = 1 THEN LOCATE 26, 30: PRINT "Strength Newton/meter width: "
IF IP = 1 THEN LOCATE 27, 20: PRINT "Lithosphere:"
IF IP = 1 THEN LOCATE 28, 20: PRINT "Crust:      "

COLOR (COL)
IF IP = 1 THEN LOCATE 20, 39 + (K + 1) * 7: PRINT USING "###.#  "; MAX
IF IP = 1 THEN LOCATE 21, 39 + (I + 1) * 7: PRINT USING "###.#  "; HF
IF IP = 1 THEN LOCATE 23, 40 + (M + 1) * 7: PRINT USING "### "; QT
IF IP = 1 THEN LOCATE 24, 32 + COL * 7: PRINT USING "#### "; T
IF ABS(DUC + DUCL) > .00001 THEN BD(I, K, M) = (BRIT + BRITL) / (DUC + DUCL)
IF ABS(DUC + DUCL) < .00001 THEN BD(I, K, M) = 99
STG(I, K, M) = ((BRIT + BRITL) + (DUC + DUCL))
STGC(I, K, M) = (BRIT + DUC)
IF IP = 1 THEN LOCATE 25, 32 + COL * 7: PRINT USING " #.##"; BD(I, K, M)
IF IP = 1 THEN LOCATE 27, 16 + COL * 9: PRINT USING " ##.#^^^^"; STG(I, K, M)
IF IP = 1 THEN LOCATE 28, 16 + COL * 9: PRINT USING " ##.#^^^^"; STGC(I, K, M)
COLOR (4)

PRINT #3, "Lithos. thickness,   "; LT
PRINT #3, "Friction,            "; FR
PRINT #3, "Crust thickness,     "; MAX
PRINT #3, "Heat flow,           "; HF
PRINT #3, "Activation,          "; QT
PRINT #3, "Moho temp,           "; T
PRINT #3, "Brittle/Ductile,      "; BD(I, K, M)
PRINT #3, "Lithos. strength,    "; STG(I, K, M)
PRINT #3, "Crustal strength,    "; STGC(I, K, M)
PRINT #3,

IF IP = 1 THEN LOCATE 1, 70: PRINT DATE$
LOCATE 28, 10: INPUT ok
PR = ACTIVE * EXP(-QT * 1000 / ((T + 273) * 8.317))

600 IF IQT <> 0 THEN GOTO 610
        NEXT M
610 IF IHF <> 0 THEN GOTO 620
        NEXT I
620 IF IMAX <> 0 THEN GOTO 630
        NEXT K
630


GOTO 640

'PRINT #3,
'PRINT #3, "RESULTS"
'PRINT #3, "In the first block:"
'PRINT #3, "Each line: Moho temp., surface heat flow, crustal thickness, friction, "
'PRINT #3, "and "; NS + 1; " values of B/D of the lithosphere for the following activation energies:"
FOR M = 0 TO NS
QT = 100 + M * 250 / NS
'PRINT #3, USING "  ####.## "; QT;
NEXT M
PRINT
'PRINT #3, "In the second block:"
'PRINT #3, "Each line: Moho temp., surface heat flow, crustal thickness, friction, "
'PRINT #3, "and "; NS + 1; " values of lithosphere and crust strength in"
'PRINT #3, "   Newton per one meter width of the lithosphere for the same activation energies as above."
PRINT

FOR I = 0 TO NS
HF = 60 + I * 30 / NS
FOR K = 0 TO NS
MAX = 20 + K * 30 / NS
'PRINT #3, USING " ####.#"; TEMP(I, K), HF, MAX, FR;
FOR M = 0 TO NS
QT = 100 + M * 250 / NS
'PRINT #3, USING " ##.##"; BD(I, K, M);
NEXT M
'PRINT #3,
NEXT K
'PRINT #3,
NEXT I
'PRINT #3,
'PRINT #3,
'PRINT #3,
FOR I = 0 TO NS
HF = 60 + I * 30 / NS
FOR K = 0 TO NS
MAX = 20 + K * 30 / NS
'PRINT #3, USING " ####.#"; TEMP(I, K), HF, MAX, FR;
FOR M = 0 TO NS
'PRINT #3, USING " ##.###"; LOG(STG(I, K, M)) / LOG(10);
'PRINT #3, USING " ##.###"; LOG(STGC(I, K, M)) / LOG(10);
NEXT M
'PRINT #3,
NEXT K
'PRINT #3,
NEXT I

640

LOCATE 29, 5: INPUT " More [YES] "; Y$
IF Y$ = "" THEN GOTO 650
CLOSE
IF Y$ <> "" THEN STOP
LOCATE 22, 1: PRINT

250
LOCATE 4, 1
PRINT "B/D and log(strength) (Pa m)";
INPUT "   Crustal thickness (step in range) [0]"; KAE
THICK = 20 + KAE * 30 / NS
PRINT "B/D ratio; friction= "; INT(100 * FR) / 100; "; crustal thickness= "; THICK; "; lithosphere= "; LT
INPUT ok

CLS
LOCATE 1, 1: PRINT "Moho temp. HF  Activation energy, thickness="; THICK; "km, friction="; FR
LOCATE 3, 13
FOR J = 0 TO NS
QT = 100 + J * 250 / NS
PRINT USING " ###"; QT;
NEXT J
'PRINT
     INPUT ok
FOR I = 0 TO NS
HF = 60 + I * 30 / NS

PRINT USING " ####.#"; TEMP(I, KAE);
PRINT USING "   ##"; HF;
FOR K = 0 TO NS
IF K < NS THEN PRINT USING " #.#"; BD(I, KAE, K);
IF K = NS THEN PRINT USING " #.#"; BD(I, KAE, K)
NEXT K
NEXT I
INPUT ok
IF NS >= 11 THEN INPUT "Screen is cleared to plot strength [OK] "; ok
IF NS >= 11 THEN CLS
LOCATE 20 - I, 1
FOR I = 0 TO NS
LOCATE 19 - I, 13
FOR K = 0 TO NS
IF K < NS THEN PRINT USING " ##.#"; LOG(STG(I, KAE, K)) / LOG(10);
IF K = NS THEN PRINT USING " ##.#"; LOG(STG(I, KAE, K)) / LOG(10)
NEXT K
NEXT I



LOCATE 1, 65: INPUT "More"; Y$
CLS
IF Y$ = "" THEN GOTO 250
200 INPUT "New run [NO] "; ok$
IF ok$ <> "" THEN GOTO 20

