'$DYNAMIC
DECLARE SUB THETASIGN (THETAS, X1, X2, X3, Y2, Y3, PI)
DECLARE SUB SETCOL (COL1, COL2)
DECLARE SUB SETCOL1 (COL1, COL2)
CLS
    COLOR (4)
    LOCATE 1, 20
FOR I = 1 TO 36
    PRINT CHR$(219);
NEXT I
    LOCATE 2, 20
FOR I = 1 TO 36
    PRINT CHR$(219);
NEXT I
    LOCATE 3, 20
FOR I = 1 TO 36
    PRINT CHR$(219);
NEXT I

    LOCATE 2, 33
    COLOR (15)
    PRINT " CRACK "
    LOCATE 5, 1
    COLOR (2)

PRINT "     STRESSES AND DISPLACEMENTS CLOSE TO A MODE I/MODE II FRACTURE"
PRINT "                   QuickBasic program by Ze'ev Reches"
PRINT "                        Version 2.1, March 1997"
PRINT
    PRINT
    COLOR (15)
    PRINT "The program prompts for defaults appear in [SQUARE BRACKETS]."
    PRINT "  Activate by hitting RETURN. "
    PRINT
    INPUT "For general information and bibliography- hit any letter [CONTINUE] "; Y$
    IF Y$ = "" THEN GOTO 1
    CLS
    COLOR (2)
    PRINT "                             GENERAL INFORMATION"
    PRINT
    PRINT "CRACK is free for NON-COMMERCIAL purposes. Using it for research is"
    PRINT "  expected to be acknowledged in resulting publications."
    PRINT "Class assignments for this program and its source code may be obtained by"
    PRINT "  direct request from the author."
    PRINT "The author would appreciate information on bugs and errors as well as "
    PRINT "  suggestions for improvements."
    PRINT "     Ze'ev Reches, e-mail:  reches@earth.es.huji.ac.il "
    COLOR (15)
    PRINT
    PRINT "For hard copies: run CRACK in DOS window under WINDOWS 3.1x; hit PrintScreen;"
    PRINT "  to copy screen display to clipboard; paste into a Windows graphic program."
    PRINT
    PRINT "Formulations after:"
    PRINT "Pollard, D. D. & P. Segall, Theoretical displacements and stresses near"
    PRINT "      fractures in rock with applications to faults, joints, veins, dikes, and"
    PRINT "      solution surfaces, in Fracture Mechanics of Rock, edited by "
    PRINT "      B. K. Atkinson, pp. 277-349, Academic"
    PRINT "Applications:"
    PRINT "Reches Z. & Lockner, D. A., 1994, The nucleation and growth of faults in brittle"
    PRINT "      rocks,  J. Geophysical Res., v. 99, p. 18,159-18,171"
    INPUT "[CONTINUE] "; Y$

1 CLS
PRINT
PRINT "STRESS DEFINITIONS:    "
PRINT "           Remote stress,  "; CHR$(229); "r, (applied at far distance)"
PRINT "           Crack stress,   "; CHR$(229); "c, (the stresses on the crack surface)"
PRINT "           Driving stress, "; CHR$(127); CHR$(229); ", (driving= remote - crack)"
PRINT " Tension is positive."
PRINT
10 SXXR = 0: SYYR = 0: SXYR = 0: NOBLUE = 0: PI = 4 * ATN(1)
NU = .25: EY = 100000!: KNU = 3 - 4 * NU
PRINT "Note: at least one of the driving stresses should differ from zero"
PRINT
INPUT "Driving stress: Mode I (enter 9 for 0), negative for closure [1] "; SYTEMP
INPUT "Driving stress: Mode II, negative for sinistral [0] "; SXYTEMP
                IF SYTEMP = 0 THEN SYTEMP = 1
                IF SYTEMP = 9 THEN SYTEMP = 0
                SYYL = SYTEMP
                SXYL = SXYTEMP
'PRINT "Two crack option (any key) (for correct stress trajectories"
'PRINT "     set RESOLUTION > 2, otherwise resolution=2 is OK ) [SINGLE CRACK] ";
'INPUT SC$
PRINT "     Stress maps shown in Red-Blue-Green "
9 INPUT "Stress mapping resolution: 2-fine, 4, 5, 10-coarse (1 for NO-Blue maps) [2] "; INC
        IF INC = 1 THEN NOBLUE = 1
        IF INC = 1 THEN PRINT "     Stress maps shown in Red-Green "
        IF INC = 1 THEN GOTO 9
        IF INC = 0 THEN INC = 2
        WIDE = 100 / INC
        FLAGCOL = 0
    PRINT "Three options of colors:"
    PRINT "     1.  Colors for B&W prints on Laser printer, hit 1"
    PRINT "     2.  Colors for PowerPoint files, hit 2"
    INPUT "         or [Red-Blue-Green] "; FLAGCOL

        INPUT "Half crack length, marked C, (plotted region is 2 by 2 meter) [1] "; A
        A = A * 100
        IF A = 0 THEN A = 100
        INPUT "Default elastic parameters: Young 100,000 MPa, Poisson 0.25. Select new [NO] "; Y$
        IF Y$ = "" THEN GOTO 8
        INPUT "New Young modulus, new Poisson's ratio "; EY, NU
        KNU = 3 - 4 * NU
8
PRINT "Few stress intensity maps are plotted; choose one option:"
PRINT "  1.  left: maximum shear,     center: maximum tension, right: crack-normal"
PRINT "  2.  left: Byerlee parameter, center: maximum tension, right: crack-normal"
INPUT "Enter stress intensity option [2] "; SOPT
IF SOPT = 0 THEN SOPT = 2
        INPUT "Remote stresses [NO] "; Y$
        IF Y$ = "" THEN GOTO 17
14      PRINT "x axis is crack parallel, y axis is crack-normal"
        PRINT "Note: Remote stress = driving stress + crack stress"
       PRINT "Remote stresses, "; CHR$(229); "xx, "; CHR$(229); "yy, "; CHR$(229); "xy ";
       INPUT SXXR, SYYR, SXYR
        PRINT "Note: Remote stress = driving stress + crack stress"
        PRINT "  Thus, crack stresses are: "; CHR$(229); "xx="; SXXR; " "; CHR$(229); "yy="; SYYR - SYYL; CHR$(229); "xy="; SXYR - SXYL
        GOSUB 999
        PRINT "The Byerlee factor, "; CHR$(229); "1-"; CHR$(229); "3/"; CHR$(229); "1+"; CHR$(229); "3, is "; INT(100 * (G2 - G1) / (G2 + G1)) / 100
        PRINT
        INPUT "Change remote stresses [NO] "; Y$
        IF Y$ <> "" THEN GOTO 14
17 INPUT "Save results to file (enter file name) [NO] "; A$
IF A$ = "" THEN GOTO 13
OPEN A$ FOR OUTPUT AS #3
GOTO 97
PRINT #3, "STRESSES AND DISPLACEMENTS CLOSE TO A MODE I/MODE II FRACTURE"
PRINT #3, "   Programming by Ze'ev Reches, equations after Pollard and Segall, 1987"
PRINT #3,
PRINT #3, " Plane strain conditions, Young modulus= "; EY; " Poisson's ratio=0.25"
PRINT #3, " Fracture length is "; 2 * A / 100; " meter"
PRINT #3, " Driving stresses: Mode I="; SYYL; " and Mode II= "; SXYL; " (MPa) "
PRINT #3, " Remote stresses: Sxx, Syy, Sxy (MPa) "; SXXR, SYYR, SXYR
PRINT #3, "     Note: Remote stress = driving stress + crack stress"
PRINT #3, "     Thus, crack stresses are: Sxx="; SXXR; " Syy="; SYYR - SYYL, " Sxy="; SXYR - SXYL; "(MPa)"
PRINT #3, " Tension is positive."
PRINT #3,
PRINT #3, " X axis crack parallel; Y axis crack normal; origin (0,0) at crack center"
PRINT #3, " Crack tip at ("; A / 100; ",0)"
PRINT #3, " In the table below: locations are in meters;"
PRINT #3, "   stresses are in the units of Young modulus; displacements in centimeters"; ""
97 PRINT #3, "     X,             Y,             SXX,            SYY,            SXY,            S1,             S2,             UX,             UY,       Theta"
13  CLS
PRINT "STRESSES AND DISPLACEMENTS CLOSE TO A MODE I/MODE II FRACTURE"
PRINT
PRINT " Plane strain conditions, Young modulus= "; EY; " Poisson's ratio=0.25"
PRINT " Fracture length is "; 2 * A / 100; " meter"
PRINT "STRESS DEFINITIONS:    "
PRINT "           Remote stress,  "; CHR$(229); "r, (applied at far distance)"
PRINT "           Crack stress,   "; CHR$(229); "c, (the stresses on the crack surface)"
PRINT "           Driving stress, "; CHR$(127); CHR$(229); ", (driving= remote - crack)"

PRINT " Tension is positive."
PRINT
PRINT "STRESS MAGNITUDES:"
PRINT " Remote stresses: "; CHR$(229); "xx="; SXXR; " "; CHR$(229); "yy="; SYYR; " "; CHR$(229); "xy="; SXYR; " (MPa) "
PRINT " Crack stresses:  "; CHR$(229); "xx="; SXXR; " "; CHR$(229); "yy="; SYYR - SYYL; " "; CHR$(229); "xy="; SXYR - SXYL; "(MPa)"
PRINT " Driving stresses: Mode I="; SYYL; " and Mode II= "; SXYL; " (MPa) "
PRINT "Stress intensity factors are derived from driving stresses where KI="; CHR$(127); CHR$(229); "I {"; CHR$(227); " C}"; CHR$(171)
PRINT " that for present case are: K I= ";
PRINT USING " ##.##"; SYYL * SQR(A * PI / 100);
PRINT ", K II= ";
PRINT USING " ##.##"; SXYL * SQR(A * PI / 100);
PRINT "  (MPa m"; CHR$(171); ")"
PRINT
PRINT "Note: maximum and minimum stress values are reported for plotted area around"
PRINT "  crack tip. Fine grid and/or longer crack yield higher stresses."
PRINT " X axis crack parallel; Y axis crack normal"
PRINT " Crack center at (0,0); Crack tip at("; A / 100; ", 0) "
PRINT
INPUT "Continue [YES] "; ok
12 CLS
SIZE = INT(200 / INC)
REDIM S11(SIZE, SIZE), S22(SIZE, SIZE), THET(SIZE, SIZE), COLNUM&(40)
REDIM SPS(SIZE, SIZE), TEMP(SIZE, SIZE), SYYT(SIZE, SIZE), BLF(SIZE, SIZE)
REDIM UX(SIZE, SIZE), UY(SIZE, SIZE)
IF SC$ <> "" THEN REDIM SPX(SIZE, SIZE), SPXY(SIZE, SIZE)

 SCREEN 12
          FOR I = 0 TO 15
                    IF I <= 8 THEN COLNUM&(I) = (8 - I) * 7 + 65536 * I * 7
                    IF I >= 8 THEN COLNUM&(I) = 256 * (I - 8) * 8 + 65536 * (15 - I) * 8
          NEXT I
          FOR I = 0 TO 15
                    IF NOBLUE = 1 THEN COLNUM&(I) = (15 - I) * 4 + 256 * I * 4
          NEXT I
         
          FOR J = 1 TO 15
                IF FLAGCOL <> 1 THEN PALETTE J, COLNUM&(J)
          NEXT J
          FOR J = 1 TO 10
          J1 = J
          IF FLAGCOL = 1 THEN CALL SETCOL(10 * J / 10, J1)
                IF FLAGCOL = 1 THEN LINE (300 + (J - 1) * 20, 80)-(300 + J * 20, 100), J1, BF
          NEXT J
          FOR J = 1 TO 15
           IF FLAGCOL = 0 THEN LINE (300 + (J - 1) * 20, 80)-(300 + J * 20, 100), J, BF
          NEXT J

          FOR J = 1 TO 10
           IF FLAGCOL = 2 THEN CALL SETCOL1(J, J1)
           IF FLAGCOL = 2 THEN LINE (300 + (J - 1) * 20, 80)-(300 + J * 20, 100), J1, BF
          NEXT J


    LOCATE 1, 65: PRINT DATE$
    LOCATE 1, 15: PRINT "Half crack "; A / 100; " meter. 2x2 m plotted."
    LOCATE 3, 15: IF SXYL = 0 THEN PRINT "";
    PRINT "Remote: "; CHR$(229); "MAX= "; INT(100 * G1) / 100; " "; CHR$(229); "min= "; INT(100 * G2) / 100; " Angle compression to X axis="; INT(THET)
    LOCATE 4, 15: PRINT "Driving: Md I="; SYYL; " Md II="; SXYL; "  Crack: "; CHR$(229); "xx="; SXXR - SXXL; " "; CHR$(229); "yy="; SYYR - SYYL; " "; CHR$(229); "xy="; SXYR - SXYL
   
    LOCATE 5, 15: IF G1 + G2 <> 0 THEN PRINT "Remote ("; CHR$(229); "1-"; CHR$(229); "3/"; CHR$(229); "1+"; CHR$(229); "3)=BLF="; INT(100 * (G2 - G1) / (G2 + G1)) / 100; "  ";
    LOCATE 5, 46: IF SYYR - SYYL <> 0 THEN PRINT "Crack ratio Shear/Normal:"; INT(100 * (SXYR - SXYL) / (SYYR - SYYL)) / 100;
    LOCATE 2, 15: PRINT "Remote: "; CHR$(229); "xx="; SXXR; " "; CHR$(229); "yy="; SYYR; " "; CHR$(229); "xy="; SXYR;
    IF SXYL > 0 THEN PRINT "   Right-lateral slip "
    IF SXYL < 0 THEN PRINT "   Left-lateral slip "

    LOCATE 6, 77: PRINT "High": LOCATE 6, 35: PRINT "Low"
    LINE (17, 87)-(67, 87): LINE (67, 87)-(67, 37)
    LOCATE 6, 1: PRINT "Y"
    LOCATE 2, 9: PRINT "X"
WIDE = 100 / INC: C = WIDE
KI = SYYL
KII = SXYL
DX = INC: DY = INC
'NU = .25: EY = 1: KNU = 3 - 4 * NU
TOTAL = (1 + 2 * WIDE) ^ 2: NC = 0
LOCATE 1, 1: PRINT "    %  done"

'
'MAIN CALCULATION LOOP
'

X1 = A
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
        X2 = X1 + (I - WIDE) * DX: Y2 = -(J - WIDE) * DY
        R0 = SQR(X2 ^ 2 + Y2 ^ 2): R1 = SQR((X1 - X2) ^ 2 + Y2 ^ 2): R2 = SQR((-X1 - X2) ^ 2 + Y2 ^ 2)
        IF X2 = 0 THEN T0 = PI / 2
        IF X2 = 0 THEN GOTO 1010
        T0 = ATN((Y2 / X2))
1010    IF X2 - X1 = 0 THEN T1 = PI / 2
        IF X2 - X1 = 0 THEN GOTO 1020
        T1 = ATN((Y2 / (X2 - X1)))
1020    IF X2 + X1 = 0 THEN T2 = PI / 2
        IF X2 + X1 = 0 THEN GOTO 1030
        T2 = ATN((Y2 / (X2 + X1)))
1030    RT = SQR(R1 * R2)
        CALL THETASIGN(T0, X1, X2, 0, Y2, Y3, PI)
        CALL THETASIGN(T1, X1, X2, X1, Y2, Y3, PI)
        CALL THETASIGN(T2, X1, X2, -X1, Y2, Y3, PI)
        TT = (T1 + T2) / 2
        IF RT = 0 THEN GOTO 1040
        SYY = KI * ((R0 / RT) * COS(T0 - TT) - 1 + A ^ 2 * R0 * SIN(T0) * SIN(3 * TT) / (RT ^ 3))
        SXX = KI * ((R0 / RT) * COS(T0 - TT) - 1 - A ^ 2 * R0 * SIN(T0) * SIN(3 * TT) / (RT ^ 3))
        SXY = KI * (A ^ 2 * R0 * SIN(T0) * COS(3 * TT) / (RT ^ 3))
        UY = (.5 * KI / EY) * (2 * (1 - NU) * (RT * SIN(TT) - R0 * SIN(T0)) - R0 * SIN(T0) * ((R0 / RT) * COS(T0 - TT) - 1))
        UX = (.5 * KI / EY) * ((1 - 2 * NU) * (RT * COS(TT) - R0 * COS(T0)) - R0 * SIN(T0) * (R0 / RT) * SIN(T0 - TT))

        SYY = SYY + KII * (A ^ 2 * R0 * SIN(T0) * COS(3 * TT) / (RT ^ 3))
        SXX = SXX + KII * (2 * (R0 / RT) * SIN(T0 - TT) - A ^ 2 * R0 * SIN(T0) * COS(3 * TT) / (RT ^ 3))
        SXY = SXY + KII * ((R0 / RT) * COS(T0 - TT) - 1 - A ^ 2 * R0 * SIN(T0) * SIN(3 * TT) / (RT ^ 3))
        UY = UY - (.5 * KII / EY) * ((1 - 2 * NU) * (RT * COS(TT) - R0 * COS(T0)) + R0 * SIN(T0) * (R0 / RT) * SIN(T0 - TT))
        UX = UX + (.5 * KII / EY) * (2 * (1 - NU) * (RT * SIN(TT) - R0 * SIN(T0)) + R0 * SIN(T0) * ((R0 / RT) * COS(T0 - TT) - 1))
       
        SXX = SXX + SXXR: SYY = SYY + SYYR: SXY = SXY + SXYR
        S1 = .5 * (SYY + SXX) + SQR(SXY ^ 2 + .25 * (SXX - SYY) ^ 2)
        S2 = .5 * (SYY + SXX) - SQR(SXY ^ 2 + .25 * (SXX - SYY) ^ 2)
              IF SXX = SYY THEN TET = 10000
              IF SXX = SYY AND SXX < 0 THEN TET = -10000
              IF SXX = SYY THEN THETA1 = ATN(TET) / 2
              IF SXX = SYY THEN GOTO 608
              TET = ABS(2 * SXY / (SXX - SYY))
              THETA1 = ATN(TET) / 2
        IF SXX > SYY AND SXY > 0 THEN GOTO 608
        IF SXX > SYY AND SXY < 0 THEN GOTO 602
        IF SXX < SYY AND SXY > 0 THEN GOTO 603
        IF SXX < SYY AND SXY < 0 THEN GOTO 604
602 THETA1 = -THETA1: GOTO 608
603 THETA1 = -THETA1 + PI / 2: GOTO 608
604 THETA1 = THETA1 - PI / 2
608 S11(I, J) = S1: S22(I, J) = S2: THET(I, J) = THETA1
    BLF(I, J) = .5 * (S1 - S2)
    IF SOPT = 1 THEN GOTO 611
    IF S1 <= 0 THEN BLF(I, J) = ABS((S1 - S2) / (S1 + S2))
    IF S1 > 0 THEN BLF(I, J) = 2
    IF BLF(I, J) > .65 AND BLF(I, J) < 1 THEN BLF(I, J) = 1
    IF BLF(I, J) <= .65 THEN BLF(I, J) = 0
    GOTO 611
610 'BLF(I, J) = .5 * (S1 - S2)
   
611
        'IF INC > 2 THEN UX(I, J) = UX * EY
    'IF INC > 2 THEN UY(I, J) = UY * EY
     UX(I, J) = UX * EY
     UY(I, J) = UY * EY

    SPS(I, J) = SYY
    SYYT(I, J) = SYY
    IF SC$ <> "" AND INC > 2 THEN SPX(I, J) = SXX
    IF SC$ <> "" AND INC > 2 THEN SPXY(I, J) = SXY
    IF A$ <> "" THEN PRINT #3, USING " ####.######,"; X2 / 100, Y2 / 100, SXX, SYY, SXY, S1, S2, UX, UY, THETA1 * 180 / PI
    'IF A$ <> "" THEN PRINT USING " ##.######,"; X2 / 100, Y2 / 100, SXX, SYY, SXY, S1, S2, UX, UY,THETA1
    NC = NC + 1
1040 NEXT J
        LOCATE 1, 1: PRINT USING "###"; 100 * NC / TOTAL
NEXT I
IF SC$ = "" THEN GOTO 29

LOCATE 1, 1: INPUT "Offset between cracks centers in plot units: X, Y (RESOLUTION x an integer) "; FX, FY
FX = FX / DX: FY = FY / DY
X1 = A
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
X2 = X1 + (I - WIDE) * DX: Y2 = -(J - WIDE) * DY
X4 = X1 + (I - FX - WIDE) * DX: Y4 = -(J - FY - WIDE) * DY
    IF ABS(X2) <= A AND Y2 = 0 THEN GOTO 35
    IF ABS(X4) <= A AND Y4 = 0 THEN GOTO 35
    IF J < FY OR I < FX THEN GOTO 35
    TEMP(I, J) = SPS(I, J) + SPS(I - FX, J - FY)
35 NEXT J
NEXT I
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
        SPS(I, J) = TEMP(I, J)
NEXT J
NEXT I

REDIM TEMP(SIZE, SIZE)
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
X2 = X1 + (I - WIDE) * DX: Y2 = -(J - WIDE) * DY
X4 = X1 + (I - FX - WIDE) * DX: Y4 = -(J - FY - WIDE) * DY
    IF ABS(X2) <= A AND Y2 = 0 THEN GOTO 36
    IF ABS(X4) <= A AND Y4 = 0 THEN GOTO 36
    IF J < FY OR I < FX THEN GOTO 36
    TEMP(I, J) = S11(I, J) + S11(I - FX, J - FY)
36 NEXT J
NEXT I
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
        S11(I, J) = TEMP(I, J)
NEXT J
NEXT I
REDIM TEMP(SIZE, SIZE)
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
X2 = X1 + (I - WIDE) * DX: Y2 = -(J - WIDE) * DY
X4 = X1 + (I - FX - WIDE) * DX: Y4 = -(J - FY - WIDE) * DY
    IF ABS(X2) <= A AND Y2 = 0 THEN GOTO 37
    IF ABS(X4) <= A AND Y4 = 0 THEN GOTO 37
    IF J < FY OR I < FX THEN GOTO 37
    TEMP(I, J) = S22(I, J) + S22(I - FX, J - FY)
37 NEXT J
NEXT I
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
        S22(I, J) = TEMP(I, J)
NEXT J
NEXT I

REDIM TEMP(SIZE, SIZE)
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
X2 = X1 + (I - WIDE) * DX: Y2 = -(J - WIDE) * DY
X4 = X1 + (I - FX - WIDE) * DX: Y4 = -(J - FY - WIDE) * DY
    IF ABS(X2) <= A AND Y2 = 0 THEN GOTO 38
    IF ABS(X4) <= A AND Y4 = 0 THEN GOTO 38
    IF J < FY OR I < FX THEN GOTO 38
    'IF INC > 2 THEN TEMP(I, J) = UX(I, J) + UX(I - FX, J - FY)
    TEMP(I, J) = UX(I, J) + UX(I - FX, J - FY)
38 NEXT J
NEXT I
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
        'IF INC > 2 THEN UX(I, J) = TEMP(I, J)
        UX(I, J) = TEMP(I, J)
NEXT J
NEXT I

REDIM TEMP(SIZE, SIZE)
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
X2 = X1 + (I - WIDE) * DX: Y2 = -(J - WIDE) * DY
X4 = X1 + (I - FX - WIDE) * DX: Y4 = -(J - FY - WIDE) * DY
    IF ABS(X2) <= A AND Y2 = 0 THEN GOTO 39
    IF ABS(X4) <= A AND Y4 = 0 THEN GOTO 39
    IF J < FY OR I < FX THEN GOTO 39
    'IF INC > 2 THEN TEMP(I, J) = UY(I, J) + UY(I - FX, J - FY)
     TEMP(I, J) = UY(I, J) + UY(I - FX, J - FY)
39 NEXT J
NEXT I
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
       'IF INC > 2 THEN UY(I, J) = TEMP(I, J)
       UY(I, J) = TEMP(I, J)
NEXT J
NEXT I

'IF INC = 2 THEN GOTO 29

REDIM TEMP(SIZE, SIZE)
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
X2 = X1 + (I - WIDE) * DX: Y2 = -(J - WIDE) * DY
X4 = X1 + (I - FX - WIDE) * DX: Y4 = -(J - FY - WIDE) * DY
    IF ABS(X2) <= A AND Y2 = 0 THEN GOTO 40
    IF ABS(X4) <= A AND Y4 = 0 THEN GOTO 40
    IF J < FY OR I < FX THEN GOTO 40
    TEMP(I, J) = SPX(I, J) + SPX(I - FX, J - FY)
40 NEXT J
NEXT I
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
        SPX(I, J) = TEMP(I, J)
NEXT J
NEXT I

REDIM TEMP(SIZE, SIZE)
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
X2 = X1 + (I - WIDE) * DX: Y2 = -(J - WIDE) * DY
X4 = X1 + (I - FX - WIDE) * DX: Y4 = -(J - FY - WIDE) * DY
    IF ABS(X2) <= A AND Y2 = 0 THEN GOTO 43
    IF ABS(X4) <= A AND Y4 = 0 THEN GOTO 43
    IF J < FY OR I < FX THEN GOTO 43
    TEMP(I, J) = SPXY(I, J) + SPXY(I - FX, J - FY)
43 NEXT J
NEXT I
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
        SPXY(I, J) = TEMP(I, J)
NEXT J
NEXT I


FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
X2 = X1 + (I - WIDE) * DX: Y2 = -(J - WIDE) * DY
X4 = X1 + (I - FX - WIDE) * DX: Y4 = -(J - FY - WIDE) * DY
    IF ABS(X2) <= A AND Y2 = 0 THEN GOTO 41
    IF ABS(X4) <= A AND Y4 = 0 THEN GOTO 41
    IF J < FY OR I < FX THEN GOTO 41

    SXX = SPX(I, J): SYY = SPS(I, J): SXY = SPXY(I, J)
              IF SXX = SYY THEN TET = 10000
              IF SXX = SYY AND SXX < 0 THEN TET = -10000
              IF SXX = SYY THEN THETA1 = ATN(TET) / 2
              IF SXX = SYY THEN GOTO 2608
              TET = ABS(2 * SXY / (SXX - SYY))
              THETA1 = ATN(TET) / 2
        IF SXX > SYY AND SXY > 0 THEN GOTO 1608
        IF SXX > SYY AND SXY < 0 THEN GOTO 1602
        IF SXX < SYY AND SXY > 0 THEN GOTO 1603
        IF SXX < SYY AND SXY < 0 THEN GOTO 1604
1602 THETA1 = -THETA1: GOTO 1608
1603 THETA1 = -THETA1 + PI / 2: GOTO 1608
1604 THETA1 = THETA1 - PI / 2
1608 THET(I, J) = THETA1
41 NEXT J
NEXT I


29 IF YM$ = "" THEN GOTO 30

31 REDIM TEMP(SIZE, SIZE)
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
X2 = X1 + (I - WIDE) * DX: Y2 = -(J - WIDE) * DY
        STEMP = 0
        IF I < A / INC OR I > WIDE * 2 - A / INC THEN GOTO 25
        IF X2 = A AND X2 = 0 THEN GOTO 25
FOR K = I - A / INC TO I + A / INC
        STEMP = STEMP + SPS(K, J)
NEXT K
25    TEMP(I, J) = STEMP
NEXT J
NEXT I

FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
        SPS(I, J) = TEMP(I, J) * INC / A
        'IF A$ <> "" THEN PRINT #3, I, J, SPS(I, J)
NEXT J
NEXT I

REDIM TEMP(SIZE, SIZE)
FOR I = SWIDE TO WIDE * 2
MAXTEMP = -1000
FOR J = WIDE TO WIDE * 2
        IF SPS(J, I) > MAXTEMP THEN MAXTEMP = SPS(J, I)
NEXT J
FOR K = WIDE TO WIDE * 2
        IF I < A / INC OR I >= WIDE * 2 - A / INC THEN GOTO 32
        X2 = X1 + (K - WIDE) * DX: Y2 = -(I - WIDE) * DY
        'IF A$ <> "" AND SPS(K, I) = MAXTEMP AND X2 >= A AND Y2 >= 0 THEN PRINT #3, X2, Y2, SPS(K, I)
        IF SPS(K, I) = MAXTEMP THEN TEMP(K, I) = 1
32 NEXT K
NEXT I

FOR I = SWIDE TO WIDE * 2
MAXTEMP = -1000
FOR J = WIDE TO WIDE * 2
        IF SPS(I, J) > MAXTEMP THEN MAXTEMP = SPS(I, J)
NEXT J
FOR K = WIDE TO WIDE * 2
        IF I < A / INC OR I >= WIDE * 2 - A / INC THEN GOTO 33
        X2 = X1 + (K - WIDE) * DX: Y2 = -(I - WIDE) * DY
        IF A$ <> "" AND SPS(I, K) = MAXTEMP THEN PRINT #3, I, K, SPS(I, K)
        'IF SPS(I, K) = MAXTEMP THEN THET(I, K) = 1
33 NEXT K
NEXT I

30  CLOSE

'PRINT "Few stress intensity maps are plotted; choose one option:"
'PRINT "  1.  left: maximum shear,     center: maximum tension, right: crack-normal"
'PRINT "  2.  left: Byerlee parameter, center: maximum tension, right: crack-normal"

    MAX1 = -1000: MIN1 = 1000: MAX2 = -1000: MIN2 = 1000: MAX3 = -1000: MIN3 = 1000: MAX4 = -1000: MIN4 = 1000
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
                IF J > WIDE - 2 AND J < WIDE + 2 AND I > WIDE - 2 AND I < WIDE + 2 THEN GOTO 100
                IF J > WIDE - 2 AND J < WIDE + 2 AND I + 2 * A / INC > WIDE - 2 AND I + 2 * A / INC < WIDE + 2 THEN GOTO 100
                IF J = WIDE THEN GOTO 100
        'IF ABS(S11(I, J) - S22(I, J)) > MAX1 THEN MAX1 = ABS(S11(I, J) - S22(I, J))
        'IF ABS(S11(I, J) - S22(I, J)) < MIN1 THEN MIN1 = ABS(S11(I, J) - S22(I, J))
        IF BLF(I, J) > MAX1 THEN MAX1 = BLF(I, J)
        IF BLF(I, J) < MIN1 THEN MIN1 = BLF(I, J)

        IF S11(I, J) > MAX2 THEN MAX2 = S11(I, J)
        IF S11(I, J) < MIN2 THEN MIN2 = S11(I, J)
        IF SYYT(I, J) > MAX3 THEN MAX3 = SYYT(I, J)
        IF SYYT(I, J) < MIN3 THEN MIN3 = SYYT(I, J)

        IF SPS(I, J) > MAX4 THEN MAX4 = SPS(I, J)
        IF SPS(I, J) < MIN4 THEN MIN4 = SPS(I, J)
                IF ABS(.5 * S11(I, J) + .5 * S22(I, J)) < .1 THEN GOTO 100
100 NEXT J
    NEXT I
IF YM$ <> "" THEN MIN4 = 0
LOCATE 8, 1: PRINT "Minimum and maximum values of the stresses (tension > 0):"
LOCATE 9, 1: PRINT USING "###.###"; MIN1
LOCATE 9, 18: PRINT USING "###.###"; MAX1
LOCATE 9, 30: PRINT USING "###.###"; MIN2
LOCATE 9, 42: PRINT USING "###.###"; MAX2
LOCATE 9, 57: PRINT USING "###.###"; MIN4
LOCATE 9, 69: PRINT USING "###.###"; MAX4

'
'  PLOTTING THE STRESS RESULTS
'
320 X1 = 105: Y1 = 250
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
                IF J > WIDE - 1 AND J < WIDE + 1 AND I > WIDE - 1 AND I < WIDE + 1 THEN GOTO 120
                IF J > WIDE - 1 AND J < WIDE + 1 AND I + 2 * A / INC > WIDE - 1 AND I + 2 * A / INC < WIDE + 1 THEN GOTO 120
                IF J = WIDE AND I < WIDE AND I + 2 * A / INC > WIDE THEN GOTO 120
                IF J < FY OR I < FX THEN GOTO 120
        X2 = X1 + (J - WIDE) * DX: Y2 = Y1 - (I - WIDE) * DY
        X6 = X1 + FY * DX: Y6 = Y1 - FX * DY
        IF X2 = X6 AND Y2 > Y6 - 2 * DY AND Y2 < Y6 + 2 * A + 2 * DY THEN GOTO 120
        IF X2 = X1 AND Y2 > Y1 - 2 * DY AND Y2 < Y1 + 2 * A + 2 * DY THEN GOTO 120
        COL1 = 1 + 10 * (BLF(I, J) - MIN1) / (MAX1 - MIN1)
        IF FLAGCOL = 1 THEN CALL SETCOL(COL1, COL2)
        IF FLAGCOL = 2 THEN CALL SETCOL1(COL1, COL2)
        IF FLAGCOL = 0 THEN COL2 = 1 + 15 * (BLF(I, J) - MIN1) / (MAX1 - MIN1)
        LINE (X2 - DX / 2, Y2 - DY / 2)-(X2 + DX / 2, Y2 + DY / 2), COL2, BF
120 NEXT J
    NEXT I
'LINE (X1, Y1)-(X1, Y1 + (2 * A + .5))
LINE (X1, 480)-(X1, Y1 + (WIDE + .5) * DY), 0
X6 = X1 + FY * DX: Y6 = Y1 - FX * DY
IF A <= 100 THEN A1 = A
IF A > 100 THEN A1 = 100
LINE (X6, Y6)-(X6, Y6 + A1)
LINE (X1 - 100 - DX / 2, 150 - DY / 2)-(X1 + 100 + DX / 2, 350 + DY / 2), , B

312 X1 = 320: Y1 = 250
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
'IF S11(I, J) < 0 THEN GOTO 142
                IF J > WIDE - 1 AND J < WIDE + 1 AND I > WIDE - 1 AND I < WIDE + 1 THEN GOTO 142
                IF J > WIDE - 1 AND J < WIDE + 1 AND I + 2 * A / INC > WIDE - 1 AND I + 2 * A / INC < WIDE + 1 THEN GOTO 142
                IF J = WIDE AND I < WIDE AND I + 2 * A / INC > WIDE THEN GOTO 142
                IF J < FY OR I < FX THEN GOTO 142
        X2 = X1 + (J - WIDE) * DX: Y2 = Y1 - (I - WIDE) * DY
        X6 = X1 + FY * DX: Y6 = Y1 - FX * DY
        IF X2 = X6 AND Y2 > Y6 - 2 * DY AND Y2 < Y6 + 2 * A + 2 * DY THEN GOTO 142
        IF X2 = X1 AND Y2 > Y1 - 2 * DY AND Y2 < Y1 + 2 * A + 2 * DY THEN GOTO 142
        COL1 = 1 + 10 * (S11(I, J) - MIN2) / (MAX2 - MIN2)
        IF FLAGCOL = 1 THEN CALL SETCOL(COL1, COL2)
        IF FLAGCOL = 2 THEN CALL SETCOL1(COL1, COL2)
        IF FLAGCOL = 0 THEN COL2 = 1 + 15 * (S11(I, J) - MIN2) / (MAX2 - MIN2)
        LINE (X2 - DX / 2, Y2 - DY / 2)-(X2 + DX / 2, Y2 + DY / 2), COL2, BF
        'LINE (X2 - DX / 2, Y2 - DY / 2)-(X2 + DX / 2, Y2 + DY / 2), 1 + 15 * (SYYT(I, J) - MIN2) / (MAX2 - MIN2), BF
142 NEXT J
    NEXT I
'LINE (X1, Y1)-(X1, Y1 + (2 * A + .5))
LINE (X1, 480)-(X1, Y1 + (WIDE + .5) * DY), 0
X6 = X1 + FY * DX: Y6 = Y1 - FX * DY
IF A <= 100 THEN A1 = A
IF A > 100 THEN A1 = 100
LINE (X6, Y6)-(X6, Y6 + A1)
LINE (X1 - 100 - DX / 2, 150 - DY / 2)-(X1 + 100 + DX / 2, 350 + DY / 2), , B

GOTO 310
X1 = 320: Y1 = 250
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
                IF J > WIDE - 1 AND J < WIDE + 1 AND I > WIDE - 1 AND I < WIDE + 1 THEN GOTO 130
                IF J > WIDE - 1 AND J < WIDE + 1 AND I + 2 * A / INC > WIDE - 1 AND I + 2 * A / INC < WIDE + 1 THEN GOTO 130
                IF J = WIDE AND I < WIDE AND I + 2 * A / INC > WIDE THEN GOTO 130
                IF J < FY OR I < FX THEN GOTO 130
        X2 = X1 + (J - WIDE) * DX: Y2 = Y1 - (I - WIDE) * DY
        X6 = X1 + FY * DX: Y6 = Y1 - FX * DY
        IF X2 = X6 AND Y2 > Y6 - 2 * DY AND Y2 < Y6 + 2 * A + 2 * DY THEN GOTO 130
        IF X2 = X1 AND Y2 > Y1 - 2 * DY AND Y2 < Y1 + 2 * A + 2 * DY THEN GOTO 130
        COL1 = 1 + 10 * (.5 * (S22(I, J) + S11(I, J)) - MIN2) / (MAX2 - MIN2)
        IF FLAGCOL = 1 THEN CALL SETCOL(COL1, COL2)
        IF FLAGCOL = 2 THEN CALL SETCOL1(COL1, COL2)
        IF FLAGCOL = 0 THEN COL2 = 1 + 15 * (.5 * (S22(I, J) + S11(I, J)) - MIN2) / (MAX2 - MIN2)
        LINE (X2 - DX / 2, Y2 - DY / 2)-(X2 + DX / 2, Y2 + DY / 2), COL2, BF
130 NEXT J
    NEXT I
'LINE (X1, Y1)-(X1, Y1 + (2 * A + .5))
LINE (X1, 480)-(X1, Y1 + (WIDE + .5) * DY), 0
X6 = X1 + FY * DX: Y6 = Y1 - FX * DY
IF A <= 100 THEN A1 = A
IF A > 100 THEN A1 = 100
LINE (X6, Y6)-(X6, Y6 + A1)
LINE (X1 - 100 - DX / 2, 150 - DY / 2)-(X1 + 100 + DX / 2, 350 + DY / 2), , B

310  X1 = 535: Y1 = 250: KSPS = 0
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
'iF J = WIDE THEN GOTO 140
                IF J > WIDE - 1 AND J < WIDE + 1 AND I > WIDE - 1 AND I < WIDE + 1 THEN GOTO 140
                IF J > WIDE - 1 AND J < WIDE + 1 AND I + 2 * A / INC > WIDE - 1 AND I + 2 * A / INC < WIDE + 1 THEN GOTO 140
                IF J = WIDE AND I < WIDE AND I + 2 * A / INC > WIDE THEN GOTO 140
                IF J < FY OR I < FX THEN GOTO 140
        X2 = X1 + (J - WIDE) * DX: Y2 = Y1 - (I - WIDE) * DY
        X6 = X1 + FY * DX: Y6 = Y1 - FX * DY
        IF X2 = X6 AND Y2 > Y6 - 2 * DY AND Y2 < Y6 + 2 * A + 2 * DY THEN GOTO 140
        IF X2 = X1 AND Y2 > Y1 - 2 * DY AND Y2 < Y1 + 2 * A + 2 * DY THEN GOTO 140

        'LINE (X2 - DX / 2, Y2 - DY / 2)-(X2 + DX / 2, Y2 + DY / 2), 1 + 15 * (.5 * (S11(I, J) + S22(I, J)) - MIN3) / (MAX3 - MIN3), BF
        COL1 = 1 + 10 * (SYYT(I, J) - MIN3) / (MAX3 - MIN3)
        IF FLAGCOL = 1 THEN CALL SETCOL(COL1, COL2)
        IF FLAGCOL = 2 THEN CALL SETCOL1(COL1, COL2)
        IF FLAGCOL = 0 THEN COL2 = 1 + 15 * (SYYT(I, J) - MIN3) / (MAX3 - MIN3)
        LINE (X2 - DX / 2, Y2 - DY / 2)-(X2 + DX / 2, Y2 + DY / 2), COL2, BF
        'GOTO 140
        COL1 = 1 + 10 * (SPS(I, J) - MIN4) / (MAX4 - MIN4)
        IF FLAGCOL = 1 THEN CALL SETCOL(COL1, COL2)
        IF FLAGCOL = 2 THEN CALL SETCOL1(COL1, COL2)
        IF FLAGCOL = 0 THEN COL2 = 1 + 12 * (SPS(I, J) - MIN4) / (MAX4 - MIN4)
        LINE (X2 - DX / 2, Y2 - DY / 2)-(X2 + DX / 2, Y2 + DY / 2), COL2, BF

        IF X2 = X1 OR X2 = X6 THEN COL1 = 1 + 10 * (.5 * (SPS(I, J - 1) + SPS(I, J + 1)) - MIN4) / (MAX4 - MIN4)
        IF FLAGCOL = 1 THEN CALL SETCOL(COL1, COL2)
        IF FLAGCOL = 2 THEN CALL SETCOL1(COL1, COL2)
        IF X2 = X1 THEN LINE (X2 - DX / 2, Y2 - DY / 2)-(X2 + DX / 2, Y2 + DY / 2), COL2, BF
        IF X2 = X6 THEN LINE (X2 - DX / 2, Y2 - DY / 2)-(X2 + DX / 2, Y2 + DY / 2), COL2, BF
IF FLAGCOL = 1 THEN GOTO 72
        'IF X2 = X1 THEN LINE (X2 - DX / 2, Y2 - DY / 2)-(X2 + DX / 2, Y2 + DY / 2), 1 + 15 * (.5 * (SPS(I, J - 1) + SPS(I, J + 1)) - MIN4) / (MAX4 - MIN4), BF
        'IF X2 = X6 THEN LINE (X2 - DX / 2, Y2 - DY / 2)-(X2 + DX / 2, Y2 + DY / 2), 1 + 15 * (.5 * (SPS(I, J - 1) + SPS(I, J + 1)) - MIN4) / (MAX4 - MIN4), BF


72  IF SPS(I, J) <= 0 AND YM$ <> "" THEN LINE (X2 - DX / 2, Y2 - DY / 2)-(X2 + DX / 2, Y2 + DY / 2), 0, BF
        IF X2 <= X6 THEN GOTO 140
        IF Y2 >= Y1 THEN GOTO 140
        IF TEMP(I, J) = 1 AND KSPS = 1 AND SC$ = "" THEN LINE (X2, Y2)-(X3, Y3), 0
        'IF THET(I, J) = 1 AND KSPS = 1 AND SC$ = "" THEN LINE (X2, Y2)-(X4, Y4), 0
        'IF TEMP(I, J) = 1 AND SC$ <> "" THEN CIRCLE (X2, Y2), 1, 0
        'IF TEMP(I, J) = 1 THEN CIRCLE (X2, Y2), 1, 0
        IF TEMP(I, J) = 1 THEN X3 = X2
        IF TEMP(I, J) = 1 THEN Y3 = Y2
        IF THET(I, J) = 1 THEN X4 = X2
        IF THET(I, J) = 1 THEN Y4 = Y2

        IF TEMP(I, J) = 1 THEN KSPS = 1
140 NEXT J
    NEXT I
'LINE (X1, Y1)-(X1, Y1 + (2 * A + .5))
LINE (X1, 480)-(X1, Y1 + (WIDE + .5) * DY), 0
X6 = X1 + FY * DX: Y6 = Y1 - FX * DY
IF A <= 100 THEN A1 = A
IF A > 100 THEN A1 = 100
LINE (X6, Y6)-(X6, Y6 + A1)
LINE (X1 - 100 - DX / 2, 150 - DY / 2)-(X1 + 100 + DX / 2, 350 + DY / 2), , B
IF YM$ = "" THEN GOTO 205
B1 = 545: C1 = 170: B2 = 610: C2 = 200

205 LOCATE 24, 1
INPUT "1,2 contour in black, green; 3,4 stress trajectories in black, green [NONE]"; PT
IF PT = 0 THEN GOTO 410
IF PT = 1 OR PT = 2 THEN GOTO 700

210  IF PT = 3 THEN CCOL = 0
     IF PT = 4 THEN CCOL = 15
IF CCOL = 15 THEN LINE (1, 145)-(639, 355), O, BF
IF INC = 10 THEN KW = 1
IF INC = 5 THEN KW = 2
IF INC = 4 THEN KW = 3
IF INC = 2 THEN KW = 5
X1 = 320: Y1 = 250
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
                'IF J > WIDE - 2 AND J < WIDE + 2 AND I > WIDE - 2 AND I < WIDE + 2 THEN GOTO 125
                IF J = WIDE AND I < WIDE AND I + 2 * A / INC > WIDE THEN GOTO 125
                IF I / KW <> INT(I / KW) THEN GOTO 125
                IF J / KW <> INT(J / KW) THEN GOTO 125
                IF J < FY OR I < FX THEN GOTO 125
        X2 = X1 + (J - WIDE) * DX: Y2 = Y1 - (I - WIDE) * DY
        IF THET(I, J) > PI / 2 THEN GOTO 201
        TH = THET(I, J) + PI / 2: GOTO 202
201       TH = THET(I, J) - PI / 2
202       XP2 = X2 + 5 * COS(TH)
          ZP2 = Y2 - 5 * SIN(TH)
          XP3 = X2 - 5 * COS(TH)
          ZP3 = Y2 + 5 * SIN(TH)
          LINE (XP2, ZP2)-(XP3, ZP3), CCOL
125 NEXT J
NEXT I
'LINE (X1, Y1)-(X1, Y1 + (2 * A + .5))
LINE (X1, 480)-(X1, Y1 + (WIDE + .5) * DY), 0
X6 = X1 + FY * DX: Y6 = Y1 - FX * DY
IF A <= 100 THEN A1 = A
IF A > 100 THEN A1 = 100
LINE (X6, Y6)-(X6, Y6 + A1)
LINE (X1 - 100 - DX / 2, 150 - DY / 2)-(X1 + 100 + DX / 2, 350 + DY / 2), , B

X1 = 105: Y1 = 250
FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE * 2
                'IF J > WIDE - 2 AND J < WIDE + 2 AND I > WIDE - 2 AND I < WIDE + 2 THEN GOTO 155
                IF J = WIDE AND I < WIDE AND I + 2 * A / INC > WIDE THEN GOTO 155
                IF I / KW <> INT(I / KW) THEN GOTO 155
                IF J / KW <> INT(J / KW) THEN GOTO 155
                IF J < FY OR I < FX THEN GOTO 155
          X2 = X1 + (J - WIDE) * DX: Y2 = Y1 - (I - WIDE) * DY
          XP2 = X2 + 5 * COS(THET(I, J))
          ZP2 = Y2 - 5 * SIN(THET(I, J))
          XP3 = X2 - 5 * COS(THET(I, J))
          ZP3 = Y2 + 5 * SIN(THET(I, J))
          LINE (XP2, ZP2)-(XP3, ZP3), CCOL
155 NEXT J
NEXT I
'LINE (X1, Y1)-(X1, Y1 + (2 * A + .5))
LINE (X1, 480)-(X1, Y1 + (WIDE + .5) * DY), 0
X6 = X1 + FY * DX: Y6 = Y1 - FX * DY
IF A <= 100 THEN A1 = A
IF A > 100 THEN A1 = 100
LINE (X6, Y6)-(X6, Y6 + A1)
LINE (X1 - 100 - DX / 2, 150 - DY / 2)-(X1 + 100 + DX / 2, 350 + DY / 2), , B

'IF YM$ <> "" THEN GOTO 410

405 X1 = 535: Y1 = 250

FOR I = SWIDE TO WIDE * 2
FOR J = SWIDE TO WIDE
                
                IF J > WIDE - 2 AND J < WIDE + 2 AND I > WIDE - 2 AND I < WIDE + 2 THEN GOTO 195
                IF J = WIDE AND I < WIDE AND I + 2 * A / INC > WIDE THEN GOTO 195
                IF I / KW <> INT(I / KW) THEN GOTO 195
                IF J / KW <> INT(J / KW) THEN GOTO 195
                IF J < FY OR I < FX THEN GOTO 195
        X2 = X1 + (J - WIDE) * DX: Y2 = Y1 - (I - WIDE) * DY
        'IF INC = 2 OR ABS(UY(I, J)) > 75 OR ABS(UX(I, J)) > 75 THEN GOTO 195
        IF ABS(UY(I, J)) > 75 OR ABS(UX(I, J)) > 75 THEN GOTO 195
        CIRCLE (X2, Y2), 1, CCOL
        LINE (X2, Y2)-(X2 - UY(I, J), Y2 - UX(I, J)), CCOL
195 NEXT J
    NEXT I
'LINE (X1, Y1)-(X1, Y1 + (2 * A + .5))
LINE (X1, 480)-(X1, Y1 + (WIDE + .5) * DY), 0
X6 = X1 + FY * DX: Y6 = Y1 - FX * DY
IF A <= 100 THEN A1 = A
IF A > 100 THEN A1 = 100
LINE (X6, Y6)-(X6, Y6 + A1)
LINE (X1 - 100 - DX / 2, 150 - DY / 2)-(X1 + 100 + DX / 2, 350 + DY / 2), , B

410 LOCATE 24, 1
IF YM$ = "" AND SOPT = 2 THEN PRINT "Byerlee parameter, BLF      Maximum tension             Crack normal stress  "
IF YM$ = "" AND SOPT = 1 THEN PRINT "Maximum shear stress        Maximum tension            Crack normal * Mean crack"
IF YM$ <> "" THEN PRINT "                                                      tension  * normal tension"
IF PT$ = "" AND YM$ = "" AND SOPT = 2 THEN PRINT "red<.65,blue<1.,green>1.=tension  Tension trajectories    & Displacements"
IF PT$ = "" AND YM$ = "" AND SOPT = 1 THEN PRINT "& Compression trajectories      & Tension trajectories  (black is compressive)"
IF PT$ <> "" AND YM$ <> "" THEN PRINT "                                                       (black is compressive)"
INPUT "1-replot the stress maps, 2-more analyses [END] "; YCON
        IF YCON = 1 THEN LINE (0, 145)-(639, 420), 0, BF
        IF YCON = 1 THEN GOTO 320
        IF YCON = 2 THEN GOTO 10
500 CLS
GOTO 1000

700  IF PT = 1 THEN CCOL = 0
     IF PT = 2 THEN CCOL = 15
IF CCOL = 15 THEN LINE (1, 145)-(639, 355), O, BF
X1 = 105: Y1 = 250
FOR I = SWIDE + 1 TO WIDE * 2 - 1
FOR J = SWIDE + 1 TO WIDE * 2 - 1
        
        X2 = X1 + (J - WIDE) * DX: Y2 = Y1 - (I - WIDE) * DY
        IF INT(.5 + 15 * (BLF(I, J) - MIN1) / (MAX1 - MIN1)) <> INT(.5 + 15 * (ABS(S11(I - 1, J) - S22(I - 1, J)) - MIN1) / (MAX1 - MIN1)) THEN LINE (X2 - DX / 2, Y2 + DY / 2)-(X2 + DX / 2, Y2 + DY / 2), CCOL
        IF INT(.5 + 15 * (BLF(I, J) - MIN1) / (MAX1 - MIN1)) <> INT(.5 + 15 * (ABS(S11(I, J - 1) - S22(I, J - 1)) - MIN1) / (MAX1 - MIN1)) THEN LINE (X2 - DX / 2, Y2 + DY / 2)-(X2 - DX / 2, Y2 - DY / 2), CCOL
NEXT J
NEXT I
'LINE (X1, Y1)-(X1, Y1 + (2 * A + .5))
LINE (X1, 480)-(X1, Y1 + (WIDE + .5) * DY), 0
LINE (X1 - 100 - DX / 2, 150 - DY / 2)-(X1 + 100 + DX / 2, 350 + DY / 2), , B

X1 = 320: Y1 = 250
FOR I = SWIDE + 1 TO WIDE * 2 - 1
FOR J = SWIDE + 1 TO WIDE * 2 - 1
IF S11(I, J) < 0 THEN GOTO 156
        X2 = X1 + (J - WIDE) * DX: Y2 = Y1 - (I - WIDE) * DY
        IF INT(.5 + 15 * (S11(I, J)) - MIN2) / (MAX2 - MIN2) <> INT(.5 + 15 * (S11(I - 1, J)) - MIN2) / (MAX2 - MIN2) THEN LINE (X2 - DX / 2, Y2 + DY / 2)-(X2 + DX / 2, Y2 + DY / 2), CCOL
        IF INT(.5 + 15 * (S11(I, J)) - MIN2) / (MAX2 - MIN2) <> INT(.5 + 15 * (S11(I, J - 1)) - MIN2) / (MAX2 - MIN2) THEN LINE (X2 - DX / 2, Y2 + DY / 2)-(X2 - DX / 2, Y2 - DY / 2), CCOL
156 NEXT J
NEXT I
'LINE (X1, Y1)-(X1, Y1 + (2 * A + .5))
LINE (X1, 480)-(X1, Y1 + (WIDE + .5) * DY), 0
LINE (X1 - 100 - DX / 2, 150 - DY / 2)-(X1 + 100 + DX / 2, 350 + DY / 2), , B

X1 = 535: Y1 = 250
FOR I = SWIDE + 1 TO WIDE * 2 - 1
FOR J = SWIDE + 1 TO WIDE * 2 - 1
        X2 = X1 + (J - WIDE) * DX: Y2 = Y1 - (I - WIDE) * DY
        IF INT(.5 + 15 * ((.5 * (S22(I, J) + S11(I, J)) - MIN3) / (MAX3 - MIN3))) <> INT(.5 + 15 * ((.5 * (S22(I - 1, J) + S11(I - 1, J)) - MIN3) / (MAX3 - MIN3))) THEN LINE (X2 - DX / 2, Y2 + DY / 2)-(X2 + DX / 2, Y2 + DY / 2), CCOL
        IF INT(.5 + 15 * (.5 * (S22(I, J) + S11(I, J)) - MIN3) / (MAX3 - MIN3)) <> INT(.5 + 15 * (.5 * (S22(I, J - 1) + S11(I, J - 1)) - MIN3) / (MAX3 - MIN3)) THEN LINE (X2 - DX / 2, Y2 + DY / 2)-(X2 - DX / 2, Y2 - DY / 2), CCOL

        'IF INT(.5+3*((SPS(I, J) - MIN4) / (MAX4 - MIN4))) <> INT(.5+3*((SPS(I - 1, J) - MIN4) / (MAX4 - MIN4))) THEN LINE (X2 - DX / 2, Y2 + DY / 2)-(X2 + DX / 2, Y2 + DY / 2), CCOL
        'IF INT(.5+3*((SPS(I, J) - MIN4) / (MAX4 - MIN4))) <> INT(.5+3*((SPS(I, J - 1) - MIN4) / (MAX4 - MIN4))) THEN LINE (X2 - DX / 2, Y2 + DY / 2)-(X2 - DX / 2, Y2 - DY / 2), CCOL
NEXT J
NEXT I
'LINE (X1, Y1)-(X1, Y1 + (2 * A + .5))
LINE (X1, 480)-(X1, Y1 + (WIDE + .5) * DY), 0
LINE (X1 - 100 - DX / 2, 150 - DY / 2)-(X1 + 100 + DX / 2, 350 + DY / 2), , B
GOTO 205

999  SX = SXXR
     SY = SYYR
     SXY = SXYR
     PRINT "The component of remote stress:"
     PRINT "  "; CHR$(229); "x=";
     PRINT USING " ####.## "; SX;
     PRINT "  "; CHR$(229); "y=";
    PRINT USING " ####.## "; SY;
     PRINT " "; CHR$(229); "xy=";
     PRINT USING " ####.## "; SXY
     G1 = (SX + SY) / 2 + SQR(.25 * (SX - SY) ^ 2 + SXY ^ 2)
     G2 = (SX + SY) / 2 - SQR(.25 * (SX - SY) ^ 2 + SXY ^ 2)

              IF SX = SY THEN TET = 10000
              IF SX = SY AND SX < 0 THEN TET = -10000
              IF SX = SY THEN THETA1 = ATN(TET) / 2
              IF SX = SY THEN GOTO 1608
              TET = ABS(2 * SXY / (SX - SY))
              THETA1 = ATN(TET) / 2
        IF SX > SY AND SXY > 0 THEN GOTO 2608
        IF SX > SY AND SXY < 0 THEN GOTO 2602
        IF SX < SY AND SXY > 0 THEN GOTO 2603
        IF SX < SY AND SXY < 0 THEN GOTO 2604
2602 THETA1 = -THETA1: GOTO 2608
2603 THETA1 = -THETA1 + PI / 2: GOTO 2608
2604 THETA1 = THETA1 - PI / 2
2608 THET = THETA1
     THET = 180 * THET / PI
     THET = THET + 90
     IF THET > 90 THEN THET = THET - 180
        IF SX > SY AND SXY = 0 THEN THET = 90
        IF SX < SY AND SXY = 0 THEN THET = 0
     PRINT CHR$(229); " MAX = "; G1;
     PRINT CHR$(229); " min = "; G2;
     PRINT " Trend (comp. from X axis)= ";
     PRINT USING " ####.#"; THET
     PRINT
     RETURN
1000

REM $STATIC
SUB SETCOL (COL1, COL2)
IF COL1 <= 1.5 THEN COL2 = 0
IF COL1 <= 2.5 AND COL1 > 1.5 THEN COL2 = 14
IF COL1 <= 3.5 AND COL1 > 2.5 THEN COL2 = 7
IF COL1 <= 4.5 AND COL1 > 3.5 THEN COL2 = 10
IF COL1 <= 5.5 AND COL1 > 4.5 THEN COL2 = 8
IF COL1 <= 6.5 AND COL1 > 5.5 THEN COL2 = 13
IF COL1 <= 7.5 AND COL1 > 6.5 THEN COL2 = 12
IF COL1 <= 8.5 AND COL1 > 7.5 THEN COL2 = 5
IF COL1 <= 9.5 AND COL1 > 8.5 THEN COL2 = 9
IF COL1 > 9.5 THEN COL2 = 1

END SUB

SUB SETCOL1 (COL1, COL2)

IF COL1 <= 1.5 THEN COL2 = 0
IF COL1 <= 2.5 AND COL1 > 1.5 THEN COL2 = 1
IF COL1 <= 3.5 AND COL1 > 2.5 THEN COL2 = 2
IF COL1 <= 4.5 AND COL1 > 3.5 THEN COL2 = 3
IF COL1 <= 5.5 AND COL1 > 4.5 THEN COL2 = 6
IF COL1 <= 6.5 AND COL1 > 5.5 THEN COL2 = 8
IF COL1 <= 7.5 AND COL1 > 6.5 THEN COL2 = 12
IF COL1 <= 8.5 AND COL1 > 7.5 THEN COL2 = 13
IF COL1 <= 9.5 AND COL1 > 8.5 THEN COL2 = 14
IF COL1 > 9.5 THEN COL2 = 14

END SUB

SUB THETASIGN (THETAS, X1, X2, X3, Y2, Y3, PI)
                IF X2 < X3 AND Y2 > 0 THEN THETAS = PI - ABS(THETAS)
                IF X2 < X3 AND Y2 < 0 THEN THETAS = -PI + THETAS
             '   IF X2 > X3 AND Y2 < 0 THEN THETAS = -THETAS
                IF X2 = X3 AND Y2 > 0 THEN THETAS = PI / 2
                IF X2 = X3 AND Y2 < 0 THEN THETAS = -PI / 2
END SUB

